//////////////////////////////////////////////////////////////////////
//
//  ADSDBE.CH
//
//  Copyright:
//     Alaska Software Inc., (c) 1998. All rights reserved.         
//  
//  Contents:
//     #define constants for DbeInfo() and DbInfo() of the ADSDBE
//   
//////////////////////////////////////////////////////////////////////

#ifndef  _ADSDBE_CH          
#define  _ADSDBE_CH

// DMLB.CH is required
#include "dmlb.ch"           
#include "dll.ch"           

// ADSDBE generics
//
#define ADSDBE_MEMOFILE_EXT    DBE_USER+1
#define ADSDBE_INDEX_EXT       DBE_USER+2
#define ADSDBE_TBL_MODE        DBE_USER+3
#define ADSDBE_LOCK_MODE       DBE_USER+4
#define ADSDBE_RIGHTS_MODE     DBE_USER+5
#define ADSDBE_MEMOBLOCKSIZE   DBE_USER+6
#define ADSDBE_PASSWORD        DBE_USER+7

// supported file types
#define ADSDBE_NTX       1    
#define ADSDBE_CDX       2

// locking compatibility
#define ADSDBE_COMPATIBLE_LOCKING  0
#define ADSDBE_PROPRIETARY_LOCKING 1

// rights checking options
#define ADSDBE_CHECKRIGHTS  1
#define ADSDBE_IGNORERIGHTS 2


// DBO instances of ADSDBE can use:
//
#define ADSDBO_MEMOBLOCKSIZE   DBE_USER+1

#ifdef __XPP__
// replacement for SET DATE to ensure the ADS is evaluating
// date expressions correctly

#command  SET DATE FORMAT [TO] <c>  =>  Set( _SET_DATEFORMAT, <c> ) ;;
                                        _adsSetDateFormat( <c> )

#define  _ADSDFSET(x, y)  Set( _SET_DATEFORMAT, iif(Set( _SET_CENTURY ), x, y) );;
                          _adsSetDateFormat( iif(Set( _SET_CENTURY ), x, y) )

#command  SET DATE [TO] SYSTEM      =>  Set( _SET_DATEFORMAT, "" )
#command  SET DATE [TO] AMERICAN    =>  _ADSDFSET( "MM/DD/YYYY", "MM/DD/YY" )
#command  SET DATE [TO] ANSI        =>  _ADSDFSET( "YYYY.MM.DD", "YY.MM.DD" )
#command  SET DATE [TO] BRITISH     =>  _ADSDFSET( "DD/MM/YYYY", "DD/MM/YY" )
#command  SET DATE [TO] FRENCH      =>  _ADSDFSET( "DD/MM/YYYY", "DD/MM/YY" )
#command  SET DATE [TO] GERMAN      =>  _ADSDFSET( "DD.MM.YYYY", "DD.MM.YY" )
#command  SET DATE [TO] ITALIAN     =>  _ADSDFSET( "DD-MM-YYYY", "DD-MM-YY" )
#command  SET DATE [TO] JAPANESE    =>  _ADSDFSET( "YYYY/MM/DD", "YY/MM/DD" )
#command  SET DATE [TO] USA         =>  _ADSDFSET( "MM-DD-YYYY", "MM-DD-YY" )

#endif // __XPP__ 

#endif                      // #ifndef _ADSDBE_CH



