/*
   Program..: DCAPP.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1998
   Date.....: Apr 2, 1998
   Notes....: Special APP Dialog commands for dCLIP++ / eXpress++
*/

#include "dcdialog.ch"

#ifndef _DCAPPEDIT_CH

*******************************************************************************
* Final translation of the DCAPPEDIT command
******************************************************************************
#command _DCAPPEDIT INTO <oEdit>                                            ;
              [ PARENT <oParent> ]                                          ;
              [ FIELDS <fields,...> ]                                       ;
              [ COLOR <fgC> [, <bgC> ] ]                                    ;
              [ FONT <(font)> ]                                             ;
              [ POSITION <nRow> [, <nCol>] ]                                ;
              [ SIZE <nWidth> [, <nHeight>] [<per:PERCENT>] ]               ;
              [ TITLE <title> ]                                             ;
              [ CAPTION [ FONT <(cFont)>]                                   ;
                   [ COLOR <cFgC> [, <cBgC>] ]                              ;
                   [ ALIGN <cAlign:LEFT,CENTER,RIGHT> ] ]                   ;
              [ HEADING <(head)> [ FONT <(hFont)>]                          ;
                   [ COLOR <hFgC> [, <hBgC>] ]                              ;
                   [ ALIGN <hAlign:LEFT,CENTER,RIGHT> ] ]                   ;
              [ STYLE <style> ]                                             ;
              [ NOACTION <suppress> ]                                       ;
              [ ALIAS <(alias)> ]                                           ;
              [ SEEK <bSeek> ]                                              ;
              [ FOR <bFor> ]                                                ;
              [ WHILE <bWhile> ]                                            ;
              [ TRIGGER <bDelete> [ON] DELETE ]                             ;
              [ TRIGGER <bInsert> [ON] INSERT ]                             ;
              [ TRIGGER <bUpdate> [ON] UPDATE ]                             ;
              [ BITMAP <bitmap> [ <fit:FIT> ] ]                             ;
              [ EVAL <bEval> ]                                              ;
              [ RELATIVE <oRel> ]                                           ;
              [ HIDE <bHide> ]                                              ;
              [ ACCELKEY <nAccel> ]                                         ;
              [ <mod:MODELESS> ]                                            ;
              [ <sav:SAVE> ]                                                ;
              [GOTFOCUS <bGotFocus>]                                        ;
              [LOSTFOCUS <bLostFocus>]                                      ;
              [<lTabStop:TABSTOP>]                                          ;
              [<lNoTabStop:NOTABSTOP>]                                      ;
              [TABGROUP <nTabGroup>]                                        ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [GROUP <cGroup>]                                              ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_APPEDIT,                          /* nGETLIST_TYPE         */ ;
      <style>,                                  /* nGETLIST_SUBTYPE      */ ;
      <title>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bFor>,<(bFor)>},                        /* bGETLIST_WHEN         */ ;
      {<bWhile>,<(bWhile)>},                    /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      [{<(fields)>}],                           /* xGETLIST_OPTIONS      */ ;
      {<fgC>,<bgC>},                            /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <alias>,                                  /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oEdit>,'O'),                                       ;
                       <(oEdit)>,'O'}],         /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      {<bEval>,<(bEval)>},                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      {<cFont>,<cFgC>,<cBgC>,<(cAlign)>},       /* xGETLIST_OPTIONS2     */ ;
      {<bSeek>,<(bSeek)>},                      /* xGETLIST_OPTIONS3     */ ;
      {<head>,<hFont>,<hFgC>,<hBgC>,<(hAlign)>},/* xGETLIST_OPTIONS4     */ ;
      {<bDelete>,<(bDelete)>},                  /* xGETLIST_OPTIONS5     */ ;
      {<bInsert>,<(bInsert)>},                  /* xGETLIST_OPTIONS6     */ ;
      {<bUpdate>,<(bUpdate)>},                  /* xGETLIST_OPTIONS7     */ ;
      {<bitmap>,<.fit.>},                       /* xGETLIST_OPTIONS8     */ ;
      {<.mod.>,<.sav.>},                        /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<{bHide}>,<(bHide)>},                    /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* bGETLIST_LOSTFOCUS    */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* lGETLIST_PROC         */ ;
     } )

******************************************************************************
* Final translation of the DCAPPBROWSE command
******************************************************************************
#command _DCAPPBROWSE  INTO <oBrowse>                                       ;
              [ PARENT <oParent> ]                                          ;
              [ FIELDS <fields,...> ]                                       ;
              [ COLOR <fgC> [, <bgC> ] ]                                    ;
              [ HILITE <fgHC> [, <bgHC> ] ]                                 ;
              [ FONT <(font)> ]                                             ;
              [ POSITION <nRow> [, <nCol>] ]                                ;
              [ SIZE <nWidth> [, <nHeight>] [<per:PERCENT>] ]               ;
              [ TITLE <title> ]                                             ;
              [ STYLE <style> ]                                             ;
              [ ALIAS <(alias)> ]                                           ;
              [ FOR <bFor> ]                                                ;
              [ EVAL <bEval> ]                                              ;
              [ RELATIVE <oRel> ]                                           ;
              [ HIDE <bHide> ]                                              ;
              [ ACCELKEY <nAccel> ]                                         ;
              [ <mod:MODELESS> ]                                            ;
              [ <sav:SAVE> ]                                                ;
              [GOTFOCUS <bGotFocus>]                                        ;
              [LOSTFOCUS <bLostFocus>]                                      ;
              [<lTabStop:TABSTOP>]                                          ;
              [<lNoTabStop:NOTABSTOP>]                                      ;
              [TABGROUP <nTabGroup>]                                        ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [GROUP <cGroup>]                                              ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_APPBROWSE,                        /* nGETLIST_TYPE         */ ;
      <style>,                                  /* nGETLIST_SUBTYPE      */ ;
      <title>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bFor>,<(bFor)>},                        /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      [{<(fields)>}],                           /* xGETLIST_OPTIONS      */ ;
      {<fgC>,<bgC>},                            /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <alias>,                                  /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oBrowse>,'O'),                                     ;
                       <(oBrowse)>,'O'}],       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      {<bEval>,<(bEval)>},                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      [{<fgHC>,<bgHC>}],                        /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      {<.mod.>,<.sav.>},                        /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<{bHide}>,<(bHide)>},                    /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* bGETLIST_LOSTFOCUS    */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* lGETLIST_PROC         */ ;
     } )

******************************************************************************
* Final translation of the DCAPPFIELD command
******************************************************************************

#command _DCAPPFIELD [<(a)> ->] <(fld)> INTO <oApp>                         ;
              [ EXPR <exp> ]                                                ;
              [ TYPE <(cType)> ]                                            ;
              [ LEN <nLen> ]                                                ;
              [ DEC <nDec> ]                                                ;
              [ FONT <(cFont)> ]                                            ;
              [ COLOR <Ffg1> [, <Fbg1> ] ]                                  ;
              [ HILITE <Ffg2> [, <Fbg2> ] ]                                 ;
              [ ALIGN <Falg> ]                                              ;
              [ WIDTH <nWidth> ]                                            ;
              [ <ro:RO,READONLY> ]                                          ;
              [ <head:CAPTION,HEADING> <(cText1)>                           ;
                 [ FONT <(cFont1)> ]                                        ;
                 [ COLOR <Cfg1> [, <Cbg1> ] ]                               ;
                 [ ALIGN <CAlg1:LEFT,CENTER,RIGHT> ] ]                      ;
              [ <foot:COMMENT,FOOTING> <(cText2)>                           ;
                 [ FONT  <(cFont2)> ]                                       ;
                 [ COLOR <Cfg2> [, <Cbg2> ] ]                               ;
                 [ ALIGN <CAlg2:LEFT,CENTER,RIGHT> ] ]                      ;
              [ EVAL <bEval> ]                                              ;
              [ ACCELKEY <nAccel> ]                                         ;
              [GOTFOCUS <bGotFocus>]                                        ;
              [LOSTFOCUS <bLostFocus>]                                      ;
              [<lTabStop:TABSTOP>]                                          ;
              [<lNoTabStop:NOTABSTOP>]                                      ;
              [TABGROUP <nTabGroup>]                                        ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [GROUP <cGroup>]                                              ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_APPFIELD,                         /* nGETLIST_TYPE         */ ;
      <(cType)>,                                /* nGETLIST_SUBTYPE      */ ;
      <exp>,                                    /* cGETLIST_CAPTION      */ ;
      {||[<a>->]<fld> [:=<exp>]},               /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      <(cFont)>,                                /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      {<Ffg1>,<Fbg1>},                          /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <(fld)>,                                  /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oApp>,'O'),                                        ;
                       <(oApp)>,'O'}],          /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      <.ro.>,                                   /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      {<bEval>,<(bEval)>},                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      {<Ffg2>,<Fbg2>},                          /* xGETLIST_OPTIONS2     */ ;
      <nLen>,                                   /* xGETLIST_OPTIONS3     */ ;
      <nDec>,                                   /* xGETLIST_OPTIONS4     */ ;
      [{__ALIGN,<Falg>}],                       /* xGETLIST_OPTIONS5     */ ;
      {<cText1>,<cFont1>,<Cfg1>,<Cbg1>,[{__ALIGN,<CAlg1>}]},                ;
                                                /* xGETLIST_OPTIONS6     */ ;
      {<cText2>,<cFont2>,<Cfg2>,<Cbg2>,[{__ALIGN,<CAlg2>}]},                ;
                                                /* xGETLIST_OPTIONS7     */ ;
      <(a)>,                                    /* xGETLIST_OPTIONS8     */ ;
      IIf(<.exp.>,.T.,<.ro.>),                  /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* bGETLIST_LOSTFOCUS    */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* lGETLIST_PROC         */ ;
     } )


#xtrans  DCAPPEDIT [<clauses,...>] STYLE PLAIN [<*more*>] ;
     =>  DCAPPEDIT [<clauses>] STYLE APPSTYLE_PLAIN [<more>]

#xtrans  DCAPPEDIT [<clauses,...>] STYLE 3D [<*more*>] ;
     =>  DCAPPEDIT [<clauses>] STYLE APPSTYLE_3D [<more>]

#xtrans  DCAPPEDIT [<clauses,...>] STYLE FANCY [<*more*>] ;
     =>  DCAPPEDIT [<clauses>] STYLE APPSTYLE_FANCY [<more>]


*******************************************************************************
* Make sure that the APPEDIT command assigns an AppEdit object to a variable
*******************************************************************************
#command  DCAPPEDIT [<clauses,...>] => ;
          _DCAPPEDIT INTO appObject [<clauses>]

#command  DCAPPEDIT INTO <oApp> [<clauses,...>] => ;
          _DCAPPEDIT INTO <oApp> [<clauses>]


#xtrans  DCAPPBROWSE [<clauses,...>] STYLE PLAIN [<*more*>] ;
     =>  DCAPPBROWSE [<clauses>] STYLE APPSTYLE_PLAIN [<more>]

#xtrans  DCAPPBROWSE [<clauses,...>] STYLE 3D [<*more*>] ;
     =>  DCAPPBROWSE [<clauses>] STYLE APPSTYLE_3D [<more>]

#xtrans  DCAPPBROWSE [<clauses,...>] STYLE FANCY [<*more*>] ;
     =>  DCAPPBROWSE [<clauses>] STYLE APPSTYLE_FANCY [<more>]


********************************************************************************
* Make sure that the APPBROWSE command assigns an AppBrowse object to a variable
********************************************************************************
#command  DCAPPBROWSE [<clauses,...>] => ;
          _DCAPPBROWSE INTO appObject [<clauses>]

#command  DCAPPBROWSE INTO <oApp> [<clauses,...>] => ;
          _DCAPPBROWSE INTO <oApp> [<clauses>]


*******************************************************************************
* Different DCAPPFIELD commands for APPs
*******************************************************************************
#xtranslate   DCAPPFIELD <fld> [<clauses,...>] => ;
             _DCAPPFIELD <fld> INTO appObject [<clauses>]

#xtranslate   DCAPPFIELD <fld> := <exp> [<clauses,...>] => ;
             _DCAPPFIELD <fld> INTO appObject EXPR <exp> [<clauses>]

#xtranslate   DCAPPFIELD <fld> INTO <oApp> [<clauses,...>] => ;
             _DCAPPFIELD <fld> INTO <oApp> [<clauses>]

#xtranslate   DCAPPFIELD <fld> := <exp> INTO <oApp> [<clauses,...>] => ;
             _DCAPPFIELD <fld> INTO <oApp> EXPR <exp> [<clauses>]

#define _DCAPPEDIT_CH

#include "App.ch"
#include "Natmsg.ch"

#endif

