/*
 ķ
   Program..: DCCOLOR.CH                            
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-1995 
   Date.....: Feb 27, 1995                          
   Notes....: dCLIP 4.0 Color system definitions    
 Ľ
*/


// dCLIP Color Manifest Symbols
#define  cC_DOTPROMPT dCCOLOR[dCCOLOR[1]+1,1]   // Main dot-prompt
#define  cC_BRMENUF   dCCOLOR[dCCOLOR[1]+1,2]   // Browse menus frame
#define  cC_BRMENUD   dCCOLOR[dCCOLOR[1]+1,3]   // Browse menus data
#define  cC_BRMENUH   dCCOLOR[dCCOLOR[1]+1,4]   // Browse menus header
#define  cC_BRMENUB   dCCOLOR[dCCOLOR[1]+1,5]   // Browse menus menu bar
#define  cC_BRMENUS   dCCOLOR[dCCOLOR[1]+1,6]   // Browse menus select bar
#define  cC_POPMENF   dCCOLOR[dCCOLOR[1]+1,7]   // Popup / pulldown menu frames
#define  cC_POPMENI   dCCOLOR[dCCOLOR[1]+1,8]   // Popup / pulldown menu items
#define  cC_POPMENS   dCCOLOR[dCCOLOR[1]+1,9]   // Popup / pulldown menu select bars
#define  cC_MEMOBOX   dCCOLOR[dCCOLOR[1]+1,10]  // All memos box
#define  cC_MEMOTXT   dCCOLOR[dCCOLOR[1]+1,11]  // All memos contents
#define  cC_EXPBOXF   dCCOLOR[dCCOLOR[1]+1,12]  // Exploding boxes frame
#define  cC_EXPBOXC   dCCOLOR[dCCOLOR[1]+1,13]  // Exploding boxes contents
#define  cC_DBUGGER   dCCOLOR[dCCOLOR[1]+1,14]  // DBUGGER main screen
#define  cC_WARNBOX   dCCOLOR[dCCOLOR[1]+1,15]  // Warning boxes frame
#define  cC_WARNTXT   dCCOLOR[dCCOLOR[1]+1,16]  // Warning boxes contents
#define  cC_DBUGBOX   dCCOLOR[dCCOLOR[1]+1,17]  // Debug boxes frames
#define  cC_DBUGTXT   dCCOLOR[dCCOLOR[1]+1,18]  // Debug boxes contents
#define  cC_DBUGBAR   dCCOLOR[dCCOLOR[1]+1,19]  // Debug boxes select bar
#define  cC_SPECIAL   dCCOLOR[dCCOLOR[1]+1,20]  // Special codes
#define  cC_SAY       dCCOLOR[dCCOLOR[1]+1,21]  // SAYs
#define  cC_PENDGET   dCCOLOR[dCCOLOR[1]+1,22]  // Pending GETs
#define  cC_CURRGET   dCCOLOR[dCCOLOR[1]+1,23]  // Current GET
#define  cC_STAT1     dCCOLOR[dCCOLOR[1]+1,24]  // Dot-prompt status line / lines
#define  cC_STAT2     dCCOLOR[dCCOLOR[1]+1,25]  // Dot-prompt status line / data
#define  cC_POPGRAY   dCCOLOR[dCCOLOR[1]+1,26]  // Pop-up menus gray items
#define  cC_MEMOEDIT  dCCOLOR[dCCOLOR[1]+1,27]  // All memos (edit mode)
#define  cC_MEMOMENU  dCCOLOR[dCCOLOR[1]+1,28]  // All memos (menu bar)
#define  cC_MEMOHILIT dCCOLOR[dCCOLOR[1]+1,29]  // All memos (menu bar hilite)
#define  cC_BUTTON    dCCOLOR[dCCOLOR[1]+1,30]  // Get Box Buttons
#define  cC_BRMENUKU  dCCOLOR[dCCOLOR[1]+1,31]  // Browse Unselected key
#define  cC_BRMENUKS  dCCOLOR[dCCOLOR[1]+1,32]  // Browse Selected key
#define  cC_PROGRESS  dCCOLOR[dCCOLOR[1]+1,33]  // Progress Bars
#define  lC_BLINKBIT  dCCOLOR[dCCOLOR[1]+1,34]  // Blink-bit or High Intensity
#define  cC_SETNAME   dCCOLOR[dCCOLOR[1]+1,35]  // Name of this color set

#define  cC_COLORNAME 35           // Numeric value of cC_SETNAME
#define  nC_COLORPAL  dCCOLOR[1]


// dCLIP Color Manifest Constants
// Usage: DC_COLOR( nC_MEMOBOX ) // set color to memo box color

#define  nC_DOTPROMPT 1   // Main dot-prompt
#define  nC_BRMENUF   2   // Browse menus frame
#define  nC_BRMENUD   3   // Browse menus data
#define  nC_BRMENUH   4   // Browse menus header
#define  nC_BRMENUB   5   // Browse menus menu bar
#define  nC_BRMENUS   6   // Browse menus select bar
#define  nC_POPMENF   7   // Popup / pulldown menu frames
#define  nC_POPMENI   8   // Popup / pulldown menu items
#define  nC_POPMENS   9   // Popup / pulldown menu select bars
#define  nC_MEMOBOX   10  // All memos box
#define  nC_MEMOTXT   11  // All memos contents
#define  nC_EXPBOXF   12  // Exploding boxes frame
#define  nC_EXPBOXC   13  // Exploding boxes contents
#define  nC_DBUGGER   14  // DBUGGER main screen
#define  nC_WARNBOX   15  // Warning boxes frame
#define  nC_WARNTXT   16  // Warning boxes contents
#define  nC_DBUGBOX   17  // Debug boxes frames
#define  nC_DBUGTXT   18  // Debug boxes contents
#define  nC_DBUGBAR   19  // Debug boxes select bar
#define  nC_SPECIAL   20  // Special codes
#define  nC_SAY       21  // SAYs
#define  nC_PENDGET   22  // Pending GETs
#define  nC_CURRGET   23  // Current GET
#define  nC_STAT1     24  // Dot-prompt status line / lines
#define  nC_STAT2     25  // Dot-prompt status line / data
#define  nC_POPGRAY   26  // Pop-up menus gray-items
#define  nC_MEMOEDIT  27  // All memos (edit screen)
#define  nC_MEMOMENU  28  // All memos (menu bar)
#define  nC_MEMOHILIT 29  // All memos (hilite color)
#define  nC_BUTTON    30  // Get box buttons
#define  nC_BRMENUKU  31  // Browse Unselected key
#define  nC_BRMENUKS  32  // Browse Selected key
#define  nC_PROGRESS  33  // Progress Bar
#define  nC_BLINKBIT  34  // Blink-bit or High Intensity
#define  nC_SETNAME   35  // Name of this color set
#define  nC_SAYGETS   100  // Standard foreground/background for SAYS..GETS


// DCCOLOR.INI Defines

#define  cINI_DOTPROMPT   'MainDotPrompt'  // Main dot-prompt
#define  cINI_BRMENUF     'BrowseFrame'    // Browse menus frame
#define  cINI_BRMENUD     'BrowseData'     // Browse menus data
#define  cINI_BRMENUH     'BrowseHeader'   // Browse menus header
#define  cINI_BRMENUB     'BrowseMenu'     // Browse menus menu bar
#define  cINI_BRMENUS     'BrowseSelect'   // Browse menus select bar
#define  cINI_POPMENF     'MenuFrame'      // Popup / pulldown menu frames
#define  cINI_POPMENI     'MenuItems'      // Popup / pulldown menu items
#define  cINI_POPMENS     'MenuSelect'     // Popup / pulldown menu select bars
#define  cINI_MEMOBOX     'MemoFrame'      // All memos box
#define  cINI_MEMOTXT     'MemoDispMode'   // All memos contents
#define  cINI_EXPBOXF     'DialogBoxFrame' // Exploding boxes frame
#define  cINI_EXPBOXC     'DialogBoxCont'  // Exploding boxes contents
#define  cINI_DBUGGER     'DebugDotPrompt' // DBUGGER main screen
#define  cINI_WARNBOX     'WarnBoxFrame'   // Warning boxes frame
#define  cINI_WARNTXT     'WarnBoxCont'    // Warning boxes contents
#define  cINI_DBUGBOX     'DebugBoxFrame'  // Debug boxes frames
#define  cINI_DBUGTXT     'DebugBoxCont'   // Debug boxes contents
#define  cINI_DBUGBAR     'DebugBoxSelect' // Debug boxes select bar
#define  cINI_SAY         'Says'           // SAYs
#define  cINI_PENDGET     'PendingGets'    // Pending GETs
#define  cINI_CURRGET     'CurrentGet'     // Current GET
#define  cINI_STAT1       'DotStatusLine'  // Dot-prompt status line / lines
#define  cINI_STAT2       'DotStatusData'  // Dot-prompt status line / data
#define  cINI_POPGRAY     'MenuGrayItem'   // Pop-up menus gray-items
#define  cINI_MEMOEDIT    'MemoEditMode'   // All memos (edit screen)
#define  cINI_MEMOMENU    'MemoMenu'       // All memos (menu bar)
#define  cINI_MEMOHILIT   'MemoMenuHilite' // All memos (hilite color)
#define  cINI_BUTTON      'DialogBoxButton' // Get box buttons
#define  cINI_BRMENUKU    'BrowseUnselKey'  // Browse Unselected key
#define  cINI_BRMENUKS    'BrowseSelKey'    // Browse Selected key
#define  cINI_PROGRESS    'ProgressBar'     // Progress Bars
#define  cINI_BLINKBIT    'BlinkBit'        // Blink-bit or High Intensity
#define  cINI_SETNAME     'ColorSetName'    // Name of this color set


