/*
   Program..: DCDIR.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1998
   Date.....: Apr 2, 1998
   Notes....: Special DIR Dialog commands for dCLIP++ / eXpress++
*/

#include "dcdialog.ch"

#command @ <nRow>, <nCol> DCDIRTREE                                         ;
              [ DIRS <oDirs> [VAR <cDirVar>] [DATALINK <bDirLink>] ]        ;
              [ FILES <oFiles> [ VAR <cFileVar> ] [DATALINK <bFileLink>] ]  ;
              [ PARENT <oParent> ]                                          ;
              [ EXT <ExtList,...> ]                                         ;
              [ AEXT <aExtList> ]                                           ;
              [ COLOR <fgC> [, <bgC> ] ]                                    ;
              [ FONT <(font)> ]                                             ;
              [ SIZE <nWidth> [, <nHeight> ] ]                              ;
              [ DIRSIZE <nDirWidth> [, <nDirHeight>] ]                      ;
              [ DIRPOS <nDirCol>, <nDirRow> ]                               ;
              [ FILESIZE <nFileWidth> [, <nFileHeight> ] ]                  ;
              [ FILEPOS <nFileCol>, <nFileRow> ]                            ;
              [ AVAILDRIVES <cAvailDrives> ]                                ;
              [ ALIGN <nAlign> ]                                            ;
              [ TITLE <title> ]                                             ;
              [ EVAL <bEval> ]                                              ;
              [ WHEN <bWhen> ]                                              ;
              [ HIDE <bHide> ]                                              ;
              [ TITLE <cTitle> ]                                            ;
              [ RELATIVE <oRel> ]                                           ;
              [ ID <cId> ]                                                  ;
              [ GOTFOCUS <bGotFocus> ]                                      ;
              [ LOSTFOCUS <bLostFocus> ]                                    ;
              [ <lTabStop:TABSTOP> ]                                        ;
              [ <lNoTabStop:NOTABSTOP> ]                                    ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [ TABGROUP <nTabGroup> ]                                      ;
              [ GROUP <cGroup> ]                                            ;
 =>                                                                         ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_DIRTREE,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <title>,                                  /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<cDirVar>,'C',,,<bDirLink>),                        ;
            <(cDirVar)>,'C',,,<(bDirLink)>}],   /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      [{<ExtList>}] [<aExtList>],               /* xGETLIST_OPTIONS      */ ;
      {<fgC>,<bgC>},                            /* cGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<cFileVar>,'C',,,<bFileLink>),                      ;
            <(cFileVar)>,'C',,,<(bFileLink)>}], /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      {<bEval>,<(bEval)>},                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      [{DC_GetAnchorCB(@<oDirs>,'O'),                                       ;
                       <(oDirs)>,'O'}],         /* aGETLIST_OPTIONS2     */ ;
      [{DC_GetAnchorCB(@<oFiles>,'O'),                                      ;
                       <(oFiles)>,'O'}],        /* aGETLIST_OPTIONS3     */ ;
      [{<nDirWidth>,<nDirHeight>}],             /* aGETLIST_OPTIONS4     */ ;
      [{<nFileWidth>,<nFileHeight>}],           /* aGETLIST_OPTIONS5     */ ;
      [{<nDirCol>,<nDirRow>}],                  /* aGETLIST_OPTIONS6     */ ;
      [{<nFileCol>,<nFileRow>}],                /* aGETLIST_OPTIONS7     */ ;
      [<cAvailDrives>],                         /* aGETLIST_OPTIONS8     */ ;
      nil,                                      /* aGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      {<bGotFocus>,<(bGotFocus)>},              /* bGETLIST_GOTFOCUS     */ ;
      {<bLostFocus>,<(bLostFocus)>},            /* nGETLIST_ACCELKEY     */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
   } )


