/*
   Program..: DCGRA.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1999
   Date.....: Aug 30, 1999
   Notes....: Special GRA Dialog commands for dCLIP++ / eXpress++
*/

#include "dcdialog.ch"

/* ------------------------ */

#command   @ <nRow>,<nCol> DCGRASTRING [<cText>]                            ;
                [FONT <cFont>]                                              ;
                [PICTURE <cPict>]                                           ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [PARENT <oParent>]                                          ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [ROWSPACE <nRowSpace>]                                      ;
                [<p: PIXEL>]                                                ;
                [ATTRIBUTE <aAttr>]                                         ;
                [RELATIVE <oRel>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [<v:VISIBLE>]                                               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_GRASTRING,                        /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      [<cFont>],                                /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      <aAttr>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.>,                                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                         <oRel>,'O'}],          /* bGETLIST_RELATIVE     */ ;
      <nRowSpace>,                              /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      <.v.>,                                    /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
    } )


#command   @ <nSRow>,<nSCol> TO <nERow>,<nECol> DCGRALINE                   ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [PARENT <oParent>]                                          ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [<p: PIXEL>]                                                ;
                [ATTRIBUTE <aAttr>]                                         ;
                [RELATIVE <oRel>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [<v:VISIBLE>]                                               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_GRALINE,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      <nERow>,                                  /* nGETLIST_ENDROW       */ ;
      <nECol>,                                  /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      <aAttr>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.>,                                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                         <oRel>,'O'}],          /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      <.v.>,                                    /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
    } )


#command   @ <nSRow>,<nSCol> TO <nERow>,<nECol> DCGRABOX                    ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [PARENT <oParent>]                                          ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [<p: PIXEL>]                                                ;
                [ATTRIBUTE <aAttr>]                                         ;
                [RELATIVE <oRel>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [GROUP <cGroup>]                                            ;
                [FILL <nFill>]                                              ;
                [HRADIUS <nHrad>]                                           ;
                [VRADIUS <nVrad>]                                           ;
                [<v:VISIBLE>]                                               ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_GRABOX,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      <nERow>,                                  /* nGETLIST_ENDROW       */ ;
      <nECol>,                                  /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      <aAttr>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.>,                                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                         <oRel>,'O'}],          /* bGETLIST_RELATIVE     */ ;
      <nFill>,                                  /* xGETLIST_OPTIONS2     */ ;
      <nHrad>,                                  /* xGETLIST_OPTIONS3     */ ;
      <nVrad>,                                  /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      <.v.>,                                    /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
    } )

#command @ <nRow>,<nCol>  DCGRAPROC <bProc>                                 ;
                [PARENT <oParent>]                                          ;
                [TITLE <cTitle>]                                            ;
                [<p:PIXEL>]                                                 ;
                [ID <cId>]                                                  ;
                [GROUP <cGroup>]                                            ;
                [<v:VISIBLE>]                                               ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_GRAPROC,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.>,                                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      <bProc>,                                  /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      <.v.>,                                    /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
    } )


