/*
   Program..: DCPICK.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-2000
   Date.....: Dec 10, 2000
   Notes....: Special PICKLIST Dialog commands for dCLIP++ / eXpress++
*/

#include "dcdialog.ch"

#command @ <nRow>, <nCol> DCPICKLIST <aPick> LIST <aList>                   ;
              [DATALINK <bLink>]                                            ;
              [PARENT <oParent> ]                                           ;
              [COLOR <fgC> [, <bgC> ] ]                                     ;
              [FONT <(font)> ]                                              ;
              [TOOLTIP <cToolTip> ]                                         ;
              [MESSAGE <cMsg> [INTO <oMsg>]]                                ;
              [CARGO <xCargo>]                                              ;
              [SIZE <nWidth> [, <nHeight>] ]                                ;
              [CAPTION <cLeftCap> [,<cRightCap> ] ]                         ;
              [EVAL <bEval> ]                                               ;
              [WHEN <bWhen>]                                                ;
              [HIDE<bHide>]                                                 ;
              [OBJECT <oObject>]                                            ;
              [ID <cId> ]                                                   ;
              [TITLE <cTitle> ]                                             ;
              [RELATIVE <oRel> ]                                            ;
              [<lIm:IMMEDIATE>]                                             ;
              [<lCopy:COPYITEMS> ]                                          ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [GROUP <cGroup>]                                              ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_PICKLIST,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      {DC_GetAnchorCB(@<aPick>,'A'),<(aPick)>,'A'},                         ;
                                                /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      [{<bLink>,<(bLink)>}],                    /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      [{<cLeftCap>,<cRightCap>,<.lCopy.>,                                   ;
        <.lIm.>}],                              /* xGETLIST_OPTIONS      */ ;
      {<fgC>,<bgC>},                            /* cGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<oMsg>,'O'}]},                  ;
                                                /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <(aPick)>,                                /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<aList>,'A'),<(aList)>,'A'}],                       ;
                                                /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      {<bEval>,<(bEval)>},                      /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* aGETLIST_OPTIONS2     */ ;
      nil,                                      /* aGETLIST_OPTIONS3     */ ;
      nil,                                      /* aGETLIST_OPTIONS4     */ ;
      nil,                                      /* aGETLIST_OPTIONS5     */ ;
      nil,                                      /* aGETLIST_OPTIONS6     */ ;
      nil,                                      /* aGETLIST_OPTIONS7     */ ;
      nil,                                      /* aGETLIST_OPTIONS8     */ ;
      nil,                                      /* aGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
     } )

