/*
   Program..: DCTREE.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1998
   Date.....: Oct 21, 1998
   Notes....: Special TREEVIEW Dialog commands for dCLIP++ / eXpress++
*/

#include "dcdialog.ch"

#command @ <nRow> [, <nCol>] DCTREEARRAY <aArray>                           ;
              [ VAR <xVar> ]                                                ;
              [ CAPTION <cCaption> ]                                        ;
              [ PARENT <oParent> ]                                          ;
              [ COLOR <fgC> [, <bgC> ] ]                                    ;
              [ FONT <(font)> ]                                             ;
              [ DATALINK <bLink> ]                                          ;
              [ SIZE <nWidth> [, <nHeight>] ]                               ;
              [ HIDE <bHide> ]                                              ;
              [ WHEN <bWhen> ]                                              ;
              [ EVAL <bEval> ]                                              ;
              [ PREEVAL <bPreEval> ]                                        ;
              [ RELATIVE <oRel> ]                                           ;
              [ OPTIONS <aOptions> ]                                        ;
              [ OBJECT <oObject> ]                                          ;
              [ ID <cId> ]                                                  ;
              [ TITLE <title> ]                                             ;
              [ <lButtons:HASBUTTONS>]                                      ;
              [ <lLines:HASLINES>]                                          ;
              [ GOTFOCUS <bGotFocus> ]                                      ;
              [ LOSTFOCUS <bLostFocus> ]                                    ;
              [ <lTabStop:TABSTOP> ]                                        ;
              [ <lNoTabStop:NOTABSTOP> ]                                    ;
              [ <lVisible:VISIBLE> ]                                        ;
              [ <lInvisible:INVISIBLE> ]                                    ;
              [ TABGROUP <nTabGroup> ]                                      ;
              [ GROUP <cGroup> ]                                            ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_TREEARRAY,                        /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cCaption>,                               /* cGETLIST_CAPTION      */ ;
      {DC_GetAnchorCB(@<aArray>,'A'),                                       ;
                 <(aArray)>,'A'},               /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.lButtons.>,<.lLines.>},                /* xGETLIST_OPTIONS      */ ;
      {<fgC>,<bgC>},                            /* cGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCb(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<aOptions>,'A'),                                    ;
                 <(aOptions)>,'A'}],            /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      [DC_GetAnchorCB(@<xVar>,,'U',,<bLink>),                               ;
                 <(xVar)>,,'U',,<(bLink)>],     /* aGETLIST_OPTIONS2     */ ;
      nil,                                      /* aGETLIST_OPTIONS3     */ ;
      nil,                                      /* aGETLIST_OPTIONS4     */ ;
      nil,                                      /* aGETLIST_OPTIONS5     */ ;
      nil,                                      /* aGETLIST_OPTIONS6     */ ;
      nil,                                      /* aGETLIST_OPTIONS7     */ ;
      nil,                                      /* aGETLIST_OPTIONS8     */ ;
      nil,                                      /* aGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* nGETLIST_ACCELKEY     */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
     } )


#command @ <nRow> [, <nCol>] DCTREEROOT                                     ;
              [ PARENT <oParent> ]                                          ;
              [ COLOR <fgC> [, <bgC> ] ]                                    ;
              [ FONT <(font)> ]                                             ;
              [ SIZE <nWidth> [, <nHeight>] ]                               ;
              [ HIDE <bHide> ]                                              ;
              [ WHEN <bWhen> ]                                              ;
              [ EVAL <bEval> ]                                              ;
              [ PRESENTATION <aPres> ]                                      ;
              [ PREEVAL <bPreEval> ]                                        ;
              [ RELATIVE <oRel> ]                                           ;
              [ HELPCODE <cHelpCode> ]                                      ;
              [ OBJECT <oObject> ]                                          ;
              [ ID <cId> ]                                                  ;
              [ TOOLTIP <cToolTip> ]                                        ;
              [ TITLE <title> ]                                             ;
              [ <lButtons:HASBUTTONS>]                                      ;
              [ <lLines:HASLINES>]                                          ;
              [ GOTFOCUS <bGotFocus> ]                                      ;
              [ LOSTFOCUS <bLostFocus> ]                                    ;
              [ <lTabStop:TABSTOP> ]                                        ;
              [ <lNoTabStop:NOTABSTOP> ]                                    ;
              [ <lVisible:VISIBLE> ]                                        ;
              [ <lInvisible:INVISIBLE> ]                                    ;
              [ TABGROUP <nTabGroup> ]                                      ;
              [ GROUP <cGroup> ]                                            ;
              [ ITEMCOLLAPSED <bItemCollapsed> ]                            ;
              [ ITEMEXPANDED <bItemExpanded> ]                              ;
              [ ITEMMARKED <bItemMarked> ]                                  ;
              [ ITEMSELECTED <bItemSelected> ]                              ;
 =>                                                                         ;
   AADD( GetList,                                                           ;
    { GETLIST_TREEROOT,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <font>,                                   /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.lButtons.>,<.lLines.>},                /* xGETLIST_OPTIONS      */ ;
      [{<fgC>,<bgC>}],                          /* cGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCb(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* aGETLIST_OPTIONS2     */ ;
      {<{bItemCollapsed}>,<(bItemCollapsed)>},  /* aGETLIST_OPTIONS3     */ ;
      {<{bItemExpanded}>,<(bItemExpanded)>},    /* aGETLIST_OPTIONS4     */ ;
      {<{bItemMarked}>,<(bItemMarked)>},        /* aGETLIST_OPTIONS5     */ ;
      {<{bItemSelected}>,<(bItemSelected)>},    /* aGETLIST_OPTIONS6     */ ;
      nil,                                      /* aGETLIST_OPTIONS7     */ ;
      nil,                                      /* aGETLIST_OPTIONS8     */ ;
      nil,                                      /* aGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<bHide>,<(bHide)>},                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* nGETLIST_ACCELKEY     */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
     } )

* ------------------------------- *

#xcommand  DCTREEITEM                                                       ;
                [CAPTION <cCaption>]                                        ;
                [PARENT <oParent>]                                          ;
                [WHEN <bWhen>]                                              ;
                [PROTECT <bProtect>]                                        ;
                [ACTION <bAction> [<lFirstClick:FIRSTCLICK>] ]              ;
                [HELPCODE <cHelpCode>]                                      ;
                [TOOLTIP <cToolTip>]                                        ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [CARGO <xCargo>]                                            ;
                [ID <cId>]                                                  ;
                [OBJECT <oObject>]                                          ;
                [TITLE <cTitle>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [GROUP <cGroup>]                                            ;
                [IMAGEEXPANDED <nImageExpanded>]                            ;
                [IMAGENORMAL <nImageNormal>]                                ;
                [IMAGEMARKED <nImageMarked>]                                ;
                [DLLNAME <cDllName>]                                        ;
                [LOCK <cLock>]                                              ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_TREEITEM,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cCaption>,                               /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      {<bWhen>,<(bWhen)>},                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      {<bAction>,<(bAction)>},                  /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<cLock>},                                /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<oMsg>,'O'}]},                  ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCb(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      {<bProtect>,<(bProtect)>},                /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      <nImageExpanded>,                         /* xGETLIST_OPTIONS2     */ ;
      <nImageNormal>,                           /* xGETLIST_OPTIONS3     */ ;
      <nImageMarked>,                           /* xGETLIST_OPTIONS4     */ ;
      <cDllName>,                               /* xGETLIST_OPTIONS5     */ ;
      <.lFirstClick.>,                          /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* aGETLIST_OPTIONS7     */ ;
      nil,                                      /* aGETLIST_OPTIONS8     */ ;
      nil,                                      /* aGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )



