/*
   Program..: DCUDC.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1998
   Date.....: Sep 26, 1998
   Notes....: Template for USER-DEFINED COMMANDS for dCLIP++ / eXpress++
*/


#include 'dcdialog.ch'


#define GETLIST_USERCOMMAND   GETLIST_USER + 1

#command  @ <nRow>,<nCol> DCUSERTEMPLATE                                    ;
                [SIZE <nHeight> [,<nWidth>]]                                ;
                [GROUP <oGroup>]                                            ;
                [PARENT <oParent>]                                          ;
                [CAPTION <cCaption>]                                        ;
                [ACTION <bAction>]                                          ;
                [TYPE <nType>]                                              ;
                [FONT <cFont>]                                              ;
                [CURSOR <nCursor>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CARGO <xCargo>]                                            ;
                [PRESENTATION <aPres>]                                      ;
                [MESSAGE <cMsg>]                                            ;
                [TOOLTIP <cToolTip>]                                        ;
                [HELPCODE <cHelpCode>]                                      ;
                [VALID <bValid>]                                            ;
                [WHEN <bWhen>]                                              ;
                [EVAL <bEval>]                                              ;
                [HIDE <bHide>]                                              ;
                [<p :PIXEL>]                                                ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>]                                        ;
                [<lNoTabStop:NOTABSTOP>]                                    ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>]                                        ;
                [<lInvisible:INVISIBLE>]                                    ;
  =>                                                                        ;
   AADD( GetList,                                                           ;
    { GETLIST_USERCOMMAND,                      /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <cCaption>,                               /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      {<{bWhen}>,<(bWhen)>},                    /* bGETLIST_WHEN         */ ;
      {<{bValid}>,<(bValid)>},                  /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      {<bAction>,<(bAction)>},                  /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      <cMsg>,                                   /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oGroup>,'O'),<(oGroup)>},/* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      {|a|MyUserDefinedFunction(a)},            /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      <.p.>,                                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      [{<bEval>,<(bEval)>}],                    /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      {<{bHide}>,<(bHide)>},                    /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      {<{bGotFocus}>,<(bGotFocus)>},            /* bGETLIST_GOTFOCUS     */ ;
      {<{bLostFocus}>,<(bLostFocus)>},          /* nGETLIST_ACCELKEY     */ ;
      [<.lTabStop.>.AND.!<.lNoTabStop.>],       /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      [<.lVisible.>.AND.!<.lInvisible.>],       /* lGETLIST_VISIBLE      */ ;
    } )


