/*

   Program..: EXPRESS.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-1998
   Date.....: Apr 14, 1998
   Notes....: Special Dialog commands for eXpress++

   This command file is for Clipper programmers who wish to use standard @ SAY..GET
   commands.  It is provided for reference only and is not recommended for regular
   use in eXPress++ applications.  The DCDIALOG.CH file is a much more robust
   command language and will not conflict with standard Clipper/Xbase++ commands.

*/

#include 'xbp.ch'

#define   MOUSE_ENTER   97
#define   FORCEVALID    OPTION 101
#define   PICKLIST      OPTION 102
#define   PROTECT       OPTION 106
#define   CAPFIRST      OPTION 107
#define   DOUBLEPICK    OPTION 112
#define   HIDE          OPTION 113
#define   CODEBLOCK     OPTION 114
#define   PICKPOINTER   116

#define   DCGUI_ROW                 -10000
#define   DCGUI_COL                 -10000

/* ------------------- */

#define   SAYRIGHT        SAYOPT XBPSTATIC_TEXT_RIGHT
#define   SAYLEFT         SAYOPT XBPSTATIC_TEXT_LEFT

/* ------------------- */

#define GETLIST_STATIC           1
#define GETLIST_GET              2
#define GETLIST_SAY             12

#define GETLIST_CLICK           100

#define nGETLIST_TYPE            1
#define nGETLIST_SUBTYPE         2
#define cGETLIST_CAPTION         3
#define bGETLIST_VAR             4
#define nGETLIST_STARTROW        5
#define nGETLIST_STARTCOL        6
#define nGETLIST_ENDROW          7
#define nGETLIST_ENDCOL          8
#define nGETLIST_WIDTH           9
#define nGETLIST_HEIGHT         10
#define cGETLIST_FONT           11
#define cGETLIST_PICTURE        12
#define bGETLIST_WHEN           13
#define bGETLIST_VALID          14
#define cGETLIST_TOOLTIP        15
#define xGETLIST_CARGO          16
#define aGETLIST_PRESENTATION   17
#define bGETLIST_ACTION         18
#define oGETLIST_OBJECT         19
#define xGETLIST_ORIGVALUE      20
#define xGETLIST_OPTIONS        21
#define aGETLIST_COLOR          22
#define cGETLIST_MESSAGE        23
#define cGETLIST_HELPCODE       24
#define cGETLIST_VARNAME        25
#define bGETLIST_READVAR        26
#define bGETLIST_DELIMVAR       27
#define bGETLIST_GROUP          28
#define nGETLIST_POINTER        29
#define bGETLIST_PARENT         30
#define bGETLIST_OUTVAR         31
#define lGETLIST_READONLY       32
#define lGETLIST_PIXEL          33
#define nGETLIST_CURSOR         34
#define bGETLIST_EVAL           35
#define bGETLIST_RELATIVE       36
#define xGETLIST_OPTIONS2       37
#define xGETLIST_OPTIONS3       38
#define xGETLIST_OPTIONS4       39
#define xGETLIST_OPTIONS5       40
#define xGETLIST_OPTIONS6       41
#define xGETLIST_OPTIONS7       42
#define xGETLIST_OPTIONS8       43
#define xGETLIST_OPTIONS9       44
#define cGETLIST_LEVEL          45
#define cGETLIST_TITLE          46
#define cGETLIST_ACCESS         47
#define bGETLIST_COMPILE        48
#define cGETLIST_ID             49
#define dGETLIST_REVDATE        50
#define cGETLIST_REVTIME        51
#define cGETLIST_REVUSER        52

#define nGET_ARRAY_SIZE         52

#define cGETOPT_NAME            1
#define cGETOPT_TITLE           2
#define nGETOPT_WNDHEIGHT       3
#define nGETOPT_WNDWIDTH        4
#define nGETOPT_ROWSPACE        5
#define nGETOPT_SAYWIDTH        6
#define oGETOPT_SAYFONT         7
#define oGETOPT_GETFONT         8
#define nGETOPT_GETHEIGHT       9
#define aGETOPT_BUTTONS        10
#define nGETOPT_WNDROW         11
#define nGETOPT_WNDCOL         12
#define nGETOPT_ROWOFFSET      13
#define nGETOPT_COLOFFSET      14
#define lGETOPT_DESIGN         15
#define cGETOPT_MENU           16
#define lGETOPT_PIXEL          17
#define oGETOPT_PARENT         18
#define nGETOPT_ICON           19
#define lGETOPT_CHECKGET       20
#define cGETOPT_HELPFILE       21
#define lGETOPT_VISIBLE        22
#define lGETOPT_TRANSLATE      23
#define lGETOPT_SAYRIGHT       24
#define nGETOPT_BITMAP         25

#define nGETOPT_ARRAY_SIZE     25

/* ------------------------------- */

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
     <uVar1> := IIF(Valtype(<uVar1>)==Valtype(<uVal1>),<uVar1>,<uVal1>) ;;
   [ <uVarN> := IIF(Valtype(<uVarN>)==Valtype(<uValN>),<uVarN>,<uValN>); ]


/* ------------------------------- */

#command  @ <nRow>,<nCol> SAY <cText>                                       ;
                [PICTURE <cPict>]                                           ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [SAYSIZE <nSayWidth> [,<nSayHeight>]]                       ;
  =>                                                                        ;
   AADD( GetList,                                                           ;
    { GETLIST_SAY,                              /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_TEXT,                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nSayWidth>,                              /* nGETLIST_WIDTH        */ ;
      <nSayHeight>,                             /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
    } )

/* ------------------------------- */

#command  @ <nSayRow>,<nSayCol> SAY <cText> GET <uVar>                      ;
                [SAYCOLOR <ncSayFgC>,[<ncSayBgC>] ]                         ;
                [GETCOLOR <ncGetFgC>,[<ncGetBgC>] ]                         ;
                [SAYSIZE <nSayWidth> [,<nSayHeight>]]                       ;
                [GETSIZE <nGetWidth> [,<nGetHeight>]]                       ;
                [VALID <bValid>]                                            ;
                [PICTURE <cPict>]                                           ;
                [WHEN <bWhen>]                                              ;
  =>                                                                        ;
   AADD( GetList,                                                           ;
    { GETLIST_SAY,                              /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_TEXT,                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSayRow>,                                /* nGETLIST_STARTROW     */ ;
      <nSayCol>,                                /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nSayWidth>,                              /* nGETLIST_WIDTH        */ ;
      <nSayHeight>,                             /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncSayFgC>,<ncSayBgC>}],                /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
     } )                                                                    ;
   ; AADD( GetList,                                                         ;
    { GETLIST_GET,                              /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      {DC_GetAnchorCB(@<uVar>,,,<cPict>),                                   ;
                 <(uVar)>,,,<cPict>},           /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nGetWidth>,                              /* nGETLIST_WIDTH        */ ;
      <nGetHeight>,                             /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <{bWhen}>,                                /* bGETLIST_WHEN         */ ;
      <{bValid}>,                               /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncGetFgC>,<ncGetBgC>}],                /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      LEN(GetList),                             /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
    } )                                                                      ;

/* ------------------------------- */

#command  @ <nRow>,<nCol> GET <uVar>                                        ;
                [COLOR <ncFgC>,[<ncBgC>] ]                                  ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [VALID <bValid>]                                            ;
                [PICTURE <cPict>]                                           ;
                [WHEN <bWhen>]                                              ;
  =>                                                                        ;
  AADD( GetList,                                                            ;
    { GETLIST_GET,                              /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      {DC_GetAnchorCB(@<uVar>,,,<cPict>),                                   ;
                <(uVar)>,,,<cPict>},            /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <{bWhen}>,                                /* bGETLIST_WHEN         */ ;
      <{bValid}>,                               /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      LEN(GetList),                             /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      {DC_GetAnchorCB(@<uVar>,,<uVar>),                                     ;
                              <(uVar)>},        /* bGETLIST_OUTVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
    } )                                                                      ;

#command DCGETOPTIONS                                                       ;
                [ NAME <cName>]                                             ;
                [ TITLE <cTitle>]                                           ;
                [ WINDOWHEIGHT <nWndHeight>]                                ;
                [ WINDOWWIDTH <nWndWidth>]                                  ;
                [ ROWSPACE <nRowSpace>]                                     ;
                [ SAYFONT <cSayFont>]                                       ;
                [ SAYWIDTH <nSayWidth>]                                     ;
                [ SAYHEIGHT <nSayHeight>]                                   ;
                [ GETHEIGHT <nGetHeight>]                                   ;
                [ GETFONT <cGetFont>]                                       ;
                [ WINDOWROW <nWindowRow>]                                   ;
                [ WINDOWCOL <nWindowCol>]                                   ;
                [ ROWOFFSET <nRowOffset>]                                   ;
                [ COLOFFSET <nColOffset>]                                   ;
                [ <lDesign:DESIGN>]                                         ;
                [ <lPixel:PIXEL>]                                           ;
                [ MENU <cMenu> ]                                            ;
                [ BUTTONS <aButtons>]                                       ;
                [ PARENT <oParent>]                                         ;
                [ ICON <nIcon>]                                             ;
                [ <lCheckGet:CHECKGET>]                                     ;
                [ HELPFILE <cHelpFile>]                                     ;
                [ <lVisible:VISIBLE>]                                       ;
                [ <lNoTrans:NOTRANSLATE>]                                   ;
                [ <lSayRight:SAYRIGHTJUST> ]                                ;
                [ BITMAP <nBitMap> ]                                        ;
                [ PRESENTATION <aPres> ]                                    ;
                [ COLOR <nBGColor> ]                                        ;
                [ SAYOPTIONS <nSayOpt> ]                                    ;
                [ EVAL <bEval> ]                                            ;
                [ MODALSTATE <nModalState> ]                                ;
                [ <lNoMin:NOMINBUTTON> ]                                    ;
                [ <lNoMax:NOMAXBUTTON> ]                                    ;
  =>                                                                        ;
   GetOptions :=                                                            ;
     { <cName>,                               /* cGETOPT_NAME      */       ;
       <cTitle>,                              /* cGETOPT_TITLE     */       ;
       <nWndHeight>,                          /* nGETOPT_WNDHEIGHT */       ;
       <nWndWidth>,                           /* nGETOPT_WNDWIDTH  */       ;
       <nRowSpace>,                           /* nGETOPT_ROWSPACE  */       ;
       <nSayWidth>,                           /* nGETOPT_SAYWIDTH  */       ;
       <cSayFont>,                            /* cGETOPT_SAYFONT   */       ;
       <cGetFont>,                            /* cGETOPT_GETFONT   */       ;
       <nGetHeight>,                          /* nGETOPT_GETHEIGHT */       ;
       <aButtons>,                            /* aGETOPT_BUTTONS   */       ;
       <nWindowRow>,                          /* nGETOPT_WNDROW    */       ;
       <nWindowCol>,                          /* nGETOPT_WNDCOL    */       ;
       <nRowOffset>,                          /* nGETOPT_ROWOFFSET */       ;
       <nColOffset>,                          /* nGETOPT_COLOFFSET */       ;
       IIF(<.lDesign.>,.t.,nil),              /* lGETOPT_DESIGN    */       ;
       <cMenu>,                               /* cGETOPT_MENU      */       ;
       <.lPixel.>,                            /* lGETOPT_PIXEL     */       ;
       <oParent>,                             /* oGETOPT_PARENT    */       ;
       <nIcon>,                               /* nGETOPT_ICON      */       ;
       <.lCheckGet.>,                         /* lGETOPT_CHECKGET  */       ;
       <cHelpFile>,                           /* cGETOPT_HELPFILE  */       ;
       <.lVisible.>,                          /* lGETOPT_VISIBLE   */       ;
       !<.lNoTrans.>,                         /* lGETOPT_TRANSLATE */       ;
       <.lSayRight.>,                         /* lGETOPT_SAYRIGHT  */       ;
       <nBitMap>,                             /* nGETOPT_BITMAP    */       ;
       <aPres>,                               /* aGETOPT_PRESENT   */       ;
       <nBGColor>,                            /* aGETOPT_BGCOLOR   */       ;
       <nSayOpt>,                             /* nGETOPT_SAYOPT    */       ;
       <bEval>,                               /* bGETOPT_EVAL      */       ;
       <nModalState>,                         /* nGETOPT_MODALSTATE*/       ;
       <nSayHeight>,                          /* nGETOPT_SAYHEIGHT */       ;
       !<.lNoMin.>,                           /* lGETOPT_MINBUTTON */       ;
       !<.lNoMax.>                            /* lGETOPT_MAXBUTTON */       ;
       }


#xtrans  DCGET OPTIONS               ;
         [WINDOW HEIGHT <WH>]        ;
         [WINDOW WIDTH <WW>]         ;
         [WINDOW ROW <WR>]           ;
         [WINDOW COL <WC>]           ;
         [<clauses,...>]             ;
                               =>    ;
         DCGETOPTIONS                ;
         [WINDOWHEIGHT <WH>]         ;
         [WINDOWWIDTH <WW>]          ;
         [WINDOWROW <WR>]            ;
         [WINDOWCOL <WC>]            ;
         [<clauses>]

/* ------------------------------- */

#command  @ <nRow>, <nCol> PROMPT <prompt> [MESSAGE <message>]         ;
                           [ID <menuid>] [ACTION <action>]             ;
      =>  DC_AtPrompt(<nRow>, <nCol>, <prompt>, promptList, <message>, ;
                      <menuid>, <action> )

#command  MENU TO <var> [<notrim:NOTRIM>] [MSGFONT <msgfont>] ;
          [MSGPOS <row>,<col>]  [<center:MSGCENTER>] [TITLE <title>]
      =>  <var> := DC_MenuTo(@PromptList, <var>, UPPER(#<var>), <title>, ;
                   {<row>,<col>,<.center.>,<msgfont>}, !<.notrim.>)

/* ------------------------------- */

#xtranslate AChoice( <a>,<b>,<c>,<d>,<e> [,<f>] [,<g>] [,<h>] [,<i>] ) => ;
            DC_Achoice(<a>,<b>,<c>,<d>,<e>,<f>,<g>,<h>,<i>)

/* ------------------------------- */

#xtranslate DBedit( <a> ,<b> ,<c> ,<d> [,<e>] [,<f>] [,<g>] [,<h>] [,<i>] [,<j>] [,<k>] [,<l>] ) => ;
            DC_DbEdit(<a>,<b>,<c>,<d>,<e>,<f>,<g>,<h>,<i>,<j>,<k>,<l>)

#xtranslate DBedit() => DC_DbEdit()

/* ------------------------------- */

#xtranslate Alert( <a>[,<b>][,<c>][,<d>][,<e>] ) => ;
            DC_Alert( <a>,<b>,<c>,<d>,<e>)

/* ------------------------------- */

#xtranslate MemoEdit( <a>, <b>, <c>, <d> ,<e> [,<f>] [,<g>] [,<h>] [,<i>] [,<j>] [,<k>] [,<l>] [,<m>] ) => ;
            DC_MemoEdit(<a>,<b>,<c>,<d>,<e>,<f>,<g>,<h>,<i>,<j>,<k>,<l>,<m>)

#xtranslate MemoEdit( <a> ) => DC_MemoEdit( <a> )

#xtranslate MemoEdit() => DC_MemoEdit()

/* ------------------------------- */

#xtranslate SetColor( <a>[,<b>][,<c>][,<d>]) => DC_SetColor( <a>,<b>,<c>,<d> )

/* ------------------------------- */

#command @ <nSRow>, <nSCol>, <nERow>, <nECol> DCEXPLODE <aScreen>        ;
         [COLOR <cFrame>, <cText>] [FONT <cFont>] [TITLE <cTitle>]      ;
         [<fixed:FIXED>]                                                ;
  =>                                                                    ;
  <aScreen> := DC_Expl( <nSRow>, <nSCol>, <nERow>, <nECol>, <cTitle>,   ;
               nil, nil, nil, !<.fixed.>, <cFont> )

/* ------------------------------- */

#command @ <nRow>, <nCol> SAYWIN <cText> [PARENT <aParent>] [FONT <cFont>] ;
         [COLOR <cColor>] [<ok:OK>]                                     ;
  =>                                                                    ;
   DC_Say( <aParent>, <nRow>, <nCol>, <cText>, <cFont>, <.ok.>, <cColor> )

/* ------------------------------- */

#command DCIMPLODE [<aScreen>]  =>  DC_Impl( <aScreen> )

/* ------------------------------- */

#command WAIT [<cMsg>] => DC_Wait(<cMsg>)

/* ------------------------------- */

/*
#command CLS [<aParent>] => DC_Cls(<aParent>)
*/

#command  CLS ;
      =>  DC_Scroll() ; DC_SetPos(0,0)

#command  CLEAR SCREEN ;
      =>  DC_Scroll() ; DC_SetPos(0,0)

#command  @ <nT>, <nL> ;
      =>  DC_Scroll(<nT>, <nL>, <nT>) ; DC_SetPos(<nT>, <nL>)

#command  @ <nT>, <nL> CLEAR ;
      =>  DC_Scroll(<nT>, <nL>) ; DC_SetPos(<nT>, <nL>)

#command  @ <nT>, <nL> CLEAR TO <nB>, <nR> ;
      =>  DC_Scroll(<nT>, <nL>, <nB>, <nR>) ; DC_SetPos(<nT>, <nL>)

#command  @ <nT>, <nL>, <nB>, <nR> BOX <cBox> [COLOR <Color>] ;
      =>  DC_DispBox(<nT>, <nL>, <nB>, <nR>, <cBox> [,<Color>])

#command  @ <nT>, <nL> TO <nB>, <nR> [DOUBLE] [COLOR <Color>] ;
      =>  DC_DispBox(<nT>, <nL>, <nB>, <nR>, 2 [,<Color>])

#command  @ <nT>, <nL> TO <nB>, <nR> [COLOR <Color>] ;
      =>  DC_DispBox(<nT>, <nL>, <nB>, <nR>, 1 [,<Color>])

*******************************************************************************
* Commands: SAVE / RESTORE SCREEN
*******************************************************************************

#command  SAVE SCREEN     =>  _DCXSaveScreen()
#command  RESTORE SCREEN  =>  _DCXRestScreen()

#command  SAVE SCREEN TO <screen> ;
      =>  <screen> := DC_SaveScreen(0, 0, DC_Maxrow(), DC_Maxcol())

#command  RESTORE SCREEN FROM <screen> ;
      =>  DC_RestScreen(0, 0, DC_Maxrow(), DC_Maxcol(), <screen>)

*******************************************************************************
* Commands for keyboard input
*******************************************************************************

#command  WAIT <cInput> ;
      =>  DC_Wait(<cInput>)

#command  WAIT [<cInput>] TO <var> ;
      =>  <var> := DC_Wait(<cInput>)

#command  WAIT ;
      =>  DC_Wait("Press any key to continue...")

#command READ SAVE          => DC_ReadGets(getList)

#command READ               => DC_ReadGets(getList) ; getList := {}

#command CLEAR GETS         => DC_ReadKill(.T.) ; getList := {}

#command GUI ON => DC_Gui(.t.)

#command GUI OFF => DC_Gui(.f.)

