* File: KL_MLE.ch
* Author..: Ken Levitt
* Copyright 2000,  Informed Computer Solutions, Inc.
*                  9 Linn Lane, Wayland, MA 01778
* Notes...: Definitions needed for KL_MLE usage.

#ifndef  _KL_MLE_CH         // KL_MLE.ch is not included

//     Note:  If you do NOT have the Alaska Tools library available,
//            comment out the 'REQUEST' line below.
//            This will cause slightly slower performance in spell checking.

// REQUEST Token, AtToken, NumToken, AtNum

//     The following are array offsets for KL_MLE:aOptions.
//     See the README.TXT file for their usage

   #define  KL_MLE_MainDict     1    // Path & file name of main dict
                                     // (KL_Spell.dic)
   #define  KL_MLE_AddOnDict    2    // Path & file name of add on dict
                                     // (Added.dic)
   #define  KL_MLE_SuggestFont  3    // CompoundName Font for suggestion box
                                     // (Depends on screen resolution)
   #define  KL_MLE_aBoxPos      4    // Position array for position of
   #define  KL_MLE_SpellBoxPos  4    // suggestion box relative to AppDeskTop()
                                     //
   #define  KL_MLE_ShortSpell   5    // Shortcut key to start spell check
                                     // xbeK_CTRL_Q
   #define  KL_MLE_DelWordKey   6    // Key for delete word (xbeK_CTRL_BS)
   #define  KL_MLE_DelWordFun   7    // Function for delete word (xbeK_F8)
   #define  KL_MLE_DelLineKey   8    // Key for delete line (xbeK_ALT_K)
   #define  KL_MLE_DelLineFun   9    // Function for delete line (xbeK_F7)
   #define  KL_MLE_PrtFont     10    // Compound font name for printing
   #define  KL_MLE_PrtTopMar   11    // Top margin for printing
   #define  KL_MLE_PrtLeftMar  12    // Left margin for printing
   #define  KL_MLE_PrtBotMar   13    // Bottom margin for printing

//    Defines for Find/Replace
   #Define  KL_MLE_WordDelimiters  14  // String of all characters which
                                       // delimit words for find operations.
   #define  KL_MLE_FindHighlight   15  // Default to highlight found word (.T.)
   #define  KL_MLE_MatchCase       16  // Match exact case on searches (.F.)
   #define  KL_MLE_RememberFind    17  // Remember last Find/Repl strings (.T.)


//    *** SearchWrap is NOT working, do NOT set this parameter!!!
   #define  KL_MLE_SearchWrap      18  // If search reaches bottom of MLE with
                                       // no match will it wrap back to top
                                       // until reaching starting point (.T.)


   #define  KL_MLE_FindBoxPos      19  // Position array for Find/Replace box
                                       // relative to AppDeskTop()

   #define  KL_MLE_ArraySize   19

//   Return codes from dictionary utility routines

   #define  KL_RTN_Success      0    // Operation sucessful
   #define  KL_RTN_Fail         1    // Unspecified failure
   #define  KL_RTN_MainNotFound 2    // Specified main dictionary not found
   #define  KL_RTN_TextNotFound 3    // Specified text file or user dictionary
                                     //     was not found
   #define  KL_RTN_MainError    4    // Error opening main dictionary
   #define  KL_RTN_TextError    5    // Error opening text file or user dict.
   #define  KL_RTN_MainExists   6    // Can't create new main dictionary, file
                                     //     already exists
   #define  KL_RTN_NoWords      7    // Requested delete words were not found
                                     //     in main dictionary
   #define  KL_RTN_NotAll      10    // Some of the requested delete words
                                     //     were not found

   #define _KL_MLE_CH
#endif

* ---------------------------------------------------------------------------
* ---------------------------------------------------------------------------

