/*
 ķ
   Program..: ADS.PRG                                          
   Author...: Roger J. Donnay                                  
   Notice...: (c) DONNAY Software Designs 1987-2001            
   Date.....: Sep 14, 2001                                     
   Notes....: eXPress Sample Program for ADSDBE                
 Ľ
*/


#include "dcdialog.ch"
#include "dmlb.ch"

#pragma Library("ADAC20B.LIB")
#pragma Library("DCLIPADS.LIB")

// Return types of ADSDBE_TBL_MODE
#define ADSDBE_NTX 1
#define ADSDBE_CDX 2


// Return types of ADSDBE_LOCK_MODE
#define ADSDBE_COMPATIBLE_LOCKING  0
#define ADSDBE_PROPRIETARY_LOCKING 1

// ADSDBE generics - use them to specify default
// behaviour of the database engine. (DbeInfo)
//
#define ADSDBE_MEMOFILE_EXT    (DBE_USER+1) // RO
#define ADSDBE_INDEX_EXT       (DBE_USER+2) // RW
#define ADSDBE_TBL_MODE        (DBE_USER+3) // RW
#define ADSDBE_LOCK_MODE       (DBE_USER+4) // RW
#define ADSDBE_RIGHTS_MODE     (DBE_USER+5) // RW
#define ADSDBE_MEMOBLOCKSIZE   (DBE_USER+6) // RW
#define ADSDBE_PASSWORD        (DBE_USER+7) // RW



FUNCTION Main( cServer )

LOCAL GetList[0], oBrowse, oAdsSession, cSession, lAIS := .f.

IF ! DbeLoad( "ADSDBE" )
  DC_WinAlert( "Unable to load ADSDBE", "ADS Server",, ;
                XBPMB_WARNING + XBPMB_APPMODAL )

  QUIT
ENDIF

DEFAULT cServer := CurDrive() + ':'

cServer := Upper(cServer)

IF cServer == 'AIS'
  cServer := '\\webserver'
  lAIS := .t.
  COPY FILE ADS.2 TO ADS.INI
ELSE
  COPY FILE ADS.1 TO ADS.INI
ENDIF

DC_Pause(1)

cSession := "DBE=ADSDBE;SERVER=" + cServer

oAdsSession := DacSession():new(cSession)

/*
IF !oAdsSession:isConnected()
  DC_WinAlert( "Unable to establish connection to ADS Server" + Chr(13) + ;
               "Error Code: " + Alltrim(Str(oAdsSession:getLastError())) + Chr(13) + ;
               oAdsSession:getLastMessage() )
  QUIT
ENDIF
*/

dbeSetDefault('ADSDBE')
DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADSDBE_CDX )
DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADSDBE_CDX )
DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ADSDBE_COMPATIBLE_LOCKING  )

IF lAIS
  USE \\webserver\f$\data\xtest INDEX \\webserver\f$\data\xtest
ELSE
  USE ..\..\DATA\xtest INDEX ..\..\DATA\xtest
ENDIF

@ 0,0 DCBROWSE oBrowse ALIAS 'XTEST' SIZE 60,20 FIT ;
      PRESENTATION DC_BrowPres()

DCBROWSECOL FIELD XTEST->areacode HEADER 'Area Code' PARENT oBrowse WIDTH 8
DCBROWSECOL FIELD XTEST->exchange HEADER 'Exchange' PARENT oBrowse WIDTH 8
DCBROWSECOL FIELD XTEST->city HEADER 'City' PARENT oBrowse WIDTH 20

DCREAD GUI FIT ADDBUTTONS TITLE 'ADSDBE Test'

oAdsSession:disconnect()

RETURN nil

* -------------

PROC appsys
RETURN
