// FTP Client

#include "common.ch"
#include "fileio.ch"
#include "dcdialog.ch"

#define CRLF Chr(13)+Chr(10)

#pragma Library("ASINET1c.LIB")
#pragma Library("ASINET10.LIB")

* ------------------

PROCEDURE Main( cAction )

LOCAL GetList[0], GetOptions, cFTPServer := Space(50), cUserID := Space(20), ;
      cPassWord := Space(20), cRemoteFile := Space(50), cLocalFile := Space(50)

@ 1,0 DCSAY 'FTP Host' GET cFTPServer
@ 2,0 DCSAY 'User Name' GET cUserID
@ 3,0 DCSAY 'Password' GET cPassword PASSWORD
@ 4,0 DCSAY 'Local File' GET cLocalFile POPUP {|c|DC_PopFile(c)}
@ 5,0 DCSAY 'Remote File' GET cRemoteFile

@ 7,0 DCPUSHBUTTON CAPTION 'Exit' SIZE 10,1.2 ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 7,12 DCPUSHBUTTON CAPTION 'Send File' SIZE 10,1.2 ;
      ACTION {||SendFile( cFTPServer, cUserID, cPassword, cLocalFile, cRemoteFile)}

@ 7,24 DCPUSHBUTTON CAPTION 'Get File' SIZE 10,1.2 ;
      ACTION {||GetFile( cFTPServer, cUserID, cPassword, cLocalFile, cRemoteFile)}

DCGETOPTIONS SAYWIDTH 100 SAYRIGHTBOTTOM
DCREAD GUI FIT OPTIONS GetOptions ;
   TITLE 'Send/Receive Files to/from FTP Server'

RETURN

* ------------

PROC Appsys
RETURN

* ------------------

STATIC FUNCTION SendFile( cFTPServer, cUserID, cPassword, cLocalFile, cRemoteFile)

LOCAL nLogHandle, oFtp, nHandle, nBytes, cContents, oScrn

cLocalFile := Alltrim(cLocalFile)
cRemoteFile := Alltrim(cRemoteFile)
cFTPServer := Alltrim(cFTPServer)

nLogHandle := FOpen('FTP.LOG',FO_READWRITE)
IF nLogHandle <= 0
  nLogHandle := FCreate('FTP.LOG')
ENDIF
FSeek(nLogHandle,0,FS_END)
FWrite(nLogHandle,'Date: ' + DtoC(Date()) + ',  Time: ' + Time() + CRLF )

oFtp := FTPClient():new( Alltrim(cFtpServer), Alltrim(cUserID), Alltrim(cPassWord) )

IF !oFtp:connect()
  DC_WinAlert("Unable to connect to: " + cFtpServer)
  FWrite(nLogHandle,'Unable to connect to: ' + cFtpServer + CRLF )
  FClose(nLogHandle)
  RETURN .f.
ENDIF
FWrite(nLogHandle,'Connected to: ' + cFtpServer + CRLF )

oScrn := DC_WaitOn('Sending ' + cLocalFile + ' to ' + ;
                    cFtpServer + ':' + cRemoteFile )

nHandle := FOpen(cLocalFile)
nBytes := FSeek( nHandle,0,FS_END)
cContents := Space(nBytes)
FSeek(nHandle,0,FS_SET)
FRead(nHandle,@cContents,nBytes)
FClose(nHandle)

// Uploading file contents
FWrite(nLogHandle,'Sending ' + cLocalFile + ' to ' + ;
                   cFtpServer + ':' + cRemoteFile )

IF !oFtp:put( cRemoteFile, cContents )
  DC_Impl(oScrn)
  DC_WinAlert( "Unable to transfer file contents" )
  FWrite(nLogHandle,' - FAILURE' + CRLF )
ELSE
  DC_Impl(oScrn)
  DC_MsgBox('File transfer successful!')
  FWrite(nLogHandle,' - SUCCESSFUL' + CRLF )
ENDIF
RETURN nil

* ---------------

STATIC FUNCTION GetFile( cFTPServer, cUserID, cPassword, cLocalFile, cRemoteFile)

LOCAL oScrn, nLogHandle, nHandle, cContents, oFtp

cLocalFile := Alltrim(cLocalFile)
cRemoteFile := Alltrim(cRemoteFile)
cFTPServer := Alltrim(cFTPServer)

nLogHandle := FOpen('FTP.LOG',FO_READWRITE)
IF nLogHandle <= 0
  nLogHandle := FCreate('FTP.LOG')
ENDIF
FSeek(nLogHandle,0,FS_END)
FWrite(nLogHandle,'Date: ' + DtoC(Date()) + ',  Time: ' + Time() + CRLF )

oFtp := FTPClient():new( Alltrim(cFtpServer), Alltrim(cUserID), Alltrim(cPassWord) )

IF !oFtp:connect()
  DC_WinAlert("Unable to connect to: " + cFtpServer)
  FWrite(nLogHandle,'Unable to connect to: ' + cFtpServer + CRLF )
  FClose(nLogHandle)
  RETURN .f.
ENDIF
FWrite(nLogHandle,'Connected to: ' + cFtpServer + CRLF )

oScrn := DC_WaitOn('Receiving ' + cLocalFile + ' from ' + ;
                    cFtpServer + ':' + cRemoteFile )

// Downloading file contents
FWrite(nLogHandle,'Receiving ' + cLocalFile + ' from ' + ;
                   cFtpServer + ':' + cRemoteFile )
cContents := oFtp:get( cRemoteFile )
DC_Impl(oScrn)

IF cContents == NIL .OR. Len(cContents) == 0
  DC_WinAlert( "Unable to transfer file contents" )
  FWrite(nLogHandle,' - FAILURE (transfer)' + CRLF )
ELSE
  nHandle := FCreate(cLocalFile)
  IF nHandle >= 0
    FWrite(nHandle,cContents)
    FClose(nHandle)
    FWrite(nLogHandle,' - SUCCESSFUL' + CRLF )
    DC_MsgBox('Download Successful!')
  ELSE
    FWrite(nLogHandle,' - FAILURE (save to disk)' + CRLF )
    DC_WinAlert('Download Failed!')
  ENDIF
ENDIF
FClose(nLogHandle)
oFtp:disconnect()

RETURN .t.


