// Using a MIMEMessage object for sending an e-mail
// The example demonstrates how to assemble an e-mail
// and send it via an SMTPCLient object to the recipient

#include 'dcdialog.ch'

#pragma library("ASINET10.LIB")

#define CRLF  Chr(13)+Chr(10)

PROCEDURE Main

LOCAL GetList[0], GetOptions, oSendButton, ;
      cText := '', cAttachment := Space(50), cSubject := Space(50), ;
      cReplyTo := Space(50), cSender := Space(50), cRecipient := Space(50), ;
      cSMTPServer := Pad('donnay-software.com',50)

@ 1,0 DCSAY 'From' GET cSender
@ 2,0 DCSAY 'To' GET cRecipient
@ 3,0 DCSAY 'Reply To' GET cReplyTo
@ 4,0 DCSAY 'Subject' GET cSubject
@ 5,0 DCSAY 'Attach' GET cAttachment POPUP {|c|DC_PopFile(c)}

@ 6,0 DCSAY 'Message' COLOR GRA_CLR_BLUE SAYLEFT
@ 7,0 DCMULTILINE cText SIZE 75,10 FONT '10.Courier'

@18,0 DCSAY 'SMTP Server' GET cSMTPServer

@20,0 DCPUSHBUTTON CAPTION 'Exit' SIZE 9,1.2 ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@20,11 DCPUSHBUTTON CAPTION 'Send' SIZE 9,1.2 ;
      OBJECT oSendButton ;
      ACTION {||SendMail( cSMTPServer, cSender, cRecipient, cSubject, ;
                          cReplyTo, cAttachment, cText ) }

DCGETOPTIONS SAYWIDTH 70 SAYRIGHTBOTTOM
DCREAD GUI FIT OPTIONS GetOptions ;
   TITLE 'Send an E-mail using ASI-Net'

RETURN

* -----------------

STATIC FUNCTION SendMail( cSMTPServer, cSender, cRecipient, cSubject, ;
                          cReplyTo, cAttachment, cText )

LOCAL oMail, oSender, oRecipient, oSmtp, lError := .t.

IF Empty(cSMTPServer)
  DC_WinAlert('Must provide a SMTP Server Address')
ELSEIF Empty(cSender)
  DC_WinAlert('Must provide a Sender Address')
ELSEIF Empty(cRecipient)
  DC_WinAlert('Must provide a Recipient Address')
ELSEIF Empty(cSubject)
  DC_WinAlert('Must provide a Recipient Address')
ELSE
  lError := .f.
ENDIF
IF lError
  RETURN .f.
ENDIF

oMail      := MIMEMessage():new()
oSender    := MailAddress():new( Alltrim(cSender) )
oRecipient := MailAddress():new( Alltrim(cRecipient) )

// Assemble the e-mail
oMail:setFrom( oSender     )
oMail:setSubject( Alltrim(cSubject) )
oMail:setMessage( cText       )
oMail:addRecipient( oRecipient  )
oMail:addHeader( "Reply-To", Alltrim(cReplyTo) )
oMail:setContentType('text/html')

IF !Empty(cAttachment)
  oMail:attachFile( cAttachment  )
ENDIF

oSmtp := SMTPClient():new( Alltrim(cSMTPServer) )
IF oSmtp:connect()
  oSmtp:send( oMail )
  oSmtp:disconnect()
  DC_MsgBox("Message sent")
ELSE
  DC_WinAlert("Unable to connect to mail server")
  lError := .f.
ENDIF

RETURN !lError

* ------------

PROC appsys
return
