/*       Show Contents of a browser cell on the fly and display
         Tooltips for every cell
         This sample should help eXpress Users to get a better understanding
         what's happening in the event-handler and how to grab events!
         It is also a good sample to show how a latency-check can be programmed
         by having a second loop! The tooltips and bitmaps are only showed when
         the mouse stops (not when moving)
         Have fun with it!


         Author:  Michael Rudrich, EDV-Bro M.Rudrich, Weiden, F.R.G.
         Date:    27th March 2001
         Code Snippets from Roger Donnay (Many Thanks to the Guru)

         Comments: I tried to comment all necesssary stuff! I hope it helps
                   all eXpress Users when using this code to understand what's
                   happening! Comments are in English (Sorry, it's not my mother
                   language :-) )
                   If somebody wants to have the comments in German, please let
                   me know!


          Version 0.9:
         This sample is made to put some kind of tooltip to the tail of the
         mouse-cursor to show cell information  or other database information
         Also, it shows a way to display Bitmaps the same way like tooltips if
         there's a .BMP in the cell which represents a path to a bitmap-file.
         You can easily change the source to use DCLIPIMG.DLL fopr displaying other
         Graphic formats also!

          Version 1.0  3-28-2001
          Now, the Bitmap is moved down to the bottom of the mouse-cursor

          Version 1.1  3-29-2001
          The Static-Object is created AFTER the Bitmap Object is created to pass the
          right size, which means that the resetting of the size that causes flickering is not
          necessary anymore

          Version 1.2 3-29-2001
          There's a do while loop to create some kind of latency-check! The Object is only
          handled when the mouse stops moving!
          (It took me some time to figure out how to do that...)   ;-)

         For Roger:
            After thinking a little, I found out that it should be easy to include
            this in your handler of DC_ReadGui if the Object is a browser!
            Feel free to use any line of code you want for your great product! It's
            a pleasure and a great honor for me to have a few lines in eXpress++

            Michael

*/
#INCLUDE "DCDIALOG.CH"
#INCLUDE "APPEVENT.CH"
#INCLUDE "DCGRA.CH"

#DEFINE mMultiLine        aLocals[1]      // Memo Field to display data
#DEFINE oMultiline        aLocals[2]      // The object of the Memo Field
#DEFINE oBrowse           aLocals[3]      // Browser Object
#DEFINE nSkips            aLocals[4]      // Number of necessary skips
#DEFINE nRecord           aLocals[5]      // to store the record number
#DEFINE oToolTip          aLocals[6]      // Tooltip Object
#DEFINE aOldPosition      aLocals[7]      // old Position of mouse-cursor
#DEFINE aAbsolutePosition aLocals[8]      // absolute position of mouse-cursor
#DEFINE lShowInformation  aLocals[9]      // Checkbox whether to show Tooltips or not

procedure appsys() // Go away!
return


function MAIN()
Local GetList := {}                       // Initialize  the  Getlist
Local aLocals[9]                          // define the local array with all necessary variables
lShowInformation := .F.                   // Initialzie the Checkbox with .F.
mMultiline := ""                          // Clear the multiline
nSkips := 0                               // A few inits more...
nRecord := 0
oToolTip := NIL
aOldPosition:= Array(1)                   // Take care to give the Old-Position array a defined value
afill(aOldPosition,0)

set path to ..\..\data\                  // Set the path to Roger's Collect.dbf and his marvelous bitmaps

use COLLECT new                          // Open Database

@ 1,1 DCBROWSE oBrowse;                  // Let's browse a few fields
        ALIAS 'COLLECT';
        SIZE 75,10 ;
        PRESENTATION DC_BrowPres() ;
        FIT


DCBROWSECOL FIELD COLLECT->DESCRIP  PARENT oBrowse   WIDTH 10 HEADER "Description"
DCBROWSECOL FIELD COLLECT->TYPE     PARENT oBrowse   WIDTH 8  HEADER "Type"
DCBROWSECOL FIELD COLLECT->LOCATION PARENT oBrowse   WIDTH 6  HEADER "Location"
DCBROWSECOL FIELD COLLECT->BITMAP1  PARENT oBrowse   WIDTH 6  HEADER "Bitmap 1"
DCBROWSECOL FIELD COLLECT->BITMAP2  PARENT oBrowse   WIDTH 6  HEADER "Bitmap 2"

@ 11.5,1 DCCHECKBOX lShowInformation PROMPT "Click here to enable Cell-Tooltips"
@ 13,  1 DCMULTILINE mMultiline SIZE 60,4 OBJECT oMultiline

DCREAD GUI FIT TITLE "Browse with Tooltips (even Bitmaps) and Changing a Multiline on the fly" ADDBUTTONS HANDLER _DlgHandler REFERENCE aLocals



select COLLECT                           // Close Database
close

set path to                              // Reset the path

return (NIL)                             // Bye!


// Custom handler to control some stuff..
STATIC FUNCTION _DlgHandler ( nEvent, mp1, mp2, oXbp, oDialog, GetList, aLocals )
Local oObject,mp3, mp4                                                          // We need this to capture a few events and
                                                                                // leave our mp1 and oXbp as it is!

IF nEvent = xbeM_Motion                                                         // First, check if we leave the browser
   if valtype(oXbp) = "O"                                                           // Only then....
      if upper(oXbp:ClassName()) # "XBPCELLGROUP"                                       // If so, we've left the browse window
        IF oToolTip # NIL
           oToolTip:SetSize({0,0})                                                      // Setsize to Zero
        ENDIF
     endif
   ENDIF
ENDIF

IF valtype(oXbp) = "O"                                                          // Only if event is fired on an object
   IF upper(oXbp:Classname()) = "XBPCELLGROUP" .AND. nEvent = xbeM_Motion       // Are we at a cellgroup and do we move?
      do while nEvent = xbeM_Motion                                                // If so, only do something if the moving stops
         nEvent := AppEvent( @mp3, @mp4, @oObject,5 )                              // To reach this, let the User 5 Milliseconds between moving
                                                                                   // from one pixel to another
         IF nEvent # xbeM_Motion                                                   // If so, leave the loop! This works, because after timeout
              exit                                                                 // xbeP_None is returned and this differs from xbeM_Motion
         endif
         *oXbp:handleEvent( nEvent, mp3, mp4 )                                     // We do not need to handle this stuff
      enddo

      // This is where the mouse stopps again!
      aAbsolutePosition := _CalculateTheAbsolutePosition(mp1,oXbp)              // store the absolute Position compared to  Appdesktop()
      IF aOldPosition[1] = 0                                                    // If default from above (initial value)
         aOldPosition := aAbsolutePosition                                      //     Init our array
      ENDIF                                                                     // Endif default

      IF ( aOldPosition[1] # aAbsolutePosition[1] .OR. aOldPosition[2] # aAbsolutePosition[2] )  // Did we move??
         aOldPosition := aAbsolutePosition                                                       // Set array for comparing...

         // Here we could manage a multiline to display data..
         IF oXbp:GetCell(oXbp:CellFromPos(mp1)) # NIL                           // Is there something in the Cell??
            oMultiline:SetData(oXbp:GetCell(oXbp:CellFromPos(mp1)))                // Use this for setting the cell-contents! No refresh necessary!
                                                                                   // GetCellFromPos returns the nRowPos from the Coordinates
                                                                                   // GetCell(nRowPos) returns the cell contents
         ENDIF                                                                  // Endif something in cell

         IF lShowInformation                                                    // Shall we display tooltips ???
            IF oToolTip # NIL                                                      // Was there a Tooltip????
               oToolTip:Destroy()                                                     // Remove the old stuff from the screen
            ENDIF                                                                  // Endif was there a tooltip

            // Try to find out wether there is a Bitmap to display or not
            IF oXbp:GetCell(oXbp:CellFromPos(mp1)) # NIL .AND. ".BMP" $ upper(alltrim(oXbp:GetCell(oXbp:CellFromPos(mp1))))
               _ShowToolTip(oXbp:GetCell(oXbp:CellFromPos(mp1)),mp1,oXbp,@oToolTip,.t.)   // Show a Bitmap as a Tooltip
            ELSE
               _ShowToolTip(oXbp:GetCell(oXbp:CellFromPos(mp1)),mp1,oXbp,@oToolTip,.f.)   // Show our new tooltip with the contents of the cell
                                                                                    // You can show the user whatever you want!
                                                                                    // Maybe youhave to convert numeric or date data
                                                                                    // Look at the next few line which are commented out:
            ENDIF

            // Having access to the other fields or the recno() (or other databases with seeks) is easy, but requires a few lines more...
               // nRecord := COLLECT->(Recno())      // Save exact position
               // nSkips  := oXbp:CellFromPos(mp1) - oBrowse:RowPos     //calculate the required skips
               // DC_DbSkip(nSkips)                                     // skip it
               // oMultiline:SetData(COLLECT->COMMENTS)                 // Use this for showing the Field Comments, which is not defined
                                                                        // as a browser-column (great..)
               // COLLECT->(DbGoTo(nRecord))                            // restore record-pointer
            //
         ENDIF
      ENDIF
   ENDIF
ENDIF
RETURN DCGUI_NONE


// Function to create the tooltip with calculated size and height
Function _ShowToolTip(cText,aPosition,oCellGroup,oTip,lBitmap)
   // Coming in:     cText      ->  Text to display
   //                aPosition  ->  Where's the mouse (relative coordinates to the cell)
   //                oCellGroup ->  The object
   //                oTip       ->  The local defined tooltip coming by refrence to be able to kill it in the handler
   //                lBitmap    ->  Wether we should display a bitmap in the tooltip!

LOCAL aAttr, oPS, nTextLen, aText, i, nOffset
LOCAL aPoints, aSize := {0,0}, aOrigPos, oBitmap

// First of all: We need absolute Coordinates, so calculate it
aOrigPos:=_CalculateTheAbsolutePosition(aPosition,oCellGroup)

IF !lBitmap                                       // Normal Text to display
   // Create the Static Object with zero-size! Create it at the bottom of the mouse cursor (-30))
   oXbp := XbpStatic():new( AppDeskTop(),AppDeskTop(), {aOrigPos[1]+10,aOrigPos[2]-30},  {0, 0} )
   oXbp:options := XBPSTATIC_TYPE_FGNDFRAME          // Style is foreground frame
   oXbp:create()                                     // Create it

   oPS := oXbp:lockPS()                              // Lock the presentation space
   aText := DC_TokenArray(cText,chr(10)+chr(13))     // Make an array out of multilines
   nTextLen := 0                                     // Some defaults
   aSize := { 0,0 }                                  //    -"-
   FOR i := 1 TO Len(aText)                          // Calculate the maximums we need , 'cause maybe we have to display lines with different sizes
   aPoints := GraQueryTextBox( oPS, aText[i] )
   aSize[1] := Max(aSize[1],(aPoints[3,1] - aPoints[1,1]) + 8 ) // width
   NEXT
   IF len(aText) > 0
      aSize[2] := ((aPoints[1,2] - aPoints[2,2]) * Len(aText)) + 4 // height
   else                                             // This change was necessary, to be able to show 'nothing' if cell is empty
      aSize[2] := 0                                  //  without running in a runtime error
   ENDIF

   IF Len(aText) > 1                                 // Let's set the Position correctly
      oXbp:setPos({oXbp:currentPos()[1], oXbp:currentPos()[2]-(aPoints[1,2]-aPoints[2,2])*(Len(aText)-1)})
   ENDIF

   oXbp:unlockPS()                                   // Unlock the presentation space again!

   IF oXbp:currentPos()[1] + aSize[1] > AppDeskTop():currentSize()[1] // See if there's enough room on the desktop
      oXbp:setPos( { AppDeskTop():currentSize()[1] - aSize[1], ;      // If not, reposition it!
                     oXbp:currentPos()[2] - aSize[2] } )
   ENDIF
  //
   oXbp:setSize(aSize,.F.)                           // Set the calculated size

   oPS := oXbp:lockPS()                              // Lock the PresSpace again!
   aAttr := Array( GRA_AA_COUNT )
   aAttr [ GRA_AA_COLOR ] := { GRA_CLR_BLACK, GRA_CLR_WHITE }[2]          // draw the boxes here, change the colors if you like
   GraSetAttrArea( oPS, aAttr )
   GraBox( oPS, { 1, 1}, { aSize[ 1] + 4, aSize[ 2] + 4}, GRA_FILL)

   aAttr := Array( GRA_AS_COUNT )
   aAttr [ GRA_AS_COLOR ] := { GRA_CLR_BLACK, GRA_CLR_WHITE }[1]
   GraSetAttrString( oPS, aAttr )
   GraBox( oPS, {1,1}, {aSize[1] - 1, aSize[2] - 1})

   nOffset := 0
   FOR i := Len(aText) TO 1 STEP -1                                      // Write the string in the box
   GraStringAt( oPS, {4,4+nOffset}, aText[i])
   nOffset += (aPoints[1,2] - aPoints[2,2])
   NEXT

   oXbp:unLockPS( oPS)                                                   // Unlock Presentation space again
   //

 ELSE  // OK Folks, here we have to create a bitmap...
   // Display a small Bitmap at the tail of the mouse cursor to show the bitmap with the .BMP path which is passed by the cell
   oBMP:= XbpBitmap():new():create()                                     // Create a Bitmap Object
   oBMP:loadfile(alltrim('..\'+cText))                        // Load the Bitmap file into it
   aSize := {oBMP:xSize,oBMP:ySize }                                     // Let's see how big it is!

   // Here you can recalculate the Size if you want for example to show a bitmap with a maximun of 50 X-Pixels
   // nSizeReferenceX := 50
   // nSizeX := oBMP:xSize
   // nSizeY := oBMP:ySize
   //  do while nSizeX > nSizeReferenceX
   //   nSizeX := nSizeX * .9
   //   nSizeY := nSizeY * .9
   // enddo
   // aSize := {int(nSizeX), int(nSizeY)}
   // End Recalculating

   // Create a Static Object to be able to use it's presentation space with zero-size! Create it at the bottom of the mouse cursor (-30))
   oXbp := XbpStatic():new( AppDeskTop(),AppDeskTop(), {aOrigPos[1]+15,aOrigPos[2]-10-aSize[2]}, aSize )
   oXbp:options := XBPSTATIC_TYPE_FGNDFRAME                              // Style is Forground Frame
   oXbp:create()                                                         // Create it

   IF oXbp:currentPos()[1] + aSize[1] > AppDeskTop():currentSize()[1]   // See if there's enough room on the desktop in X-Direction
      oXbp:setPos( { AppDeskTop():currentSize()[1] - aSize[1], ;        // If not, reposition it!
                     oXbp:currentPos()[2] - aSize[2] } )
   ENDIF

   IF oXbp:currentPos()[2] + aSize[2] > AppDeskTop():currentSize()[2]   // See if there's enough room on the desktop in Y-Direction
      oXbp:setPos( { oXbp:currentPos()[1], ;                            // If not, reposition it!
                     oXbp:currentPos()[2] - aSize[2] } )
   ENDIF
   oXbp:setSize(aSize,.F.)                                               // Set the calculated size
   oPS := XbpPresSpace():new():create( oXbp:winDevice() )
   oBMP:draw( oPS )                                                      // Show our Bitmap file

ENDIF

oTip := oXbp                                                          // Point the object to oTip which is the refrence of oToolTip of the custom
                                                                      // handler!
return (NIL)


// Function to calculate the absolute Position from relative Position Array and Object
STATIC FUNCTION _CalculateTheAbsolutePosition(aPos,oXbp)
   // Coming in:       aPos   ->  relative Coordinates
   //                  oXbp   ->  Object
   LOCAL aAbsPos := AClone(aPos)          // Clone our incoming array to type-define the return value
   LOCAL oParent := oXbp                  // Default oParent to our Object
   LOCAL oDesktop := AppDesktop()         // Default oDesktop to Appdesktop

   DO WHILE oParent # oDesktop               // Do this until we reach the Appdesktop
      aAbsPos[1] += oParent:currentPos()[1]        // Add the X-Coordinates
      aAbsPos[2] += oParent:currentPos()[2]        // Add the Y-Coordinates
      oParent := oParent:setParent()               // Set oParent to our own parent
   ENDDO
RETURN(aAbsPos)                               // return the absolute Position

