/*
 Using the Flipper Graphics OCX in an Xbase++ form

The sample below shows how to:
  - create an instance of the Flipper Graphics OCX in an Xbase++ form
  - turn that Xbase++ form into a full featured Graphics system.

This FLIPPER example requires that you install the Flipper Graph Control on
your computer.  A trial version of this control can be downloaded from
http://www.proworks.com.

FLIPJAZZ.PRG was created by running the JazzAge 3.0 Active X Wizard and
generating the Classes for Flipper.  This demo requires JazzAge 3.0
Professional Edition.

The FLIPPER.JPG file is a screen snapshot of a graph in an eXPress+ dialog.

*/

MEMVAR oFlipper

#include "Gra.ch"
#include "dcdialog.ch"
#include "appevent.ch"

#define _FlpGrf_
#include "flipjazz.prg"

#define JARESIZESTYLE_X1LEFT        0x0
#define JARESIZESTYLE_X1RIGHT       0x1
#define JARESIZESTYLE_X2LEFT        0x00
#define JARESIZESTYLE_X2RIGHT       0x10
#define JARESIZESTYLE_Y1TOP         0x000
#define JARESIZESTYLE_Y1BOTTOM      0x100
#define JARESIZESTYLE_Y2TOP         0x0000
#define JARESIZESTYLE_Y2BOTTOM      0x1000

#define JAHANDLE_PUNK      0
#define JAHANDLE_HWND		2

PROCEDURE Main

Flipper()

RETURN

* -------------

PROCEDURE AppSys
RETURN

* -------------

PROCEDURE Flipper

LOCAL GetList := {}, oStatic, oStatus, oThread, oDlg, oDlgArea, GetOptions

PRIVATE oFlipper  // make this private so it can be manipulated at the dot-prompt

// REQUIRED: a separate thread polling and dispatching the various ActiveX events.
oThread := Thread():new()
oThread:start( "JAProcessOCXEvents")

@  0, 0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 90,20.5 OBJECT oStatic

@ 21, 0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 90,1 ;
        FONT '10.Arial' COLOR GRA_CLR_BLUE OBJECT oStatus

@  0, 0 DCDIALOG oDlg NOTITLEBAR DRAWINGAREA oDlgArea SIZE 90,20.5 PARENT oStatic

@ 22, 0 DCPUSHBUTTON CAPTION "Pie" SIZE 10,1.2 ACTION {||Pie(oFlipper),oDlg:invalidateRect()}

@ 22,10 DCPUSHBUTTON CAPTION 'Bar #1' SIZE 10,1.2 ACTION {||Bar1(oFlipper),oDlg:invalidateRect()}

@ 22,20 DCPUSHBUTTON CAPTION 'Bar #2' SIZE 10,1.2 ACTION {||Bar2(oFlipper),oDlg:invalidateRect()}

@ 22,30 DCPUSHBUTTON CAPTION 'Bubble' SIZE 10,1.2 ACTION {||Bubble(oFlipper),oDlg:invalidateRect()}

@ 22,40 DCPUSHBUTTON CAPTION 'Spider' SIZE 10,1.2 ACTION {||Spider(oFlipper),oDlg:invalidateRect()}

@ 22,70 DCPUSHBUTTON CAPTION 'Print' SIZE 10,1.2 ACTION {||oFlipper:printnow := 2}


DCGETOPTIONS AUTORESIZE

DCREAD GUI FIT TITLE 'Flipper Graphing System' ;
   OPTIONS GetOptions ;
   EVAL {|o| CreateFlipper( o:drawingArea, oDlgArea, oStatus, @oFlipper )}

oFlipper:Disconnect()

RETURN

* ------------------

STATIC FUNCTION CreateFlipper( oWindow, oDlgArea, oStatus, oFlipper )

LOCAL nWidth, nHeight, nCol, nRow, punk, cCode

// Create an ActiveX instance in the Form client area, and wrap it in an Xbase++ class instance
oFlipper:= FlpGrf():new()
nWidth  := oDlgArea:currentSize()[1]
nHeight := oDlgArea:currentSize()[2]
nCol    := oDlgArea:currentPos()[1]
nRow    := oDlgArea:currentPos()[2]

cCode := "ProgID:FLPGRF.FlpGrfCtrl.1;LicKey:Copyright (c) 1997 ProWorks"

punk := JAXPPCREATECONTROL(oDlgArea:getHWND(),;
         "FlpGrf",nCol,nRow,nWidth,nHeight,cCode,1)

JAXPPSETCONTROLRESIZESTYLE(punk,JAHANDLE_PUNK,JARESIZESTYLE_X2RIGHT + ;
       JARESIZESTYLE_Y2BOTTOM)

oFlipper:Connect(punk)

// Connect to the events fired by the ActiveX.
oFlipper:SubscribeToEvents({|hEvent| ReflectEventToStatusText(hEvent,oStatus) })

SalesDataInit(oFlipper)

RETURN nil

* ---------------

STATIC FUNCTION SalesDataInit( oFlipper )

oFlipper:FontOpen := "Arial,20,B"
oFlipper:GraphTitleFont := oFlipper:FontCurrent
oFlipper:GraphTitle := 'Year 2000 Sales'
oFlipper:FontOpen := "Times New Roman,16,N"
oFlipper:AxisTitleFont := oFlipper:FontCurrent
oFlipper:BackColor := _RGBColor( {192,192,192} )
oFlipper:GraphBackColor := _RGBColor( {128,128,128} )

oFlipper:DataInit := 3

oFlipper:PutDataValue( 1, 0, "Jan")
oFlipper:PutDataValue( 2, 0, "Feb")
oFlipper:PutDataValue( 3, 0, "Mar")
oFlipper:PutDataValue( 4, 0, "Apr")
oFlipper:PutDataValue( 5, 0, "May")
oFlipper:PutDataValue( 6, 0, "Jun")
oFlipper:PutDataValue( 7, 0, "Jul")
oFlipper:PutDataValue( 8, 0, "Aug")
oFlipper:PutDataValue( 9, 0, "Sep")
oFlipper:PutDataValue(10, 0, "Oct")
oFlipper:PutDataValue(11, 0, "Nov")
oFlipper:PutDataValue(12, 0, "Dec")

oFlipper:PutDataValue( 1, 1, 12)
oFlipper:PutDataValue( 2, 1, 34)
oFlipper:PutDataValue( 3, 1, 21)
oFlipper:PutDataValue( 4, 1, 45)
oFlipper:PutDataValue( 5, 1, 67)
oFlipper:PutDataValue( 6, 1, 45)
oFlipper:PutDataValue( 7, 1, 53)
oFlipper:PutDataValue( 8, 1, 12)
oFlipper:PutDataValue( 9, 1, 34)
oFlipper:PutDataValue(10, 1, 50)
oFlipper:PutDataValue(11, 1, 57)
oFlipper:PutDataValue(12, 1, 74)

oFlipper:PutDataValue( 1, 2, 12)
oFlipper:PutDataValue( 2, 2, 34)
oFlipper:PutDataValue( 3, 2, 21)
oFlipper:PutDataValue( 4, 2, 45)
oFlipper:PutDataValue( 5, 2, 67)
oFlipper:PutDataValue( 6, 2, 45)
oFlipper:PutDataValue( 7, 2, 53)
oFlipper:PutDataValue( 8, 2, 12)
oFlipper:PutDataValue( 9, 2, 34)
oFlipper:PutDataValue(10, 2, 50)
oFlipper:PutDataValue(11, 2, 57)
oFlipper:PutDataValue(12, 2, 74)

RETURN nil

*/

// Function called by the Event codeblock to fully analyze the received Event,
// The code below also shows how to analyze the received event and take any
// appropriate action, given its name.
PROCEDURE ReflectEventToStatusText(hEvent,oSTStatusText)
LOCAL eventname
LOCAL status

 eventname=JAXPPGETEVENTNAME(hEvent)
 IF eventname="StatusTextChange"
   // Obtain the value of the 'Text' parameter
   status=JAXPPGETEVENTPARAMETERVALUE(hEvent,"Text")
   // Reflect the parameter to the StatusText label control
   oSTStatusText:setCaption(status)
 END

RETURN


// REQUIRED by the JA runtime to process smoothly the OCX events sent by the various ActiveX instances.
PROCEDURE JAProcessOCXEvents()
  JAXPPPROCESSEVENTS()
RETURN

* ---------------------

STATIC FUNCTION Bar1( oFlipper )

oFlipper:GraphReset := .t.
oFlipper:GraphEnabled := .F.

oFlipper:GraphType := 0

SalesDataInit(oFlipper)

oFlipper:Column := 0
oFlipper:ColumnAxis := 0

oFlipper:Column := 1
oFlipper:ColumnAxis := 1
oFlipper:ColumnType := 1

oFlipper:Column := 2
oFlipper:ColumnAxis := 1
oFlipper:ColumnType := 3

oFlipper:GraphSwapScale := .T.

oFlipper:GraphEnabled := .T.

RETURN nil

* ------------------

FUNCTION Bar2( oFlipper )

oFlipper:GraphReset := .t.
oFlipper:GraphEnabled := .F.

SalesDataInit(oFlipper)

oFlipper:GraphType := 0

oFlipper:Column := 0
oFlipper:ColumnAxis := 0
oFlipper:ColumnType := 1

oFlipper:Column := 1
oFlipper:ColumnAxis := 1
oFlipper:ColumnType := 3

oFlipper:Graph3DRotation := 30
oFlipper:Graph3DElevation := 30

oFlipper:GraphEnabled := .T.

RETURN nil

* ---------------------

STATIC FUNCTION Pie( oFlipper )

oFlipper:GraphReset := .t.
oFlipper:GraphEnabled := .F.

SalesDataInit(oFlipper)

oFlipper:GraphType := 1

oFlipper:Column := 0
oFlipper:ColumnAxis := 0

oFlipper:Column := 1
oFlipper:ColumnAxis := 1
oFlipper:ColumnType := 9

oFlipper:PutDataExplode(4, 1, 25)
oFlipper:AxisScaleBackColor := -2
oFlipper:Graph3DRotation := 20
oFlipper:GraphEnabled := .T.

RETURN nil

* -----------------------

STATIC FUNCTION Bubble( oFlipper )

oFlipper:GraphEnabled := .F.

oFlipper:DataInit := 3

// The x-axis bubble positions
oFlipper:PutDataValue(1, 0, 4)
oFlipper:PutDataValue(2, 0, 12)
oFlipper:PutDataValue(3, 0, 15)
oFlipper:PutDataValue(4, 0, 25)
oFlipper:PutDataValue(5, 0, 34)
oFlipper:PutDataValue(6, 0, 46)
oFlipper:PutDataValue(7, 0, 52)
oFlipper:PutDataValue(8, 0, 68)
oFlipper:PutDataValue(9, 0, 72)

// The y-axis bubble positions
oFlipper:PutDataValue(1, 1, 23)
oFlipper:PutDataValue(2, 1, 78)
oFlipper:PutDataValue(3, 1, 23)
oFlipper:PutDataValue(4, 1, 12)
oFlipper:PutDataValue(5, 1, 45)
oFlipper:PutDataValue(6, 1, 64)
oFlipper:PutDataValue(7, 1, 12)
oFlipper:PutDataValue(8, 1, 42)
oFlipper:PutDataValue(9, 1, 39)

// The bubble radius
oFlipper:PutDataValue(1, 2, 13)
oFlipper:PutDataValue(2, 2, 15)
oFlipper:PutDataValue(3, 2, 23)
oFlipper:PutDataValue(4, 2, 45)
oFlipper:PutDataValue(5, 2, 23)
oFlipper:PutDataValue(6, 2, 17)
oFlipper:PutDataValue(7, 2,  8)
oFlipper:PutDataValue(8, 2, 17)
oFlipper:PutDataValue(9, 2, 24)

oFlipper:GraphType := 4
oFlipper:Column := 0
oFlipper:ColumnAxis := 0

oFlipper:Column := 1
oFlipper:ColumnAxis := 1
oFlipper:ColumnType := 8

oFlipper:Column := 2
oFlipper:ColumnAxis := 2
oFlipper:ColumnType := 8

oFlipper:GraphTitle := 'Bubble Graph'

oFlipper:Graph3DRotation := 10
oFlipper:GraphEnabled := .T.

RETURN nil

* -----------------------

STATIC FUNCTION Spider( oFlipper )

oFlipper:GraphReset := .t.
oFlipper:GraphEnabled := .F.

SalesDataInit(oFlipper)

oFlipper:GraphType = 2

oFlipper:Column = 0
oFlipper:ColumnAxis = 0

oFlipper:Column = 1
oFlipper:ColumnAxis = 1
oFlipper:ColumnType = 10

oFlipper:GraphEnabled := .T.

RETURN nil

* -----------------

STATIC FUNCTION _RGBColor( aRGB )

RETURN GraMakeRGBColor( aRGB ) - 16777216
