#INCLUDE "dcdialog.ch"
#INCLUDE "appevent.ch"

#define HELP_TYPE_TEXTMEMO      1
#define HELP_TYPE_TEXTFILE      2
#define HELP_TYPE_TEXTCONTROL   3

#define BUILD_TREE   xbeP_User + 3000

PROCEDURE Main( cMode )

LOCAL GetList[0], GetOptions, cString, dDate, lLogic, nNumber, ;
      lFocusHelp := .f., lMotionHelp := .f., oHelp, oStatic, ;
      oTabPage1, oTabPage2, oGroup1, oGroup2

cString := Space(20)
dDate := Date()
lLogic := .t.
nNumber := 0
DEFAULT cMode := ''

IF Upper(cMode) == 'T'
  oHelp := Help():new(.t.,,,'10.Courier Bold','Test System Help Window', 'DESKTOP' )
  oHelp:editTree()
  RETURN
ENDIF

DC_ReadGuiHandler( {|a,b,c,d|HelpHandler(a,b,c,d,@lFocusHelp,@lMotionHelp, ;
                                         @oHelp,GetList)} )

@ 0,0 DCTABPAGE oTabPage1 ;
      CAPTION 'Gets' ;
      SIZE 50,20 ;
      HELPCODE 'DESKTOP.TABPAGE1' TITLE 'This is the TabPage 1 Parent of the Gets'

@ 0,0 DCTABPAGE oTabPage2 RELATIVE oTabPage1 ;
      CAPTION 'Buttons' ;
      HELPCODE 'DESKTOP.TABPAGE2' TITLE 'This is the TabPage 2 Parent of the Buttons'

DCSETPARENT TO oTabPage1

@ 2,5 DCSAY 'String' GET cString HELPCODE 'TABPAGE1.STRING' ;
            GETTITLE 'Enter a String'

@ 3,5 DCSAY 'Date' GET dDate HELPCODE 'TABPAGE1.DATE' ;
            GETTITLE 'Enter a Date' EDITPROTECT {||.t.}

@ 4,5 DCSAY 'Logic' GET lLogic HELPCODE 'TABPAGE1.LOGIC' ;
            GETTITLE 'Enter a Logic'

@ 5,5 DCSAY 'Number' GET nNumber HELPCODE 'TABPAGE1.NUMBER' ;
            GETTITLE 'Enter a Number'

DCSETPARENT TO oTabPage2

@ 2,5 DCGROUP oGroup1 CAPTION 'Button Group 1' HELPCODE 'TABPAGE2.GROUP1' ;
      SIZE 30,8 TITLE 'This is the first Group of Buttons'

DCSETPARENT TO oGroup1

@ 2,5 DCPUSHBUTTON CAPTION 'Button 1' ACTION {||MsgBox('Button 1')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP1.BUTTON1' TITLE 'This is Button 1'

@ 4,5 DCPUSHBUTTON CAPTION 'Button 2' ACTION {||MsgBox('Button 2')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP1.BUTTON2' TITLE 'This is Button 2'

@ 6,5 DCPUSHBUTTON CAPTION 'Button 3' ACTION {||MsgBox('Button 3')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP1.BUTTON3' TITLE 'This is Button 3'

DCSETPARENT TO oTabPage2

@10.5,5 DCGROUP oGroup2 CAPTION 'Button Group 2' HELPCODE 'TABPAGE2.GROUP2' ;
      SIZE 30,8 TITLE 'This is the Second Group of Buttons'

DCSETPARENT TO oGroup2

@ 2,5 DCPUSHBUTTON CAPTION 'Button 1' ACTION {||MsgBox('Button 1')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP2.BUTTON1' TITLE 'This is Button 1'

@ 4,5 DCPUSHBUTTON CAPTION 'Button 2' ACTION {||MsgBox('Button 2')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP2.BUTTON2' TITLE 'This is Button 2'

@ 6,5 DCPUSHBUTTON CAPTION 'Button 3' ACTION {||MsgBox('Button 3')} ;
      SIZE 20, 1.5 ;
      HELPCODE 'GROUP2.BUTTON3' TITLE 'This is Button 3'

DCGETOPTIONS ;
   SAYWIDTH 50 ;

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   OPTIONS GetOptions ;
   TITLE 'Help Test (Press F1 while a GET has focus)' ;
   POSTEVENT BUILD_TREE

RETURN

* --------------

FUNCTION HelpHandler( nEvent, mp1, mp2, oXbp, lFocusHelp, lMotionHelp, oHelp, GetList )

STATIC soXbp
LOCAL nPointer, aGetList, i, aEvents, aLastEvent

IF nEvent == BUILD_TREE

  IF oHelp == NIL
     oHelp := Help():new(.t.,,,'10.Courier Bold','Test System Help Window', 'DESKTOP' )
     Sleep(30)
  ENDIF
  oHelp:buildTreeIndex(GetList)

ELSEIF soXbp == NIL .OR. soXbp # oXbp .OR. (nEvent == xbeP_Keyboard .AND. mp1 == xbeK_F1)

  IF (lFocusHelp .AND. nEvent == xbeP_SetInputFocus) .OR. ;
     (lMotionHelp .AND. nEvent == xbeM_Motion) .OR. ;
      nEvent == xbeP_Keyboard .AND. mp1 == xbeK_F1

    IF Valtype(oXbp:cargo)=='A' .AND. Len(oXbp:cargo) >= 2 .AND. ;
       Valtype(oXbp:cargo[1]) == 'N' .AND. ;
       Valtype(oXbp:cargo[2]) == 'A'

      nPointer := oXbp:cargo[1]
      aGetList := oXbp:cargo[2]

      IF oHelp == NIL
        oHelp := Help():new(.t.,,,'12.Courier','Test System Help Window', 'DESKTOP' )
        Sleep(30)
      ENDIF
      IF nPointer > 0 .AND. !Empty(aGetList[nPointer,cGETLIST_HELPCODE])
        oHelp:lookup(aGetList[nPointer,cGETLIST_HELPCODE], ;
                     aGetList[nPointer,cGETLIST_TITLE])
        Sleep(20)
        aEvents := Array(0)
        nEvent := 1
        soXbp := oXbp
        DO WHILE nEvent # 0
          nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
          IF nEvent # xbeM_Motion
            AAdd(aEvents,{ nEvent, mp1, mp2, oXbp })
          ENDIF
          IF nEvent > 0
            aLastEvent := { nEvent, mp1, mp2, oXbp }
          ENDIF
        ENDDO
        IF Valtype(aLastEvent) == 'A'
          AAdd(aEvents, aLastEvent)
        ENDIF
        FOR i := 1 TO Len(aEvents)
          PostAppEvent( aEvents[i,1], aEvents[i,2], aEvents[i,3], aEvents[i,4] )
        NEXT

      ENDIF
    ENDIF
  ENDIF
  IF Valtype(oHelp)='O'
    lFocusHelp := oHelp:focusHelp
    lMotionHelp := oHelp:motionHelp
  ENDIF
ENDIF

RETURN DCGUI_NONE

* --------------

PROCEDURE appsys
return


