#INCLUDE "dcdialog.CH"
#INCLUDE "dmlb.CH"
#INCLUDE "dcbitmap.CH"

#DEFINE ODBCDBE_NOUTIL
#INCLUDE "odbcdbe.CH"

#pragma Library("ADAC20B.LIB")

EXTERNAL OdbcListSqlKeywords

FUNCTION Main()

LOCAL cConnect, oSession, oMenuBar, oTableMenu, oWindowMenu, GetList[0], ;
      GetOptions, aDataSources, oViewMenu

PUBLIC oMainWindow

/*
IF ! DbeLoad( "ODBCDBE" )
    DC_WinAlert( "Unable to load ODBCDBE", "ODBC Driver",, ;
                  XBPMB_WARNING + XBPMB_APPMODAL )

  QUIT
ENDIF
*/

dbeSetDefault('ODBCDBE')

oSession := SQLConnect('Northwind','(Local)')

IF Valtype(oSession) # 'O' .OR. !oSession:isConnected()
  RETURN .f.
ENDIF

/*
aDataSources := DbeInfo(COMPONENT_DATA,ODBCDBE_DATASOURCES)
DC_ArrayView(aDataSources)
*/

DC_ClearEvents()

DCMENUBAR oMenuBar

  USE @NORTHWIND.TABLES

  DCSUBMENU oTableMenu PROMPT 'Tables' PARENT oMenuBar

  DO WHILE !Eof()
    DCMENUITEM PROMPT FIELD->Table_Name ;
      PARENT oTableMenu ;
      ACTION &('{||SQLBrowseCall("' + FIELD->Table_name + '")}')
    DC_DbSkip()
  ENDDO

  CLOSE ALL

  USE @WEBBOARD.VIEWS

  DCSUBMENU oViewMenu PROMPT 'Views' PARENT oMenuBar

  DO WHILE !Eof()
    DCMENUITEM PROMPT FIELD->Table_Name ;
      PARENT oViewMenu ;
      ACTION &('{||SQLBrowseCall("' + FIELD->Table_name + '")}')
    DC_DbSkip()
  ENDDO

  DCSUBMENU oWindowMenu PROMPT 'Window' PARENT oMenuBar
    DCMENUITEM 'SQL Statement' ;
      PARENT oWindowMenu ;
      ACTION {|o|o:=Thread():new(), ;
                 o:start({||SQLStatement()}) }
DCGETOPTIONS ;
   WINDOWHEIGHT 600 ;
   WINDOWWIDTH 800 ;
   BITMAP BITMAP_EXPRESS_BACKGROUND1

CLOSE ALL

oSession:disConnect()

DCREAD GUI ;
   OPTIONS GetOptions ;
   TITLE 'NorthWind Enterprises' ;
   EVAL {|o|M->oMainWindow := o}

RETURN nil

* --------------

FUNCTION SQLStatement()

LOCAL GetList[0], cSQLStatement := 'SELECT * FROM [database] ;', ;
      GetOptions

@ 0,0 DCPUSHBUTTON CAPTION 'Run' ;
      SIZE 5,1 ;
      ACTION {||SQLBrowseCall(cSQLStatement)}

@ 0,7 DCSAY 'SQL Statement:' ;
      SAYSIZE 0 ;
      SAYBOTTOM

@ 1,0 DCMULTILINE cSQLStatement ;
      SIZE 50,5 ;
      FONT '10.Alaska Crt' ;
      NOHSCROLL

DCGETOPTIONS ;
   NOMAXBUTTON ;
   AUTORESIZE

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   ADDBUTTONS ;
   APPWINDOW M->oMainWindow:drawingArea ;
   TITLE 'Enter SQL Statement'

RETURN nil

* --------------

FUNCTION SQLBrowseCall( cSQLStatement )

LOCAL oThread := Thread():new()
oThread:start({||SQLBrowse(cSQLStatement)})

RETURN nil

* --------------

FUNCTION SQLBrowse( cSQLStatement )

LOCAL GetList[0], i, oBrowse, aFields, nWidth, cAlias, bErrorBlock, ;
      oSession, lError, GetOptions

oSession := SQLConnect()
IF !oSession:isConnected()
  RETURN .f.
ENDIF

bErrorBlock := ErrorBlock({|e|SQLError(e,cSQLStatement)})

lError := .t.
BEGIN SEQUENCE
USE (cSQLStatement)
lError := .f.
END SEQUENCE
ErrorBlock(bErrorBlock)

IF lError
  RETURN .f.
ENDIF

cAlias := Alias()

aFields := dbStruct()

nWidth := 0
FOR i := 1 TO Len(aFields)
  nWidth += aFields[i,3]
NEXT

@ 0,0 DCBROWSE ;
   OBJECT oBrowse ;
   ALIAS cAlias ;
   SIZE 80,15 ;
   _FIT nWidth < 60 ;
   _NOHSCROLL nWidth < 60 ;
   PRESENTATION DC_BrowPres()

FOR i := 1 TO Len(aFields)
  DCBROWSECOL DATA DC_FieldWBlock(aFields[i,1],Alias()) ;
    PARENT oBrowse HEADER aFields[i,1] WIDTH Min(20,aFields[i,3])
NEXT

DCGETOPTIONS ;
   AUTORESIZE

DCREAD GUI FIT ADDBUTTONS ;
   TITLE cSQLStatement ;
   OPTIONS GetOptions ;
   APPWINDOW M->oMainWindow:drawingArea

CLOSE ALL
oSession:disconnect()

RETURN .t.

* --------------

FUNCTION SQLConnect(cDatabase,cServer,cUserID,cPassword)

STATIC saConnect := {}

LOCAL cConnect, oSession, GetList[0], nFound

cServer := '(Local)'
cConnect := "DBE=ODBCDBE"
cConnect += ";DRIVER=SQL Server"

IF Empty(cDatabase)
  cDatabase := Atail(saConnect)[1]
ENDIF

DCQDEBUG saConnect, cDatabase

/*
IF Empty(cUserID)
  nFound := AScan(saConnect,{|a|a[1]==Upper(cDatabase)})
  IF nFound > 0
    cServer := saConnect[nFound,2]
    cUserID := saConnect[nFound,3]
    cPassword := saConnect[nFound,4]
  ELSE
    cUserID := Space(30)
    cPassword := Space(30)
    @ 0,0 DCSAY ' User ID' GET cUserID SAYRIGHT
    @ 1,0 DCSAY 'Password' GET cPassword SAYRIGHT PASSWORD
    DCREAD GUI FIT ADDBUTTONS ;
      ENTEREXIT ;
      TITLE 'Login Information for ' + cDataBase
    IF Empty(cUserID)
      RETURN .f.
    ENDIF
  ENDIF
ENDIF
*/

cConnect += ";SERVER=" + '(Local)'

/*
cConnect += ";UID=" + Alltrim(cUserID)

cConnect += ";PWD=" + Alltrim(cPassword)
*/

cConnect += ";DATABASE=" + cDatabase

cConnect += ";WSID=WorkStationID"

cConnect += ";Trusted_Connection=Yes"

oSession := DacSession():new( cConnect )

nFound := 0
cUserId := ''
cPassword := ''

IF !oSession:isConnected()
  DC_WinAlert( "Unable to establish connection to ODBC Server" + Chr(13) + ;
               "Error Code: " + Alltrim(Str(oSession:getLastError())) + Chr(13) + ;
               oSession:getLastMessage() + ';' + cConnect )
ELSEIF nFound = 0
  AADD( saConnect, { Upper(cDatabase), Alltrim(cServer), ;
                     Alltrim(cUserId), Alltrim(cPassword) })
ELSE
  saConnect[nFound,1] := cDatabase
  saConnect[nFound,2] := cServer
  saConnect[nFound,3] := cUserID
  saConnect[nFound,4] := cPassword
ENDIF

RETURN oSession

* ----------------

STATIC FUNCTION SQLError( oError, cSQLStatement )

LOCAL cMessage := ''

cSQLStatement += Chr(13)+Chr(13) + ;
  'Make sure that the statement ends with a semi-colon (;)'

DC_WinAlert(cSQLStatement, 'SQL Statement Error')

BREAK

RETURN nil
