#INCLUDE "dcdialog.CH"
#INCLUDE "dcprint.CH"
#INCLUDE "dcbitmap.CH"


FUNCTION Main

   LOCAL oPrinter, i, aUnits, GetList[0], GetOptions, lTranslate := .f., ;
      nPointer := 1, nScaleFactor, oBrowse, lStatus, lScale := .f., ;
      lText := .f., lBitMap := .f., lPreview := .t., lGrid := .t., nEnd, ;
      nStart

   aUnits := { ;
      { 'GRA_PU_LOMETRIC', GRA_PU_LOMETRIC, 300, 1500, '1 Centimeter' }, ;
      { 'GRA_PU_HIMETRIC', GRA_PU_HIMETRIC, 1000, 5000, '1 Millimeter' }, ;
      { 'GRA_PU_LOENGLISH', GRA_PU_LOENGLISH, 300, 800, '1 Inch' }, ;
      { 'GRA_PU_HIENGLISH', GRA_PU_HIENGLISH, 500, 3000, '1 Mil (1/10 Inch)' }, ;
      { 'GRA_PU_ARBITRARY', GRA_PU_ARBITRARY, 300, 1000, 'AutoScale' }, ;
      { 'GRA_PU_TWIPS', GRA_PU_TWIPS, 500, 300, '1/14.4 Inch' } ;
      }

   SetAppWindow():hide()
   DO WHILE .t.

      nPointer := 1
      oBrowse := nil

      @ 0,0 DCBROWSE oBrowse ;
         SIZE 40,10 ;
         DATA aUnits ;
         PRESENTATION DC_BrowPres() ;
         FIT ;
         POINTER nPointer ;
         ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

      DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'Units' WIDTH 20 FONT '8.Courier'

      @ 11,0 DCCHECKBOX lTranslate PROMPT 'Translate Coordinates' ;
             TOOLTIP '0,0 is at the TOP,LEFT of the page'

      @ 12,0 DCCHECKBOX lScale PROMPT 'Scale Output' ;
             TOOLTIP 'Use a scaling factor to make each printout identical'

      @ 13,0 DCCHECKBOX lText PROMPT 'Text-Based Coordinates' ;

      @ 14,0 DCCHECKBOX lBitMap PROMPT 'Print Bit-Map' ;
             WHEN {||!lGrid}

      @ 15,0 DCCHECKBOX lPreview PROMPT 'Preview on Screen'

      @ 17,0 DCRADIO lGrid PROMPT 'Print a Grid' VALUE .t.
      @ 18,0 DCRADIO lGrid PROMPT 'Print a Box with Text' VALUE .f.

      DCREAD GUI FIT ADDBUTTONS TO lStatus TITLE 'Print Setup'

      IF !lStatus
         RETURN nil
      ENDIF

      DCPRINT ON ;
         UNITS aUnits[nPointer,2] ;
         TO oPrinter ;
         FONT '10.Courier New' ;
         _PIXEL !lText ;
         _NOTRANSLATE !lTranslate ;
         _PREVIEW lPreview

      IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
         LOOP
      ENDIF

      IF lScale
         nScaleFactor := oPrinter:ScaleFactor()
      ELSE
         nScaleFactor := 1
      ENDIF

      IF lText
         nScaleFactor /= 20
      ENDIF

      nStart := aUnits[nPointer,3]
      nEnd := aUnits[nPointer,4]

      IF !lGrid

         @ 10*nScaleFactor,0,1000*nScaleFactor,1000*nScaleFactor DCPRINT BOX

         @ 1010*nScaleFactor,0, 1010*nScaleFactor,1000*nScaleFactor DCPRINT LINE

         IF lBitMap
            @ 1020*nScaleFactor,0, 1500*nScaleFactor,1000*nScaleFactor ;
               DCPRINT BITMAP BITMAP_EXPRESS
         ENDIF

         @ 50*nScaleFactor,20*nScaleFactor DCPRINT SAY ;
            'This is ' + aUnits[nPointer,1] + IIF(lTranslate,' TRANSLATED',' UNTRANSLATED' ) ;

         DCPRINT FONT '8.Courier New'
         FOR i := 100 TO 500 STEP 40
            @ i*nScaleFactor, i*nScaleFactor ;
               DCPRINT SAY 'Row ' + Alltrim(Str(i)) + ' Column ' + alltrim(Str(i))
         NEXT

      ELSE

         @ 200,0 DCPRINT SAY aUnits[nPointer,1] + ', each square is ' + aUnits[nPointer,5]

         // horizontal lines
         FOR i := nStart TO nEnd STEP 100
            @ i*nScaleFactor,0, i*nScaleFactor,nEnd*nScaleFactor ;
               DCPRINT LINE
         NEXT

         // vertical lines
         FOR i := 0 TO nEnd STEP 100
            @ nStart*nScaleFactor,i*nScaleFactor, nEnd*nScaleFactor,i*nScaleFactor DCPRINT LINE
         NEXT

      ENDIF


      DCPRINT OFF

   ENDDO

RETURN nil

PROC appsys
return
