/*
 ķ
   Program..: TRACKER.PRG                                      
   Author...: Roger J. Donnay                                  
   Notice...: (c) Donnay Software Designs, 2001                
   Date.....: Jul 24, 2001                                     
   Notes....: Defect Tracking Program                          
 Ľ
*/

#include "dcdialog.ch"
#include "dcprint.ch"
#include "xbp.ch"
#include "appevent.ch"
#include "dmlb.ch"

#define  CRLF          Chr(13) + Chr(10)

#define  aCategory       aApp[1 ]
#define  aChildList      aApp[2 ]
#define  aGetList        aApp[3 ]
#define  aGetOptions     aApp[4 ]
#define  aPres           aApp[5 ]
#define  cCategory       aApp[6 ]
#define  cComplTime      aApp[7 ]
#define  cDescription    aApp[8 ]
#define  cIndex          aApp[9 ]
#define  cNotes          aApp[10]
#define  cOrigTime       aApp[11]
#define  cPriority       aApp[12]
#define  cResponse       aApp[13]
#define  cSeeAlso        aApp[14]
#define  cShort          aApp[15]
#define  cTitle          aApp[16]
#define  cTrackerNo      aApp[17]
#define  cUserID         aApp[18]
#define  cUserName       aApp[19]
#define  dComplDate      aApp[20]
#define  dOrigDate       aApp[21]
#define  nRecord         aApp[22]
#define  oBrowBox        aApp[23]
#define  oBrowse         aApp[24]
#define  oMsgBox         aApp[25]
#define  oStatBarRight   aApp[26]
#define  oStaticGets     aApp[27]
#define  oTabPage1       aApp[28]
#define  oTabPage2       aApp[29]
#define  oTabPage3       aApp[30]
#define  oTabPage4       aApp[31]
#define  oTabPage5       aApp[32]
#define  oToolBar        aApp[33]
#define  aLocate         aApp[35]
#define  bReSize         aApp[36]
#define  oUserID         aApp[37]
#define  oDesc           aApp[38]
#define  oResponse       aApp[39]
#define  oNotes          aApp[40]
#define  oShort          aApp[41]
#define  lAddingRec      aApp[42]
#define  lEditingRec     aApp[43]
#define  nRow            aApp[44]
#define  oStatBarBottom  aApp[45]
#define  oMsgStatic      aApp[46]
#define  oToolBottom     aApp[47]
#define  oStatBottom     aApp[48]
#define  cErrorDump      aApp[49]
#define  oErrorDump      aApp[50]
#define  oTracker        aApp[51]
#define  bEditProtect1   aApp[52]
#define  bEditProtect2   aApp[53]
#define  bEditProtect3   aApp[54]
#define  bColorBlock     aApp[55]

#define  ccompl_user     aApp[56]
#define  cveri_user      aApp[57]
#define  dveri_Date      aApp[58]
#define  cveri_time      aApp[59]

//FIELD tracker_no, user_id, orig_date, orig_time, priority, category

CLASS Tracker
EXPORTED:
  VAR trackerNo
  VAR userID
  VAR userName
  VAR priority
  VAR category
  VAR short
  VAR description
  VAR response
  VAR notes
  VAR errorDump
  VAR seeAlso
  VAR origDate
  VAR origTime
  VAR complDate
  VAR complTime
  VAR window
  METHOD init, dialog, addRecord, openFiles, trackerNo()
ENDCLASS


FUNCTION TrackerDialog()

LOCAL oThread := Thread():new(), oTracker

oThread:start({||oTracker:=Tracker():new(),oTracker:Dialog()})

RETURN oTracker

* -----------

METHOD Tracker:init()

RETURN self

* ----------

METHOD Tracker:dialog()

LOCAL GetList[0], GetOptions, i, aGets, oDialog

LOCAL aApp[90]

   local dialog_title := "Defect Tracker"

   local ogroup, ogroup2, ogroup3, oheader2
   local lresp   := .f., ;
         ldesc   := .f., ;
         lrnotes := .f., ;
         lerrlog := .f.

   local page_hdr_blk := {||cTrackerNo+": "+rtrim(cShort)+" (" + ;
                            rtrim(_UserName(aApp))+" "+DC_XtoC(dOrigDate)+")"}


oTracker := self
aGetList := GetList
lAddingRec := .f.
lEditingRec := .f.

aCategory := { 'New Feature', ;
               'Suggestion', ;
               'Defect', ;
               'Other' }

::openFiles()

_LoadFields( aApp,,,.f. )

nRecord    := TRACKER->(RecNo())

bEditProtect1 := {||!lEditingRec .AND. Trim(TRACKER->user_id)==Trim(Set_User())}

bEditProtect2 := {||!lEditingRec .OR. (Trim(TRACKER->user_id)#Trim(Set_User()) .AND. !lAddingRec)}

bEditProtect3 := {||!lEditingRec .OR. Set_User()=='ADMIN  '}

aPres := { ;
    { XBP_PP_COL_HA_FGCLR, GRA_CLR_YELLOW },     /*  Header FG Color  */     ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKBLUE },  /*  Header BG Color  */     ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },   /* Row Sep  */     ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },   /* Col Sep  */     ;
    { XBP_PP_COL_DA_ROWHEIGHT, 13 },                   /* Row Height */     ;
    { XBP_PP_COL_DA_CELLHEIGHT, 13 },                 /* Cell Height */     ;
    { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE }, /* Cursor FG Color*/     ;
    { XBP_PP_COL_DA_HILITE_BGCLR   , GRA_CLR_PALEGRAY  } ;
  }


/* ---- Tool Bar ---- */

//DCSTATUSBAR oStatBarRight ;
//   ALIGN DCGUI_ALIGN_RIGHT ;
//   WIDTH 9*7

@ 0,92*7 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX ;
      OBJECT oStatBarRight ;
      SIZE 9*7+1,13*1.2*20+2*10 ;
      PIXEL

@ 0,0 DCTOOLBAR oToolBar ;
   SIZE 9*7,1000 ;
   BUTTONSIZE 9*7,1.2*20 ;
   PIXEL ;
   PARENT oStatBarRight

DCADDBUTTON CAPTION '&Top' ;
            PARENT oToolBar ;
            TOOLTIP 'Go to the Top of the File' ;
            ACTION {||dbGoTop(),_LoadFields(aApp)} ;
            WHEN { || !DC_TestBof() .AND. !lEditingRec}

DCADDBUTTON CAPTION '&Previous' ;
            PARENT oToolBar ;
            TOOLTIP 'Skip to the Previous Record' ;
            ACTION {||dbSkip(-1),_LoadFields(aApp)} ;
            WHEN { || !DC_TestBof() .AND. !lEditingRec}

DCADDBUTTON CAPTION '&Next' ;
            PARENT oToolBar ;
            TOOLTIP 'Skip to the Next Record' ;
            ACTION {||dbSkip(), _LoadFields(aApp)} ;
            WHEN { || !DC_TestEof() .AND. !lEditingRec}

DCADDBUTTON CAPTION '&Bottom' ;
            PARENT oToolBar ;
            TOOLTIP 'Go to the Bottom of the File' ;
            ACTION {||dbGoBottom(),_LoadFields(aApp)} ;
            WHEN { || !DC_TestEof() .AND. !lEditingRec}

   DCADDBUTTON ;   // toolbar spacer
      PARENT  oToolBar ;
      TYPE    XBPSTATIC_TYPE_RAISEDBOX ;
      SIZE    9*7,10 ;
      PIXEL

DCADDBUTTON CAPTION 'Ne&w' ;
            PARENT oToolBar ;
            TOOLTIP 'Add a New Record' ;
            ACTION {||_NewRecord(aApp)} ;
            WHEN {||!lEditingRec}

DCADDBUTTON CAPTION '&Update' ;
            PARENT oToolBar ;
            TOOLTIP 'Edit the Selected Record' ;
            ACTION {||_UpdateRecord(aApp)} ;
            WHEN {||!lEditingRec .AND. ;
             (Trim(TRACKER->user_id)==Trim(Set_User()).OR.Trim(Set_User())=='ADMIN')}

DCADDBUTTON CAPTION '&Delete' ;
            PARENT oToolBar ;
            TOOLTIP 'Delete Selected Record' ;
            WHEN {||!lEditingRec .AND. ;
                    (Trim(TRACKER->user_id)==Trim(Set_User()) .OR. Trim(Set_User())=='ADMIN')} ;
            ACTION {|x|SetAppFocus(oTabPage1),;
                       x:=DC_MsgBox(,,{'Delete this Record?'},,,,.t.),;
                       iif(x,(tracker->(RecLock(5)),;
                              tracker->(dbDelete()),;
                              tracker->(dbUnlock()),;
                              tracker->(dbSkip()), ;
                              tracker->(dbSkip(-1)), ;
                              _LoadFields(aApp)),) }

DCADDBUTTON CAPTION '&Save' ;
            PARENT oToolBar ;
            TOOLTIP 'Save Changes to the File' ;
            ACTION {||IIF(lAddingRec,SetAppFocus(oTabPage1),nil),_SaveFields(aApp),DC_GetRefresh(aGetList)} ;
            WHEN {||lEditingRec}

DCADDBUTTON CAPTION '&Cancel' ;
            PARENT oToolBar ;
            CARGO 'CANCEL' ;
            TOOLTIP 'Cancel Changes to this Record' ;
            ACTION {||IIF(lAddingRec,dbGoto(nRecord),nil), ;
                      lAddingRec:=.f., ;
                      lEditingRec:=.f., ;
                      _LoadFields(aApp), ;
                      oMsgBox:setCaption('Cancelled!!')} ;
            WHEN {||lEditingRec}

   DCADDBUTTON ;   // toolbar spacer
      PARENT  oToolBar ;
      TYPE    XBPSTATIC_TYPE_RAISEDBOX ;
      SIZE    9*7,10 ;
      PIXEL

DCADDBUTTON CAPTION '&Find' ;
            PARENT oToolBar ;
            TOOLTIP 'Find a Record' ;
            ACTION {||_Find(aApp),DC_GetRefresh(Getlist)} ;
            WHEN {||!lEditingRec}


IF Trim(Set_User())=='ADMIN'
  DCADDBUTTON CAPTION 'Comp&leted' ;
            PARENT oToolBar ;
            TOOLTIP 'Update Completed Date and Time' ;
            ACTION {||_Completed(aApp),_LoadFields(aApp)} ;
            WHEN {||!lEditingRec}
ENDIF

DCADDBUTTON CAPTION '&Verified' ;
         PARENT oToolBar ;
         TOOLTIP 'Update Verified Date and Time' ;
         ACTION {||_verified(aApp),_LoadFields(aApp)} ;
         WHEN {||!lEditingRec.and.!empty(TRACKER->compl_date)}

DCADDBUTTON CAPTION 'E&xit' ;
            PARENT oToolBar ;
            TOOLTIP 'Exit the Tracker System' ;
            ;// ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
            ACTION {||PostAppEvent(xbeP_Close,,,odialog)} ;
            ;// ACTION {||tracker_close(odialog, aApp, getlist)} ;
            WHEN {||!lEditingRec}


//---------------------------------------------------------------------
// Bottom Statusbar with message
//DCSTATUSBAR oStatBarBottom ;
//   ALIGN DCGUI_ALIGN_BOTTOM ;
//   HEIGHT 28

@ 24*20,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      OBJECT oStatBarBottom ;
      SIZE 90*7+9*7,28 ;
      PIXEL

@ 3,4 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX ;
      SIZE 90*7+9*7-8,20 ;
      PARENT oStatBarBottom ;
      PIXEL ;
      OBJECT oMsgStatic

@ 1,2 DCSAY '' ;
      SIZE 450,18 ;
      SAYCENTER ;
      COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND ;
      OBJECT oMsgBox ;
      PARENT oMsgStatic ;
      PIXEL ;
      FONT '8.Arial Bold'


//---------------------------------------------------------------------
/* ---- Tab Page #1 ---- */

@  0,0 DCTABPAGE oTabPage1 ;
   CAPTION  'General (F2)' ;
   SIZE     90,16.5 ;
   GOTFOCUS {||SetAppFocus(oBrowse:getColumn(1))} ;
   ACCELKEY xbeK_F2 ;
   MESSAGE _Message('This TabPage contains general information',aApp)

// Set up browser.

@  1.7, 2 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX ;
   PARENT oTabPage1 ;
   OBJECT oBrowBox ;
   SIZE 87,14.1

bColorBlock := {||IIF(Empty(TRACKER->compl_date), ;
                      {GRA_CLR_BLACK,GRA_CLR_WHITE}, ;
                      {GRA_CLR_DARKGREEN,GRA_CLR_WHITE})}

@ .1,.5 DCBROWSE oBrowse ;
   PARENT oBrowBox ;
   ALIAS 'TRACKER' ;
   SIZE 86,13.8 ;
   _NOHSCROLL   .f. ;
   _NOSOFTTRACK .t. ;
   ITEMSELECTED {||_LoadFields(aApp),SetAppFocus(oTabPage2)} ;
   ITEMMARKED {||_LoadFields(aApp,DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE})} ;
   PRESENTATION aPres ;
   CURSORMODE   XBPBRW_CURSOR_ROW ;
   FREEZELEFT {1,2} ;
   COLOR bColorBlock

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||TRACKER->tracker_no} ;
   HEADER "Number" ;
   SORT {||_ColorHeader(1,aApp),OrdSetFocus('TRACKER_NO')} ;
      LEFTBUTTON ;
   WIDTH 4

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||rtrim(TRACKER->short)} ;
   HEADER "Short Description" ;
   WIDTH 19

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||DC_XtoC(TRACKER->orig_date)} ;
   HEADER "Reported" ;
   SORT {||_ColorHeader(3,aApp),OrdSetFocus('DATE')} ;
   WIDTH 5

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||rtrim(_UserName(aApp,TRACKER->user_id))} ;
   HEADER "User ID" ;
   SORT {||_ColorHeader(4,aApp),OrdSetFocus('USER_ID')} ;
      LEFTBUTTON ;
   WIDTH 8

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||TRACKER->priority} ;
   HEADER "P" ;
   SORT {||_ColorHeader(5,aApp),OrdSetFocus('PRIORITY')} ;
      LEFTBUTTON ;
   WIDTH 1

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||rtrim(TRACKER->category)} ;
   HEADER "Category" ;
   SORT {||_ColorHeader(6,aApp),OrdSetFocus('CATEGORY')} ;
      LEFTBUTTON ;
   WIDTH 6

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||DC_XtoC(TRACKER->compl_date)} ;
   HEADER "Completed" ;
   WIDTH 5

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||DC_XtoC(TRACKER->veri_date)} ;
   HEADER "Verified" ;
   WIDTH 5

DCBROWSECOL ;
   PARENT oBrowse ;
   DATA {||iif(!empty(tracker->desc),      "D"," ") + ;
           iif(!empty(tracker->response),  "R"," ") + ;
           iif(!empty(tracker->notes),     "N"," ") + ;
           iif(!empty(tracker->error_dump),"E"," ")}  ;
   HEADER "Notes" ;
   WIDTH 3

   //------------------------------------------------------------------
   @ 16.8,2 DCTOOLBAR oStaticGets ;
      SIZE 87,7.0 ;
//      PARENT oTabPage1

   @ .25, 1 ;
      DCGROUP ogroup ;
         PARENT  oStaticGets ;
         CAPTION "Report" ;
         SIZE    25, 3.5 ;
         COLOR   GRA_CLR_DARKPINK

   @ 0.8, 1 DCSAY "Number" ;
      PARENT ogroup ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 0.8,10 DCSAY {||cTrackerNo} ;
      PARENT ogroup ;
      SAYLEFT ;
      SAYSIZE 10 ;
      COLOR GRA_CLR_BLUE

   @ 1.6, 1 DCSAY "Reported by" ;
      PARENT ogroup ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 1.6,10 DCSAY {||rtrim(_UserName(aApp))} ;
      PARENT ogroup ;
      SAYLEFT ;
      SAYSIZE 12 ;
      COLOR GRA_CLR_BLUE

   @ 2.4, 1 DCSAY "On" ;
      PARENT ogroup ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 2.4,10 DCSAY {||DC_XtoC(dOrigDate)} ;
      PARENT ogroup  ;
      SAYLEFT ;
      SAYSIZE 8 ;
      COLOR GRA_CLR_BLUE

   @ 2.4,17.5 DCSAY {||cOrigTime} ;
      PARENT ogroup ;
      SAYLEFT ;
      SAYSIZE 7 ;
      COLOR GRA_CLR_BLUE

   //------------------------------------------------------------------
   @ .25,27 ;
      DCGROUP ogroup3 ;
         PARENT  oStaticGets ;
         CAPTION "Information" ;
         SIZE    59, 6.5 ;
         COLOR   GRA_CLR_DARKPINK

   @ 0.8, 1  DCSAY "Description" ;
      PARENT ogroup3 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 0.8,10 DCGET cShort ;
      PARENT ogroup3 ;
      GETSIZE 48 ;
      COLOR GRA_CLR_BLACK ;
      GETOBJECT oShort ;
      EDITPROTECT bEditProtect2 ;
      MESSAGE 'Enter a short description of this Posting (REQUIRED)' ;
      VALID { ||!Empty(cShort)}

   @ 1.8, 1 DCSAY 'Category' ;
      PARENT ogroup3 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 1.8,10 DCCOMBOBOX cCategory ;
      LIST aCategory ;
      PARENT ogroup3 ;
      SIZE 20,6 ;
      COLOR GRA_CLR_BLACK ;
      EDITPROTECT bEditProtect2 ;
      MESSAGE 'Enter a Category (REQUIRED)' ;
      VALID { || IIF(Empty(cCategory),DC_MsgBox('Category Required'),nil), ;
               !Empty(cCategory) } ;
      EVAL {|o|o:keyboard:={|a,b,x|IIF(a==xbeK_ENTER,(SetAppFocus(oTabPage2),SetAppFocus(oDesc)),nil)}}

   @ 1.8,35 DCSAY "Priority (A/B/C)" ;
      PARENT ogroup3 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 1.8,47 DCGET cPriority ;
      PARENT ogroup3 ;
      PICT '@!' ;
      COLOR GRA_CLR_BLACK ;
      VALID {||cPriority$'ABC'} ;
      EDITPROTECT bEditProtect2 ;
      MESSAGE 'A - High Priority,  B - Can wait a few days,  C - Can live without it (but really want it)'

   @ 2.8, 1  DCSAY "See Also" ;
      PARENT ogroup3 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 2.8,10 DCGET cSeeAlso ;
      PARENT ogroup3 ;
      GETSIZE 48 ;
      COLOR GRA_CLR_BLACK ;
      EDITPROTECT bEditProtect2 ;
      MESSAGE "Enter a list of Tracker item IDs related to this item" ;
      VALID {||.t.}

   @ 3.8, 1 DCCHECKBOX ldesc ;
      DATALINK    {||ldesc:=!empty(cDescription)} ;
      PARENT      ogroup3 ;
      PROMPT      "Description" ;
      EDITPROTECT {||.t.} ;
      COLOR       GRA_CLR_BLACK

   @ 3.8,15 DCCHECKBOX lresp ;
      DATALINK    {||lresp:=!empty(cResponse)} ;
      PARENT      ogroup3 ;
      PROMPT      "Response" ;
      EDITPROTECT {||.t.} ;
      COLOR       GRA_CLR_BLACK

   @ 3.8,28 DCCHECKBOX lrnotes ;
      DATALINK    {||lrnotes:=!empty(cNotes)} ;
      PARENT      ogroup3 ;
      PROMPT      "Release notes" ;
      EDITPROTECT {||.t.} ;
      COLOR       GRA_CLR_BLACK

   @ 3.8,44 DCCHECKBOX lerrlog ;
      DATALINK    {||lerrlog:=!empty(cErrorDump)} ;
      PARENT      ogroup3 ;
      PROMPT      "Error log" ;
      EDITPROTECT {||.t.} ;
      COLOR       GRA_CLR_BLACK

   //------------------------------------------------------------------
   @ 3.75, 1 ;
      DCGROUP ogroup2 ;
         PARENT  oStaticGets ;
         CAPTION "Resolution" ;
         SIZE    25, 3 ;
         COLOR   GRA_CLR_DARKPINK

   @ 0.8, 1 DCSAY "Compl." ;
      PARENT ogroup2 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 0.8, 6.5 DCSAY {||DC_XtoC(dComplDate)} ;
      PARENT ogroup2  ;
      SAYLEFT ;
      SAYSIZE 9 ;
      COLOR GRA_CLR_BLUE

   @ 0.8,14.5 DCSAY {||rtrim(_username(aApp,ccompl_user))} ;
      PARENT ogroup2 ;
      SAYLEFT ;
      SAYSIZE 10 ;
      COLOR GRA_CLR_BLUE

   @ 1.8, 1 DCSAY "Verified" ;
      PARENT ogroup2 ;
      SAYLEFT ;
      COLOR GRA_CLR_BLACK

   @ 1.8, 6.5 DCSAY {||DC_XtoC(dveri_Date)} ;
      PARENT ogroup2  ;
      SAYLEFT ;
      SAYSIZE 9 ;
      COLOR GRA_CLR_BLUE

   @ 1.8,14.5 DCSAY {||rtrim(_username(aApp,cveri_user))} ;
      PARENT ogroup2 ;
      SAYLEFT ;
      SAYSIZE 10 ;
      COLOR GRA_CLR_BLUE

/* ---- Tab Page #2 ---- */

@  0,0 DCTABPAGE oTabPage2 ;
   CAPTION 'Desc. (F3)' ;
   RELATIVE oTabPage1 ;
   ACCELKEY xbeK_F3 ;
   GOTFOCUS {||SetAppFocus(oDesc)} ;
   MESSAGE  {||_Message("This TabPage is for the Poster's Description Memo",aApp)}

@  1.7, 1 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX ;
   SIZE 87,1 ;
   PARENT oTabPage2 ;
   OBJECT oheader2

@  .15, .45 DCSAY page_hdr_blk ;
   PARENT oheader2 ;
   SAYSIZE 86 ;
   SAYLEFT ;
   FONT "10.Helv.Bold" ;
   COLOR GRA_CLR_DARKBLUE, gramakergbcolor({241,234,189})

@  3.0,1 DCMULTILINE cDescription ;
   PARENT      oTabPage2 ;
   SIZE        87,13 ;
   FONT        "10.Courier" ;
   NOHORIZSCROLL ;
   EDITPROTECT bEditProtect2 ;
   OBJECT      oDesc ;
   GOTFOCUS    {|a,b,o|_SetFocus(o)}


/* ---- Tab Page #3 ---- */

@  0,0 DCTABPAGE oTabPage3 ;
   CAPTION 'Response (F4)' ;
   RELATIVE oTabPage2 ;
   ACCELKEY xbeK_F4 ;
   GOTFOCUS {||SetAppFocus(oResponse)} ;
   MESSAGE  {||_Message("This TabPage is for Programming Team's Response Memo",aApp)}

@  1.7, 1 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX ;
   SIZE 87,1 ;
   PARENT oTabPage3 ;
   OBJECT oheader2

@  .15, .45 DCSAY page_hdr_blk ;
   PARENT oheader2 ;
   SAYSIZE 86 ;
   SAYLEFT ;
   FONT "10.Helv.Bold" ;
   COLOR GRA_CLR_DARKBLUE, gramakergbcolor({241,234,189})

@  3.0,1 DCMULTILINE cResponse ;
   PARENT      oTabPage3 ;
   SIZE        87,13 ;
   FONT        "10.Courier" ;
   NOHORIZSCROLL ;
   EDITPROTECT bEditProtect3 ;
   OBJECT      oResponse ;
   GOTFOCUS    {|a,b,o|_SetFocus(o)}

/* ---- Tab Page #4 ---- */

@  0,0 DCTABPAGE oTabPage4 ;
   CAPTION 'Notes (F5)' ;
   RELATIVE oTabPage3 ;
   ACCELKEY xbeK_F5 ;
   GOTFOCUS {||SetAppFocus(oNotes)} ;
   MESSAGE {||_Message('This TabPage is for Release Notes (from Programming Team)',aApp)}

@  1.7, 1 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX ;
   SIZE 87,1 ;
   PARENT oTabPage4 ;
   OBJECT oheader2

@  .15, .45 DCSAY page_hdr_blk ;
   PARENT oheader2 ;
   SAYSIZE 86 ;
   SAYLEFT ;
   FONT "10.Helv.Bold" ;
   COLOR GRA_CLR_DARKBLUE, gramakergbcolor({241,234,189})

@  3.0,1 DCMULTILINE cNotes ;
   PARENT      oTabPage4 ;
   SIZE        87,13 ;
   FONT        "10.Courier" ;
   NOHORIZSCROLL ;
   EDITPROTECT bEditProtect3 ;
   OBJECT      oNotes ;
   GOTFOCUS    {|a,b,o|_SetFocus(o)}

/* ---- Tab Page #5 ---- */

@  0,0 DCTABPAGE oTabPage5 ;
   CAPTION  'ErrorDump (F6)' ;
   RELATIVE oTabPage4 ;
   ACCELKEY xbeK_F6 ;
   GOTFOCUS {||SetAppFocus(oErrorDump)} ;
   MESSAGE  {||_Message('This TabPage is for error dump text (from Cowpoke)',aApp)}

@  1.7, 1 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX ;
   SIZE 87,1 ;
   PARENT oTabPage5 ;
   OBJECT oheader2

@  .15, .45 DCSAY page_hdr_blk ;
   PARENT oheader2 ;
   SAYSIZE 86 ;
   SAYLEFT ;
   FONT "10.Helv.Bold" ;
   COLOR GRA_CLR_DARKBLUE, gramakergbcolor({241,234,189})

@  3.0,1 DCMULTILINE cErrorDump ;
   PARENT   oTabPage5 ;
   SIZE     87,13 ;
;//   FONT     "8.Courier" ;
   FONT     "8.Courier New" ;
   READONLY ;
   OBJECT   oErrorDump ;
   GOTFOCUS {|a,b,o|_SetFocus(o)}

DCGETOPTIONS ;
   SAYRIGHTCENTER ;
   SAYWIDTH 110 ;
   HILITEGETS GRA_CLR_RED ;
   NOESCAPEKEY ;
   FITPAD 3 ;
   HIDE ;
   MESSAGEINTO {|c|oMsgBox:setCaption(c)}


   //------------------------------------------------------------------
   DCREAD GUI ;
      TITLE     dialog_title ;
      PARENT    @oDialog ;
      HANDLER   DlgHandler REFERENCE aApp ;
      OPTIONS   getoptions ;
      FIT ;
      NODESTROY ;   // destroyed in :close callback
      EVAL      {|o|::window := o, tracker_dialog_init(o, oBrowse, aApp)}

RETURN nil


//

static function tracker_dialog_init(o, obr, aApp)
// Initialization for tracker dialog window.
// Parameters: o - xbpdialog object for tracker window
//             obr - xbpbrowse object for tracker item list
//             aApp -

   // Initialize the browse.
   oBr:goBottom()
   oBr:forceStable()
   _ColorHeader(1,aApp)

   o:close := {|p1,p2,odlg|tracker_close(odlg)} // close callback

   setappfocus(obr:getcolumn(1))

   o:show()   // unhide (show) the dialog

   o:minsize := o:currentSize()
   o:maxSize := o:currentSize()
   o:resize := {|a,b,oDlg|IIF(!oDlg:getFrameState()==XBPDLG_FRAMESTAT_NORMALIZED .AND. ;
                              lEditingRec, ;
                              (oDlg:setFrameState(XBPDLG_FRAMESTAT_NORMALIZED), ;
                               Tone(300,1)),nil)}

return (nil)

//

static function tracker_close_confirm(odlg, aApp, getlist)
// Close Tracker dialog window.
// Parameters: odlg    - tracker dialog object
//             aApp    - array of variables (for lEditingRec)
//             getlist - DC getlist array for Tracker dialog

   local nbutton

   if lEditingRec .and. dc_getorigupdated(getlist)

      nbutton := confirmbox(,"Changes have been made to this record" + ;
                            chr(13) + ;
                            "Are you sure you want to exit without saving?", ;
                            "Tracker Close Request", ;
                            XBPMB_YESNO , ;
                            XBPMB_QUESTION+XBPMB_APPMODAL+XBPMB_MOVEABLE)

      if !nbutton == XBPMB_RET_YES
         return (.f.)   // multi-return alert <<<<<<<<<<<<<<<<<<<<<<<<<
      endif

   endif

return (.t.)

// --------------------------------------------------------------------

static function tracker_close(oDlg)
// Function for close callback.
// Parameters: odlg - tracker xbpdialog object

   dbcloseall()
   odlg:destroy()

RETURN (nil)

//

STATIC FUNCTION ;
  DlgHandler ( nEvent, mp1, mp2, oXbp, oDialog, GetList, aApp )

   local retval := DCGUI_NONE   // default return value

   IF nEvent == xbeP_Close

      IF !tracker_close_confirm(oDialog, aApp, getlist)
         retval := DCGUI_IGNORE
      ENDIF

   ENDIF   // nEvent == xbeP_Close

RETURN (retval)

* -------------------

STATIC FUNCTION _LoadFields ( aApp, nRefreshMode, aRefreshList, lRefresh )

LOCAL nSaveRec := RecNo(), nSaveOrder := IndexOrd()

DEFAULT lRefresh := .t.

cDescription := TRACKER->desc
cSeeAlso     := TRACKER->see_also
cCategory    := TRACKER->category
cShort       := TRACKER->short
dOrigDate    := TRACKER->orig_date
cOrigTime    := TRACKER->orig_time
dComplDate   := TRACKER->compl_date
cComplTime   := TRACKER->compl_time
cResponse    := TRACKER->response
cNotes       := TRACKER->notes
cErrorDump   := TRACKER->error_dump
cPriority    := TRACKER->priority
cUserID      := TRACKER->user_id
//cUserName    := TRACKER->user_name
ccompl_user  := tracker->compl_user
cveri_user   := tracker->veri_user
dveri_Date   := tracker->veri_date
cveri_time   := tracker->veri_time


IF lAddingRec
  cTrackerNo := oTracker:TrackerNo(aApp)
  dOrigDate := Date()
  cOrigTime := Time()
  cUserID := _UserId(aApp)
ELSE
  cTrackerNo   := TRACKER->tracker_no
ENDIF

IF lRefresh

  DC_GetRefresh(aGetList, nil, nRefreshMode, aRefreshList )
  DC_GetOrigSet( aGetList )  // Store new values to ORIG field in Getlist

ENDIF

RETURN .t.

/* ------------------ */

PROCEDURE _SaveFields ( aApp )

LOCAL nSaveOrder := IndexOrd(), nSaveRec := RecNo()

IF lAddingRec
  TRACKER->(DC_AddRec(5))
ELSE
  TRACKER->(DC_Reclock(5))
ENDIF

IF Empty(dOrigDate) .OR. Empty(StrTran(cOrigTime,':',''))
  dOrigDate := Date()
  cOrigTime := Time()
ENDIF

REPL TRACKER->desc WITH cDescription
REPL TRACKER->see_also WITH cSeeAlso
REPL TRACKER->category WITH cCategory
REPL TRACKER->short WITH cShort
REPL TRACKER->orig_date WITH dOrigDate
REPL TRACKER->orig_time WITH cOrigTime
REPL TRACKER->compl_date WITH dComplDate
REPL TRACKER->compl_time WITH cComplTime
REPL TRACKER->response WITH cResponse
REPL TRACKER->notes WITH cNotes
REPL TRACKER->error_dump WITH cErrorDump
REPL TRACKER->priority WITH cPriority
REPL TRACKER->user_id WITH cUserID
//REPL TRACKER->user_name WITH cUserName
IF lAddingRec
  cTrackerNo := oTracker:TrackerNo(aApp)
  REPL TRACKER->tracker_no WITH cTrackerNo
ENDIF
tracker->compl_user := ccompl_user
tracker->veri_user  := cveri_user
tracker->veri_date  := dveri_Date
tracker->veri_time  := cveri_time

TRACKER->(dbCommit())
TRACKER->(dbUnlock())

DC_GetOrigSet( aGetList )  // Store new values to ORIG field in Getlist

lAddingRec := .f.
lEditingRec := .f.
oMsgBox:setCaption('Record has been Saved!!')

RETURN

/* ------------------- */

STATIC FUNCTION _SetFocus ( oXbp )

STATIC oFocus

IF Valtype(oXbp) = 'O'
  oFocus := oXbp
ENDIF
RETURN oFocus

/* ------------------- */

STATIC FUNCTION _PrintItem ()

MsgBox( '_PrintItem() is not completed' )

RETURN nil

/* --------------------- */

STATIC FUNCTION _Paste ()

LOCAL oXbp := _SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:pasteMarked()
  oXbp:GetData()
ENDIF
RETURN nil

/* --------------------- */

STATIC FUNCTION _Copy ()

LOCAL oXbp := _SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:copyMarked()
  oXbp:setMarked({0,0})
ENDIF
RETURN nil

/* --------------------- */

STATIC FUNCTION _Cut ()

LOCAL oXbp := _SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:cutMarked()
  oXbp:GetData()
ENDIF
RETURN nil

/* --------------------- */

STATIC FUNCTION _Find ( aApp )

LOCAL GetList := {}, nRecNo := RecNo(), cSeek, nChoice, cLocate, lOk, aFields, ;
      lBrowse := .f.

cSeek := Space(20)
cLocate := Space(30)
aFields := { ;
   { {||TRACKER->user_id}, 'User Id', 8, "USER_ID", 'User ID' } , ;
   { {||TRACKER->category}, 'Category', 8, 'CATEGORY', 'Category' }, ;
   { {||TRACKER->SHORT}, 'Short Description', 25, nil, nil } ;
 }
@ 0,0 DCSAY 'Item to Seek' GET cSeek PICT '@!' ;
      SAYRIGHT SAYSIZE 30 TABSTOP

@ 2,0 DCSAY 'Text to Locate' GET cLocate PICT '@!' ;
      SAYRIGHT SAYSIZE 30 TABSTOP

@ 4,0 DCPUSHBUTTON CAPTION '~Browse' SIZE 9,1.2 ;
      TABSTOP ;
      ACTION {||lBrowse:=DC_FindBrowse(aFields,,,,85,15), ;
                DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

DCREAD GUI FIT ADDBUTTONS ENTEREXIT TO lOk MODAL ;
   TITLE 'Find or Locate a Record'

IF lOk .AND. (!Empty(cSeek) .OR. !Empty(cLocate))
  IF !Empty(cSeek)
    OrdSetFocus('COMMAND')
    cSeek := Alltrim(Upper(cSeek))
    dbSeek( cSeek )
  ENDIF
  IF Eof() .OR. Empty(cSeek)
    IF !Empty(cLocate)
      cSeek := Alltrim(Upper(cLocate))
    ENDIF
    IF !Empty(cLocate) .OR. DC_MsgBox(,,{'Search: ' + cSeek,'', ;
                'Record not found in Index. Try using text-search?'},,,,.t.)
      LOCATE FOR cSeek $ Upper(TRACKER->desc) .OR. ;
                 cSeek $ Upper(TRACKER->response) .OR.   ;
                 cSeek $ Upper(TRACKER->notes) .OR.     ;
                 cSeek $ Upper(TRACKER->short)
      IF !Eof()
        nChoice = 1
        DO WHILE nChoice = 1
          _LoadFields(aApp)
          nChoice := DC_Alert('Text Search: ' + cSeek, ;
                     { '&Continue','&Ok', '&Abort' }, nil,nil,nil,nil,nil,@aLocate )
          IF nChoice = 1
            CONTINUE
          ELSEIF nChoice = 3
            GO nRecNo
            EXIT
          ELSE
            EXIT
          ENDIF
        ENDDO
        _LoadFields(aApp)
      ELSE
        DC_MsgBox({'Search: ' + cSeek,'','Record not found'})
      ENDIF
    ELSE
      GO nRecNo
    ENDIF
  ELSE
    _LoadFields(aApp)
  ENDIF
ELSEIF lBrowse
    _LoadFields(aApp)
ENDIF

RETURN nil


/* ------------------- */

FUNCTION _PrintList ()

MsgBox( '_PrintList() is not completed' )

RETURN nil

/* -------------------- */

STATIC FUNCTION RecLock( nWaitTime )

LOCAL nWait

IF DBRLOCK()
  RETURN (.T.)   // locked
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime=0 .OR. nWait>0)
    IF DBRLOCK()     // locked
      RETURN (.T.)
    ENDIF
    INKEY(.5)     // wait 1/2 second
    nWait -= .5
  ENDDO
ENDDO
RETURN (.F.)      // not locked

/* -------------------- */

STATIC FUNCTION AddRec ( nWaitTime )

LOCAL nWait

APPEND BLANK
IF !NETERR()
   RETURN (.T.)
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime = 0 .OR. nWait > 0)
    APPEND BLANK
    IF .NOT. NETERR()
      RETURN .T.
    ENDIF
    nWait -= .5
  ENDDO
ENDDO
RETURN .F.

/* --------------------- */

STATIC FUNCTION FiLock( nWaitTime )

LOCAL nWait

IF FLOCK()
  RETURN (.T.)   // locked
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime=0 .OR. nWait>0)
    INKEY(.5)     // wait 1/2 second
    nWait -= .5
    IF FLOCK()
      RETURN (.T.)    // locked
    ENDIF
  ENDDO
ENDDO
RETURN .F.

/* ------------------- */

STATIC FUNCTION Pack ( aApp )

LOCAL lIsShared := dbInfo( DBO_SHARED )

IF lIsShared
  IF DC_MsgBox(,,{'The file must be opened exclusive to Pack.',;
                      'Close file and reopen exclusive?'},,,,.t.)
    dbCloseArea()
    USE xpddoc EXCLUSIVE VIA FOXCDX
  ENDIF
ENDIF
lIsShared := dbInfo( DBO_SHARED )
IF !lIsShared
  dbPack()
  dbGoTop()
  _LoadFields( aApp )
ENDIF

RETURN nil

/* --------------------- */

STATIC FUNCTION MemoTrim ( cMemo, cQuote )

LOCAL cOut := '', cLine, nLines, i

cQuote := IIF(Valtype(cQuote)='C',cQuote,'')
nLines := MlCount(cMemo)
FOR i := nLines TO 1 STEP -1
  IF !Empty(Trim(MemoLine(cMemo,,i)))
    EXIT
  ENDIF
NEXT
nLines := i
FOR i := 1 TO nLines
  cLine := Trim( MemoLine( cMemo,, i ) ) + CRLF
  IF Empty(cLine) .AND. i=nLines
    EXIT
  ENDIF
  cOut += ( cQuote + cLine )
NEXT

RETURN cOut

* -------------------

FUNCTION _LoadRdds()

LOCAL i, aDbeList := DbeList(), cDbeList := '', cDbe := dbeSetDefault()

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

  IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
     DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  ENDIF
  IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
     DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  ENDIF
  IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
     DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  ENDIF

DbeSetDefault(cDbe)

RETURN .t.

* -------------

STATIC FUNCTION _NewRecord(aApp)

nRecord := RecNo()
dbGoBottom()
dbSkip()
lAddingRec := .t.
lEditingRec := .t.
_LoadFields(aApp)
SetAppFocus(oTabPage1)
SetAppFocus(oShort)
oMsgBox:setCaption('*** Adding NEW Tracking Item ***')

RETURN nil

* -------------

STATIC FUNCTION _UpdateRecord(aApp)

lEditingRec := .t.
DC_GetWhen(aGetList)
IF !oTabPage1:minimized
  SetAppFocus(oShort)
ELSEIF !oTabPage2:minimized
  SetAppFocus(oDesc)
ELSEIF !oTabPage3:minimized
  SetAppFocus(oResponse)
ELSEIF !oTabPage4:minimized
  SetAppFocus(oNotes)
ENDIF

oMsgBox:setCaption('*** Editing Tracking Item ***')

RETURN nil

* -------------

STATIC FUNCTION _Message( cMessage, aApp )

IF lAddingRec
  RETURN '*** Adding NEW Tracker Item ***'
ELSEIF lEditingRec
  RETURN '*** Editing Tracker Item ***'
ENDIF

RETURN cMessage

* -------------

METHOD Tracker:openFiles()

LOCAL aStructure

//////SET DELETED ON    // why do we need this?

_LoadRdds()

IF !File('TRACKER.DBF')
  aStructure := { ;
   { 'TRACKER_NO','C',    5, 0 },;
   { 'USER_ID',   'C',    7, 0 },;
   { 'ORIG_DATE', 'D',    8, 0 },;
   { 'ORIG_TIME', 'C',    8, 0 },;
   { 'COMPL_USER','C',    7, 0 },;
   { 'COMPL_DATE','D',    8, 0 },;
   { 'COMPL_TIME','C',    8, 0 },;
   { 'VERI_USER', 'C',    7, 0 },;
   { 'VERI_DATE', 'D',    8, 0 },;
   { 'VERI_TIME', 'C',    8, 0 },;
   { 'SHORT',     'C',   65, 0 },;
   { 'DESC',      'M',   10, 0 },;
   { 'RESPONSE',  'M',   10, 0 },;
   { 'NOTES',     'M',   10, 0 },;
   { 'ERROR_DUMP','M',   10, 0 },;
   { 'PRIORITY',  'C',    1, 0 },;
   { 'CATEGORY',  'C',   20, 0 },;
   { 'SEE_ALSO',  'C',   60, 0 } }
  dbCreate( 'TRACKER.DBF', aStructure, 'FOXCDX' )
ENDIF

IF !DC_DbSel('TRACKER')

  USE TRACKER VIA 'FOXCDX' NEW

  IF !File('TRACKER.CDX')
    INDEX ON tracker->tracker_no TAG 'TRACKER_NO' TO TRACKER.CDX
    INDEX ON Upper(tracker->user_id)+DtoS(tracker->orig_date)+tracker->orig_time TAG 'USER_ID' TO TRACKER.CDX
    INDEX ON DtoS(tracker->orig_date)+tracker->orig_time+Upper(tracker->user_id) TAG 'DATE' TO TRACKER.CDX
    INDEX ON tracker->priority+DtoS(tracker->orig_date)+tracker->orig_time+Upper(tracker->user_id) TAG 'PRIORITY' TO TRACKER.CDX
    INDEX ON tracker->category+Dtos(tracker->orig_date)+tracker->orig_time+Upper(tracker->user_id) TAG 'CATEGORY' TO TRACKER.CDX
  ENDIF

  SET INDEX TO TRACKER.CDX

ENDIF

SELE TRACKER

RETURN self

* -----------------

METHOD Tracker:addRecord()

LOCAL lDeleted := Set(_SET_DELETED,.f.), nSaveArea := Select()

::openFiles()

::TrackerNo := ::TrackerNo()

DEFAULT ::userID := Set_User(), ;
        ::priority := 'A', ;
        ::category := 'Defect', ;
        ::short := '', ;
        ::description := '', ;
        ::response := '', ;
        ::notes := '', ;
        ::errordump := '', ;
        ::seealso := '', ;
        ::origdate := Date(), ;
        ::origtime := Time(), ;
        ::compldate := Ctod(''), ;
        ::compltime := ''


TRACKER->(dbGoTop())

DO WHILE !TRACKER->(Eof())
  IF TRACKER->(Deleted())
    EXIT
  ENDIF
  TRACKER->(dbSkip())
ENDDO

IF TRACKER->(Eof())
  TRACKER->(DC_AddRec(5))
ELSE
  TRACKER->(DC_RecLock(5))
  TRACKER->(dbRecall())
ENDIF

REPL TRACKER->tracker_no WITH ::TrackerNo
REPL TRACKER->user_id WITH ::userID
REPL TRACKER->priority WITH ::priority
REPL TRACKER->category WITH ::category
REPL TRACKER->short WITH ::short
REPL TRACKER->desc WITH ::description
REPL TRACKER->response WITH ::response
REPL TRACKER->notes WITH ::notes
REPL TRACKER->error_dump WITH ::errorDump
REPL TRACKER->see_also WITH ::seeAlso
REPL TRACKER->orig_date WITH ::origDate
REPL TRACKER->orig_time WITH ::origTime
REPL TRACKER->compl_date WITH ::complDate
REPL TRACKER->compl_time WITH ::complTime

TRACKER->(dbCommit())
TRACKER->(dbUnlock())

Set(_SET_DELETED,lDeleted)

STORE nil TO ;
   ::userID, ;
   ::username, ;
   ::priority, ;
   ::category, ;
   ::short, ;
   ::description, ;
   ::response, ;
   ::notes, ;
   ::errordump, ;
   ::seealso, ;
   ::origdate, ;
   ::origtime, ;
   ::compldate, ;
   ::compltime

CLOSE TRACKER
SELE (nSaveArea)

RETURN self

* -------------

METHOD Tracker:TrackerNo(aApp)

LOCAL cTrackNo, nSaveOrder := IndexOrd(), nSaveRec := RecNo()

TRACKER->(OrdSetFocus('TRACKER_NO'))
TRACKER->(dbGoBottom())
TRACKER->(OrdSetFocus(nSaveOrder))
cTrackNo := DC_PadZero(DC_NumIncr(TRACKER->tracker_no))
IF Empty(cTrackNo)
  cTrackNo := '00001'
ENDIF
TRACKER->(dbGoto(nSaveRec))

RETURN cTrackNo

* -------------

static FUNCTION dc_numincr ( cVarName, cLoVal, cHiVal )

STATIC cVar := ''

LOCAL  nVarLength, nNumStart, nNumEnd, nVarPointer, cNewString

IF Empty(cVarName)
  cVarName := cVar
ENDIF
nVarLength := LEN(cVarName)
nVarPointer := nVarLength
DO WHILE nVarPointer>0
  IF SUBSTR(cVarName,nVarPointer,1)>='0' ;
    .AND. SUBSTR(cVarName,nVarPointer,1)<='9'
    EXIT
  ENDIF
  nVarPointer--
ENDDO
nNumEnd := nVarPointer
DO WHILE nVarPointer>0
  IF (SUBSTR(cVarName,nVarPointer,1)<'0' ;
    .OR. SUBSTR(cVarName,nVarPointer,1)>'9') .AND. ;
    SUBSTR(cVarName,nVarPointer,1)#' '
    EXIT
  ENDIF
  nVarPointer--
ENDDO
nNumStart := nVarPointer+1
cNewString := STRTRAN(STR(VAL(SUBSTR(cVarName,nNumStart,;
           nNumEnd-nNumStart+1))+1,nNumEnd-nNumStart+1),' ','0')
cVar := SUBSTR(cVarName,1,nNumStart-1)+cNewString+;
        SUBSTR(cVarName,nNumEnd+1,nVarLength-nNumEnd)
IF !Empty(cLoVal) .AND. !Empty(cHiVal) .AND. cVar > cHiVal
  cVar := cLoVal
ENDIF
RETURN cVar

* -----------------

STATIC FUNCTION _UserName(aApp,cID)

LOCAL cName
DEFAULT cID := cUserID

IF Trim(cID) == 'ADMIN'
  RETURN 'System Administrator'
ENDIF

RETURN 'Unknown User'

* -------------

STATIC FUNCTION _UserId(aApp)

// Put code here to return the USER ID of the logged on user instead of Space(7).

RETURN Pad('ADMIN',10)

* -------------

FUNCTION dc_dbsel ( cAlias )

LOCAL i

cAlias := IIF(Valtype(cAlias)='C',UPPER(cAlias),'')
IF cAlias=='0'
  FOR i := 253 TO 1 STEP -1
    IF Empty(Alias(i))
      SELE (i)
      RETURN .t.
    ENDIF
  NEXT
  RETURN .f.
ENDIF
cAlias := IIF(Valtype(cAlias)='C',cAlias,'')
IF SELECT(cAlias)>0 .AND. !(':'$cAlias)
  SELE SELECT(cAlias)
  RETURN .t.
ENDIF
RETURN .f.

* ----------------

STATIC FUNCTION _Completed(aApp)

IF TRACKER->(DC_RecLock(5))
  IF Empty(TRACKER->compl_date)
    tracker->compl_user := set_user()
    TRACKER->compl_date := Date()
    TRACkER->compl_time := Time()
  ELSE
    tracker->compl_user := ""
    TRACKER->compl_date := Ctod("")
    TRACkER->compl_time := ""
  ENDIF
  TRACKER->(dbCommit())
  TRACKER->(dbUnlock())
ENDIF

RETURN nil

* ----------------

STATIC FUNCTION _verified(aApp)

IF TRACKER->(DC_RecLock(5))
  IF Empty(TRACKER->veri_date)
    tracker->veri_user := set_user()
    TRACKER->veri_date := Date()
    TRACkER->veri_time := Time()
  ELSE
    tracker->veri_user := ""
    TRACKER->veri_date := Ctod("")
    TRACkER->veri_time := ""
  ENDIF
  TRACKER->(dbCommit())
  TRACKER->(dbUnlock())
ENDIF

RETURN nil

* ----------------

STATIC FUNCTION _ColorHeader( nColumn, aApp )

LOCAL i, oColumn, bBlock

FOR i := 1 TO oBrowse:colCount
  oColumn := oBrowse:GetColumn(i)
  IF i == nColumn
     oColumn:heading:setColorBG(GRA_CLR_BLUE)
  ELSE
     oColumn:heading:setColorBG(GRA_CLR_DARKBLUE)
  ENDIF
NEXT

RETURN nil

* ---------------

FUNCTION Set_User()

RETURN Pad('RDONNAY',10)
