/*
 ķ
   Program..: DS.PRG                                                   
   Author...: Roger J. Donnay                                          
   Notice...: (c) Donnay Software 1996-2000                            
   Date.....: Sep  2, 2000                                             
   Notes....: Donnay Software Website CGI Routines                     
 Ľ
*/

// Function/Procedure Prototype Table  -  Last Update: 10/28/2000 @ 12:45:37PM
// --------------------------------------------------------------------------
// Return Value         Function/Arguments
// -------------------  -----------------------------------------------------
// .F.                  STATIC FUNCTION DC_addrec ( nWaitTime )
// .f.                  STATIC FUNCTION DC_reclock ( nWaitTime, lDisplayError )
// nil                  STATIC FUNCTION _DonnayFooter( oHtml )
// nil                  STATIC FUNCTION _DonnayHeader( oHtml, cTitle )
// cText                STATIC FUNCTION _FreeFileText( cName, cFileName, cEmail, cResponseFile )
// ''                   STATIC FUNCTION _GetOrderVars( aOrder )
// Strtran(cText,CR...  STATIC FUNCTION _OrderText( aOrder, nMode )
// nil                  STATIC FUNCTION _SetUpData()
// cPath + cFileName    STATIC FUNCTION _TempFileName( cPath )
// .t.                  FUNCTION DonnaySoftware( oHtml, oContext )
// .T.                  FUNCTION ReplicateVars( oHTML, aVars )
// "Donnay Software...  FUNCTION _Copyright()
// .T.                  FUNCTION _register( oPackage )
// "Version 1.3"        FUNCTION _version()


#include "DCCGI.CH"
#include "SET.CH"
#include "dbstruct.ch"
#include "dmlb.ch"
#include "common.ch"
#INCLUDE "dcdialog.ch"

#DEFINE cORDER_NAME            aOrder[1]
#DEFINE cORDER_COMPANY         aOrder[2]
#DEFINE cORDER_STREET1         aOrder[3]
#DEFINE cORDER_STREET2         aOrder[4]
#DEFINE cORDER_CITY            aOrder[5]
#DEFINE cORDER_STATE           aOrder[6]
#DEFINE cORDER_COUNTRY         aOrder[7]
#DEFINE cORDER_ZIP             aOrder[8]
#DEFINE cORDER_PHONE           aOrder[9]
#DEFINE cORDER_FAX             aOrder[10]
#DEFINE cORDER_PAYMENTTYPE     aOrder[11]
#DEFINE cORDER_CREDITCARDNMBR  aOrder[12]
#DEFINE nORDER_EXPYEAR         aOrder[13]
#DEFINE nORDER_EXPMONTH        aOrder[14]
#DEFINE nORDER_TOTAL           aOrder[15]
#DEFINE aORDER_QTY             aOrder[16]
#DEFINE aORDER_PRICE           aOrder[17]
#DEFINE aORDER_PARTNO          aOrder[18]
#DEFINE aORDER_DESC            aOrder[19]
#DEFINE cORDER_EMAIL           aOrder[20]
#DEFINE nORDER_QTY             aOrder[21]
#DEFINE cORDER_HOWSHIP         aOrder[22]
#DEFINE cORDER_NAMEONCARD      aOrder[23]
#DEFINE cORDER_REMARKS         aOrder[24]
#DEFINE cORDER_PONUMBER        aOrder[25]
#DEFINE cORDER_NUMBER          aOrder[26]
#DEFINE aORDER_WEIGHT          aOrder[27]
#DEFINE nORDER_WEIGHT          aOrder[28]
#DEFINE aORDER_CODE            aOrder[29]
#DEFINE nORDER_SHIPPING        aOrder[30]
#DEFINE cORDER_SERIALNUMBER    aOrder[31]
#DEFINE lORDER_LETTER          aOrder[32]
#DEFINE cORDER_CUSTNUMBER      aOrder[33]
#DEFINE lORDER_DEALER          aOrder[34]
#DEFINE nORDER_DISCOUNT        aOrder[35]
#DEFINE nORDER_DISCPERCENT     aOrder[36]


FUNCTION _register( oPackage )

oPackage:registerForm( 'DonnaySoftware' )

_SetupData()

RETURN .T.

* -----------------

FUNCTION _version()

RETURN "Version 1.3"

* -----------------

FUNCTION _Copyright()

RETURN "Donnay Software, (c) 2000. All rights reserved."

* ------------------ */

FUNCTION DonnaySoftware( oHtml, oContext )

LOCAL cDefault, aHeader, cUserId, cLongId, cAsciiHex, aItems, cVariable,;
      cRedirect, cHtml := '', cName, cStreet1, cStreet2, cCompany, ;
      cEmail, cState, cZip, cPhone, cFax, cCountry, cCity, i, ;
      cTempFileName, cText, cError, aOrder[40], aVars, aCGIvars, ;
      cResponseFile

IF !DC_CGIInit(oHtml, oContext)
  RETURN .f.
ENDIF

DO CASE

  CASE !Empty(DC_CGIGetParmVal('DownloadFreeFile',@cVariable))

    dbeSetDefault('DBFCDX')

    cName := DC_CGIGetParmVal('Name')
    cCompany := DC_CGIGetParmVal('Company')
    cStreet1 := DC_CGIGetParmVal('Street1')
    cStreet2 := DC_CGIGetParmVal('Street2')
    cState := DC_CGIGetParmVal('State')
    cZip := DC_CGIGetParmVal('Zip')
    cEmail := DC_CGIGetParmVal('Email')
    cCountry := DC_CGIGetParmVal('Country')
    cCity := DC_CGIGetParmVal('City')
    cPhone := DC_CGIGetParmVal('Phone')
    cFax := DC_CGIGetParmVal('Fax')
    cResponseFile := DC_CGIGetParmVal('ResponseFileName')

    IF Empty(cName) .OR. !'@'$cEmail
      _DonnayHeader(oHtml,'Free Download')
      oHTML:message( "Error", ;
                     'Please provide a Name and E-mail Address.<p>' + ;
                     'Click on your Browser Back Button to return to the download page.<p>')
      _DonnayFooter(oHtml)
      DC_CGIQuit()
      RETURN .t.
    ELSE

      SET DEFAULT TO F:\web\ds\data
      USE register INDEX register.cdx
      OrdSetFocus('EMAIL')

      SEEK Upper(Alltrim(cEmail))
      IF Eof() .AND. DC_AddRec(10)
        REPL REGISTER->name WITH cName,;
             REGISTER->company WITH cCompany,;
             REGISTER->street1 WITH cStreet1,;
             REGISTER->street2 WITH cStreet2,;
             REGISTER->city WITH cCity,;
             REGISTER->country WITH cCountry,;
             REGISTER->state WITH cState,;
             REGISTER->zip WITH cZip,;
             REGISTER->phone WITH cPhone,;
             REGISTER->fax WITH cFax,;
             REGISTER->email WITH cEmail,;
             REGISTER->filename WITH cVariable,;
             REGISTER->date WITH Date(),;
             REGISTER->time WITH Time()
        UNLOCK
      ENDIF

      cVariable := Upper(cVariable)

      cText := _FreeFileText( cName, cVariable, cEmail, cResponseFile )
      cTempFileName := _TempFileName( 'F:\web\ds\data\' )
      MemoWrit( cTempFileName, cText )

      RunShell('/C C:\spimail\sm.exe /t:' + Alltrim(cEmail) + ;
                   ' /s:"File Download Instructions"' + ;
                   ' /m:' + cTempFileName,,.t.,.t. )

      RunShell('/C C:\spimail\sm.exe /t:' + 'Sales@Donnay-Software.Com' + ;
                   ' /s:"File Download Instructions"' + ;
                   ' /m:' + cTempFileName,,.t.,.t. )

      cHtml += 'An email message has been sent to <em><b>' + Alltrim(cEmail) + ;
               ' </b></em>with download instructions<br><br>'

      _DonnayHeader( oHtml, 'Thank You' )
      DC_CGISend(cHtml)
      _DonnayFooter( oHtml )

    ENDIF

  CASE !Empty(DC_CGIGetParmVal('PlaceOrder',@cVariable))

    dbeSetDefault('DBFCDX')

    cError := _GetOrderVars( aOrder )

    IF !Empty(cError)
      //
    ELSEIF Empty(cORDER_NAME)
      cError := 'Must provide a Name'
    ELSEIF Empty(cORDER_STREET1)
      cError := 'Must provide a street Address'
    ELSEIF Empty(cORDER_CITY) .OR. Empty(cORDER_COUNTRY)
      cError := 'Must provide a City, State, Zip and Country'
    ELSEIF Empty(cORDER_PHONE) .AND. Empty(cORDER_FAX)
      cError := 'Must provide either a voice phone or fax phone number'
    ELSEIF !'@'$cORDER_EMAIL
      cError := 'Must provide a valid Email Address'
    ELSEIF nORDER_QTY <= 0 .AND. Empty(cORDER_CUSTNUMBER)
      cError := 'Must enter a quantity of 1 for at least one product'
    ELSEIF Upper(Alltrim(cORDER_PAYMENTTYPE)) $ ' VISA MASTERCARD EUROCARD ' .AND. ;
           Len(Alltrim(cORDER_CREDITCARDNMBR)) # 16
      cError := 'Credit card number must be 16 numeric digits'
    ELSEIF Upper(Alltrim(cORDER_PAYMENTTYPE)) $ ' AMERICAN EXPRESS ' .AND. ;
           Len(Alltrim(cORDER_CREDITCARDNMBR)) # 15
      cError := 'Credit card number must be 15 numeric digits'

    ENDIF

    IF !Empty(cError)

      cError += '<p>Click on your Browser Back Button to return to the ordering page.<p>'
      _DonnayHeader(oHtml,'Product Order')
      oHTML:message( "Error", cError )
      _DonnayFooter(oHtml)
      DC_CGIQuit()
      RETURN .t.

    ENDIF

    aVars := {}
    aCGIVars := DC_CGIParamArray()
    FOR i := 1 TO Len(aCGIVars)
      IF !(aCGIVars[i,1] == "PlaceOrder")
        AAdd(aVars,aCGIVars[i,1])
      ENDIF
    NEXT

    _DonnayHeader(oHtml,'Order Verification')
    cText := MemoRead( 'F:\web\ds\htdocs\ordtmpl.txt')
    cText := StrTran( cText, '<<NAME>>',cORDER_NAME)
    cText := StrTran( cText, '<<EMAIL>>',cORDER_EMAIL)
    cText := StrTran( cText, '<<WEIGHT>>',Str(nORDER_WEIGHT/14) )
    IF lORDER_LETTER
      cText := StrTran( cText, '<<PACKAGING>>','My Packaging' )
    ELSE
      cText := StrTran( cText, '<<PACKAGING>>','FedEx Express Envelope' )
    ENDIF
    cText += _OrderText( aOrder, 3 )
    SEND cText
    SEND '<FORM  ACTION="/cgi-bin/waa1gate.exe?WAA_PACKAGE=DS&WAA_FORM=DonnaySoftware" METHOD=POST>'
    ReplicateVars( oHTML, aVars )
    SEND '<INPUT TYPE=SUBMIT NAME="ConfirmOrder" VALUE="Confirm!">'
    SEND '</FORM>'
    _DonnayFooter(oHtml)

  CASE !Empty(DC_CGIGetParmVal('ConfirmOrder',@cVariable))

      _GetOrderVars( aOrder )

      SET DEFAULT TO F:\web\ds\data
      USE orders ALIAS orders NEW

      IF ORDERS->(DC_AddRec(10))
        ORDERS->name := cORDER_NAME
        ORDERS->company := cORDER_COMPANY
        ORDERS->street1 := cORDER_STREET1
        ORDERS->street2 := cORDER_STREET2
        ORDERS->city := cORDER_CITY
        ORDERS->country := cORDER_COUNTRY
        ORDERS->state := cORDER_STATE
        ORDERS->zip := cORDER_ZIP
        ORDERS->phone := cORDER_PHONE
        ORDERS->fax := cORDER_FAX
        ORDERS->email := cORDER_EMAIL
        ORDERS->paytype := cORDER_PAYMENTTYPE
        ORDERS->crednmbr := cORDER_CREDITCARDNMBR
        ORDERS->expyear := nORDER_EXPYEAR
        ORDERS->expmonth := nORDER_EXPMONTH
        ORDERS->howship := cORDER_HOWSHIP
        ORDERS->nameoncard := cORDER_NAMEONCARD
        ORDERS->date := Date()
        ORDERS->time := Time()
        ORDERS->remarks := cORDER_REMARKS
        ORDERS->ponmbr := cORDER_PONUMBER
        ORDERS->sernmbr := cORDER_SERIALNUMBER
        ORDERS->custnmbr := cORDER_CUSTNUMBER
        FOR i := 1 TO Len(aORDER_QTY)
          &('ORDERS->qty'+DC_PadZero(Str(i,2))) := aORDER_QTY[i]
          &('ORDERS->price'+DC_PadZero(Str(i,2))) := aORDER_PRICE[i]
          &('ORDERS->desc'+DC_PadZero(Str(i,2))) := aORDER_DESC[i]
          &('ORDERS->partno'+DC_PadZero(Str(i,2))) := aORDER_PARTNO[i]
          &('ORDERS->weight'+DC_PadZero(Str(i,2))) := aORDER_WEIGHT[i]
          &('ORDERS->code'+DC_PadZero(Str(i,2))) := aORDER_CODE[i]
        NEXT
        cORDER_NUMBER := '15' + Strtran(Str(Recno(),4),' ','0')
        UNLOCK
      ENDIF

      _DonnayHeader(oHtml,'Thank You for your Order')
      cVariable := Upper(cVariable)

      cText := MemoRead( 'F:\web\ds\htdocs\ordemail.txt')
      cText := StrTran( cText, '<<NAME>>',cORDER_NAME)
      cText := StrTran( cText, '<<EMAIL>>',cORDER_EMAIL)
      cText := StrTran( cText, '<<PAYTYPE>>',cORDER_PAYMENTTYPE)
      cText := StrTran( cText, '<<ORDER_NUMBER>>',cORDER_NUMBER )
      cText += _OrderText( aOrder, 1 ) // EMAIL response to Client
      cTempFileName := _TempFileName( 'F:\web\ds\data\' )
      MemoWrit( cTempFileName, cText )

      RunShell('/C C:\spimail\sm.exe /t:' + Alltrim(cORDER_EMAIL) + ;
                   ' /s:"Order Confirmation"' + ;
                   ' /f:Sales@Donnay-Software.Com' + ;
                   ' /m:' + cTempFileName,,.t.,.t. )

      cText := MemoRead( 'F:\web\ds\htdocs\ordemail.txt')
      cText := StrTran( cText, '<<NAME>>',cORDER_NAME)
      cText := StrTran( cText, '<<EMAIL>>',cORDER_EMAIL)
      cText := StrTran( cText, '<<PAYTYPE>>',cORDER_PAYMENTTYPE)
      cText := StrTran( cText, '<<ORDER_NUMBER>>',cORDER_NUMBER )
      cText += _OrderText( aOrder, 2 ) // EMAIL response to Donnay
      cTempFileName := _TempFileName( 'F:\web\ds\data\' )
      MemoWrit( cTempFileName, cText )

      RunShell('/C C:\spimail\sm.exe /t:' + 'Sales@Donnay-Software.Com' + ;
                   ' /s:"Order Confirmation"' + ;
                   ' /f:' + Alltrim(cORDER_EMAIL) + ;
                   ' /m:' + cTempFileName,,.t.,.t. )

      RunShell('/C C:\spimail\sm.exe /t:' + 'AmyBrown@Donnay-Software.Com' + ;
                   ' /s:"Order Confirmation"' + ;
                   ' /f:' + Alltrim(cORDER_EMAIL) + ;
                   ' /m:' + cTempFileName,,.t.,.t. )

      cHtml += '<p>An email message has been sent to <b><em>' + Alltrim(cORDER_EMAIL) + ;
               ' </em></b>with confirmation of your order.<br><br>' + ;
               ' Your order confirmation number is <b>' + cORDER_NUMBER + '</b><br><p>'

      DC_CGISend(cHtml)
      _DonnayFooter( oHtml )

  OTHERWISE

    cHtml += 'You called our CGI program without passing it proper parameters'
    _DonnayHeader( oHtml, 'Sorry' )
    DC_CGISend(cHtml)
    _DonnayFooter( oHtml )

ENDCASE

CLOSE ALL
DC_CGIQuit()

RETURN .t.


* ------------------------

STATIC FUNCTION DC_addrec ( nWaitTime )

LOCAL nWait

nWaitTime := IIF(Valtype(nWaitTime)='N',nWaitTime,5)

IF EMPTY(ALIAS())
  RETURN .f.
ENDIF

APPEND BLANK
IF !NETERR()
   RETURN (.T.)
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime = 0 .OR. nWait > 0)
    APPEND BLANK
    IF .NOT. NETERR()
      RETURN .T.
    ENDIF
    nWait  :=  nWait - .5
  ENDDO
  RETURN .F.
ENDDO
RETURN .F.

* -------------------

STATIC FUNCTION DC_reclock ( nWaitTime, lDisplayError )

LOCAL  nWait

nWaitTime := IIF(Valtype(nWaitTime)='N',nWaitTime,1)
lDisplayError := IIF(Valtype(lDisplayError)='L',lDisplayError,.t.)

IF DbrLock()
  RETURN (.T.)   // locked
ENDIF

DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime=0 .OR. nWait>0)
    IF DBRLOCK()     // locked
      RETURN (.T.)
    ENDIF
    INKEY(.5)     // wait 1/2 second
    nWait  :=  nWait - .5
  ENDDO
  RETURN .f.
ENDDO
RETURN (.f.)      // not locked


/* replicate variables according to the passed array
 * from the input CGI data into the output HTML page
 */
FUNCTION ReplicateVars( oHTML, aVars )

LOCAL i, imax := Len( aVars )

FOR i := 1 TO imax
  oHTML:setVar( aVars[i], oHTML:getVar(aVars[i]) )
NEXT

RETURN .T.

* ----------------

STATIC FUNCTION _FreeFileText( cName, cFileName, cEmail, cResponseFile )

LOCAL cText

cText := MemoRead( 'F:\web\ds\htdocs\' + cResponseFile )
cText := StrTran( cText, '<<NAME>>',cName)
cText := StrTran( cText, '<<EMAIL>>',cEmail)
cText := StrTran( cText, '<<FILENAME>>',cFileName)

RETURN cText

* --------------

// This function returns a different file name with each call,

STATIC FUNCTION _TempFileName( cPath )

LOCAL nSeconds := Seconds()

STATIC snCount := 0

LOCAL  cFileName

DO WHILE Seconds() - nSeconds < 100

  IF ++ snCount == 100
    snCount := 0
  ENDIF

  cFileName   := PadL( snCount, 2, "_" )    + ;
                 StrTran( Time(), ":", "" ) + ".$$$"

  IF !File(cPath+cFileName)
    EXIT
  ENDIF

ENDDO

RETURN cPath + cFileName

* ---------------

STATIC FUNCTION _OrderText( aOrder, nMode )

LOCAL cText := '', i, cSuffix, cPrefix, cReplace, lCredit, lHtml

IF nMode = 1  // EMAIL response to Client
  cReplace := CRLF
  cPrefix := ''
  cSuffix := ''
  lCredit := .f.
  lHtml := .f.
ELSEIF nMode = 2  // EMAIL response to Donnay
  cReplace := CRLF
  cPrefix := ''
  cSuffix := ''
  lCredit := .t.
  lHtml := .f.
ELSEIF nMode = 3  // HTML response to Client
  cReplace := '<p>'
  cPrefix := '<B>'
  cSuffix := '</B>'
  lCredit := .t.
  lHtml := .t.
ENDIF

cText += CRLF

IF lHtml
  cText += '<pre>' + CRLF
ENDIF

cText += ;
' Customer Number: ' + cPrefix + cORDER_CUSTNUMBER + cSuffix + CRLF + ;
'            Name: ' + cPrefix + cORDER_NAME + cSuffix + CRLF + ;
'         Company: ' + cPrefix + cORDER_COMPANY + cSuffix + CRLF + ;
'       Address 1: ' + cPrefix + cORDER_STREET1 + cSuffix + CRLF +  ;
'       Address 2: ' + cPrefix + cORDER_STREET2 + cSuffix + CRLF +  ;
'            City: ' + cPrefix + cORDER_CITY + cSuffix + CRLF + ;
'           State: ' + cPrefix + cORDER_STATE + cSuffix + CRLF + ;
'             Zip: ' + cPrefix + cORDER_ZIP + cSuffix + CRLF + ;
'         Country: ' + cPrefix + cORDER_COUNTRY + cSuffix + CRLF + ;
'           Phone: ' + cPrefix + cORDER_PHONE + cSuffix + CRLF + ;
'             Fax: ' + cPrefix + cORDER_FAX + cSuffix + CRLF + ;
'           Email: ' + cPrefix + cORDER_EMAIL + cSuffix + CRLF + ;
'     P.O. Number: ' + cPrefix + cORDER_PONUMBER + cSuffix + CRLF + ;
'   Serial Number: ' + cPrefix + cORDER_SERIALNUMBER + cSuffix + CRLF + ;
' Shipping Method: ' + cPrefix + cORDER_HOWSHIP + cSuffix + CRLF + ;
'    Payment Type: ' + ;
   IIF(lCredit, cPrefix + cORDER_PAYMENTTYPE + ;
       cSuffix, '** on file **') + CRLF + ;
'Credit Card Nmbr: ' + ;
   IIF(lCredit, cPrefix + cORDER_CREDITCARDNMBR + ;
       cSuffix, '** on file **') + CRLF + ;
' Expiration Date: ' + ;
   IIF( lCredit, cPrefix + StrTran(Str(nORDER_EXPMONTH,2) + '/' + ;
                               Str(nORDER_EXPYEAR,2),' ','0') + ;
                               cSuffix, '** on file **')  + CRLF + ;
'    Name on Card: ' + cPrefix + cORDER_NAMEONCARD + cSuffix + CRLF + ;
CRLF + ;
'Remarks: ' + CRLF + ;
cPrefix + Strtran(cORDER_REMARKS,CRLF+CRLF,CRLF) + cSuffix

cText += ' ' + CRLF + ' ' + CRLF + ;
'Product Description                          Qty     U/Price    Ext/Price' + CRLF + ;
'------------------------------------------- -----  ----------- ----------' + CRLF + ;
CRLF

FOR i := 1 TO Len(aORDER_QTY)
  IF aORDER_QTY[i] > 0
     cText += Pad(aORDER_DESC[i],45) + ;
              Str(aORDER_QTY[i],3) + '    ' + ;
              Str(aORDER_PRICE[i],9,2)  + '  ' + ;
              Str(aORDER_PRICE[i]*aORDER_QTY[i],9,2) + ;
              CRLF
  ENDIF
NEXT

cText += ' ' + CRLF + ' ' + CRLF
cText += ;
'------------------------------------------- -----  ----------- ----------' + CRLF + ;
IIF( nORDER_DISCOUNT > 0,;
'                                          Less Discount ('+Alltrim(Str(Int(nORDER_DISCPERCENT*100)))+'%): ' + ;
Str(nORDER_DISCOUNT,9,2) + CRLF,'') + ;
'                                          Shipping (' + Str(nORDER_WEIGHT/14,5,2)+ 'lbs): ' + ;
IIF(nORDER_SHIPPING=-1,'   ?????',Str(nORDER_SHIPPING,9,2)) + CRLF + ;
'                                                  Order Total: ' + ;
Str(nORDER_TOTAL-nORDER_DISCOUNT,9,2) + IIF( nORDER_SHIPPING=-1,' (Plus Shipping)','') + CRLF

IF lHtml
  cText += '</pre>'
ENDIF

RETURN Strtran(cText,CRLF,cReplace)

* ----------------

STATIC FUNCTION _GetOrderVars( aOrder )

LOCAL i, lLetter, nShipping, nWeight, nHowShip, lDealer

aORDER_QTY := Array(30)
aORDER_DESC := Array(30)
aORDER_PRICE := Array(30)
aORDER_PARTNO := Array(30)
aORDER_WEIGHT := Array(30)
aORDER_CODE := Array(30)
nORDER_QTY := 0
nORDER_TOTAL := 0
nORDER_WEIGHT := 0

lLetter := .t.
lDealer := .f.

FOR i := 1 TO 30
  aORDER_QTY[i] := Val(DC_CGIGetParmVal('ProductQty' + StrTran(Str(i,2),' ','0')))
  nORDER_QTY += aORDER_QTY[i]
  IF aORDER_QTY[i] < 0
    RETURN 'Quantity cannot be negative'
  ENDIF
  aORDER_DESC[i] := DC_CGIGetParmVal('ProductDesc' + StrTran(Str(i,2),' ','0'))
  aORDER_PARTNO[i] := DC_CGIGetParmVal('ProductPartNo' + StrTran(Str(i,2),' ','0'))
  aORDER_PRICE[i] := Val(DC_CGIGetParmVal('ProductPrice'+ StrTran(Str(i,2),' ','0')))
  nORDER_TOTAL += ( aORDER_PRICE[i] * aORDER_QTY[i] )
  aORDER_WEIGHT[i] := Val(DC_CGIGetParmVal('ProductWeight'+ StrTran(Str(i,2),' ','0')))
  nORDER_WEIGHT += ( aORDER_WEIGHT[i] * aORDER_QTY[i] )
  aORDER_CODE[i] := Val(DC_CGIGetParmVal('ProductCode'+ StrTran(Str(i,2),' ','0')))
  IF aORDER_CODE[i] > 1 .OR. nORDER_WEIGHT > 8
    lLetter := .f.
  ENDIF
NEXT

cORDER_CUSTNUMBER     := DC_CGIGetParmVal('CustomerNumber')

cORDER_NAME     := DC_CGIGetParmVal('Name')
cORDER_COMPANY  := DC_CGIGetParmVal('Company')
cORDER_STREET1  := DC_CGIGetParmVal('Street1')
cORDER_STREET2  := DC_CGIGetParmVal('Street2')
cORDER_STATE    := DC_CGIGetParmVal('State')
cORDER_ZIP      := DC_CGIGetParmVal('Zip')
cORDER_EMAIL    := DC_CGIGetParmVal('Email')
cORDER_COUNTRY  := DC_CGIGetParmVal('Country')
cORDER_CITY     := DC_CGIGetParmVal('City')
cORDER_PHONE    := DC_CGIGetParmVal('Phone')
cORDER_FAX      := DC_CGIGetParmVal('Fax')

IF !Empty(cORDER_CUSTNUMBER)
  SET DEFAULT TO F:\web\ds\data
  USE CUSTOMER INDEX CUSTOMER VIA 'DBFCDX' NEW
  OrdSetFocus('CUSTNMBR')
  SEEK cORDER_CUSTNUMBER
  IF Eof()
    RETURN 'Customer Number not on file'
  ENDIF
  lDealer := CUSTOMER->dealer
  cORDER_NAME           := Alltrim(CUSTOMER->firstname) + ' ' + Alltrim(CUSTOMER->lastname)
  cORDER_COMPANY        := CUSTOMER->company
  cORDER_STREET1        := CUSTOMER->address1
  cORDER_STREET2        := CUSTOMER->address2
  cORDER_STATE          := CUSTOMER->state
  cORDER_ZIP            := CUSTOMER->zip
  cORDER_EMAIL          := CUSTOMER->email
  cORDER_COUNTRY        := CUSTOMER->country
  cORDER_CITY           := CUSTOMER->city
  cORDER_PHONE          := CUSTOMER->phone
  cORDER_FAX            := CUSTOMER->fax
ENDIF

IF !Empty(DC_CGIGetParmVal('Name'))
  cORDER_NAME     := DC_CGIGetParmVal('Name')
ENDIF
IF !Empty(DC_CGIGetParmVal('Company'))
  cORDER_COMPANY  := DC_CGIGetParmVal('Company')
ENDIF
IF !Empty(DC_CGIGetParmVal('Street1'))
  cORDER_STREET1  := DC_CGIGetParmVal('Street1')
ENDIF
IF !Empty(DC_CGIGetParmVal('Street2'))
  cORDER_STREET2  := DC_CGIGetParmVal('Street2')
ENDIF
IF !Empty(DC_CGIGetParmVal('State'))
  cORDER_STATE    := DC_CGIGetParmVal('State')
ENDIF
IF !Empty(DC_CGIGetParmVal('Zip'))
  cORDER_ZIP      := DC_CGIGetParmVal('Zip')
ENDIF
IF !Empty(DC_CGIGetParmVal('Email'))
  cORDER_EMAIL    := DC_CGIGetParmVal('Email')
ENDIF
IF !Empty(DC_CGIGetParmVal('Country'))
  cORDER_COUNTRY  := DC_CGIGetParmVal('Country')
ENDIF
IF !Empty(DC_CGIGetParmVal('City'))
  cORDER_CITY     := DC_CGIGetParmVal('City')
ENDIF
IF !Empty(DC_CGIGetParmVal('Phone'))
  cORDER_PHONE    := DC_CGIGetParmVal('Phone')
ENDIF
IF !Empty(DC_CGIGetParmVal('Fax'))
  cORDER_FAX      := DC_CGIGetParmVal('Fax')
ENDIF
cORDER_PAYMENTTYPE      := DC_CGIGetParmVal('PaymentType')
cORDER_CREDITCARDNMBR   := DC_CGIGetParmVal('CreditCardNmbr')
nORDER_EXPYEAR          := Val(DC_CGIGetParmVal('ExpirationYear'))
nORDER_EXPMONTH         := Val(DC_CGIGetParmVal('ExpirationMonth'))
cORDER_HOWSHIP          := DC_CGIGetParmVal('HowShip')
cORDER_NAMEONCARD       := DC_CGIGetParmVal('NameOnCard')
cORDER_REMARKS          := DC_CGIGetParmVal('Remarks')
cORDER_PONUMBER         := DC_CGIGetParmVal('PONumber')
cORDER_SERIALNUMBER     := DC_CGIGetParmVal('SerialNumber')

IF lDealer
  IF nORDER_TOTAL >= 2500
     nORDER_DISCPERCENT := .50
  ELSEIF nORDER_TOTAL >= 1000
     nORDER_DISCPERCENT := .45
  ELSE
     nORDER_DISCPERCENT := .40
  ENDIF
ELSE
  nORDER_DISCPERCENT := 0
ENDIF
nORDER_DISCOUNT := nORDER_TOTAL * nORDER_DISCPERCENT

nHowShip := Val(SubStr(cORDER_HOWSHIP,2,1))
nWeight := nORDER_WEIGHT
nShipping := -1

IF nHowShip == 1  // internet
  nShipping := 0
ELSEIF nHowShip == 2 // U.S. AirMail
  nShipping := ( nWeight / 14 ) * 7.00
ELSEIF nHowShip == 3 // FEDEX Overnight (U.S. Only)
  IF lLetter
    nShipping := 19.00  // Envelope
  ELSEIF nWeight <= 14  // 1 pound
    nShipping := 26.00
  ELSEIF nWeight <= 28  // 2 pounds
    nShipping := 29.00
  ELSEIF nWeight <= 43  // 3 pounds
    nShipping := 31.00
  ELSEIF nWeight <= 58  // 4 pounds
    nShipping := 33.00
  ELSE
    nShipping := (nWeight / 15) * 7.2
  ENDIF
ELSEIF nHowShip == 4 // FEDEX Afternoon (U.S. Only)
  IF lLetter
    nShipping := 17.00  // Envelope
  ELSEIF nWeight <= 14  // 1 pound
    nShipping := 22.00
  ELSEIF nWeight <= 28  // 2 pounds
    nShipping := 25.00
  ELSEIF nWeight <= 43  // 3 pounds
    nShipping := 27.00
  ELSEIF nWeight <= 58  // 4 pounds
    nShipping := 29.00
  ELSE
    nShipping := (nWeight / 15) * 6.2
  ENDIF
ELSEIF nHowShip == 5 // FEDEX 2-day (U.S. Only)
  IF lLetter
    nShipping := 12.00  // Envelope
  ELSEIF nWeight <= 14  // 1 pound
    nShipping := 12.00
  ELSEIF nWeight <= 28  // 2 pounds
    nShipping := 13.00
  ELSEIF nWeight <= 43  // 3 pounds
    nShipping := 14.50
  ELSEIF nWeight <= 58  // 4 pounds
    nShipping := 16.00
  ELSE
    nShipping := (nWeight / 15) * 3.4
  ENDIF
ELSEIF nHowShip == 6 // FEDEX (Priority International)
  nShipping := -1
ELSEIF nHowShip == 7 // FEDEX (Economy International)
  nShipping := -1
ELSEIF nHowShip == 8 // FEDEX (Priority Canada)
  IF lLetter
    nShipping := 20.00  // Envelope
  ELSEIF nWeight <= 16 * 11  // 11 pounds
    nShipping := 65.00
  ELSE
    nShipping := (nWeight / 15) * 5
  ENDIF
ENDIF

nORDER_SHIPPING := nShipping
lORDER_LETTER := lLetter

RETURN ''

* --------------

STATIC FUNCTION _SetUpData()

DC_ChDir('F:\web\ds\data')
SET DEFAULT TO F:\web\ds\data\
SET EXACT OFF
SET EXCLUSIVE OFF
SET COLLATION TO AMERICAN
dbeSetDefault('DBFNTX')

RETURN nil

* -----------------

STATIC FUNCTION _DonnayHeader( oHtml, cTitle )

SEND '<body bgcolor="#FFFFFF" background="/backgrounds/grey.jpg">'
SENDBR '<p><img SRC="/graphics/donnay-logo.jpg" WIDTH="96" HEIGHT="118" ALIGN="right"> </p>'
SEND '<h2>' + cTitle + '</h2>'
SEND '<hr>'
SEND '<p>&nbsp;</p>'

RETURN nil

* -----------------

STATIC FUNCTION _DonnayFooter( oHtml )

SEND '<em><b><TABLE><TR>'
SEND '<TD><A HREF="https://digitalid.verisign.com/as2/bc8bd15227b3cc9fa1adb33be23ea2a7" TARGET="new">'
SEND '<IMG SRC="/graphics/VeriSignSeal.gif" WIDTH="98" HEIGHT="100" BORDER="0"></A>'
SEND '<A HREF="https://digitalid.verisign.com/as2/bc8bd15227b3cc9fa1adb33be23ea2a7" TARGET="new"></TD>'
SEND '<TD>Powered by</TD><TD> <IMG SRC="/graphics/waawhite.gif"></TD>'
SEND '<TD>and</TD><TD> <IMG SRC="/graphics/explogo.gif"></em></TD><TD></TD>'
SEND '<TD><a href="http://donnay-software.com" target="_top"><IMG SRC="/graphics/DonnayHome.Gif" WIDTH=97 HEIGHT=89></A></TD>'
SEND '</TR></TABLE></em></b>'

RETURN nil


