/*
 ķ
   Program..: XDEMO5.PRG                                          
   Author...: Roger J. Donnay                                     
   Notice...: (c) DONNAY Software Designs 1987-1998               
   Date.....: Jun 26, 1999                                        
   Notes....: eXPress Demo Program #5                             
 Ľ

 This sample program demonstrates miscellaneous features of
 eXPress++ like Array Browsing and Crt Objects.
*/

#include "dctree.ch"
#include "Inkey.ch"
#include "dcicon.ch"
#include "dcbitmap.ch"
#include "xbp.ch"
#include "appevent.ch"

#define  oTabPage1     aLocals[1]
#define  oTabPage2     aLocals[2]
#define  oTabPage3     aLocals[3]
#define  oTabPage4     aLocals[4]
#define  oTabPage5     aLocals[5]
#define  oTabPage6     aLocals[6]
#define  oTabPage7     aLocals[7]
#define  oTabPage8     aLocals[8]
#define  oTabPage9     aLocals[9]
#define  oTabPage10    aLocals[10]
#define  aDirectory    aLocals[11]
#define  aDirOptions   aLocals[12]
#define  oDirTree1     aLocals[13]
#define  oDirTree2     aLocals[14]
#define  oCrt1         aLocals[15]
#define  oCrt2         aLocals[16]
#define  oCrt3         aLocals[17]
#define  bCrt1         aLocals[18]
#define  bCrt2         aLocals[19]
#define  bCrt3         aLocals[20]
#define  cSource       aLocals[21]
#define  oToolBar      aLocals[22]
#define  oGroup1       aLocals[23]
#define  oDateGroup    aLocals[24]
#define  oNameGroup    aLocals[25]
#define  oTelGroup     aLocals[26]
#define  dDate         aLocals[27]
#define  cTime         aLocals[28]
#define  cName         aLocals[29]
#define  cStreet       aLocals[30]
#define  cCity         aLocals[31]
#define  cState        aLocals[32]
#define  cVoice        aLocals[33]
#define  cFax          aLocals[34]
#define  cEmail        aLocals[35]
#define  nGroup        aLocals[36]
#define  aGetList      aLocals[37]
#define  cZip          aLocals[38]
#define  oMsgBox       aLocals[39]
#define  oGroup2       aLocals[40]
#define  oLastFocus    aLocals[41]
#define  nTabOffset    aLocals[42]
#define  xTree1        aLocals[43]
#define  xTree2        aLocals[44]
#define  oDlg          aLocals[45]
#define  oDlgWindow    aLocals[46]
#define  lMDIApp       aLocals[47]
#define  cTitle        aLocals[48]
#define  oTannenBaum   aLocals[49]
#define  oBrowse       aLocals[50]

FUNCTION XDemo_5 ( oDialog )

LOCAL GetList, GetOptions, aLocals[50], aApplication

DC_Gui(.t.)
SET PATH TO ..\DATA

aApplication := _BuildApp( aLocals )

GetOptions := aApplication[1]
Getlist    := aApplication[2]

aGetList := GetList

DCREAD GUI ;
   OPTIONS GetOptions ;
   APPWINDOW oDialog ;
   TITLE cTitle ;
   FIT ;
   EVAL {||oTannenBaum:show()}

RETURN nil

* --------------------

STATIC FUNCTION _BuildApp( aLocals, oDialog, lMDI )

LOCAL Getlist := {}, GetOptions, i, aCoords

cTitle := 'eXPress++ Demo Program #5'

/* ---- Tab Page #1 (top) ---- */

@  2,0 DCTABPAGE oTabPage1 CAPTION 'Array' ;
   SIZE 85,16.3 PREOFFSET 0 POSTOFFSET 80 ;
   MESSAGE 'Demonstration of Array Browsers'

aDirectory := Directory( '*.*' )
IF Len(aDirectory) > 30
  ASize(aDirectory,30)
ENDIF

@ 3,2 DCTREEROOT OBJECT oTannenBaum SIZE 40,12 FONT '10.Courier' ;
      HASLINES HASBUTTONS PARENT oTabPage1 INVISIBLE

FOR i := 1 TO Len(aDirectory)
  _ArrayView( 1, GetList, aDirectory[i], @oTannenBaum,, i )
NEXT

@ 3,43 DCBROWSE oBrowse DATA aDirectory SIZE 40,12 ;
       PRESENTATION DC_BrowPres() PARENT oTabPage1 ;
       INVISIBLE

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 6 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 5 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'File Date' WIDTH 6 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'File Time' WIDTH 6 PARENT oBrowse

/* ---- Tab Page #2 (top) ---- */

@  0,0 DCTABPAGE oTabPage2 CAPTION 'Crt ' ;
   RELATIVE oTabPage1 ;
   MESSAGE 'CRT Window' ;
   DATALINK {||IIF(oCrt1:status()=XBP_STAT_CREATE,SetAppFocus(oCrt1),nil)}

@ 1,1 DCAPPCRT oCrt1 SIZE 25,80 PARENT oTabPage2 ;
      CAPTION 'Crt Demo Window' BORDER XBPDLG_NO_BORDER ;
      FONT 'Terminal' FONTSIZE 6,11 ;
      ACTION {||DC_Gui(.f.),XDemo5_Crt(),DC_Gui(.t.)}


/* ---- Tab Page #3 (top) ---- */

@  0,0 DCTABPAGE oTabPage3 CAPTION 'HIDE Clause' ;
   RELATIVE oTabPage2 ;
   MESSAGE "Demonstration of the HIDE Clause"

@ 2,5 DCSAY 'This page demonstrates how to hide and display objects conditionally' ;
      PARENT oTabPage3 SAYSIZE 70

@ 4,2 DCGROUP oGroup1 CAPTION 'Pick a Group to Edit' SIZE 35,10 ;
      PARENT oTabPage3

cName := Space(20)
cStreet := Space(25)
cCity := Space(25)
cState := Space(10)
cZip := Space(10)
cVoice := Space(15)
cFax := Space(15)
cEmail := Space(30)
cTime := Time()
dDate := Date()

nGroup := 1

@ 3,5 DCRADIO nGroup       ;
  VALUE 1                  ;
  PARENT oGroup1           ;
  PROMPT 'Date and Time'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 4,5 DCRADIO nGroup       ;
  VALUE 2                  ;
  PARENT oGroup1           ;
  PROMPT 'Name and Address'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 5,5 DCRADIO nGroup       ;
  VALUE 3                  ;
  PARENT oGroup1           ;
  PROMPT 'Telephone Numbers'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 4,38 DCGROUP oDateGroup CAPTION 'Date/Time' SIZE 45,10 ;
  HIDE {|| nGroup # 1} PARENT oTabPage3

@ 2,1 DCSAY 'Date' GET dDate PARENT oDateGroup ;
      SAYSIZE 8 SAYRIGHT

@ 4,1 DCSAY 'Time' GET cTime PARENT oDateGroup ;
      SAYSIZE 8 SAYRIGHT

@ 4,38 DCGROUP oNameGroup CAPTION 'Name/Address' SIZE 45,10 ;
  HIDE {|| nGroup # 2} PARENT oTabPage3

@ 2,1 DCSAY 'Name' GET cName PARENT oNameGroup ;
      SAYSIZE 8 SAYRIGHT

@ 4,1 DCSAY 'Street' GET cStreet PARENT oNameGroup ;
      SAYSIZE 8 SAYRIGHT

@ 5,1 DCSAY 'City' GET cCity PARENT oNameGroup ;
      SAYSIZE 8 SAYRIGHT

@ 6,1 DCSAY 'State' GET cState PARENT oNameGroup ;
      SAYSIZE 8 SAYRIGHT

@ 7,1 DCSAY 'Zip' GET cZip PARENT oNameGroup ;
      SAYSIZE 8 SAYRIGHT

@ 4,38 DCGROUP oTelGroup CAPTION 'Telephone/E-Mail' SIZE 45,10 ;
  HIDE {|| nGroup # 3} PARENT oTabPage3

@ 2,1 DCSAY 'Voice' GET cVoice PICT '999-999-9999' PARENT oTelGroup ;
      SAYSIZE 8 SAYRIGHT

@ 4,1 DCSAY 'Fax' GET cFax PICT '999-999-9999' PARENT oTelGroup ;
      SAYSIZE 8 SAYRIGHT

@ 5,1 DCSAY 'E-Mail' GET cEmail PICT '@!' PARENT oTelGroup ;
      SAYSIZE 8 SAYRIGHT


/* ---- Tab Page #4 (top) ---- */

@  0,0 DCTABPAGE oTabPage4 CAPTION 'WHEN Clause' ;
   RELATIVE oTabPage3 ;
   MESSAGE "Demonstration of the WHEN Clause"


@ 2,5 DCSAY 'This page demonstrates how to disable and enable objects conditionally' ;
      PARENT oTabPage4 SAYSIZE 70

@ 4,2 DCGROUP oGroup2 CAPTION 'Pick a Group to Edit' SIZE 30,10 ;
      PARENT oTabPage4

@ 3,5 DCRADIO nGroup       ;
  VALUE 1                  ;
  PARENT oGroup2           ;
  PROMPT 'Date and Time'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 4,5 DCRADIO nGroup       ;
  VALUE 2                  ;
  PARENT oGroup2           ;
  PROMPT 'Name and Address'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 5,5 DCRADIO nGroup       ;
  VALUE 3                  ;
  PARENT oGroup2           ;
  PROMPT 'Telephone Numbers'   ;
  ACTION {||DC_GetRefresh(aGetList)}

@ 3,35 DCSAY 'Date' GET dDate PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 1}

@ 4,35 DCSAY 'Time' GET cTime PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 1}

@ 6,35 DCSAY 'Name' GET cName PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 2}

@ 7,35 DCSAY 'Street' GET cStreet PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 2}

@ 8,35 DCSAY 'City' GET cCity PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 2}

@ 9,35 DCSAY 'State' GET cState PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 2}

@10,35 DCSAY 'Zip' GET cZip PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 2}

@12,35 DCSAY 'Voice' GET cVoice PICT '999-999-9999' PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 3}

@13,35 DCSAY 'Fax' GET cFax PICT '999-999-9999' PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 3}

@14,35 DCSAY 'E-Mail' GET cEmail PICT '@!' PARENT oTabPage4 ;
       SAYSIZE 8 SAYRIGHT WHEN {||nGroup = 3}


/* ---- Tab Page #5 (top) ---- */

@  0,0 DCTABPAGE oTabPage5 CAPTION 'Source' ;
   RELATIVE oTabPage4 ;
   MESSAGE "This is the Source Code for Demo 5"

cSource := MemoRead('XDEMO5.PRG')
IF Empty(cSource)
  cSource := MemoRead('..\PRG\XDEMO5.PRG')
ENDIF
IF Empty(cSource)
  cSource := 'XDEMO5.PRG cannot be found'
ENDIF

@  2,2 DCMULTILINE cSource PARENT oTabPage5 SIZE 81,13.5 ;
   FONT "8.Alaska Crt" EDITPROTECT {||.t.}

/* ---- Tab Page #6 (bottom)  ---- */

nTabOffset := IIF( '1.1'$Version(),1.1,0 )

@  3,0 DCTABPAGE oTabPage6 CAPTION 'Bottom 1' ;
   SIZE 85,16.3 PREOFFSET 0 POSTOFFSET 90 ;
   TYPE XBPTABPAGE_TAB_BOTTOM ;
   MESSAGE 'This Tab Page is Here to demonstrate bottom tabs'

@  5,5 DCSAY 'This TabPage is here to show' PARENT oTabPage6 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

@ 10,5 DCSAY 'how to do bottom tabs' PARENT oTabPage6 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

/* ---- Tab Page #7 (bottom)  ---- */

@  nTabOffset,0 DCTABPAGE oTabPage7 CAPTION 'Bottom 2' ;
   RELATIVE oTabPage6 ;
   TYPE XBPTABPAGE_TAB_BOTTOM

@  5,5 DCSAY 'This TabPage is here to show' PARENT oTabPage7 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

@ 10,5 DCSAY 'how to do bottom tabs' PARENT oTabPage7 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

/* ---- Tab Page #8 (bottom)  ---- */

@  nTabOffset,0 DCTABPAGE oTabPage8 CAPTION 'Bottom 3' ;
   RELATIVE oTabPage7 ;
   TYPE XBPTABPAGE_TAB_BOTTOM

@  5,5 DCSAY 'This TabPage is here to show' PARENT oTabPage8 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

@ 10,5 DCSAY 'how to do bottom tabs' PARENT oTabPage8 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

/* ---- Tab Page #9 (bottom)  ---- */

@  nTabOffset,0 DCTABPAGE oTabPage9 CAPTION 'Bottom 4' ;
   RELATIVE oTabPage8 ;
   TYPE XBPTABPAGE_TAB_BOTTOM

@  5,5 DCSAY 'This TabPage is here to show' PARENT oTabPage9 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

@ 10,5 DCSAY 'how to do bottom tabs' PARENT oTabPage9 ;
   FONT '20.Arial Bold' SAYSIZE 70,3

/* ---- Tool Bar ---- */

@ 0,0 DCPUSHBUTTON  CAPTION 'Exit' SIZE 9,1   ;
  ACTION {||DC_PutKey(K_ESC),DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}  ;
  TOOLTIP 'Exit this Program'


/* ---- Message Box ---- */

@ 18.2,37 DCMESSAGEBOX OBJECT oMsgBox FONT "8.Arial Bold" ;
  SIZE 45

DCGETOPTIONS ;
   SAYWIDTH 100 ;
   HELPFILE '..\DOC\EXPRESS.HLP'

RETURN { GetOptions, GetList }


/* ------------------- */

STATIC FUNCTION FileData ( xData, nElement )

LOCAL cData := DC_XtoC( xData ), cPrefix

DO CASE
  CASE nElement = 2
    cPrefix := 'File Size: '
  CASE nElement = 3
    cPrefix := 'File Date: '
  CASE nElement = 4
    cPrefix := 'File Time: '
  CASE nElement = 7
    cPrefix := 'Creation Date: '
  CASE nElement = 8
    cPrefix := 'Creation Time: '
  OTHERWISE
    cPrefix := ''
ENDCASE

RETURN cPrefix + cData

/* ------------------------- */

STATIC FUNCTION XDemo5_Crt ( )

LOCAL aDir

CLS
@ 2,10 SAY 'This is an Achoice of the directory using the XbpCrt() Class'

aDir := Directory()
aDir := DC_Aconvert( aDir )

DC_AChoice (  10, 10, 20, 35, aDir[1],,,,,,{.t.} )

RETURN nil

/* --------------------------- */

STATIC FUNCTION IsEditFocus( aLocals )

LOCAL oXbpCurrent := SetAppFocus(), oXbp, i

FOR i := 1 TO Len(aGetList)
  oXbp := aGetList[i,oGETLIST_OBJECT]
  IF Valtype(oXbp)='O' .AND. oXbp:ClassName() = 'XbpGet' .AND. oXbp == oXbpCurrent
    RETURN .t.
  ENDIF
NEXT

RETURN .f.

* --------------------

STATIC FUNCTION _ArrayView( nMode, GetList, xData, oTree, cCaption, ;
                            nElement )

LOCAL i, oThread, GetOptions, bAction, bExpand, cElement, oTreeItem

DEFAULT nElement := 0
cElement := Alltrim(Str(nElement)) + ': '
IF nMode = 1

  IF Valtype(xData) = 'C'

     DCTREEITEM CAPTION cElement + xData PARENT oTree ;
       IMAGENORMAL ICON_CHARACTER ;
       IMAGEEXPANDED ICON_CHARACTER ;
       IMAGEMARKED ICON_CHARACTER

  ELSEIF Valtype(xData) = 'D'

     DCTREEITEM CAPTION cElement + DC_XtoC(xData) PARENT oTree ;
       IMAGENORMAL ICON_DATE ;
       IMAGEEXPANDED ICON_DATE ;
       IMAGEMARKED ICON_DATE

  ELSEIF Valtype(xData) = 'N'

     DCTREEITEM CAPTION cElement + DC_XtoC(xData) PARENT oTree ;
       IMAGENORMAL ICON_NUMERIC ;
       IMAGEEXPANDED ICON_NUMERIC ;
       IMAGEMARKED ICON_NUMERIC

  ELSEIF Valtype(xData) = 'L'

     DCTREEITEM CAPTION cElement + DC_XtoC(xData) PARENT oTree ;
       IMAGENORMAL ICON_LOGICAL ;
       IMAGEEXPANDED ICON_LOGICAL ;
       IMAGEMARKED ICON_LOGICAL

  ELSEIF Valtype(xData) = 'B'

     DCTREEITEM CAPTION cElement + DC_GetCodeBlockText(xData) PARENT oTree ;
       IMAGENORMAL ICON_CODEBLOCK ;
       IMAGEEXPANDED ICON_CODEBLOCK ;
       IMAGEMARKED ICON_CODEBLOCK

  ELSEIF Valtype(xData) = 'U'

     DCTREEITEM CAPTION cElement + 'Nil' PARENT oTree ;
       IMAGENORMAL ICON_NIL ;
       IMAGEEXPANDED ICON_NIL ;
       IMAGEMARKED ICON_NIL

  ELSEIF Valtype(xData) = 'A'

     cCaption := cElement + 'Array (' + Alltrim(Str(Len(xData))) + ')'
     bAction := { |o| _ArrayView( 2,  nil, o:cargo[3], o, cCaption ) }

     DCTREEITEM CAPTION cCaption ;
       PARENT oTree ;
       CARGO xData ;
       OBJECT oTreeItem ;
       ACTION bAction ;
       IMAGENORMAL ICON_CLOSED_ARRAY ;
       IMAGEEXPANDED ICON_OPEN_ARRAY ;
       IMAGEMARKED ICON_CLOSED_ARRAY ;

     _ArrayView( 2, GetList, xData, @oTreeItem, cCaption )

  ENDIF

ELSEIF nMode = 2 .AND. Valtype(xData) = 'A'

  IF Empty(GetList)
    GetList := {}
  ENDIF

  FOR i := 1 TO Len(xData)
    _ArrayView( 1, GetList, xData[i], @oTree,, i )
  NEXT

ENDIF

RETURN nil




