/*
 ķ
   Program..: XDOC.PRG                                         
   Author...: Roger J. Donnay                                  
   Notice...: (c) DONNAY Software Designs 1987-2001            
   Date.....: Sep 15, 2001                                     
   Notes....: eXPress Documentation Program                    
 Ľ

 This program demonstrates a data-driven documentation system
 written in a procedural fashion using commands supported by the
 DCDIALOG.CH header file.  The application includes 8 Tab Pages,
 a Menu, a Toolbar, a Message box area, @Say..Gets, Multiline
 Gets, Bitmaps, a Database browse, list boxes, check boxes,
 radio buttons, Tooltips, context help, cut & paste, and printing.
 This application maintains a documentation database and writes
 Source code files for .HLP, .NG and HTML documentation.

*/

FIELD type, sort, command, module, category, version

#include "dcdialog.ch"
#include "dccursor.ch"
#include "dcbitmap.ch"
#include "dcprint.ch"
#include "dcicon.ch"
#include "xbp.ch"
#include "gra.ch"
#include "appevent.ch"
#include 'dmlb.ch'
#include "fileio.ch"

#define  CRLF          Chr(13) + Chr(10)

#define  oTabPage1     aApp[1]
#define  oTabPage2     aApp[2]
#define  oTabPage3     aApp[3]
#define  oTabPage4     aApp[4]
#define  oTabPage5     aApp[5]
#define  oTabPage6     aApp[6]
#define  oTabPage7     aApp[7]
#define  oTabPage8     aApp[8]
#define  oTabPage9     aApp[9]
#define  oTabPage10    aApp[10]
#define  oBrowse       aApp[11]
#define  oToolBar      aApp[12]
#define  oMenuFile     aApp[14]
#define  oMenuEdit     aApp[15]
#define  oMenuPrint    aApp[16]
#define  nMenuExit     aApp[17]
#define  nMenuPack     aApp[18]
#define  nMenuNext     aApp[19]
#define  nMenuPrev     aApp[20]
#define  nMenuTop      aApp[21]
#define  nMenuBott     aApp[22]
#define  nMenuFont     aApp[22]
#define  nMenuList     aApp[24]
#define  nMenuItem     aApp[25]
#define  nRecord       aApp[26]
#define  cDescription  aApp[27]
#define  cSyntax       aApp[28]
#define  cType         aApp[29]
#define  cSeeAlso      aApp[30]
#define  cReturns      aApp[31]
#define  cFiles        aApp[32]
#define  cModule       aApp[33]
#define  cChapter      aApp[34]
#define  cSort         aApp[35]
#define  cCommand      aApp[36]
#define  cNotes        aApp[37]
#define  cArguments    aApp[38]
#define  cMethods      aApp[39]
#define  cIvars        aApp[40]
#define  cCategory     aApp[41]
#define  cShort        aApp[42]
#define  aType         aApp[43]
#define  cExamples     aApp[44]
#define  oFontDlg      aApp[45]
#define  oMsgBox       aApp[46]
#define  aGetList      aApp[47]
#define  aGetOptions   aApp[48]
#define  aCategory     aApp[49]
#define  aPres         aApp[50]
#define  aChildList    aApp[51]
#define  oNextButton   aApp[52]
#define  oPrevButton   aApp[53]
#define  oTopButton    aApp[54]
#define  oBottButton   aApp[55]
#define  oBrowBox      aApp[57]
#define  cTitle        aApp[58]
#define  aModule       aApp[59]
#define  aModuleDesc   aApp[60]
#define  aCatDesc      aApp[61]
#define  aFiles        aApp[62]
#define  aFileDesc     aApp[63]
#define  aStructure    aApp[64]
#define  cAuthor       aApp[65]
#define  cOutput       aApp[66]
#define  dOrigDate     aApp[67]
#define  cOrigTime     aApp[68]
#define  dRevDate      aApp[69]
#define  cRevTime      aApp[70]
#define  cSource       aApp[71]
#define  oTabPage11    aApp[72]
#define  cDatabase     aApp[73]
#define  cIndex        aApp[74]
#define  cDriver       aApp[75]
#define  ncNext        aApp[76]
#define  ncPrevious    aApp[77]
#define  ncTop         aApp[78]
#define  ncBottom      aApp[79]
#define  ncSave        aApp[80]
#define  ncNew         aApp[81]
#define  ncHelp        aApp[82]
#define  ncDelete      aApp[83]
#define  aButtons      aApp[84]
#define  aButtonDesc   aApp[85]
#define  nBrowEdit     aApp[86]
#define  nMenuBrowse   aApp[87]
#define  aLocate       aApp[88]
#define  lAppendMode   aApp[89]
#define  oDescription  aApp[90]
#define  oSyntax       aApp[91]
#define  oReturns      aApp[92]
#define  oNotes        aApp[93]
#define  oArguments    aApp[94]
#define  oMethods      aApp[95]
#define  oIvars        aApp[96]
#define  oSource       aApp[97]
#define  oExamples     aApp[98]
#define  oStaticPage1  aApp[99]
#define  oStaticPage2  aApp[100]
#define  oStaticPage3  aApp[101]
#define  oStaticPage4  aApp[102]
#define  oStaticPage5  aApp[103]
#define  oStaticPage6  aApp[104]
#define  oStaticPage7  aApp[105]
#define  oStaticPage8  aApp[106]
#define  oStaticPage9  aApp[107]
#define  oStaticPage10 aApp[108]
#define  oStaticPage11 aApp[109]
#define  cIniFile      aApp[110]
#define  oDlg          aApp[111]
#define  oDlgWindow    aApp[112]
#define  oExitButton   aApp[113]
#define  nVersion      aApp[114]
#define  nSubType      aApp[115]

#define BUTTON_NEXT_1     aButtons[1]
#define BUTTON_PREVIOUS_1 aButtons[2]
#define BUTTON_TOP_1      aButtons[3]
#define BUTTON_BOTTOM_1   aButtons[4]
#define BUTTON_SAVE_1     aButtons[5]
#define BUTTON_DELETE_1   aButtons[6]
#define BUTTON_HELP_1     aButtons[7]
#define BUTTON_NEW_1      aButtons[8]
#define BUTTON_FIND_1     aButtons[9]
#define BUTTON_PRINT_1    aButtons[10]
#define BUTTON_FILE_1     aButtons[11]
#define BUTTON_EXIT_1     aButtons[12]
#define BUTTON_NEXT_2     aButtons[13]
#define BUTTON_PREVIOUS_2 aButtons[14]
#define BUTTON_TOP_2      aButtons[15]
#define BUTTON_BOTTOM_2   aButtons[16]
#define BUTTON_SAVE_2     aButtons[17]
#define BUTTON_DELETE_2   aButtons[18]
#define BUTTON_HELP_2     aButtons[19]
#define BUTTON_NEW_2      aButtons[20]
#define BUTTON_FIND_2     aButtons[21]
#define BUTTON_PRINT_2    aButtons[22]
#define BUTTON_FILE_2     aButtons[23]
#define BUTTON_EXIT_2     aButtons[24]


FUNCTION XDoc( oDialog )

LOCAL GetList, GetOptions, i, aGets, lOk, cScrn

LOCAL aApp[120]

DC_Gui(.t.)
DC_IconDefault(ICON_EXPRESS)
DC_DotHotKey(xbeK_F12)

SET DELETED ON
SET DATE FORMAT TO 'mm/dd/yyyy'

/* --- Setup FILE arrays for XDOC.INI  --- */
aFiles := Array(4)
AFill(aFiles,Space(50))
aFileDesc := { 'Database','Title','Output','Driver' }

/* --- Setup MODULE arrays for XDOC.INI  --- */

aModule := Array(99)
AFill(aModule,Space(50))
aModuleDesc := Array(99)
FOR i := 1 TO 99
  aModuleDesc[i] := 'Module' + StrTran(Str(i,2),' ','0')
NEXT

/* --- Setup BUTTON arrays for XDOC.INI  --- */

aButtons := Array(24)
AFill(aButtons,Space(20))
aButtonDesc := ;
  { 'Next_Enabled','Previous_Enabled','Top_Enabled','Bottom_Enabled', ;
    'Save_Enabled','Delete_Enabled','Help_Enabled','New_Enabled','Find_Enabled', ;
    'Print_Enabled','File_Enabled','Exit_Enabled',;
    'Next_Disabled','Previous_Disabled','Top_Disabled','Bottom_Disabled', ;
    'Save_Disabled','Delete_Disabled','Help_Disabled','New_Disabled','Find_Disabled',;
    'Print_Disabled','File_Disabled','Exit_Disabled' }

/* --- Setup CATEGORY arrays for XDOC.INI --- */

aCategory := Array(99)
AFill(aCategory,Space(20))
aCatDesc := Array(99)
FOR i := 1 TO 99
  aCatDesc[i] := 'Category' + StrTran(Str(i,2),' ','0')
NEXT

cIniFile := 'XDOC.INI'
FOR i := 1 TO 3
  /* --- Load app from XDOC.INI file --- */
  DC_IniLoad( cIniFile,  { { 'BUTTONS',    aButtons,  aButtonDesc },;
                           { 'FILES',      aFiles,    aFileDesc   },;
                           { 'MODULES',    aModule,   aModuleDesc },;
                           { 'CATEGORIES', aCategory, aCatDesc    } } )

  cDatabase := Upper(Alltrim(aFiles[1]))
  cTitle    := Alltrim(aFiles[2])
  cOutput   := Upper(Alltrim(aFiles[3]))
  cDriver   := Upper(Alltrim(aFiles[4]))
  IF !Empty(cDatabase)
    EXIT
  ENDIF
  IF i = 2
    Set(_SET_DEFAULT,'..\XDOC\')
  ENDIF
  cIniFile := Set(_SET_DEFAULT) + 'XDOC.INI'
NEXT

aButtonDesc := ;
   { '&Next','&Previous','&Top','&Bottom','&Save', ;
     '&Delete','&Help','&New','&Find','P&rint','F&ile','E&xit', ;
     '&Next','&Previous','&Top','&Bottom','&Save', ;
     '&Delete','&Help','&New','&Find','P&rint','F&ile','E&xit' }

FOR i := 1 TO Len(aButtons)
  IF !Empty(aButtons[i])
    aButtons[i] := Val(aButtons[i])
  ELSE
    aButtons[i] := aButtonDesc[i]
  ENDIF
NEXT

aModuleDesc := aModule
aModule := {}
FOR i := 1 TO 99
  IF !Empty(aModuleDesc[i])
    AAdd(aModule,aModuleDesc[i])
  ENDIF
NEXT

aCatDesc := aCategory
aCategory := {}
FOR i := 1 TO 99
  IF !Empty(aCatDesc[i])
    AAdd(aCategory,aCatDesc[i])
  ENDIF
NEXT

IF Empty(cDriver)
  cDriver := 'FOXCDX'
ENDIF

dbeSetdefault(cDriver)

IF Empty(cDatabase)
  DC_WinAlert('Database name not defined in XDOC.INI')
  RETURN nil
ENDIF

IF !File(cDatabase)
  aStructure := { ;
   { 'CATEGORY', 'C',   20, 0 },;
   { 'CHAPTER',  'N',    2, 0 },;
   { 'COMMAND',  'C',   30, 0 },;
   { 'TYPE',     'C',   15, 0 },;
   { 'SHORT',    'C',   65, 0 },;
   { 'SYNTAX',   'M',   10, 0 },;
   { 'ARGS',     'M',   10, 0 },;
   { 'METHODS',  'M',   10, 0 },;
   { 'IVARS',    'M',   10, 0 },;
   { 'DESCRIPT', 'M',   10, 0 },;
   { 'NOTES',    'M',   10, 0 },;
   { 'EXAMPLES', 'M',   10, 0 },;
   { 'RETURNS',  'M',   10, 0 },;
   { 'SOURCE',   'M',   10, 0 },;
   { 'SEE_ALSO', 'C',   75, 0 },;
   { 'MODULE',   'C',    8, 0 },;
   { 'FILES',    'C',   65, 0 },;
   { 'AUTHOR',   'C',   25, 0 },;
   { 'ORIG_DATE','D',    8, 0 },;
   { 'ORIG_TIME','C',    8, 0 },;
   { 'REV_DATE', 'D',    8, 0 },;
   { 'REV_TIME', 'C',    8, 0 },;
   { 'SORT',     'C',    3, 0 },;
   { 'VERSION',  'C',    6, 2 },;
   { 'SUBTYPE',  'N',    1, 0 } }
  dbCreate( aFiles[1], aStructure, cDriver )
ENDIF

cIndex := Strtran(cDatabase,'.DBF','') + '.CDX'

IF !File(cIndex)
  USE (cDatabase) VIA (cDriver) NEW EXCLUSIVE ALIAS 'XDOC'
  cScrn := DC_WaitOn('Please wait while creating indexes...')
  INDEX ON Upper(type+sort+command) TAG 'TYPE' TO (cIndex)
  INDEX ON Upper(command) TAG 'COMMAND' TO (cIndex)
  INDEX ON Upper(category+type+sort+command) TAG 'CATEGORY' TO (cIndex)
  INDEX ON Upper(module+type+sort+command) TAG 'MODULE' TO (cIndex)
  INDEX ON Upper(Str(FIELD->version,6,2)+module+type+sort+command) TAG 'VERSION' TO (cIndex)
  SET INDEX TO (cIndex)
  DC_Impl(cScrn)
ELSE
  USE (cDatabase) VIA (cDriver) NEW SHARED ALIAS 'XDOC' INDEX (cIndex)
ENDIF

SET INDEX TO (cIndex)
OrdSetFocus('COMMAND')

aType := { 'FUNCTION', 'COMMAND', 'CLASS', 'STATEMENT', 'DIRECTIVE', ;
           'OPERATOR', 'ERROR', 'DATATYPE', 'PICTURE', 'GENERAL', ;
           'SYSTEM', 'DCDIALOG' }

aPres := ;
  { { XBP_PP_COL_HA_FGCLR,        GRA_CLR_WHITE },     /*  Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR,        GRA_CLR_DARKGRAY },  /*  Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep  */           ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep  */           ;
    { XBP_PP_COL_DA_FGCLR,        GRA_CLR_BLACK },     /* Row FG Color  */      ;
    { XBP_PP_COL_DA_BGCLR,        GRA_CLR_WHITE }      /* Row BG Color  */      ;
  }

lAppendMode := .f.

XDoc_LoadFields( aApp )

aGets := _BuildGets( aApp, oDialog )

GetOptions := aGets[1]
Getlist    := aGets[2]

nRecord    := XDOC->(RecNo())
aGetList   := GetList

DCREAD GUI ;
   EXPRESS ;
   TITLE cTitle ;
   OPTIONS GetOptions ;
   APPWINDOW oDialog ;
   TO lOk ;
   CLEAREVENTS ;
   FIT ;
   PARENT @oDlg

dbCloseAll()

RETURN nil

* -------------------------

STATIC FUNCTION _BuildGets ( aApp, oDialog )

LOCAL GetList := {}, GetOptions, aCoords

BEGIN SEQUENCE

/* ---- Tab Page #1 ---- */

@  1,1 DCTABPAGE oTabPage1 CAPTION '&General' ;
   STATICAREA oStaticPage1 ;
   SIZE 79,17 PREOFFSET 0 POSTOFFSET 91 ;
   MESSAGE 'This Page contains general information' ;
   INTO oMsgBox ;
   ACCELKEY xbeK_ALT_G

@  1,1  DCSAY 'Class' GET nSubType PARENT oStaticPage1 SAYSIZE 9 PICT '9' ;
        SAYRIGHT

@  1,15 DCSAY '0 - General, 1 - Gui, 2 - Text, 3 - Dual Mode' ;
        PARENT oStaticPage1 SAYSIZE 0

/*
DCHOTKEY Asc('0') ;
  ACTION {||nSubType := 0, XDoc_SaveFields(aApp),DC_GetRefresh(Getlist)}

DCHOTKEY Asc('1') ;
  ACTION {||nSubType := 1, XDoc_SaveFields(aApp),DC_GetRefresh(Getlist)}

DCHOTKEY Asc('2') ;
  ACTION {||nSubType := 2, XDoc_SaveFields(aApp),DC_GetRefresh(Getlist)}

DCHOTKEY Asc('3') ;
  ACTION {||nSubType := 3, XDoc_SaveFields(aApp),DC_GetRefresh(Getlist)}
*/


@  2,1  DCSAY "Command" GET cCommand SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 9 ;
   VALID { || IIF(Empty(cCommand),DC_MsgBox('Command Required'),nil), ;
              !Empty(cCommand) } ;
   GETID "GET_COMMAND"

@  2,53  DCSAY "Sort" GET cSort PICT '@!' SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 0 ;

@  2,63  DCSAY "Vers" GET nVersion SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 0 ;

@  3,1  DCSAY "Short" GET cShort SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 9 GETSIZE 65 ;
   VALID { || IIF(Empty(cShort),DC_MsgBox('Description Required'),nil), ;
              !Empty(cShort) }

@  4, 1  DCSAY "Author" GET cAuthor SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 9

@  5, 1  DCSAY "See Also" GET cSeeAlso SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 9 GETSIZE 65

@  6, 1  DCSAY "Files" GET cFiles SAYRIGHT ;
   PARENT oStaticPage1 SAYSIZE 9 GETSIZE 65

@  7, 1  DCSAY "Original" GET dOrigDate PICT '99/99/9999' SAYSIZE 9 ;
   GETSIZE 13 PARENT oStaticPage1 SAYRIGHT

@  7, 26 DCGET cOrigTime PICT '99:99:99' PARENT oStaticPage1

@  7, 40 DCSAY "Revised" GET dRevDate PICT '99/99/9999' SAYSIZE 9 ;
   GETSIZE 13 PARENT oStaticPage1 SAYRIGHT

@  7, 65 DCGET cRevTime PICT '99:99:99' PARENT oStaticPage1

@  8.5, 4 DCSAY "Type" PARENT oStaticPage1 SAYSIZE 10

@  9.5, 4 DCCOMBOBOX cType SIZE 17,6 TYPE XBPCOMBO_DROPDOWN ;
   PARENT oStaticPage1 LIST aType

@  8.5, 23 DCSAY "Module" PARENT oStaticPage1 SAYSIZE 10

@  9.5, 23 DCCOMBOBOX cModule SIZE 35,6 PARENT oStaticPage1 ;
   TYPE XBPCOMBO_DROPDOWN LIST aModule

@  8.5, 60 DCSAY "Category" PARENT oStaticPage1 SAYSIZE 10

@  9.5, 60 DCCOMBOBOX cCategory SIZE 17,6 PARENT oStaticPage1 ;
   TYPE XBPCOMBO_DROPDOWN LIST aCategory


/* ---- Tab Page #2 ---- */

SetCancel(.f.)

@  0,0 DCTABPAGE oTabPage2 CAPTION 'Des&crip.' ;
   STATICAREA oStaticPage2;
   RELATIVE oTabPage1 ;
   MESSAGE 'This Tab page is for the Description' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_C ;
   GOTFOCUS {||SetAppFocus(oDescription)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage2 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cDescription PARENT oStaticPage2 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oDescription ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #3 ---- */

@  0,0 DCTABPAGE oTabPage3 CAPTION 'Synta&x' ;
   RELATIVE oTabPage2 ;
   STATICAREA oStaticPage3 ;
   MESSAGE 'This Tab page is for Syntax' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_X ;
   GOTFOCUS {||SetAppFocus(oSyntax)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage3 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cSyntax PARENT oStaticPage3 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oSyntax ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #4 ---- */

@  0,0 DCTABPAGE oTabPage4 CAPTION '&Args' ;
   RELATIVE oTabPage3 ;
   STATICAREA oStaticPage4 ;
   MESSAGE 'This Tab page is for Arguments' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_A ;
   GOTFOCUS {||SetAppFocus(oArguments)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage4 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cArguments PARENT oStaticPage4 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oArguments ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #5 ---- */

@  0,0 DCTABPAGE oTabPage5 CAPTION '&Methods' ;
   RELATIVE oTabPage4 ;
   STATICAREA oStaticPage5 ;
   MESSAGE 'This Tab page is for Methods' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_M ;
   GOTFOCUS {||SetAppFocus(oMethods)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage5 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cMethods PARENT oStaticPage5 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oMethods ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #6 ---- */

@  0,0 DCTABPAGE oTabPage6 CAPTION 'i&Vars' ;
   RELATIVE oTabPage5 ;
   STATICAREA oStaticPage6 ;
   MESSAGE 'This Tab page is for Instance Variables' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_V ;
   GOTFOCUS {||SetAppFocus(oIvars)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage6 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cIvars PARENT oStaticPage6 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oIvars ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #7 ---- */

@  0,0 DCTABPAGE oTabPage7 CAPTION 'N&otes' ;
   RELATIVE oTabPage6 ;
   STATICAREA oStaticPage7 ;
   MESSAGE 'This Tab page is for Notes' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_O ;
   GOTFOCUS {||SetAppFocus(oNotes)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage7 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cNotes PARENT oStaticPage7 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oNotes ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #8 ---- */

@  0,0 DCTABPAGE oTabPage8 CAPTION '&Returns' ;
   RELATIVE oTabPage7 ;
   STATICAREA oStaticPage8 ;
   MESSAGE 'This Tab page is for Returns' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_R ;
   GOTFOCUS {||SetAppFocus(oReturns)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage8 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cReturns PARENT oStaticPage8 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oReturns ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10

/* ---- Tab Page #9 ---- */

@  0,0 DCTABPAGE oTabPage9 CAPTION 'Examp&le' ;
   RELATIVE oTabPage8 ;
   STATICAREA oStaticPage9 ;
   MESSAGE 'This Tab page is for Examples' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_L ;
   GOTFOCUS {||SetAppFocus(oExamples)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage9 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cExamples PARENT oStaticPage9 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oExamples ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE ;
   EXITKEY xbeK_F10


/* ---- Tab Page #10 ---- */

@  0,0 DCTABPAGE oTabPage10 CAPTION 'So&urce' ;
   RELATIVE oTabPage9 ;
   STATICAREA oStaticPage10 ;
   MESSAGE 'This Tab page is for Source Code' ;
     INTO oMsgBox ;
   ACCELKEY xbeK_ALT_U ;
   GOTFOCUS {||SetAppFocus(oSource)}

@  0, 2 DCSAY cCommand SAYVAR cCommand SAYSIZE 30 ;
   FONT "10.Arial Bold" PARENT oStaticPage10 ;
   COLOR GRA_CLR_DARKBLUE, GRA_CLR_WHITE

@  1.2,1 DCMULTILINE cSource PARENT oStaticPage10 SIZE 76,13.5 ;
   FONT "8.Courier" ;
   OBJECT oSource ;
   GOTFOCUS {|a,b,o|XDoc_SetFocus(o)} ;
   COMPATABILE


/* ---- Tab Page #11 ---- */

@  0,0 DCTABPAGE oTabPage11 CAPTION '&Browse' ;
   RELATIVE oTabPage10 ;
   STATICAREA oStaticPage11 ;
   MESSAGE 'This Tab Page contains a Browse of the Database' ;
     INTO oMsgBox  ;
   GOTFOCUS {||XDOC_TestChanged(aApp)}

DCHOTKEY xbeK_ALT_B ACTION {||SetAppFocus(oTabPage11),SetAppFocus(oBrowse)}

@  0, 2 DCSTATIC XBPSTATIC_TYPE_RECESSEDBOX SIZE 75,14.7 ;
      OBJECT oBrowBox PARENT oStaticPage11

nBrowEdit := DCGUI_BROWSE_EDITDOWN

@ .1,.5 DCBROWSE oBrowse PARENT oBrowBox ALIAS 'XDOC' ;
   SIZE 74,14.5 ;
   ID 'BROWSE' ;
   FREEZELEFT {1} ;
   FREEZERIGHT {8} ;
   PRESENTATION aPres  ;
   EVAL {|o|o:itemMarked := ;
        {||XDoc_LoadFields(aApp,DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE})} } ;

DCBROWSECOL FIELD XDOC->command HEADER "Command" PARENT oBrowse ;
  WIDTH 7 ;
  SORT {||OrdSetFocus('COMMAND'), DC_GetRefresh(aGetList)}

DCBROWSECOL DATA {||XDOC->type} HEADER "Type" PARENT oBrowse ;
  WIDTH 6 ;
  SORT {||OrdSetFocus('TYPE'), DC_GetRefresh(aGetList)}

DCBROWSECOL DATA {||XDOC->category} HEADER "Category" PARENT oBrowse ;
  WIDTH 6 ;
  SORT {||OrdSetFocus('CATEGORY'), DC_GetRefresh(aGetList)}

DCBROWSECOL DATA {||XDOC->short} HEADER "Short Description" ;
   PARENT oBrowse WIDTH 20

DCBROWSECOL DATA {||XDOC->module} HEADER "Module" PARENT oBrowse ;
  WIDTH 6 ;
  SORT {||OrdSetFocus('MODULE'),DC_GetRefresh(aGetList)}

DCBROWSECOL DATA {||XDOC->see_also} HEADER "See Also" ;
  PARENT oBrowse WIDTH 10

DCBROWSECOL DATA {||XDOC->sort} HEADER "Sort" PARENT oBrowse ;
  WIDTH 3 ;
  SORT {||OrdSetFocus('TYPE'),DC_GetRefresh(aGetList)}

DCBROWSECOL DATA {||XDOC->(recno())} HEADER "Record" ;
  PARENT oBrowse ;
  SORT {||OrdSetFocus(0),DC_GetRefresh(aGetList)} WIDTH 4


/* ---- Tool Bar ---- */

@ .5,81 DCTOOLBAR oToolBar BUTTONSIZE 9,1.5 ;
  SIZE 9, 19 FANCY

DCADDBUTTON TYPE XBPSTATIC_TYPE_RAISEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_TOP_1, BUTTON_TOP_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Go to the Top of the File' ;
            OBJECT oTopButton ;
            ACTION {||XDoc_TestChanged(aApp),dbGoTop(), ;
                      XDoc_LoadFields(aApp)} ;
            WHEN {||!_Bof()}

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_PREVIOUS_1, BUTTON_PREVIOUS_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Skip to the Previous Record' ;
            OBJECT oPrevButton ;
            ACTION {||XDoc_TestChanged(aApp),DC_DbSkip(-1), ;
                      XDoc_LoadFields(aApp)} ;
            WHEN { ||!_Bof() }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_NEXT_1, BUTTON_NEXT_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Skip to the Next Record' ;
            OBJECT oNextButton ;
            ACTION {||XDoc_TestChanged(aApp),DC_DbSkip(), ;
                      XDoc_LoadFields(aApp)} ;
            WHEN { ||!_Eof() }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_BOTTOM_1, BUTTON_BOTTOM_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Go to the Bottom of the File' ;
            OBJECT oBottButton ;
            ACTION {||XDoc_TestChanged(aApp),dbGoBottom(), ;
                      XDoc_LoadFields(aApp)} ;
            WHEN { ||!_Eof() }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_NEW_1, BUTTON_NEW_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Add a New Record' ;
            ID "NEW_BUTTON" ;
            ACCELKEY xbeK_ALT_N ;
            ACTION {|x|XDoc_TestChanged(aApp), ;
                       XDoc_NewRecord(aApp) }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_DELETE_1, BUTTON_DELETE_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Delete Selected Record' ;
            ACCELKEY xbeK_ALT_D ;
            ACTION {|x|SetAppFocus(oTabPage1),;
                       x:=DC_MsgBox(,,{'Delete this Record?'},,,,.t.),;
                       RecLock(5),;
                       IIF(x,dbDelete(),nil),;
                       dbUnlock(),;
                       IIF(x,DC_DbSkip(),nil), ;
                       IIF(x,DC_DbSkip(-1),nil), ;
                       XDoc_LoadFields(aApp) }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_SAVE_1, BUTTON_SAVE_2 } ;
            PARENT oToolBar ;
            TOOLTIP 'Save Changes to the File' ;
            ACCELKEY xbeK_ALT_S ;
            ACTION {||XDoc_SaveFields(aApp),DC_GetRefresh(Getlist)}

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION { BUTTON_FIND_1, BUTTON_FIND_2 } ;
            PARENT oToolBar ;
            ACCELKEY xbeK_ALT_I ;
            TOOLTIP 'Find a Record' ;
            ACTION {||XDoc_TestChanged(aApp), ;
                      XDoc_Find(aApp), ;
                      DC_GetRefresh(Getlist)}

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION BUTTON_PRINT_1 ;
            PARENT oToolBar ;
            ACCELKEY xbeK_ALT_R ;
            TOOLTIP 'Printing options' ;
            ACTION {|a,b,o|oMenuPrint:PopUp( o, o:currentPos(), 2 , ;
                    XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  ) }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION BUTTON_FILE_1 ;
            PARENT oToolBar ;
            ACCELKEY xbeK_ALT_R ;
            TOOLTIP 'File options' ;
            ACTION {|a,b,o|oMenuFile:PopUp( o, o:currentPos(), 2 ) }

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar

DCADDBUTTON CAPTION BUTTON_EXIT_1 ;
            OBJECT oExitButton ;
            PARENT oToolBar ;
            ACCELKEY xbeK_ALT_X ;
            TOOLTIP 'Exit program' ;
            ACTION {||PostAppEvent(xbeP_Close,,,oDlg)}

DCADDBUTTON TYPE XBPSTATIC_TYPE_RECESSEDRECT ;
            SIZE 9,.2 PARENT oToolBar


/* ---- Message Box ---- */

@ 18.5, 1 DCMESSAGEBOX OBJECT oMsgBox FONT "8.Courier New Bold" ;
   COLOR GRA_CLR_BLUE ;
   MOTION ;
   TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 78


/* --- Popup File Menu --- */

DCSUBMENU oMenuFile PROMPT "&File"

  DCMENUITEM "&Exit" INDEX nMenuExit PARENT oMenuFile ;
     ACTION {|| XDoc_TestChanged(aApp), ;
                PostAppevent(xbeP_Close) }

  DCMENUITEM "&Pack File" INDEX nMenuPack PARENT oMenuFile ;
     ACTION {||Pack(aApp)}

  DCMENUITEM SEPARATOR PARENT oMenuFile

  DCMENUITEM "&HTML Source" PARENT oMenuFile ;
      ACTION {||XDoc_Source( 1, aApp, cTitle, cOutput )}

  DCMENUITEM "&RTF Help Source" PARENT oMenuFile ;
     ACTION {||XDoc_Source( 2, aApp, cTitle, cOutput )}

  DCMENUITEM "&Norton Guide Source" PARENT oMenuFile ;
     ACTION {||XDoc_Source( 3, aApp, cTitle, cOutput )}

  DCMENUITEM SEPARATOR PARENT oMenuFile

  DCMENUITEM "&Import Database" PARENT oMenuFile ;
     ACTION {||XDoc_Import( 1 )}

  DCMENUITEM SEPARATOR PARENT oMenuFile

  DCMENUITEM "&Save to Array File" PARENT oMenuFile ;
     ACTION {||XDoc_ArrayFile( 1, aApp )}

  DCMENUITEM "Restore from Array &File" PARENT oMenuFile ;
     ACTION {||XDoc_ArrayFile( 2, aApp )}

/* --- Popup Edit Menu --- */

DCSUBMENU oMenuEdit PROMPT "&Edit"

  DCMENUITEM "&Copy" PARENT oMenuEdit ACTION {||XDoc_Copy(aApp)}

  DCMENUITEM "C&ut" PARENT oMenuEdit ACTION {||XDoc_Cut(aApp)}

  DCMENUITEM "&Paste" PARENT oMenuEdit ACTION {||XDoc_Paste(aApp)}

  DCMENUITEM SEPARATOR PARENT oMenuEdit

  DCMENUITEM "&Browse Edit Mode" INDEX nMenuBrowse PARENT oMenuEdit ;
     ACTION {||XDoc_BrowEditMode(aApp)}

/* --- Popup Print Menu --- */

DCSUBMENU oMenuPrint PROMPT "&Print"

  DCMENUITEM "&Print List" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintList(3, aApp)}

  DCMENUITEM "P&review List" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintList(1, aApp)}

  DCMENUITEM "&Output List to File" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintList(2, aApp)}

  DCMENUITEM SEPARATOR PARENT oMenuPrint

  DCMENUITEM "Print &Item" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintItem( 3, aApp )}

  DCMENUITEM "Pre&View Item" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintItem( 1, aApp )}

  DCMENUITEM "Output Item to &File" PARENT oMenuPrint ;
     ACTION {||XDoc_PrintItem( 2, aApp )}
*
END SEQUENCE

DCGETOPTIONS WINDOWHEIGHT 430 ;
             WINDOWWIDTH 640 ;
             SAYWIDTH 130 ;
             NAME 'COLLECT' ;
             SAYOPTIONS XBPSTATIC_TEXT_BOTTOM ;
             HELPFILE 'EXPRESS.HLP' ;
             CLOSEQUERY ;
             ABORTQUERY ;
             NOESCAPEKEY ;
             TABSTOP ;
             GETFONT '10.Courier' ;
             EVAL {|o|SetAppWindow(o)} ;
             HILITEGETS GRA_CLR_RED ;
             NOSUPERVISE ;
             CASCADE

RETURN { GetOptions, GetList }

/* ------------------- */

PROCEDURE XDoc_LoadFields ( aApp, nRefreshMode, aRefreshList )

cDescription := XDOC->descript
cType        := XDOC->type
cSyntax      := XDOC->syntax
cArguments   := XDOC->args
cSeeAlso     := XDOC->see_also
cModule      := XDOC->module
cFiles       := XDOC->files
cSort        := XDOC->sort
cReturns     := XDOC->returns
cCommand     := XDOC->command
cMethods     := XDOC->methods
cIvars       := XDOC->ivars
cChapter     := XDOC->chapter
cCategory    := XDOC->category
cShort       := XDOC->short
cNotes       := XDOC->notes
cExamples    := XDOC->examples
cAuthor      := XDOC->author
dOrigDate    := XDOC->orig_date
cOrigTime    := XDOC->orig_time
dRevDate     := XDOC->rev_date
cRevTime     := XDOC->rev_time
cSource      := XDOC->source
nVersion     := XDOC->version
nSubType     := XDOC->subtype

IF Empty(dOrigDate)
  dOrigDate := Date()
  dRevDate  := Date()
ENDIF

IF Empty(cOrigTime)
  cOrigTime := Time()
  cRevTime  := Time()
ENDIF

IF !Empty(aGetList)
  DC_GetRefresh(aGetList, nil, nRefreshMode, aRefreshList )
  DC_GetOrigSet( aGetList )  // Store new values to ORIG field in Getlist
ENDIF
nRecord := RecNo()

RETURN

/* ------------------ */

PROCEDURE XDoc_SaveFields ( aApp )


IF lAppendMode

  AddRec()

ELSE

  Reclock(5)

ENDIF

  REPL XDOC->descript   WITH cDescription
  REPL XDOC->type       WITH cType
  REPL XDOC->syntax     WITH cSyntax
  REPL XDOC->args       WITH cArguments
  REPL XDOC->see_also   WITH cSeeAlso
  REPL XDOC->module     WITH DC_Token(cModule,',',1)
  REPL XDOC->files      WITH cFiles
  REPL XDOC->sort       WITH cSort
  REPL XDOC->returns    WITH cReturns
  REPL XDOC->command    WITH cCommand
  REPL XDOC->methods    WITH cMethods
  REPL XDOC->ivars      WITH cIvars
  REPL XDOC->chapter    WITH cChapter
  REPL XDOC->category   WITH cCategory
  REPL XDOC->short      WITH cShort
  REPL XDOC->notes      WITH cNotes
  REPL XDOC->examples   WITH cExamples
  REPL XDOC->author     WITH cAuthor
  REPL XDOC->orig_date  WITH dOrigDate
  REPL XDOC->orig_time  WITH cOrigTime
  REPL XDOC->rev_date   WITH Date()
  REPL XDOC->rev_time   WITH Time()
  REPL XDOC->source     WITH cSource
  REPL XDOC->version    WITH nVersion
  REPL XDOC->subtype    WITH nSubType

  UNLOCK
  lAppendMode := .f.

  // DC_MsgBox(,,{'Record has been saved!'},,,,.f.,1)
  DC_GetOrigSet( aGetList )  // Store new values to ORIG field in Getlist

RETURN

/* ------------------- */

PROCEDURE XDoc_TestChanged ( aApp, lExit )

lExit := IIF( Valtype(lExit)='L',lExit,.f. )
IF nRecord = RecNo() .AND. DC_GetOrigUpdated( aGetList )
  IF DC_MsgBox(,,{'Data has been modified. Save Changes?'},,,,.t.)
    XDoc_SaveFields(aApp)
  ELSEIF !lExit
    nRecord := 0
    XDoc_LoadFields(aApp)
  ENDIF
ENDIF
RETURN

/* ------------------- */

STATIC FUNCTION XDoc_SetFocus ( oXbp )

STATIC oFocus

IF Valtype(oXbp) = 'O'
  oFocus := oXbp
ENDIF
RETURN oFocus

/* ------------------- */

STATIC FUNCTION XDoc_PrintItem ( nMode )

LOCAL cScrn

IF nMode = 1
  DCPRINT ON SIZE 60,100 FONT '12.Courier New' PREVIEW AUTOEJECT NONSTOP
ELSEIF nMode = 2
  DCPRINT ON SIZE 60,100 TEXTONLY AUTOEJECT
ELSE
  DCPRINT ON SIZE 60,100 FONT '12.Courier New' AUTOEJECT
ENDIF

IF Valtype(DC_PrinterObject()) # 'O' .OR. !DC_PrinterObject():lActive
  BREAK
ENDIF

IF nMode # 1
  cScrn := DC_WaitOn()
ENDIF

DCPRINT FONT "16.Arial Bold"
@ 1, 5 DCPRINT SAY XDOC->command

DCPRINT FONT "12.Arial Bold"
@ DC_PrinterRow() + 2, 5 DCPRINT SAY XDOC->short

_MemoPrint( 'Syntax:', XDOC->syntax )
_MemoPrint( 'Arguments:', XDOC->args )
_MemoPrint( 'Returns:', XDOC->returns )
_MemoPrint( 'Description:', XDOC->descript )
_MemoPrint( 'iVars:', XDOC->ivars )
_MemoPrint( 'Methods:', XDOC->methods )
_MemoPrint( 'Notes:', XDOC->notes )
_MemoPrint( 'Examples:', XDOC->examples )
_MemoPrint( 'Files:', XDOC->files )
_MemoPrint( 'See Also:', XDOC->see_also )
_MemoPrint( 'Source Code:', XDOC->source )

IF nMode # 1
  DC_Impl(cScrn)
ENDIF

DCPRINT OFF PAGE 1

RETURN nil

/* --------------------- */

STATIC FUNCTION _MemoPrint( cHeading, cMemo )

LOCAl nLineCount, i, cMemoLine

IF Empty(cMemo)
  RETURN nil
ENDIF

cMemo := MemoTrim(cMemo)

IF Empty(cMemo)
  RETURN nil
ENDIF

DCPRINT FONT "10.Arial Bold"

@ DC_PrinterRow() + 2, 5 DCPRINT SAY cHeading

DCPRINT FONT "10.Courier New"

nLineCount := MLCount(cMemo)
FOR i := 1 TO nLineCount
  cMemoLine := MemoLine( cMemo, nil, i )
  @ DC_PrinterRow()+1,7 DCPRINT SAY cMemoLine
NEXT

RETURN nil

/* --------------------- */

STATIC FUNCTION XDoc_Paste ()

LOCAL oXbp := XDoc_SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:pasteMarked()
  oXbp:GetData()
ENDIF
RETURN nil

/* --------------------- */


STATIC FUNCTION XDoc_Copy ()

LOCAL oXbp := XDoc_SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:copyMarked()
  oXbp:setMarked({0,0})
ENDIF
RETURN nil

/* --------------------- */

STATIC FUNCTION XDoc_Cut ()

LOCAL oXbp := XDoc_SetFocus()

IF Valtype(oXbp) = 'O'
  oXbp:cutMarked()
  oXbp:GetData()
ENDIF
RETURN nil

/* --------------------- */

STATIC FUNCTION XDoc_Find ( aApp )

LOCAL GetList := {}, nRecNo := RecNo(), cSeek, nChoice, cLocate, lOk, aFields, ;
      lBrowse := .f.

cSeek := Space(20)
cLocate := Space(30)
aFields := { ;
   { {||XDOC->type}, 'Type', 8, "TYPE", 'Type' } , ;
   { {||XDOC->command}, 'Command', 8, 'COMMAND', 'Command' }, ;
   { {||XDOC->category}, 'Category', 8, 'CATEGORY', 'Category' }, ;
   { {||XDOC->module}, 'Module', 8, 'MODULE', 'Module' }, ;
   { {||XDOC->SHORT}, 'Short Description', 25, nil, nil } ;
 }
@ 0,0 DCSAY 'Command or Function to Seek' GET cSeek PICT '@!' ;
      SAYRIGHT SAYSIZE 30 TABSTOP

@ 2,0 DCSAY 'Text to Locate' GET cLocate PICT '@!' ;
      SAYRIGHT SAYSIZE 30 TABSTOP

@ 4,0 DCPUSHBUTTON CAPTION '~Browse' SIZE 9,1.2 ;
      TABSTOP ;
      ACTION {||lBrowse:=DC_FindBrowse(aFields,,,,85,15), ;
                DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

DCREAD GUI EXPRESS FIT ADDBUTTONS ENTEREXIT TO lOk MODAL ;
   TITLE 'Find or Locate a Record'

IF lOk .AND. (!Empty(cSeek) .OR. !Empty(cLocate))
  IF !Empty(cSeek)
    OrdSetFocus('COMMAND')
    cSeek := Alltrim(Upper(cSeek))
    dbSeek( cSeek )
  ENDIF
  IF Eof() .OR. Empty(cSeek)
    IF !Empty(cLocate)
      cSeek := Alltrim(Upper(cLocate))
    ENDIF
    IF !Empty(cLocate) .OR. DC_MsgBox(,,{'Search: ' + cSeek,'', ;
                'Record not found in Index. Try using text-search?'},,,,.t.)
      LOCATE FOR cSeek $ Upper(XDOC->descript) .OR. ;
                 cSeek $ Upper(XDOC->syntax) .OR.   ;
                 cSeek $ Upper(XDOC->args) .OR.     ;
                 cSeek $ Upper(XDOC->ivars) .OR.    ;
                 cSeek $ Upper(XDOC->methods) .OR.  ;
                 cSeek $ Upper(XDOC->returns) .OR.  ;
                 cSeek $ Upper(XDOC->notes)   .OR.  ;
                 cSeek $ Upper(XDOC->see_also) .OR. ;
                 cSeek $ Upper(XDOC->command) .OR.  ;
                 cSeek $ Upper(XDOC->short)
      IF !Eof()
        nChoice = 1
        DO WHILE nChoice = 1
          XDOC_LoadFields(aApp)
          nChoice := DC_Alert('Text Search: ' + cSeek, ;
                     { '&Continue','&Ok', '&Abort' }, nil,nil,nil,nil,nil,@aLocate )
          IF nChoice = 1
            CONTINUE
          ELSEIF nChoice = 3
            GO nRecNo
            EXIT
          ELSE
            EXIT
          ENDIF
        ENDDO
        XDoc_LoadFields(aApp)
      ELSE
        DC_MsgBox({'Search: ' + cSeek,'','Record not found'})
      ENDIF
    ELSE
      GO nRecNo
    ENDIF
  ELSE
    XDoc_LoadFields(aApp)
  ENDIF
ELSEIF lBrowse
    XDoc_LoadFields(aApp)
ENDIF

RETURN nil

/* --------------------- */

STATIC PROCEDURE XDoc_NewRecord( aApp )

LOCAL nChoice

nChoice := DC_Alert('Select Option for Adding New Record', ;
           { '&Copy Current','&Blank','&Abort' } )

IF nChoice = 1
  XDoc_LoadFields(aApp)
  GO BOTTOM
  SKIP
ELSEIF nChoice = 2
  GO BOTTOM
  SKIP
  XDoc_LoadFields(aApp)
ENDIF
lAppendMode := .t.
DC_GetRefresh(aGetList)
SetAppFocus(oTabPage1)
SetAppFocus(DC_GetObject(aGetList,'GET_COMMAND'))

RETURN

/* --------------------- */

STATIC FUNCTION XDoc_Import ( aApp )

LOCAL GetList := {}, nRecNo := RecNo(), cImport, lOk

cImport := Space(50)
@ 0,0 DCSAY 'Database Name to Import' GET cImport PICT '@!'

DCREAD GUI EXPRESS FIT ADDBUTTONS TITLE 'Import Database' ;
   TO lOk ENTEREXIT

IF !lOk
   RETURN nil
ENDIF

cImport := Alltrim(cImport)
IF !Empty(cImport)
  IF !('.'#cImport)
    cImport += '.DBF'
  ENDIF
  IF !File(cImport)
    DC_MsgBox( cImport + ' not found.' )
  ELSE
    APPEND FROM (cImport)
  ENDIF
ENDIF
GO nRecNo

RETURN nil

/* ------------------- */

FUNCTION XDoc_PrintList ( nMode, aApp )

LOCAL nRow, nSaveRec, cScrn, cFontName, oPrinter, i

SELE xdoc
nSaveRec := RecNo()
GO TOP

BEGIN SEQUENCE

IF nMode = 1
  DCPRINT ON SIZE 50,132 FONT '6.Courier New' TO oPrinter ;
     PREVIEW NONSTOP HIDE
ELSEIF nMode = 2
  DCPRINT ON SIZE 50,132 TEXTONLY
ELSE
  DCPRINT ON SIZE 50,132 FONT '6.Courier New' TO oPrinter
ENDIF

IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
  BREAK
ENDIF

IF nMode # 1
  cScrn := DC_WaitOn('Printing..')
ENDIF

FOR i := 1 TO oPrinter:nCopies

  GO TOP
  nRow := 3
  oPrinter:nPage := 1
  DO WHILE !Eof()

    IF nRow <= 3

      DCPRINT FONT '12.Arial Bold'

      @ nRow,10 DCPRINT SAY cTitle
      @ nRow,70 DCPRINT SAY 'Page ' + Alltrim(Str(oPrinter:nPage))
      @ nRow,90 DCPRINT SAY Date()

      nRow += 2

      DCPRINT FONT '10.Arial Bold'

      @ nRow,0  DCPRINT SAY 'Command'
      @ nRow,30 DCPRINT SAY 'Type'
      @ nRow,40 DCPRINT SAY 'Category'
      @ nRow,55 DCPRINT SAY 'Short Description'
      @ nRow,125 DCPRINT SAY 'Module'
      nRow += 2

      DCPRINT FONT '10.Arial'

    ELSE

      @ nRow,0  DCPRINT SAY XDOC->command
      @ nRow,30 DCPRINT SAY XDOC->type
      @ nRow,40 DCPRINT SAY XDOC->category
      @ nRow,55 DCPRINT SAY XDOC->short
      @ nRow,125 DCPRINT SAY XDOC->module
      nRow++

      SKIP

      IF nRow > ( oPrinter:nRows - 5 )
        DCPRINT EJECT
        nRow := 3
      ENDIF

    ENDIF

  ENDDO

NEXT

END SEQUENCE

DCPRINT OFF

IF nMode # 1
  DC_Impl(cScrn)
ENDIF

GO nSaveRec
RETURN nil

/* -------------------- */

STATIC FUNCTION RecLock( nWaitTime )

LOCAL nWait

IF DBRLOCK()
  RETURN (.T.)   // locked
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime=0 .OR. nWait>0)
    IF DBRLOCK()     // locked
      RETURN (.T.)
    ENDIF
    INKEY(.5)     // wait 1/2 second
    nWait -= .5
  ENDDO
ENDDO
RETURN (.F.)      // not locked

/* -------------------- */

STATIC FUNCTION AddRec ( nWaitTime )

LOCAL nWait

APPEND BLANK
IF !NETERR()
   RETURN (.T.)
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime = 0 .OR. nWait > 0)
    APPEND BLANK
    IF .NOT. NETERR()
      RETURN .T.
    ENDIF
    nWait -= .5
  ENDDO
ENDDO
RETURN .F.

/* --------------------- */

STATIC FUNCTION FiLock( nWaitTime )

LOCAL nWait

IF FLOCK()
  RETURN (.T.)   // locked
ENDIF
DO WHILE .T.
  nWait := nWaitTime
  DO WHILE (nWaitTime=0 .OR. nWait>0)
    INKEY(.5)     // wait 1/2 second
    nWait -= .5
    IF FLOCK()
      RETURN (.T.)    // locked
    ENDIF
  ENDDO
ENDDO
RETURN .F.

/* ------------------- */

STATIC FUNCTION Pack( aApp )

LOCAL lIsShared := dbInfo( DBO_SHARED ), GetList := {}, lOk, ;
      nPackMode := 1, cAlias, cScrn

IF lIsShared
  IF DC_MsgBox(,,{'The file must be opened exclusive to Pack.',;
                      'Close file and reopen exclusive?'},,,,.t.)
    dbCloseArea()
    USE (cDatabase) VIA (cDriver) NEW EXCLUSIVE ALIAS 'XDOC'
  ENDIF
ENDIF
lIsShared := dbInfo( DBO_SHARED )
IF !lIsShared
  @ 1,1 DCRADIO nPackMode VALUE 1 PROMPT 'Fast Pack'
  @ 2,1 DCRADIO nPackMode VALUE 2 PROMPT 'Slow Pack (compress memo fields)'
  DCREAD GUI EXPRESS TO lOk FIT ADDBUTTONS ;
     TITLE 'Pack Database'
  IF !lOk
    RETURN nil
  ELSEIF nPackMode = 1
    dbPack()
    dbGoTop()
    XDoc_LoadFields( aApp )
    DC_MsgBox('Done!')
  ELSEIF nPackMode = 2
    IF File('BAKDATA.DBF') .OR. File('BAKDATA.FPT')
       IF !DC_MsgBox(,,{'BAKDATA.* file exist.  Erase and continue?'},,,,.t.)
          RETURN .f.
       ENDIF
       FErase('BAKDATA.DBF')
       FErase('BAKDATA.FPT')
    ENDIF
    cAlias := Strtran(Upper(cDatabase),'.DBF','')
    CLOSE
    FRename(cAlias+'.DBF','BAKDATA.DBF')
    FRename(cAlias+'.FPT','BAKDATA.FPT')
    USE BAKDATA VIA (cDriver) NEW EXCLUSIVE
    COPY STRUCTURE TO (cAlias)
    CLOSE
    USE (cDatabase) VIA (cDriver) NEW EXCLUSIVE ALIAS 'XDOC'
    ZAP
    cScrn := DC_WaitOn()
    APPEND FROM BAKDATA FOR !Deleted()
    REINDEX
    DC_Impl(cScrn)
    XDoc_LoadFields( aApp )
    DC_MsgBox('Done!')
  ENDIF

ENDIF

RETURN nil

/* ------------------------- */

STATIC FUNCTION RTFHeader ()

LOCAL cCrLf := Chr(13)+Chr(10)

RETURN ;
"{\rtf1\ansi \deff0 {\fonttbl" + cCrLf + ;
"{\f0\fswiss Arial;}" + cCrLf + ;
"{\f1\fmodern Courier;}" + cCrLf + ;
"{\f2\froman Times New Roman;}" + cCrLf + ;
"{\f3\fdecor Symbol;}}" + cCrLf + ;
"{\colortbl;" + cCrLf + ;
"\red0\green0\blue0;" + cCrLf + ;
"\red0\green0\blue127;" + cCrLf + ;
"\red0\green127\blue0;" + cCrLf + ;
"\red0\green127\blue127;" + cCrLf + ;
"\red127\green0\blue0;" + cCrLf + ;
"\red127\green0\blue127;" + cCrLf + ;
"\red127\green127\blue0;" + cCrLf + ;
"\red127\green127\blue127;" + cCrLf + ;
"\red192\green192\blue192;" + cCrLf + ;
"\red0\green0\blue255;" + cCrLf + ;
"\red0\green255\blue0;" + cCrLf + ;
"\red0\green255\blue255;" + cCrLf + ;
"\red255\green0\blue0;" + cCrLf + ;
"\red255\green0\blue255;" + cCrLf + ;
"\red255\green255\blue0;" + cCrLf + ;
"\red255\green255\blue255}" + cCrLf + ;
"\paperw11906\paperh16838" + cCrLf

/* ------------------ */

// Create NG, RTF or HTML Source

STATIC FUNCTION XDoc_Source ( nMode, aApp, cNGTitle, cSystem )

LOCAL cText, nVers := 999.99, GetList := {}, lOk

IF nMode = 1
  cText := 'HTML files for use with a Web-Browser'
ELSEIF nMode = 2
  cText := '.RTF/.CNT files for compiling with the Windows Help Compiler'
ELSEIF nMode = 3
  cText := ;
    '.TXT files for compiling with the Norton Guide/Expert Help Compiler'
ENDIF

@ 1,1 DCSAY 'This selection will output the contents of the help database to' ;
   SAYSIZE 0
@ 2,1 DCSAY cText SAYSIZE 0

@ 4,1 DCSAY 'Only records with a Version Less Than or Equal To' SAYSIZE 0
@ 5,1 DCSAY 'the below number will be included.' SAYSIZE 0

@ 7,1 DCSAY 'Version' GET nVers PICT '999.99'

DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk ;
  TITLE 'Write Help Source Code' ;
  ENTEREXIT

IF lOk
  IF nMode < 3
    XDoc_WriteSource( nMode, .t., aApp, cNGTitle, cSystem, nVers )
  ENDIF
  XDoc_WriteSource( nMode, .f., aApp, cNGTitle, cSystem, nVers )
ENDIF
RETURN nil

/* ------------------ */

// Create NG, RTF or HTML Source

STATIC FUNCTION XDoc_WriteSource ( nMode, lIndex, aApp, cNGTitle, cSystem, nVers )

LOCAL nRecCount, aSeeAlso, cNGSeeAlso, cSeekAlso, nSaveRec, nSaveOrd, ;
      nHandle, cNGName, i, aSyntax, cNGModule, nCount, aTypes, ;
      cNGCommand, cEol, lTrim, cBlankLine, nPass, aKeyWord, ;
      cHelpHpj, nHelpCnt, cFunction, cText, cSeekAlso2, cSubType

nMode   := IIF(Valtype(nMode)='N',nMode,0)
lIndex  := IIF(Valtype(lIndex)='L',lIndex,.f.)
IF Empty(cSystem)
  cSystem := 'XDOC'
ENDIF
aTypes := {{},{}}
FOR i := 1 TO LEN(aModule)
  AAdd(aTypes[1],Pad(DC_Token(aModule[i],',',1),8))
  AAdd(aTypes[2],DC_Token(aModule[i],',',2))
NEXT

IF nMode = 2 // RTF

  cEol := '\line'
  lTrim := .f.
  cBlankLine := ''

  cHelpHpj := ;
  '[WINDOWS]' + CRLF + ;
  'Main="",(170,18,835,961),60672,,(r12632256)' + CRLF + CRLF + ;
  '[CONFIG]' + CRLF + ;
  'BrowseButtons()' + CRLF +CRLF + ;
  '[OPTIONS]' + CRLF + ;
  'HCW=0' + CRLF + ;
  'COMPRESS=12 Hall Zeck' + CRLF + ;
  'LCID=0x409 0x0 0x0 ;English (United States)' + CRLF +;
  'REPORT=Yes' + CRLF + ;
  'FTS=1' + CRLF + ;
  'CNT=' + cSystem + '.cnt' + CRLF + ;
;//  'BMROOT=' + CRLF + ;
  'HLP=' + cSystem + '.hlp' + CRLF + CRLF + ;
  '[FILES]' + CRLF

  nHelpCnt := FCreate( cSystem + '.CNT' )
  FWrite( nHelpCnt,;
   ':Base ' + cSystem + '.hlp > main' + CRLF + ':Title ' + cNGTitle + CRLF )

ELSE

  cEol := ''
  lTrim := .f.
  cBlankLine := ''

ENDIF
nCount := 0
nPass := 1

OrdSetFocus('MODULE')

DO WHILE nPass <= LEN(aTypes[1])

  cNGName  := aTypes[ 1, nPass ]
  cNGTitle := aTypes[ 2, nPass ]
  SEEK cNGName
  IF Eof()
    nPass++
    LOOP
  ENDIF
  IF nMode = 1     // HTML
    cNGName := Trim(cNGName) + '.HTM'
  ELSEIF nMode = 2 // RTF
    cNGName := Trim(cNGName) + '.RTF'
  ELSEIF nMode = 3 // NG
    cNGName := Trim(cNGName) + '.TXT'
  ENDIF
  IF lIndex .OR. nMode = 0  .OR. nMode = 3
    IF ( nHandle := FCreate( cNGName, FC_NORMAL ) ) <= 0
      DC_WinAlert("Cannot Create " + cNGName + ", DOS error " + Alltrim(Str(FError())) )
      RETURN .f.
    ELSE
      DC_Working(0, "Creating " + cNGName,,,,,,,,{nil,POINTER_BUSY_1,1} )
    ENDIF
  ELSE
    IF ( nHandle := FOpen( cNGName, FO_WRITE ) ) <= 0
      DC_WinAlert("Cannot Open " + cNGName + ", DOS error " + Alltrim(Str(FError())) )
      RETURN .f.
    ELSE
      DC_Working( 0, "Appending " + cNGName,,,,,,,,{nil,POINTER_BUSY_1,1} )
    ENDIF
    IF nMode = 1      // HTML
      FSeek( nHandle, 0, FS_END )
      Fwrite( nHandle, '<HR>')
    ELSEIF nMode = 2  // RTF
      Fwrite ( nHandle, RTFHeader() )
      cHelpHpj += cNGName + CRLF
      IF !Empty(cNGTitle)
        FWrite( nHelpCnt, '1 ' + cNGTitle + CRLF )
      ENDIF
    ENDIF
  ENDIF
  nRecCount := 0

  DO WHILE (Left( XDOC->module, 8 ) == aTypes[ 1, nPass ]) .AND. !Eof()

    IF XDOC->version > nVers
      SKIP
      LOOP
    ENDIF

    IF EMPTY(XDOC->short) .OR. Deleted()
      SKIP
      LOOP
    ENDIF
    nRecCount ++
    DC_Working(1)
    IF lIndex
      cNGCommand := AllTrim(XDOC->command)
      FWrite( nHandle, '<A HREF="#' + ;
              cNGCommand + '"><TT>' + ;
              cNGCommand + '</A>' + Repl('.',21-Len(cNGCommand)) + ;
              '</TT>' + Alltrim(XDOC->short) + '<BR>' + CRLF )
      SKIP
      LOOP
    ENDIF

    IF XDOC->subtype = 0 .AND. ;
       ' ' + Alltrim(XDOC->module) + ' ' $ ' FUNCTION COMMAND CLASS LIBRARY ADSDBE '
      cSubType := '   ' + Substr(Alltrim(Str(XDOC->version)),1,3)
    ELSEIF XDOC->subtype = 1
      cSubType := '   (GUI)   ' + Substr(Alltrim(Str(XDOC->version)),1,3)
    ELSEIF XDOC->subtype = 2
      cSubType := '   (TEXT)   ' + Substr(Alltrim(Str(XDOC->version)),1,3)
    ELSEIF XDOC->subtype = 3
      cSubType := '   (DUAL)   ' + Substr(Alltrim(Str(XDOC->version)),1,3)
    ELSE
      cSubType := ''
    ENDIF

    /* ------ Command ------ */
    IF nMode = 1      // HTML
      FWrite( nHandle, '<A NAME="'+Alltrim(XDOC->command)+'"></A>'+CRLF+ ;
                  '<H2>'+Alltrim(XDOC->command)+'</H2>'+ CRLF )
    ELSEIF nMode = 2  // RTF
      cNGCommand := Trim(XDOC->command)
      cFunction := ''
      IF XDOC->type = 'COMMAND' .OR. XDOC->type = 'FUNCTION' .OR. ;
         XDOC->type = 'CLASS' .OR. XDOC->type = 'DCDIALOG'
        cFunction := cNGCommand + ' - '
      ENDIF
      cNGCommand := _Strtran(cNGCommand,"[]/~`|@ '=+.?#!%^&*-+\{}:;<>,",'')
      FWrite( nHandle, ;
        "#{\footnote " + Trim(XDOC->module)+':' + cNGCommand + "}" + CRLF )
      FWrite( nHandle, "${\footnote " + Trim(SubStr(XDOC->short,1,60)) + "}" + CRLF )
      FWrite( nHandle, "K{\footnote " + cNGCommand + "}" + CRLF )
      nCount += 10
      FWrite( nHandle, "+{\footnote " + ;
           Strtran(Str(nCount,5),' ','0') + "}" + CRLF )
      FWrite( nHelpCnt, '2 ' + cFunction + Trim(SubStr(XDOC->short,1,60)) + ;
              cSubType + '=' + ;
              Trim(XDOC->module)+':' + cNGCommand + CRLF )
    ELSEIF nMode = 3  // NG
      FWrite( nHandle, "!short:" + SUBSTR( XDOC->command ,1,18) + ' ' + ;
             SUBSTR( XDOC->short ,1,60) + CRLF )
      FWrite( nHandle, "^b" + AllTrim( XDOC->command ) + "^b" + CRLF )
    ENDIF
    FWrite( nHandle, CRLF )

    /* ------ Short ------ */
    IF nMode = 1      // HTML
      FWrite( nHandle, " <H3>" + Trim( SubStr( XDOC->short ,1,70)) + "</H3>" + CRLF )
    ELSEIF nMode = 2  // RTF
      FWrite( nHandle, "\pard \f0 \fs35 \cf1 \keepn \b " + Alltrim( XDOC->command ) + ' - ' + ;
                       "\fs21 " + Alltrim(SubStr( XDOC->short ,1,70)) + ;
                       "\fs24 \cf10" + cSubType + "\cf1" + ;
                       " \b0 \f1 \fs20 \par \pard" + CRLF )
    ELSEIF nMode = 3  // NG
      FWrite( nHandle, " " + SUBSTR( XDOC->short ,1,70) + CRLF )
    ENDIF

    aKeyWord := nil

    /* ------ Syntax ------ */
    IF !Empty(_Trim(XDOC->syntax))
      FWrite( nHandle, CRLF )
      IF nMode = 1     // HTML
        FWrite( nHandle, "<H4>Syntax:</H4>" + CRLF + "<PRE>" )
      ELSEIF nMode = 2 // RTF
        FWrite( nHandle, ;
            "\par \f0 \fs22 \b Syntax: \b0 \f1 \fs20 \par \par"  + CRLF )
      ELSEIF nMode = 3 // NG
        FWrite( nHandle, "^bSyntax:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->syntax, nMode )
      cText := SPACE(IIF(nMode=2,0,3)) + ;
             StrTran( HardCr( MemoTrim( cText,,cEol,cBlankLine,lTrim) ), ;
             CRLF,CRLF+Space(IIF(nMode=2,0,3)))
      cText := DocHyperLink( cText, nMode, ;
                IIF( XDOC->type='FUNCTION',2,1), ;
                Alltrim(XDOC->command),@aKeyWord )
      FWrite( nHandle, cText )
      IF nMode = 1 // HTML
        FWrite( nHandle, "</PRE>" + CRLF )
      ENDIF
    ENDIF

    /* ------ Arguments ------ */
    IF !Empty(_Trim(XDOC->args))
      FWrite( nHandle, CRLF )
      IF nMode = 1      // HTML
        FWrite( nHandle, "<H4>Arguments:</H4>" + CRLF + "<PRE>" )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle, ;
          "\par \par \f0 \fs22 \b Arguments: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSEIF nMode = 3  // NG
        FWrite( nHandle, "^bArguments:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->args, nMode )
      cText := SPACE(IIF(nMode=2,0,3)) + ;
            StrTran(HardCr( MemoTrim( cText,,cEol,cBlankLine,lTrim) ), ;
            CRLF,CRLF+Space(IIF(nMode=2,0,3)))
      cText := DocHyperLink( cText, nMode, 3, Alltrim(XDOC->command), aKeyWord )
      Fwrite( nHandle, cText )
      IF nMode = 1      // HTML
        FWrite( nHandle, "</PRE>" + CRLF )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle, "\par" + CRLF )
      ENDIF
    ENDIF

    /* ------ Returns ------ */
    IF !Empty(_Trim(XDOC->returns))
      FWrite( nHandle, CRLF )
      IF nMode = 1 // HTML
        FWrite( nHandle, "<H4>Returns:</H4>" + CRLF + "<PRE>" )
      ELSEIF nMode = 2 // RTF
        FWrite( nHandle, ;
           "\f0 \fs22 \b Returns: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSE // NG
        FWrite( nHandle, "^bReturns:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->returns, nMode, 0 )
      FWrite( nHandle, SPACE(IIF(nMode=2,0,3)) + ;
            StrTran( MemoTrim( cText,,cEol,cBlankLine,lTrim) , ;
            CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
      IF nMode = 1 // HTML
        FWrite( nHandle, "</PRE>" + CRLF )
      ENDIF
    ENDIF

    /* ------ Description ------ */
    IF !Empty(XDOC->descript)
      FWrite( nHandle, CRLF )
      IF nMode = 1 // HTML
        FWrite( nHandle, "<H4>Description:</H4>" + CRLF )
      ELSEIF nMode = 2 // RTF
        FWrite( nHandle, ;
            "\par \par \f0 \fs22 \b Description: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSE // NG
        FWrite( nHandle, "^bDescription:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->descript, nMode, 0 )
      FWrite( nHandle, Space(IIF(nMode=2,0,3)) + ;
            StrTran( HardCr( MemoTrim(cText,,cEol,cBlankLine,lTrim) ),;
            CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
    ENDIF

    /* ------ IVars ------ */
    IF !Empty(XDOC->ivars)
      FWrite( nHandle, CRLF )
      IF nMode = 1 // HTML
        FWrite( nHandle, "<H4>Exported Instance Variables:</H4>" + CRLF )
      ELSEIF nMode = 2 // RTF
        FWrite( nHandle, ;
            "\par \par \f0 \fs22 \b Exported Instance Variables: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSE // NG
        FWrite( nHandle, "^bExported Instance Variables:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->ivars, nMode, 0 )
      FWrite( nHandle, Space(IIF(nMode=2,0,3)) + ;
            StrTran( HardCr( MemoTrim(cText,,cEol,cBlankLine,lTrim) ),;
            CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
    ENDIF

    /* ------ Methods ------ */
    IF !Empty(XDOC->methods)
      FWrite( nHandle, CRLF )
      IF nMode = 1 // HTML
        FWrite( nHandle, "<H4>Methods:</H4>" + CRLF )
      ELSEIF nMode = 2 // RTF
        FWrite( nHandle, ;
            "\par \par \f0 \fs22 \b Methods: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSE // NG
        FWrite( nHandle, "^bMethods:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->methods, nMode, 0 )
      FWrite( nHandle, Space(IIF(nMode=2,0,3)) + ;
            StrTran( HardCr( MemoTrim(cText,,cEol,cBlankLine,lTrim) ),;
            CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
    ENDIF

    /* ------ Notes ------ */
    IF !Empty(XDOC->notes)
      FWrite( nHandle, CRLF )
      IF nMode = 1      // HTML
        FWrite( nHandle, "<H4>Notes:</H4>" + CRLF )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle, ;
          "\par \par \f0 \fs24 \b Notes: \b0 \f1 \fs20 \line \par \par" + CRLF )
      ELSEIF nMode = 3  // NG
        FWrite( nHandle, "^bNotes:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->notes, nMode, 0 )
      FWrite( nHandle, Space(IIF(nMode=2,0,3)) + ;
             StrTran( HardCr( MemoTrim( cText,,cEol,cBlankLine,lTrim) ),;
             CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
    ENDIF

    /* ------ Examples ------ */
    IF !Empty(XDOC->examples)
      FWrite( nHandle, CRLF )
      IF nMode = 1      // HTML
        FWrite( nHandle, "<H4>Examples:</H4>" + CRLF + "<PRE>" )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle, ;
             "\par \par \f0 \fs22 \b Examples: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSEIF nMode = 3  // NG
        FWrite( nHandle, "^bExamples:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      cText := DocTran( XDOC->examples, nMode, 0 )
      FWrite( nHandle, SPACE(IIF(nMode=2,0,3)) + ;
             StrTran( HardCr( MemoTrim( cText,,cEol,cBlankLine,lTrim) ), ;
             CRLF,CRLF+Space(IIF(nMode=2,0,3))) )
      IF nMode = 1  // HTML
        FWrite( nHandle, "</PRE>" + CRLF )
      ENDIF
    ENDIF

    /* ------ Files ------ */
    IF !Empty(XDOC->files)
      FWrite( nHandle, CRLF )
      IF nMode = 1      // HTML
        FWrite( nHandle, "<H4>Source/Library:</H4>" + CRLF )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle, ;
           "\par \par \f0 \fs22 \b Source/Library: \b0 \f1 \fs20 \par \par" + CRLF )
      ELSEIF nMode = 3  // NG
        FWrite( nHandle, "^bSource/Library:^b" + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
      FWrite( nHandle, '  '+Trim(XDOC->files) + CRLF )
    ENDIF
    aSeeAlso := DC_TokenArray(Trim(XDOC->see_also),',')
    cNGSeeAlso := ''
    nSaveRec := RecNo()
    nSaveOrd := IndexOrd()
    OrdSetFocus(2)

    /* ------ See Also ------ */
    FOR i := 1 TO LEN(aSeeAlso)
      IF !Empty(aSeeAlso[i])
        cSeekAlso := Alltrim(aSeeAlso[i])
        cNGModule := ''
        IF ':'$cSeekAlso
          cNGModule   := SubStr(cSeekAlso,1,AT(':',cSeekAlso)-1)
          cSeekAlso := SubStr(cSeekAlso,AT(':',cSeekAlso)+1)
        ENDIF
        OrdSetFocus(2)
        SEEK UPPER(cSeekAlso)
        IF !EOF()
          IF !EMPTY(cNGModule)
            DO WHILE !EOF()
              IF cNGModule == TRIM(XDOC->module)
                EXIT
              ELSEIF Upper(XDOC->command) # cSeekAlso
                EXIT
              ENDIF
              SKIP
            ENDDO
          ENDIF
        ENDIF
        IF !Eof()
          IF nMode = 1   // HTML
            cNGSeeAlso += '   <A HREF="' + Alltrim(XDOC->module) + '.htm#' + ;
                        cSeekAlso + '">' + cSeekAlso + '</A><BR>'
          ELSEIF nMode = 2 // RTF
            IF 'dc_' $ cSeekAlso .AND. !('()' $ cSeekAlso)
              cSeekAlso += '()'
            ENDIF
            cSeekAlso2 := Strtran(cSeekAlso,'=','')
            cSeekAlso := _Strtran(cSeekAlso, ;
                                  "[]/~`|@ '=+.?#!%^&*-+\{}:;<>,",'')
            cNGSeeAlso += '{\uldb ' + cSeekAlso2 + '}{\v ' + ;
                         Alltrim(XDOC->module) + ':' + cSeekAlso +'}' + ', '
          ELSEIF nMode = 3 // NG
            cNGSeeAlso += ' "'+Alltrim(XDOC->module)+'.eho:'+cSeekAlso+'"'
          ENDIF
        ENDIF
      ENDIF
    NEXT
    cNGSeeAlso := Alltrim(cNGSeeAlso)
    IF Right(cNGSeeAlso,1)=','
      cNGSeeAlso := Substr(cNGSeeAlso,1,Len(cNGSeeAlso)-1)
    ENDIF
    GO nSaveRec
    OrdSetFocus(nSaveOrd)
    IF !Empty(cNGSeeAlso)
      FWrite( nHandle, CRLF )
      IF nMode = 1      // HTML
        FWrite( nHandle, "<H4>See Also:</H4>" + cNGSeeAlso + CRLF )
      ELSEIF nMode = 2  // RTF
        FWrite( nHandle,;
           "\par \par \f0 \fs22 \b See Also: \b0 \f1 \fs20 \par \par" + CRLF )
        FWrite( nHandle, cNGSeeAlso + CRLF )
      ELSEIF nMode = 3  // NG
        FWrite( nHandle, "!seealso: " + cNGSeeAlso + CRLF )
      ENDIF
      FWrite( nHandle, CRLF )
    ENDIF

    FWrite( nHandle, CRLF )
    IF nMode = 1      // HTML
      FWrite( nHandle, '<HR>' + CRLF )
    ELSEIF nMode = 2  // RTF
      FWrite( nHandle, '\page' + CRLF )
    ENDIF
    FWrite( nHandle, CRLF )
    SKIP

  ENDDO

  DC_Working(2)
  IF nMode = 2 // RTF
    FWrite( nHandle, '}' + CRLF )
  ENDIF
  FClose( nHandle )
  nPass++

ENDDO

IF nMode = 2 // RTF
  MemoWrit( cSystem + '.HPJ',cHelpHpj)
  FClose( nHelpCnt )
ENDIF
IF !lIndex
* _dchlpfuncref( nMode )
* _dchlpcommref( nMode )
* _dchlplink()
  DC_MsgBox(,,{"Done!"},"Write Help Source Code")
ENDIF

RETURN .t.

/* ---------------------- */

STATIC FUNCTION DocTran ( cText, nMode )

IF nMode = 1 // HTML
  cText := Strtran(cText,'<','(')
  cText := Strtran(cText,'>',')')
  cText := Strtran(cText,CHR(13)+CHR(10),CHR(13)+CHR(10)+'<BR>')
ELSEIF nMode = 2 // RTF
  cText := Strtran(cText,'\','\\')
  cText := Strtran(cText,CHR(12),'')
  cText := Strtran(cText,'{','\{')
  cText := Strtran(cText,'}','\}')
ENDIF
RETURN cText

* ----------------

FUNCTION DocHyperLink( cText, nMode, nMode2, cPrefix, aKeyWord )

LOCAL aText, i, j, nEnd, nStart, cKeyWord, cKeyWord2, cLine, cChar

IF nMode2 = 1  // commands

    aKeyWord := {}
    cPrefix := Strtran(cPrefix,' ','')
    cPrefix := Strtran(cPrefix,'@','')
    cPrefix := Strtran(cPrefix,')','')
    cPrefix := Strtran(cPrefix,'(','')
    aText := DC_TokenArray(cText,Chr(13)+Chr(10))
    cText := ''
    FOR i := 1 TO Len(aText)
      cLine := aText[i]
      IF '[' $ cLine .AND. !'[ ' $ cLine
        nStart := At('[',cLine) + 1
        nEnd := 0
        FOR j := nStart TO Len(cLine)
          cChar := Substr(cLine,j,1)
          IF cChar $ ' [],;'
            nEnd := j
            EXIT
          ENDIF
        NEXT
        IF nEnd > nStart
          cKeyWord := SubStr(cLine,nStart,nEnd-nStart)
          cKeyWord2 := Strtran(Strtran(cKeyWord,'<',''),'>','')
          cLine := StrTran(cLine, cKeyWord,'{\uldb ' + cKeyWord + '}{\v ' + ;
                   cPrefix + ':' + cKeyWord2 + '}') + Chr(13) + Chr(10)
          AAdd(aKeyWord,{cKeyWord2,.f.})
        ELSE
          cLine += Chr(13)+Chr(10)
        ENDIF
      ELSE
        cLine += Chr(13)+Chr(10)
      ENDIF
      cText += cLine
    NEXT

ELSEIF nMode2 = 2   // functions

    aKeyWord := {}
    cPrefix := Strtran(cPrefix,' ','')
    cPrefix := Strtran(cPrefix,'@','')
    cPrefix := Strtran(cPrefix,')','')
    cPrefix := Strtran(cPrefix,'(','')
    aText := DC_TokenArray(cText,Chr(13)+Chr(10))
    cText := ''
    FOR i := 1 TO Len(aText)
      cLine := aText[i]
      IF '<' $ cLine
        nStart := At('<',cLine)
        nEnd := 0
        FOR j := nStart TO Len(cLine)
          cChar := Substr(cLine,j,1)
          IF cChar $ ' >],;'
            nEnd := j
            EXIT
          ENDIF
        NEXT
        IF nEnd > nStart
          cKeyWord := SubStr(cLine,nStart,nEnd-nStart+1)
          cKeyWord2 := Strtran(Strtran(cKeyWord,'<',''),'>','')
          cLine := StrTran(cLine, cKeyWord,'{\uldb ' + cKeyWord + '}{\v ' + ;
                   cPrefix + ':' + cKeyWord2 + '}' ) + Chr(13) + Chr(10)
          AAdd(aKeyWord,{cKeyWord,.f.})
        ELSE
          cLine += Chr(13)+Chr(10)
        ENDIF
      ELSE
        cLine += Chr(13)+Chr(10)
      ENDIF
      cText += cLine
    NEXT

ELSEIF nMode2 = 3 .AND. !Empty(aKeyWord)

    cPrefix := Strtran(cPrefix,' ','')
    cPrefix := Strtran(cPrefix,'@','')
    cPrefix := Strtran(cPrefix,')','')
    cPrefix := Strtran(cPrefix,'(','')
    aText := DC_TokenArray(cText,Chr(13)+Chr(10))
    cText := ''
    FOR i := 1 TO Len(aText)
      cLine := Chr(255) + aText[i] + Chr(255)
      FOR j := 1 TO Len(aKeyWord)
        IF !aKeyWord[j,2] .AND. ;
            ( Chr(255) + aKeyWord[j,1] + ' ' $ cLine .OR. ;
              Chr(255) + aKeyWord[j,1] + ',' $ cLine .OR. ;
              ' ' + aKeyWord[j,1] + ' ' $ cLine .OR. ;
              ' ' + aKeyWord[j,1] + ',' $ cLine .OR. ;
              ',' + aKeyWord[j,1] + ',' $ cLine .OR. ;
              '@' + aKeyWord[j,1] + ' ' $ cLine .OR. ;
              ' ' + aKeyWord[j,1] + Chr(255) $ cLine )
          cKeyWord := aKeyWord[j,1]
          cKeyWord := Strtran(cKeyWord,'<','')
          cKeyWord := Strtran(cKeyWord,'>','')
          cLine := '#{\footnote ' + cPrefix + ':' + cKeyWord + '}' + ;
                   cLine // Chr(13) + Chr(10) + cLine
          aKeyWord[j,2] := .t.
        ENDIF
      NEXT
      cLine := Strtran(cLine,Chr(255),'')
      cLine += Chr(13) + Chr(10)
      cText += cLine
    NEXT
    FOR j := 1 TO Len(aKeyWord)
      cText := Strtran(cText,' ' + aKeyWord[j,1] + ' ','\b  ' + aKeyWord[j,1]+' \b0 ')
      cText := Strtran(cText,' ' + aKeyWord[j,1] + Chr(13),'\b  ' + aKeyWord[j,1]+'\b0'+Chr(13))
      cText := Strtran(cText,Chr(10) + aKeyWord[j,1] + ' ',Chr(10)+'\b ' + aKeyWord[j,1]+'\b0 ')
      cText := Strtran(cText,'}' + aKeyWord[j,1] + ' ','}'+'\b ' + aKeyWord[j,1]+' \b0 ')
    NEXT

ENDIF

RETURN cText

/* --------------------- */

STATIC FUNCTION _StrTran( cString, cChars, cRepl )

LOCAL i

FOR i := 1 TO Len(cChars)
  cString := Strtran(cString,Substr(cChars,i,1),cRepl )
NEXT
RETURN cString

/* --------------------- */

STATIC FUNCTION MemoTrim( cMemo, cQuote, cEndofLine, cBlankLine, lTrim )

LOCAL cOut := '', cLine, nLines, i

cQuote     := IIF(Valtype(cQuote)='C',cQuote,'')
cEndofLine := IIF(Valtype(cEndofLine)='C',cEndofLine,'')
cBlankLine := IIF(Valtype(cBlankLine)='C',cBlankLine,'')
lTrim      := IIF(Valtype(lTrim)='L',lTrim,.f.)

nLines := MLCOUNT(cMemo)
FOR i := nLines TO 1 STEP -1
  IF !EMPTY(_TRIM(MEMOLINE(cMemo,,i)))
    EXIT
  ENDIF
NEXT
nLines := i
FOR i := 1 TO nLines
  cLine := _TRIM( MEMOLINE( cMemo,, i ) )
  IF lTrim
    cLine := AllTrim(cLine)
  ENDIF
  IF Empty(cLine)
    cLine := cBlankLine
  ENDIF
  IF EMPTY(cLine) .AND. i=nLines
    EXIT
  ENDIF
  cLine := cLine + cEndofLine + CHR(13) +CHR(10)
  cOut := cOut + cQuote + cLine
NEXT
RETURN cOut

/* --------------------- */

STATIC FUNCTION _Trim( cText )

cText := StrTran(cText,CHR(13),'')
cText := StrTran(cText,CHR(10),'')
cText := StrTran(cText,CHR(0),'')

RETURN Trim(cText)

/* --------------------- */

STATIC FUNCTION _Bof()

LOCAL nRecNo := RecNo()

dbSkip(-1)
IF nRecNo == RecNo()
  RETURN .t.
ENDIF
GO nRecNo
RETURN .f.

/* --------------------- */

STATIC FUNCTION _Eof()

LOCAL nRecNo := RecNo()

IF Eof()
  RETURN .t.
ENDIF
dbSkip(1)
IF Eof()
  GO nRecNo
  RETURN .t.
ENDIF
GO nRecNo
RETURN .f.

/* ------------------------- */

STATIC FUNCTION XDoc_BrowEditMode( aApp )

LOCAL GetList := {}

@ 1,1 DCSAY 'Choose a navigation mode for browse editing'

@ 3,1 DCRADIO nBrowEdit                     ;
   VALUE DCGUI_BROWSE_EDITEXIT              ;
   PROMPT 'Exit after ENTER key'

@ 4,1 DCRADIO nBrowEdit                     ;
   VALUE DCGUI_BROWSE_EDITACROSS            ;
   PROMPT 'Edit next cell ACROSS after ENTER key'

@ 5,1 DCRADIO nBrowEdit                     ;
   VALUE DCGUI_BROWSE_EDITDOWN              ;
   PROMPT 'Edit next cell DOWN after ENTER key'

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL

oBrowse:cargo[14] := nBrowEdit

RETURN nil

/* ------------------------ */

STATIC FUNCTION XDoc_ArrayFile( nMode, aApp )

LOCAL GetList := {}, lOk, cFileName, aRecord

cFileName := Space(50)
IF nMode = 1
   @ 1,1 DCSAY 'This selection will save the current record to an array file' ;
         SAYSIZE 60
   @ 3,1 DCSAY "Array File Name" GET cFileName PICT '@!' SAYSIZE 15 SAYRIGHT
   DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk TITLE 'Export Record to Array File'
   IF lOk
      IF File(Alltrim(cFileName)) .AND. ;
        !DC_MsgBox(,,{'File ' + Alltrim(cFileName) + ' exists. Overwrite?'},,,,.t.)
        RETURN nil
      ENDIF
      aRecord := _VirtCapture(.t.)
      DC_ASave( aRecord, cFileName )
   ENDIF
ELSEIF nMode = 2
   @ 1,1 DCSAY 'This selection will overwrite the current record from an array file' ;
         SAYSIZE 60
   @ 3,1 DCSAY "Array File Name" GET cFileName PICT '@!' SAYSIZE 15 SAYRIGHT
   DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk TITLE 'Import from Array File'
   IF lOk
      IF !File(Alltrim(cFileName))
        DC_WinAlert('File ' + Alltrim(cFileName) + ' not found.')
        RETURN nil
      ENDIF
      aRecord := DC_ARestore( cFileName )
      _VirtReplace(aRecord)
      XDoc_LoadFields(aApp)
   ENDIF
ENDIF
RETURN nil

/* ---------------- */

STATIC FUNCTION _VirtCapture()

LOCAL aVirtual := {}, nCount, cFieldName

aVirtual := {{},{}}
ASIZE( aVirtual[1], FCOUNT() )
ASIZE( aVirtual[2], FCOUNT() )
FOR nCount := 1 TO FCOUNT()
  cFieldName := FIELDName(nCount)
  IF TYPE(cFieldName) = 'M'
    aVirtual[2,nCount] := STRTRAN(HARDCR(&cFieldName),CHR(13)+CHR(10),CHR(255))
  ELSE
    aVirtual[2,nCount] := &cFieldName
  ENDIF
  aVirtual[1,nCount] := cFieldName
NEXT
RETURN aVirtual

/* ---------------------- */

STATIC FUNCTION _VirtReplace ( aVirtual )

LOCAL nCount, cFieldName, cFieldType

IF VALTYPE(aVirtual) # 'A'
  RETURN .f.
ENDIF
dbRLock()
FOR nCount := 1 TO LEN(aVirtual[1])
  cFieldName := aVirtual[1,nCount]
  cFieldType := TYPE(cFieldName)
  IF cFieldType = 'M' .AND. !('Array String'$aVirtual[2,nCount])
    REPL &cFieldName WITH STRTRAN(aVirtual[2,nCount],CHR(255),CHR(13)+CHR(10))
  ELSEIF cFieldType $ 'CDLN'
    REPL &cFieldName WITH aVirtual[2,nCount]
  ENDIF
NEXT
dbRUnlock()
RETURN .t.


