/*
 ķ
   Program..: XMAIN.PRG                             
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-1998 
   Date.....: May 30, 1998                          
   Notes....: eXPress++ Demo main startup program   
 Ľ

 Must compile with /N/W

*/

#include 'common.ch'
#include 'std.ch'
#include 'inkey.ch'
#include 'set.ch'
#include "xbp.ch"

FUNCTION Main ( cParam1, cParam2 )

XDemo()

RETURN nil

/* ------------- */

PROCEDURE DbeSys()

_LoadDbes()

RETURN

* --------------

PROCEDURE AppSys()

  LOCAL oCrt, nAppType := AppType()

  DO CASE

    CASE .t.

    // PM Mode: create an XbpCrt instance
    CASE nAppType == APPTYPE_PM

      // First active SetAppWindow() == Desktop
      AppDesktop ( SetAppWindow() )

      // Create XbpCRT object
      oCrt := XbpCrt():New ( NIL, NIL, { 0, 0 }, 25, 80 )
      oCrt:FontWidth  := 8
      oCrt:FontHeight := 16
#ifdef __OS2__
      oCrt:FontName   := "System VIO"
#endif
#ifdef __WIN32__
      oCrt:FontName   := "Alaska Crt"
      oCrt:Title      := "eXPress++ 1.0 Alpha 1.00"
#endif
      oCrt:Create()

      // Init Presentation Space
      oCrt:PresSpace()

      // XbpCrt gets active window and output device
      SetAppWindow ( oCrt )

    // VIO or NOVIO Mode: create a RootCrt instance
    CASE nAppType == APPTYPE_VIO .OR. nAppType == APPTYPE_NOVIO

      // Create RootCrt object
      oCrt := RootCrt():New():Create()

      // RootCrt gets active window and output device
      SetAppWindow ( oCrt )

  ENDCASE

RETURN

* --------------------

STATIC FUNCTION _LoadDbes()

LOCAL i, aDbeList := DbeList(), cDbeList := ''


IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

  IF !('DBFDBE'$aDbeList) .AND. !DbeLoad( "DBFDBE",.T.)
     DC_WinAlert( "Database-Engine DBFDBE not loaded" )
  ENDIF
  IF !('NTXDBE'$aDbeList) .AND. !DbeLoad( "NTXDBE",.T.)
     DC_WinAlert( "Database-Engine NTXDBE not loaded"  )
  ENDIF
  IF !('DBFNTX'$aDbeList) .AND. !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
     DC_WinAlert( "DBFNTX Database-Engine, Could not build engine" )
  ENDIF
  IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
     DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  ENDIF
  IF !('DBFCDX'$aDbeList) .AND. !DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
     DC_WinAlert( "DBFCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
     DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  ENDIF
  IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
     DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('DELDBE'$aDbeList) .AND. !DbeLoad( "DELDBE",.T.)
     DC_WinAlert( "Database-Engine DELDBE not loaded" )
  ENDIF

RETURN .t.


