/*
 ķ
   Program..: XPFEDIT.PRG                                  
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 1987-2000        
   Date.....: Jan  1, 2000                                 
   Notes....: *.XPF (Memory) File Editor                   
 Ľ
*/


#INCLUDE "dcdialog.ch"
#INCLUDE "dcprint.ch"
#INCLUDE "appevent.ch"


FUNCTION Main( cXPFFile )

LOCAL GetList := {}, lOk

DEFAULT cXPFFile := ''

cXPFFile := Pad( cXPFFile, 100 )

IF Empty(cXPFFile)
  @ 0,0 DCSAY 'Memory File to Edit (*.XPF)'
  @ 1,0 DCGET cXPFFile POPUP {|c|DC_PopFile(c,,'*.XPF')} GETSIZE 50
  DCREAD GUI FIT ADDBUTTONS TO lOk ENTEREXIT TITLE 'Edit Memory (*.XPF) file'
  IF !lOk
    RETURN nil
  ENDIF
ENDIF

CLEAR MEMORY

RETURN DC_DispMemFile( cXPFFile )

* --------------

PROC AppSys()
RETURN

* --------------

FUNCTION DC_XPFtoArray( cXPFFile )

LOCAL nHandle, aMemVars := {}, cChar, cString, cVar, i, nPointer

nHandle := FOpen( cXPFFile )

DO WHILE nHandle > 0

  cChar := Space(1)
  IF Fread(nHandle,@cChar,1) = 0
    EXIT
  ENDIF

  IF Asc(cChar) = 3
    cString := Space(3)
    IF Fread(nHandle,@cString,3) = 0
      EXIT
    ELSE
      IF cString == Repl(Chr(0),3)
        nPointer := FSeek(nHandle,0,1)
        FSeek(nHandle,-3,1)
        cString := ''
        DO WHILE .t.
          cChar := Space(1)
          FSeek(nHandle,-2,1)
          IF Fread(nHandle,@cChar,1) = 0
            EXIT
          ELSEIF Asc(cChar) = 0
            IF _ValidMemVar(cString)
              AAdd( aMemVars, { cString, nil, nil, nil } )
            ENDIF
            EXIT
          ELSEIF Asc(cChar) < 32
            EXIT
          ELSE
            cString := cChar + cString
          ENDIF
        ENDDO
        FSeek(nHandle,nPointer,0)
      ENDIF
    ENDIF
  ENDIF

ENDDO

FClose(nHandle)

IF !Empty(aMemVars)
  FOR i := 1 TO Len(aMemVars)
    cVar := aMemVars[i,1]
    PRIVATE &cVar
  NEXT
  CLEAR MEMORY
  REST FROM (cXPFFile) ADDITIVE
  FOR i := 1 TO Len(aMemVars)
    cVar := aMemVars[i,1]
    IF Type(cVar) # 'U'
      aMemVars[i,2] := Valtype(&cVar)
      aMemVars[i,3] := &cVar
      aMemVars[i,4] := DC_XtoC(aMemVars[i,3])
    ENDIF
  NEXT
ENDIF

RETURN aMemVars

* ---------------

STATIC FUNCTION _ValidMemVar( cString )

LOCAL i, cChar

cString := Upper(cString)
IF !(SubStr(cString,1,1) $ '_ABCDEFGHIJKLMNOPQRSTUVWXYZ')
  RETURN .f.
ENDIF
FOR i := 1 TO Len(cString)
  cChar := SubStr(cString,i,1)
  IF !(cChar $ '_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789')
    RETURN .f.
  ENDIF
NEXT
RETURN .t.

* ---------------

FUNCTION DC_DispMem ( cMemFileName, cOutFileName, lAppend )

DEFAULT cMemFileName := ''

IF EMPTY(cMemFileName)
  cMemFileName := DC_SETDCLIP() + 'EXPRESS.XPF'
  SAVE TO (cMemFileName) ALL EXCEPT _d_c*
ENDIF
DC_DispMemFile( cMemFileName, cOutFileName, lAppend )

RETURN 0

* -----------------

FUNCTION DC_DispMemFile( cMemFileName, cOutFileName, lAppend )

LOCAL GetList := {}, oBrowse, aMemFile, i, bSortCol, nPointer := 1, GetOptions

DEFAULT cMemFileName := '', ;
        cOutFileName := '', ;
        lAppend := .t.

IF Empty(cMemFileName)
  RETURN .f.
ENDIF

cMemFileName := Alltrim(cMemFileName)

IF !('.'$cMemFileName)
  cMemFileName += '.XPF'
ENDIF

aMemFile := DC_XPFtoArray( cMemFileName )

ASort( aMemFile,,, { |a,b| a[1] < b[1] } )

bSortCol := {|a,n,o| _Sort(aMemFile,n) }

@ 0,0 DCSAY 'Right Click Column Header to Sort'

@ 1,0 DCBROWSE oBrowse DATA aMemFile SIZE 70,17 ;
      PRESENTATION DC_BrowPres() ;
      POINTER nPointer ;
      DELETE xbeK_DEL ;
      FIT ;
      NOSOFTTRACK ;
      FONT '10.Courier'

DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'Variable Name' WIDTH 10 ;
   SORT bSortCol

DCBROWSECOL ELEMENT 2 PARENT oBrowse HEADER 'Type' WIDTH 3 ;
   SORT bSortCol

DCBROWSECOL ELEMENT 4 PARENT oBrowse HEADER 'Contents' WIDTH 50 ;
   SORT bSortCol

@ 18.5,0 DCPUSHBUTTON CAPTION '~Print' SIZE 9,1.2 ;
       ACTION {||_PrintMem(1,aMemFile,cMemFileName)} ;
       ACCELKEY { xbeK_ALT_P, Asc('p'), Asc('P') } ;
       TOOLTIP 'Print Memory File Contents'

@ 18.5,10 DCPUSHBUTTON CAPTION '~File' SIZE 9,1.2 ;
       ACTION {||_PrintMem(2,aMemFile,cMemFileName)} ;
       ACCELKEY { xbeK_ALT_F, Asc('f'), Asc('F') } ;
       TOOLTIP 'Output Memory File Contents to a Text File'

@ 18.5,20 DCPUSHBUTTON CAPTION 'Edit' SIZE 9,1.2 ;
       ACTION {||_EditData(aMemFile,@nPointer,oBrowse,.f.)}

@ 18.5,30 DCPUSHBUTTON CAPTION 'Add' SIZE 9,1.2 ;
       ACTION {||_EditData(aMemFile,@nPointer,oBrowse,.t.)}

@ 18.5,40 DCPUSHBUTTON CAPTION 'Delete' SIZE 9,1.2 ;
       ACTION {||ADel(aMemFile,nPointer), ;
                 ASize(aMemFile,Len(aMemFile)-1), ;
                 oBrowse:refreshAll()}

@ 18.5,50 DCPUSHBUTTON CAPTION 'Save' SIZE 9,1.2 ;
       ACTION {||_SaveMemFile(aMemFile,cMemFileName)}

@ 18.5,60 DCPUSHBUTTON CAPTION 'E~xit' SIZE 9,1.2 ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
       ACCELKEY { xbeK_ALT_X, Asc('x'), Asc('X') }


DCGETOPTIONS AUTORESIZE

DCREAD GUI ;
   FIT ;
   MODAL ;
   TITLE 'Memory File: ' + Alltrim(cMemFileName) ;
   EVAL {||SetAppFocus(oBrowse:GetColumn(1))} ;
   OPTIONS GetOptions ;
   SETAPPWINDOW


RETURN .t.

* -----------

STATIC FUNCTION _EditData( aMemFile, nPointer, oBrowse, lAppend )

LOCAL GetList := {}, xValue, cVarName, cVarType, nDecimals, nLength, cValue, lOk

DEFAULT lAppend := .f.

IF nPointer > Len(aMemFile)
  nPointer := Len(aMemFile)
ENDIF

IF nPointer > 0
  cVarName := aMemFile[nPointer,1]
  cVarType := aMemFile[nPointer,2]
  xValue   := aMemFile[nPointer,3]
ELSE
  lAppend := .t.
ENDIF

IF lAppend
  cVarName := Space(160)
  cVarType := ' '
  @ 0,0 DCSAY 'New Variable Name' GET cVarName GETSIZE 30 SAYRIGHT ;
        VALID {||DC_ReadEmpty(cVarName)}
  @ 2,0 DCSAY '    Variable Type' GET cVarType VALID {||cVarType$'CDNL'} ;
        SAYRIGHT PICT '!'
  DCREAD GUI FIT ADDBUTTONS TO lOk ENTEREXIT TITLE 'Add New Variable' MODAL
  IF !lOk
     RETURN .f.
  ENDIF
  IF cVarType = 'D'
    xValue := Date()
  ELSEIF cVarType = 'N'
    xValue := 0
  ELSEIF cVarType = 'C'
    xValue := ''
  ELSEIF cVarType = 'L'
    xValue := .f.
  ENDIF
  cVarName := Alltrim(cVarName)
  AAdd(aMemFile, { cVarName, cVarType, xValue, DC_XtoC(xValue) })
  nPointer := Len(aMemFile)
ENDIF

IF Valtype(xValue) = 'O'
  DC_InspectObject(xValue)
ELSEIF Valtype(xValue) = 'A'
  DC_ArrayView(xValue)
ELSEIF Valtype(xValue) = 'N'
  cValue := Str(xValue)
  IF '.' $ cValue
    nDecimals := Len(cValue) - At('.',cValue)
  ELSE
    nDecimals := 0
  ENDIF
  @ 1,1 DCSAY cVarName GET xValue PICT '999999999999.999999999999' ;
        SAYSIZE 0 SAYFONT '12.Courier Bold'
  @ 3,1 DCSAY 'Decimals' GET nDecimals PICT '99' SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TO lOk ENTEREXIT TITLE 'Edit Character Value' MODAL
  IF lOk
    xValue := Val(Str(xValue,,nDecimals))
  ENDIF
ELSEIF Valtype(xValue) = 'D'
  @ 1,1 DCSAY cVarName GET xValue POPUP {|d|DC_PopDate(d,,,,cVarName)} ;
    SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TO lOk ENTEREXIT TITLE 'Edit Date Value' MODAL
ELSEIF Valtype(xValue) = 'C'
  nLength := Len(xValue)
  @ 1,1 DCSAY cVarName SAYSIZE 0 FONT '12.Courier Bold'
  @ 2,1 DCMULTILINE xValue SIZE 80,10 FONT '10.Courier'
  @ 13,1 DCSAY 'String Length (0=Trim)' GET nLength PICT '9999' SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TO lOk ENTEREXIT TITLE 'Edit Numeric Value' MODAL
  IF lOk
    IF nLength = 0
      xValue := Trim(xValue)
    ELSE
      xValue := Pad(xValue,nLength)
    ENDIF
  ENDIF
ELSEIF Valtype(xValue) = 'L'
  @ 1,1 DCCHECKBOX xValue PROMPT cVarName
  DCREAD GUI FIT ADDBUTTONS TITLE 'Edit Logical Value' MODAL
ENDIF

aMemFile[nPointer,3] := xValue
aMemFile[nPointer,4] := DC_XtoC(xValue)
oBrowse:refreshAll()
SetAppFocus(oBrowse:getColumn(1))

RETURN nil

* -----------

STATIC PROCEDURE _Sort ( aArray, nColumn )

ASort( aArray,,,{|x,y|DC_XtoC(x[nColumn]) < DC_XtoC(y[nColumn])} )

RETURN

* -----------

STATIC FUNCTION _PrintMem( nMode, aMemFile, cMemFileName )

LOCAL oPrinter, nRow := 1, i, nPage := 1

IF nMode = 1
  DCPRINT ON TO oPrinter FONT '8.Alaska Crt' PREVIEW HIDE ZOOMFACTOR 1.25 NOSTOP
ELSEIF nMode = 2
  DCPRINT ON TEXTONLY TO oPrinter
ENDIF

IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
  RETURN nil
ENDIF

FOR i := 1 TO Len(aMemFile)

  IF nRow = 1
    @ nRow,5 DCPRINT SAY 'Memory File: ' + cMemFileName + ;
             '   Page ' + Alltrim(Str(nPage,3))
    nRow += 2
    @ nRow,5 DCPRINT SAY 'Variable Name' PRINTER oPrinter
    @ nRow,25 DCPRINT SAY 'Type' PRINTER oPrinter
    @ nRow,30 DCPRINT SAY 'Contents' PRINTER oPrinter
    nRow++
    @ nRow,5 DCPRINT SAY '-------------' FIXED PRINTER oPrinter
    @ nRow,25 DCPRINT SAY '----' FIXED PRINTER oPrinter
    @ nRow,30 DCPRINT SAY '---------------------------------------------' ;
      FIXED PRINTER oPrinter
    nRow++
  ENDIF

  @ nRow,5  DCPRINT SAY DC_XtoC(aMemFile[i,1]) PRINTER oPrinter
  @ nRow,25 DCPRINT SAY DC_XtoC(aMemFile[i,2]) PRINTER oPrinter
  @ nRow,30 DCPRINT SAY DC_XtoC(aMemFile[i,3]) PRINTER oPrinter

  nRow++

  IF nRow > 55
    nRow := 1
    nPage++
    DCPRINT EJECT PRINTER oPrinter
  ENDIF

NEXT

DCPRINT OFF PRINTER oPrinter

RETURN nil

* ----------------

STATIC FUNCTION _SaveMemFile( aMemFile, cMemFileName )

LOCAL i, cVar

CLEAR MEMORY

IF !Empty(aMemFile)
  FOR i := 1 TO Len(aMemFile)
    cVar := aMemFile[i,1]
    PRIVATE &cVar
    &(cVar) := aMemFile[i,3]
  NEXT
  SAVE TO (cMemFileName) ALL EXCEPT oDeskTop
  DC_MsgBox(cMemFileName + ' has been Saved!')
  RETURN .t.
ENDIF

RETURN .f.


