/*
   Program..: DCDIALOG.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-2001
   Date.....: Aug 05, 2001
   Notes....: Special Dialog commands for eXPress++
*/

#include 'xbp.ch'
#include 'gra.ch'

#ifndef HKEY_LOCAL_MACHINE
  #include "dcreg.ch"
#endif

#ifndef  DCGUI_GETLIST
  #define DCGUI_GETLIST    GetList
#endif

#ifndef _DCDIALOG_CH

#ifndef MOUSE_ENTER
  #define   MOUSE_ENTER   97
#endif
/*
#define   FORCEVALID    OPTION 101
#define   PICKLIST      OPTION 102
#define   READPROTECT   OPTION 106
#define   CAPFIRST      OPTION 107
#define   DOUBLEPICK    OPTION 112
#define   HIDEIT        OPTION 113
#define   CODEBLOCK     OPTION 114
*/
#define   PICKPOINTER   116

* ------------------- *

#define   SAYRIGHT        SAYOPTION XBPSTATIC_TEXT_RIGHT
#define   SAYLEFT         SAYOPTION XBPSTATIC_TEXT_LEFT
#define   SAYRIGHTBOTTOM  SAYOPTION XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_BOTTOM
#define   SAYLEFTBOTTOM   SAYOPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_BOTTOM
#define   SAYCENTERBOTTOM SAYOPTION XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_BOTTOM
#define   SAYRIGHTCENTER  SAYOPTION XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_VCENTER
#define   SAYLEFTCENTER   SAYOPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER
#define   SAYRIGHTTOP     SAYOPTION XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_TOP
#define   SAYLEFTTOP      SAYOPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_TOP
#define   SAYCENTER       SAYOPTION XBPSTATIC_TEXT_CENTER
#define   SAYHCENTER      SAYOPTION XBPSTATIC_TEXT_CENTER
#define   SAYBOTTOM       SAYOPTION XBPSTATIC_TEXT_BOTTOM
#define   SAYTOP          SAYOPTION XBPSTATIC_TEXT_TOP
#define   SAYVCENTER      SAYOPTION XBPSTATIC_TEXT_VCENTER
#define   SAYHVCENTER     SAYOPTION XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER
#define   SAYWORDBREAK    SAYOPTION XBPSTATIC_TEXT_WORDBREAK

#define   sayright        SAYRIGHT
#define   sayleft         SAYLEFT
#define   sayrightbottom  SAYRIGHTBOTTOM
#define   sayleftbottom   SAYLEFTBOTTOM
#define   saycenterbottom SAYCENTERBOTTOM
#define   sayrightcenter  SAYRIGHTCENTER
#define   sayleftcenter   SAYLEFTCENTER
#define   sayrighttop     SAYRIGHTTOP
#define   saylefttop      SAYLEFTTOP
#define   saycenter       SAYCENTER
#define   sayhcenter      SAYHCENTER
#define   saybottom       SAYBOTTOM
#define   saytop          SAYTOP
#define   sayvcenter      SAYVCENTER
#define   sayhvcenter     SAYHVCENTER

#define   TOOLBAR_TOP                1
#define   TOOLBAR_LEFT               2
#define   TOOLBAR_BOTTOM             3
#define   TOOLBAR_RIGHT              4
#define   TOOLBAR_TOP_LEFT           1
#define   TOOLBAR_LEFT_TOP           2
#define   TOOLBAR_BOTTOM_LEFT        3
#define   TOOLBAR_RIGHT_TOP          4
#define   TOOLBAR_TOP_RIGHT          5
#define   TOOLBAR_BOTTOM_RIGHT       6
#define   TOOLBAR_LEFT_BOTTOM        7
#define   TOOLBAR_RIGHT_BOTTOM       8

#define   DCGUI_ALIGN_TOP            1
#define   DCGUI_ALIGN_LEFT           2
#define   DCGUI_ALIGN_BOTTOM         3
#define   DCGUI_ALIGN_RIGHT          4

#define   BROWSE_ARRAY               1
#define   BROWSE_DATABASE            2
#define   BROWSE_SQLEXPRESS          3

#define   MESSAGEBOX_TOP             1
#define   MESSAGEBOX_BOTTOM          2

#define   DCGUI_DRAG_ENTIRE_OBJECT   1    // POINTER_ARROW_L
#define   DCGUI_DRAG_RIGHT_TOP       2    // POINTER_SIZE1_1
#define   DCGUI_DRAG_LEFT_BOTTOM     3    // POINTER_SIZE1_1
#define   DCGUI_DRAG_LEFT_TOP        4    // POINTER_SIZE2_1
#define   DCGUI_DRAG_RIGHT_BOTTOM    5    // POINTER_SIZE2_1
#define   DCGUI_DRAG_LEFT            6    // POINTER_SIZE3_1
#define   DCGUI_DRAG_RIGHT           7    // POINTER_SIZE3_1
#define   DCGUI_DRAG_TOP             8    // POINTER_SIZE4_1
#define   DCGUI_DRAG_BOTTOM          9    // POINTER_SIZE4_1

#define   DCGUI_REGION_OCTAGON       1
#define   DCGUI_REGION_DIAMOND       2
#define   DCGUI_REGION_ELLIPSE       3

#define   DCGUI_NONE            1    // Handle Default Event
#define   DCGUI_IGNORE          2    // Ignore Event
#define   DCGUI_CLEAR           3    // Ignore Event and Clear Queue
#define   DCGUI_EXIT            4    // Exit GUI Reader
#define   DCGUI_EXIT_ABORT      5    // Exit GUI Reader WITH .FALSE. and ;
                                     // restore all memvars
#define   DCGUI_EXIT_OK         6    // Exit GUI Reader WITH .TRUE.
#define   DCGUI_MOVE_UP         7    // Set Focus to previous item in GetList
#define   DCGUI_MOVE_DOWN       8    // Set Focus to next item in Getlist
#define   DCGUI_MOVE_TOP        9    // Set Focus to first item in Getlist
#define   DCGUI_MOVE_BOTTOM     10   // Set Focus to last item in GetList
#define   DCGUI_MOVE_UP_PAR     11   // Set Focus to previous item in Parent
#define   DCGUI_MOVE_DOWN_PAR   12   // Set Focus to next item in Parent
#define   DCGUI_MOVE_TOP_PAR    13   // Set Focus to first item in Parent
#define   DCGUI_MOVE_BOTTOM_PAR 14   // Set Focus to last item in Parent
#define   DCGUI_NOHOTKEY        15   // Don't activate any hotkey associated with current event

#define   DCGUI_TAB_SELECT_NEXT     1    // Select Next Tab Page
#define   DCGUI_TAB_SELECT_PREVIOUS 2    // Select Previous Tab Page
#define   DCGUI_TAB_SELECT_FIRST    3    // Select First Tab Page
#define   DCGUI_TAB_SELECT_LAST     4    // Select Last Tab Page

#define   DCGUI_DEBUG_CREATE        1    // Turn on debugging during creation
#define   DCGUI_DEBUG_EVENTS        2    // Turn on Event Spy debugging in Event Loop
#define   DCGUI_DEBUG_VALIDATE      4    // Turn on debugging when validating

#define   DCGUI_HELP_REQUEST        1    // Array element of :helpLink that holds F1 Help Request Object
#define   DCGUI_HELP_TOOLTIP        2    // Array element of :helpLink that holds Tooltip Object

#define   DCGUI_ROW                 -10000
#define   DCGUI_COL                 -10000

#define   DCGETREFRESH_ID_INCLUDE   1    // Only refresh included IDs
#define   DCGETREFRESH_ID_EXCLUDE   2    // Only refresh excluded IDs
#define   DCGETREFRESH_TYPE_INCLUDE 3    // Only refresh included Types
#define   DCGETREFRESH_TYPE_EXCLUDE 4    // Only refresh excluded Types

#define   DCGUI_BROWSE_EDITEXIT     0    // Exit cell editing after ENTER

#define   DCGUI_BROWSE_EDITACROSS   1    // Move across columns during browse edit after ENTER

#define   DCGUI_BROWSE_EDITDOWN     2    // Move down columns during browse edit after ENTER

#define   DCGUI_BROWSE_INSERT       3    // Insert a new array element or record in browse

#define   DCGUI_BROWSE_DELETE       4    // Delete array element or record in browse

#define   DCGUI_BROWSE_EDITACROSSDOWN  ;
                                    5    // Move across and then down

#define   DCGUI_BROWSE_APPEND       6    // Add a new array element or record in browse

#define   DCGUI_BROWSE_EDITACROSSDOWN_APPEND  ;
                                    7    // Move across and then down.  Append new element or record
                                         // if hit bottom.

#define   DCGUI_BROWSE_SUBMODE_1    1    // Don't allow movement to move to new row
#define   DCGUI_BROWSE_SUBMODE_2    2    // Allow movement to new row

#define   DCGUI_BUTTON_OK           1    // Add OK Button
#define   DCGUI_BUTTON_CANCEL       2    // Add CANCEL Button
#define   DCGUI_BUTTON_EXIT         4    // Add EXIT Button
#define   DCGUI_BUTTON_HELP         8    // Add HELP Button
#define   DCGUI_BUTTON_CUSTOM    1024    // Add CUSTOM Button

#define   DCGUI_BUTTONALIGN_LEFT    0    // Align Buttons Left
#define   DCGUI_BUTTONALIGN_CENTER  1    // Align Buttons Center
#define   DCGUI_BUTTONALIGN_RIGHT   2    // Align Buttons Right

#define   DCGUI_POPUPSTYLE_OUTSIDE  0    // Popup Button is outside of GET
#define   DCGUI_POPUPSTYLE_IMBEDDED 1    // Popup Button is imbedded in GET

// Events  ( 2000 - 2999 reserved by eXPress++ )

#define   DCGUI_EVENT_BROWSE_REFRESH  xbeP_User + 2000

#define   DCGUI_WINMENU_DESTROYMODE_EXIT   0
#define   DCGUI_WINMENU_DESTROYMODE_CLOSE  1


* ------------------- *

#define GETLIST_STATIC           1
#define GETLIST_GET              2
#define GETLIST_MLE              3
#define GETLIST_3STATE           4
#define GETLIST_CHECKBOX         5
#define GETLIST_COMBOBOX         6
#define GETLIST_LISTBOX          7
#define GETLIST_PUSHBUTTON      10
#define GETLIST_RADIOBUTTON     11
#define GETLIST_SAY             12
#define GETLIST_SAY_OPT         12.1
#define GETLIST_ADDBUTTON       13
#define GETLIST_SPINBUTTON      14

#define GETLIST_GROUPBOX        19
#define GETLIST_TABPAGE         20
#define GETLIST_SCROLLBAR       21
#define GETLIST_BITMAP          22
#define GETLIST_METAFILE        23
#define GETLIST_TOOLBAR         24
#define GETLIST_TOOLBAR_OPT     24.1
#define GETLIST_MENUBAR         25
#define GETLIST_SUBMENU         26
#define GETLIST_MENUITEM        27
#define GETLIST_BROWSE          28
#define GETLIST_BROWSECOL       29

#define GETLIST_MESSAGEBOX      30
#define GETLIST_MESSAGEBOX_OPT  30.1
#define GETLIST_CUSTOM          31
#define GETLIST_APPCRT          32
#define GETLIST_PICKLIST        33
#define GETLIST_PROGRESS        34
#define GETLIST_STATUSBAR       35
#define GETLIST_HOTKEY          36
#define GETLIST_QUICKBROWSE     37

#define GETLIST_APPEDIT         40
#define GETLIST_APPBROWSE       41
#define GETLIST_APPFIELD        42

#define GETLIST_DIRTREE         50

#define GETLIST_TREEARRAY       60
#define GETLIST_DIALOG          61
#define GETLIST_TREEROOT        62
#define GETLIST_TREEITEM        63

#define GETLIST_GRASTRING       70
#define GETLIST_GRALINE         71
#define GETLIST_GRABOX          72
#define GETLIST_GRAPROC         73

#define GETLIST_OBJECT          80

#define GETLIST_SETGROUP        97
#define GETLIST_SETPARENT       98
#define GETLIST_DATASTORE       99
#define GETLIST_CLICK           100

* -- 200 thru 499 are reserved for third party support -- *
#define GETLIST_3P_START        200
#define GETLIST_KLMLE           200

#define GETLIST_3P_END          499

#define GETLIST_USER            1000

#define nGETLIST_TYPE            1
#define nGETLIST_SUBTYPE         2
#define cGETLIST_CAPTION         3
#define bGETLIST_VAR             4
#define nGETLIST_STARTROW        5
#define nGETLIST_STARTCOL        6
#define nGETLIST_ENDROW          7
#define nGETLIST_ENDCOL          8
#define nGETLIST_WIDTH           9
#define nGETLIST_HEIGHT         10
#define cGETLIST_FONT           11
#define cGETLIST_PICTURE        12
#define bGETLIST_WHEN           13
#define bGETLIST_VALID          14
#define cGETLIST_TOOLTIP        15
#define xGETLIST_CARGO          16
#define aGETLIST_PRESENTATION   17
#define bGETLIST_ACTION         18
#define oGETLIST_OBJECT         19
#define xGETLIST_ORIGVALUE      20
#define xGETLIST_OPTIONS        21
#define aGETLIST_COLOR          22
#define cGETLIST_MESSAGE        23
#define cGETLIST_HELPCODE       24
#define cGETLIST_VARNAME        25
#define bGETLIST_READVAR        26
#define bGETLIST_DELIMVAR       27
#define bGETLIST_GROUP          28
#define nGETLIST_POINTER        29
#define bGETLIST_PARENT         30
#define bGETLIST_REFVAR         31
#define bGETLIST_PROTECT        32
#define lGETLIST_PIXEL          33
#define nGETLIST_CURSOR         34
#define bGETLIST_EVAL           35
#define bGETLIST_RELATIVE       36
#define xGETLIST_OPTIONS2       37
#define xGETLIST_OPTIONS3       38
#define xGETLIST_OPTIONS4       39
#define xGETLIST_OPTIONS5       40
#define xGETLIST_OPTIONS6       41
#define xGETLIST_OPTIONS7       42
#define xGETLIST_OPTIONS8       43
#define xGETLIST_OPTIONS9       44
#define cGETLIST_LEVEL          45
#define cGETLIST_TITLE          46
#define cGETLIST_ACCESS         47
#define bGETLIST_COMPILE        48
#define cGETLIST_ID             49
#define dGETLIST_REVDATE        50
#define cGETLIST_REVTIME        51
#define cGETLIST_REVUSER        52
#define bGETLIST_HIDE           53
#define nGETLIST_ACCELKEY       54
#define bGETLIST_GOTFOCUS       55
#define bGETLIST_LOSTFOCUS      56
#define lGETLIST_TABSTOP        57
#define nGETLIST_TABGROUP       58
#define lGETLIST_VISIBLE        59
#define cGETLIST_GETGROUP       60
#define lGETLIST_FLAG           61
#define aGETLIST_PROC           62
#define bGETLIST_PREEVAL        63

#define nGET_ARRAY_SIZE         63

#define cGETOPT_NAME            1
#define cGETOPT_TITLE           2
#define nGETOPT_WNDHEIGHT       3
#define nGETOPT_WNDWIDTH        4
#define nGETOPT_ROWSPACE        5
#define nGETOPT_SAYWIDTH        6
#define cGETOPT_SAYFONT         7
#define cGETOPT_GETFONT         8
#define nGETOPT_GETHEIGHT       9
#define aGETOPT_BUTTONS        10
#define nGETOPT_WNDROW         11
#define nGETOPT_WNDCOL         12
#define nGETOPT_ROWOFFSET      13
#define nGETOPT_COLOFFSET      14
#define lGETOPT_DESIGN         15
#define cGETOPT_MENU           16
#define lGETOPT_PIXEL          17
#define xGETOPT_SPARE          18
#define nGETOPT_ICON           19
#define lGETOPT_CHECKGET       20
#define cGETOPT_HELPFILE       21
#define lGETOPT_VISIBLE        22
#define lGETOPT_TRANSLATE      23
#define lGETOPT_SAYRIGHT       24
#define nGETOPT_BITMAP         25
#define aGETOPT_PRESENT        26
#define nGETOPT_BGCOLOR        27
#define nGETOPT_SAYOPT         28
#define bGETOPT_EVAL           29
#define nGETOPT_MODALSTATE     30
#define nGETOPT_SAYHEIGHT      31
#define lGETOPT_MINBUTTON      32
#define lGETOPT_MAXBUTTON      33
#define lGETOPT_TABSTOP        34
#define lGETOPT_ABORTQUERY     35
#define nGETOPT_ROWPIXELS      36
#define nGETOPT_COLPIXELS      37
#define lGETOPT_ESCAPEKEY      38
#define cGETOPT_SOURCECODE     39
#define aGETOPT_TOOLCOLOR      40
#define nGETOPT_BORDER         41
#define lGETOPT_EXVALID        42
#define lGETOPT_CLOSEQUERY     43
#define lGETOPT_NOTASKLIST     44
#define aGETOPT_MINSIZE        45
#define aGETOPT_MAXSIZE        46
#define lGETOPT_NORESIZE       47
#define lGETOPT_NOTITLEBAR     48
#define lGETOPT_NOMOVE         49
#define nGETOPT_ORIGIN         50
#define nGETOPT_HILITECOLOR    51
#define lGETOPT_SUPERVISE      52
#define lGETOPT_HIDEDIALOG     53
#define lGETOPT_NOBUSY         54
#define cGETOPT_BUSYMSG        55
#define nGETOPT_DESIGNKEY      56
#define lGETOPT_CASCADE        57
#define lGETOPT_AUTORESIZE     58
#define aGETOPT_COLORGETS      59
#define lGETOPT_CONFIRM        60
#define nGETOPT_FITPAD         61
#define nGETOPT_BUTTONALIGN    62
#define lGETOPT_EXITQUERY      63
#define nGETOPT_DISABLEDCOLOR  64
#define lGETOPT_ENTERTAB       65
#define bGETOPT_PREEVAL        66
#define cGETOPT_FONT           67
#define bGETOPT_EDITPROTECT    68
#define oGETOPT_MESSAGEINTO    69
#define bGETOPT_NOEDITNAVKEYS  70
#define aGETOPT_BUTTONSOUND    71
#define lGETOPT_MESSAGECLEAR   72
#define cGETOPT_HELPCODE       73
#define lGETOPT_AUTOWINMENU    74
#define cGETOPT_KEYBOARD       75
#define lGETOPT_NOWINMENU      76

#define nGETOPT_ARRAY_SIZE     76

* ------------------------------- *

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
     <uVar1> := IIF(Valtype(<uVar1>)==Valtype(<uVal1>).OR.<uVal1>==NIL,<uVar1>,<uVal1>) ;;
   [ <uVarN> := IIF(Valtype(<uVarN>)==Valtype(<uValN>).OR.<uValN>==NIL,<uVarN>,<uValN>); ]


* ------------------------------- *

#xcommand LOGICDEFAULT <uVar> := <uVal>  => ;
          <uVar> := IIF(Valtype(<uVar>)=='L',<uVar>, ;
                    IIF(Valtype(<uVal>)=='L',<uVal>,.f.))

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCDIALOG <oObject>                             ;
                [DRAWINGAREA <oDrawingArea>]                                ;
                [FONT <cFont>]                                              ;
                [<c:CAPTION,TITLE> <cTitle>]                                ;
                [BITMAP <nBitMap>]                                          ;
                [ICON <nIcon>]                                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [PARENT <oParent>]                                          ;
                [PARENTID <cPID>]                                           ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [PRESENTATION <aPres>]                                      ;
                [CARGO <xCargo>]                                            ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [<lModal:MODAL>] [_MODAL <_modal>]                          ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [<lNoMin:NOMINBUTTON,NOMINIMIZE>] [_NOMINBUTTON <_nomin>]   ;
                [<lNoMax:NOMAXBUTTON,NOMAXIMIZE>] [_NOMAXBUTTON <_nomax>]   ;
                [GROUP <cGroup>]                                            ;
                [BORDER <nBorder>]                                          ;
                [<lNoTitleBar:NOTITLEBAR>] [_NOTITLEBAR <_notitlebar>]      ;
                [<lNoReSize:NORESIZE>] [_NORESIZE <_noresize>]              ;
                [<lNoTaskList:NOTASKLIST>] [_NOTASKLIST <_notasklist>]      ;
                [MINSIZE <nMinCol>, <nMinRow>]                              ;
                [MAXSIZE <nMaxCol>, <nMaxRow>]                              ;
                [MENU <acMenu> [MSGBOX <oMsgBox>]]                          ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lAutoResize:AUTORESIZE>] [_AUTORESIZE <_autoresize>]      ;
                [<lFit:FIT> [_FIT <_fit>] [FITPAD <nFitPad>]]               ;
                [<lSetAppWindow:SETAPPWINDOW>]                              ;
                [_SETAPPWINDOW <_setappwindow>]                             ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_DIALOG,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cTitle>,                                 /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nIcon>,<nBitMap>,!<.lNoMin.> [.AND. !<_nomin>],                    ;
        !<.lNoMax.> [.AND. !<_nomax>],                                      ;
        <.lModal.> [.OR. <_modal>],<nBorder>,                               ;
        !<.lNoTitleBar.> [.AND. !<_notitlebar>],                            ;
        <.lNoReSize.> [.OR. <_noresize>],                                   ;
        [{<nMinCol>, <nMinRow>}],[{<nMaxCol>, <nMaxRow>}],                  ;
        <.lNoTaskList.> [.OR. <_notasklist>],<.lFit.> [.OR. <_fit>],        ;
        <nFitPad>,                                                          ;
        <.lSetAppWindow.> [.OR. <_setappwindow>] },                         ;
                                                /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [DC_GetAnchorCB(@<oObject>,'O')],         /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),<(oParent)>,'O'}][<cPID>],           ;
                                                /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<oDrawingArea>,'O'),<(oDrawingArea)>,'O'}],         ;
                                                /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),<(oRel)>,'O'}],                         ;
                                                /* bGETLIST_RELATIVE     */ ;
      [{<acMenu>,<oMsgBox>}],                   /* xGETLIST_OPTIONS2     */ ;
      <.lAutoResize.>,                          /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------ *

#command   @ <nRow> [,<nCol>] DCSAY [<cText>]                               ;
                [SAYVAR <uSayVar>]                                          ;
                [<font:FONT,SAYFONT> <cFont>]                               ;
                [PICTURE <cPict>]                                           ;
                [<color:COLOR,SAYCOLOR> <ncFgC> [,<ncBgC>] ]                ;
                [PARENT <oParent>]                                          ;
                [PARENTID <cPID>]                                           ;
                [<option:OPTIONS,SAYOPTIONS> <nOpt>]                        ;
                [<size:SIZE,SAYSIZE> <nWidth> [,<nHeight>]]                 ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [PRESENTATION <aPres>]                                      ;
                [<tool:TOOLTIP,SAYTOOLTIP> <cToolTip>]                      ;
                [<object:OBJECT,SAYOBJECT> <oObject>]                       ;
                [CARGO <xCargo>]                                            ;
                [CURSOR <nCursor>]                                          ;
                [<eval:EVAL,SAYEVAL> <bEval>]                               ;
                [<peval:PREEVAL,SAYPREEVAL> <bPreEval>]                     ;
                [RELATIVE <oRel>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TITLE <cTitle>]                                            ;
                [<id:ID,SAYID> <cId>]                                       ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [_INVISIBLE <_invis>]              ;
                [GROUP <cGroup>]                                            ;
                [<lGraString:GRASTRING>] [_GRASTRING <_grastring>]          ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SAY,                              /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_TEXT,                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uSayVar>,'C'),                                     ;
                       <(uSayVar)>,'C'}],       /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      [<cFont>],                                /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      [<cToolTip>],                             /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nOpt>},                                 /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),<(oParent)>,'O'}] [<cPID>],          ;
                                                /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                         <oRel>,'O'}],          /* bGETLIST_RELATIVE     */ ;
      <.lGraString.> [.OR. <_grastring>],       /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#command  @ <nSayRow> [,<nSayCol>] DCSAY [<cText>]                          ;
                GET <uVar>                                                  ;
                [GETPOS <nGetRow> [,<nGetCol>] ]                            ;
                [DATALINK <bLink>]                                          ;
                [SAYVAR <uSayVar>]                                          ;
                [<color:COLOR,SAYCOLOR> <ncSayFgC> [,<ncSayBgC>] ]          ;
                [GETCOLOR <ncGetFgC> [,<ncGetBgC>] ]                        ;
                [OPTION <option>]                                           ;
                [<lGraString:GRASTRING>] [_GRASTRING <_grastring>]          ;
                [SAYSIZE <nSayWidth> [,<nSayHeight>]]                       ;
                [GETSIZE <nGetWidth> [,<nGetHeight>]]                       ;
                [PARENT <oParent>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [VALID <bValid>]                                            ;
                [SAYOPTION <nSayOpt>]                                       ;
                [HELPCODE <cHelpCode>]                                      ;
                [PREBLOCK <preblock>]                                       ;
                [POSTBLOCK <postblock>]                                     ;
                [<kb:KEYBLOCK,KEYBOARD> <keyblock>]                         ;
                [PICTURE <cPict>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [<u: UNREADABLE>] [_UNREADABLE <_unreadable>]               ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [<noconfirm: NOCONFIRM>] [_NOCONFIRM <_noconfirm>]          ;
                [<confirm: CONFIRM>] [_CONFIRM <_confirm>]                  ;
                [SAYPRESENTATION <aSayPres>]                                ;
                [GETPRESENTATION <aGetPres>]                                ;
                [TOOLTIP <cToolTip>]                                        ;
                [SAYTOOLTIP <cSayToolTip>]                                  ;
                [GETTOOLTIP <cGetToolTip>]                                  ;
                [SAYOBJECT <oSayObject>]                                    ;
                [GETOBJECT <oGetObject>]                                    ;
                [SAYCURSOR <nSayCursor>]                                    ;
                [GETCURSOR <nGetCursor>]                                    ;
                [SAYCARGO <xSayCargo>]                                      ;
                [GETCARGO <xGetCargo>]                                      ;
                [SAYEVAL <bSayEval>]                                        ;
                [SAYPREEVAL <bSayPreEval>]                                  ;
                [GETEVAL <bGetEval>]                                        ;
                [GETPREEVAL <bGetPreEval>]                                  ;
                [SAYTITLE <cSayTitle>]                                      ;
                [GETTITLE <cGetTitle>]                                      ;
                [SAYFONT <cSayFont>]                                        ;
                [GETFONT <cGetFont>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [SAYID <cSayId>]                                            ;
                [GETID <cGetId>]                                            ;
                [POPUP <bPopUp> [<lPopTab:POPTABSTOP>]                      ;
                   [<d:DROPDOWN>] [POPCAPTION <c>] [POPFONT <f>]            ;
                   [POPWIDTH <w>] [POPHEIGHT <h>]                           ;
                   [POPSTYLE <s>] [POPKEY <k>] [<g:POPGLOBAL>] ]            ;
                   [POPTOOLTIP <t>]                                         ;
                [<pv:POPVALID>]                                             ;
                [COMBO [HEIGHT <nComboHeight>] [WIDTH <nComboWidth>]        ;
                    [DATA <acbComboData>]                                   ;
                    [<nf:FIELD,ELEMENT> <nbField>] [RETURN <bReturn>] ]     ;
                [ACCELKEY <nAccel>]                                         ;
                [REFERENCE <xRef>]                                          ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<pass:PASSWORD>] [_PASSWORD <_password>]                   ;
                [<proper:PROPER> [PROPOPTIONS <aProperOptions>]]            ;
                [_PROPER <_proper>]                                         ;
                [<ljust:LEFTJUSTIFY>] [_LEFTJUSTIFY <_leftjustify>]         ;
                [RANGE <nStart>, <nEnd>]                                    ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [_INVISIBLE <_invis>]              ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SAY,                              /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_TEXT,                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uSayVar>,'C'),                                     ;
                       <(uSayVar)>,'C'}],       /* bGETLIST_VAR          */ ;
      <nSayRow>,                                /* nGETLIST_STARTROW     */ ;
      <nSayCol>,                                /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nSayWidth>,                              /* nGETLIST_WIDTH        */ ;
      <nSayHeight>,                             /* nGETLIST_HEIGHT       */ ;
      <cSayFont>,                               /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      [<cToolTip>][<cSayToolTip>],              /* cGETLIST_TOOLTIP      */ ;
      <xSayCargo>,                              /* xGETLIST_CARGO        */ ;
      <aSayPres>,                               /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nSayOpt>},                              /* xGETLIST_OPTIONS      */ ;
      [{<ncSayFgC>,<ncSayBgC>}],                /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oSayObject>,'O'),                                  ;
                        <(oSayObject)>,'O'}],   /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                         <(oParent)>,'O'}],     /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nSayCursor>,                             /* nGETLIST_CURSOR       */ ;
      <bSayEval>,                               /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      <.lGraString.> [.OR. <_grastring>],       /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cSayTitle>,                              /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cSayId>,                                 /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bSayPreEval>,                            /* bGETLIST_PREEVAL      */ ;
      } )  ;
   ; AADD( DCGUI_GETLIST,                                                   ;
    { GETLIST_GET,                              /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      {DC_GetAnchorCB(@<uVar>,,<uVar>,<cPict>,<bLink>),                     ;
                <(uVar)>,,,<cPict>,<(bLink)>},  /* bGETLIST_VAR          */ ;
      [<nGetRow>],                              /* nGETLIST_STARTROW     */ ;
      [<nGetCol>],                              /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nGetWidth>,                              /* nGETLIST_WIDTH        */ ;
      <nGetHeight>,                             /* nGETLIST_HEIGHT       */ ;
      <cGetFont>,                               /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      [<cToolTip>][<cGetToolTip>],              /* cGETLIST_TOOLTIP      */ ;
      <xGetCargo>,                              /* xGETLIST_CARGO        */ ;
      <aGetPres>,                               /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncGetFgC>,<ncGetBgC>}],                /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      [{<(uVar)>,<(bLink)>}],                   /* cGETLIST_VARNAME      */ ;
      [{DC_GetAnchorCB(@<xRef>,,<xRef>),                                    ;
                               <(xRef)>}],      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oGetObject>,'O'),                                  ;
                        <(oGetObject)>,'O'}],   /* bGETLIST_GROUP        */ ;
      LEN(DCGUI_GETLIST),                       /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>),                                    ;
                               <(uVar)>}],      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nGetCursor>,                             /* nGETLIST_CURSOR       */ ;
      <bGetEval>,                               /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      {<bPopUp>,nil,<.lPopTab.>,<.d.>,<.pv.>,<c>,<f>,<w>,<h>,<s>,<k>,       ;
                <.g.>,<t>},                                                 ;
                                                /* xGETLIST_OPTIONS2     */ ;
      <.u.>,                                    /* xGETLIST_OPTIONS3     */ ;
      [<.noconfirm.>][!<.confirm.>],            /* xGETLIST_OPTIONS4     */ ;
      <.pass.> [.OR. <_password>],              /* xGETLIST_OPTIONS5     */ ;
      {<.proper.> [.OR. <_proper>],<aProperOptions>},                       ;
                                                /* xGETLIST_OPTIONS6     */ ;
      <.ljust.> [.OR. <_leftjustify>],          /* xGETLIST_OPTIONS7     */ ;
      [{<nStart>,<nEnd>}],                      /* xGETLIST_OPTIONS8     */ ;
      [<keyblock>],                             /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cGetTitle>,                              /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cGetId>,                                 /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
                                                /* lGETLIST_VISIBLE      */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bGetPreEval>,                            /* bGETLIST_PREEVAL      */ ;
   } )                                                                      ;
      [; DC_GetAddOption(DCGUI_GETLIST,<option>) ]                          ;
      [; DC_GetAddOption(DCGUI_GETLIST,                                     ;
          { 120, <nComboHeight>, <acbComboData>, <nbField>, <bReturn>,      ;
                 <nComboWidth> } ) ]                                        ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 103, <preblock> } ) ]              ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 104, <postblock> } ) ]             ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 105, <cMsg> }) ]                   ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 115, <cHelpCode> }) ]

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCGET [<uVar>]                                 ;
                [DATALINK <bLink> ]                                         ;
                [<color:COLOR,GETCOLOR> <ncFgC> [,<ncBgC>] ]                ;
                [<size:SIZE,GETSIZE> <nWidth> [,<nHeight>] ]                ;
                [<font:FONT,GETFONT> <cFont>]                               ;
                [COMBO [HEIGHT <nComboHeight>] [WIDTH <nComboWidth>]        ;
                    [DATA <acbComboData>]                                   ;
                    [<nf:FIELD,ELEMENT> <nbField>] [RETURN <bReturn>] ]     ;
                [PARENT <oParent>]                                          ;
                [OPTION <option>]                                           ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [VALID <bValid>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
                [PREBLOCK <preblock>]                                       ;
                [POSTBLOCK <postblock>]                                     ;
                [<kb:KEYBLOCK,KEYBOARD> <keyblock>]                         ;
                [PICTURE <cPict>]                                           ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [<pp:EDITPROTECT,PROTECT> <bProtect>]                       ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [<u: UNREADABLE>] [_UNREADABLE <_unreadable>]               ;
                [<noconfirm: NOCONFIRM>]                                    ;
                [<confirm: CONFIRM>]                                        ;
                [<pres:PRESENTATION,GETPRESENTATION> <aPres>]               ;
                [<tool:TOOLTIP,GETTOOLTIP> <cToolTip>]                      ;
                [<obj:OBJECT,GETOBJECT> <oObject>]                          ;
                [<cur:CURSOR,GETCURSOR> <nCursor>]                          ;
                [CARGO <xCargo>]                                            ;
                [<eval:EVAL,GETEVAL> <bEval>]                               ;
                [<peval:PREEVAL,GETPREEVAL> <bPreEval>]                     ;
                [POPUP <bPopUp> [<lPopTab:POPTABSTOP>]                      ;
                   [<d:DROPDOWN>] [REFERENCE <xRef>]                        ;
                   [POPCAPTION <c>] [POPFONT <f>]                           ;
                   [POPWIDTH <w>] [POPHEIGHT <h>]                           ;
                   [POPSTYLE <s>] [POPKEY <k>] [<g:POPGLOBAL>] ]            ;
                   [POPTOOLTIP <t>]                                         ;
                [<pv:POPVALID>]                                             ;
                [RELATIVE <oRel>]                                           ;
                [TITLE <cTitle>]                                            ;
                [<id:ID,GETID> <cId>]                                       ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<pass:PASSWORD>] [_PASSWORD <_password>]                   ;
                [<proper:PROPER> [PROPOPTIONS <aProperOptions>]]            ;
                [_PROPER <_proper>]                                         ;
                [<ljust:LEFTJUSTIFY>] [_LEFTJUSTIFY <_leftjustify>]         ;
                [RANGE <nStart>, <nEnd>]                                    ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [<lCellEditor:CELLEDITOR>] [_CELLEDITOR <_celleditor>]      ;
  =>                                                                        ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_GET,                              /* nGETLIST_TYPE         */ ;
      IIF(<.lCellEditor.>,1,0),                 /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>,<cPict>,<bLink>),                    ;
                <(uVar)>,,,<cPict>,<(bLink)>}], /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      [<cFont>],                                /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      [<cToolTip>],                             /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      [{<(uVar)>,<(bLink)>}],                   /* cGETLIST_VARNAME      */ ;
      [{DC_GetAnchorCB(@<xRef>,,<xRef>),                                    ;
                               <(xRef)>}],      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>),                                    ;
                              <(uVar)>}],       /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      {<bPopUp>,nil,<.lPopTab.>,<.d.>,<.pv.>,<c>,<f>,<w>,<h>,<s>,<k>,       ;
            <.g.>,<t>},                                                     ;
                                                /* xGETLIST_OPTIONS2     */ ;
      <.u.> [.OR. <_unreadable>],               /* xGETLIST_OPTIONS3     */ ;
      [<.noconfirm.>][!<.confirm.>],            /* xGETLIST_OPTIONS4     */ ;
      <.pass.> [.OR. <_password>],              /* xGETLIST_OPTIONS5     */ ;
      {<.proper.> [ .OR. <_proper>],<aProperOptions>},                      ;
                                                /* xGETLIST_OPTIONS6     */ ;
      <.ljust.> [.OR. <_leftjustify>],          /* xGETLIST_OPTIONS7     */ ;
      [{<nStart>,<nEnd>}],                      /* xGETLIST_OPTIONS8     */ ;
      [<keyblock>],                             /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      [<cId>],                                  /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
                                                /* lGETLIST_VISIBLE      */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
   } )                                                                      ;
      [; DC_GetAddOption(DCGUI_GETLIST,<option>) ]                          ;
      [; DC_GetAddOption(DCGUI_GETLIST,                                     ;
         { 120, <nComboHeight>, <acbComboData>, <nbField>, <bReturn>,       ;
                <nComboWidth> }) ]                                          ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 103, <preblock> } ) ]              ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 104, <postblock> } ) ]             ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 105, <cMsg> }) ]                   ;
      [; DC_GetAddOption(DCGUI_GETLIST,{ 115, <cHelpCode> }) ]

* ------------------------ *

#command  @ <nGetRow> [,<nGetCol>] DCCHECKBOX [<uVar>]                      ;
                [DELIMVAR <cDelim>]                                         ;
                [<prompt: PROMPT,CAPTION> <cPrompt>]                        ;
                [VALID <bValid>]                                            ;
                [PARENT <oParent>]                                          ;
                [DATALINK <bLink>]                                          ;
                [ACTION <bAction>]                                          ;
                [FONT <cFont>]                                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CARGO <xCargo>]                                            ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [SIZE <nWidth>[,<nHeight>]]                                 ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [OBJECT <oObject>]                                          ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_CHECKBOX,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cPrompt>,                                /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,'L',,,<bLink>),                              ;
                   <(uVar)>,'L',,,<(bLink)>}],  /* bGETLIST_VAR          */ ;
      <nGetRow>,                                /* nGETLIST_STARTROW     */ ;
      <nGetCol>,                                /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      [{||DC_ReadVar(@<uVar>,,,.t.)}],          /* bGETLIST_READVAR      */ ;
      [{DC_GetAnchorCB(@<cDelim>),<(cDelim)>}], /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                       <(oObject)>,'O'}],       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
     } )

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCRADIOBUTTON [<uVar>]                         ;
                [VALUE <xVal>]                                              ;
                [PARENT <oParent>]                                          ;
                [<prompt: PROMPT,CAPTION> <cPrompt>]                        ;
                [DELIMVAR <cDelim>]                                         ;
                [DATALINK <bLink>]                                          ;
                [FONT <cFont>]                                              ;
                [ACTION <bAction>]                                          ;
                [OBJECT <oObject>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CARGO <xCargo>]                                            ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [<b:PROTECT,EDITPROTECT> <bProtect>]                        ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [CURSOR <nCursor>]                                          ;
                [TITLE <cTitle>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_RADIOBUTTON,                      /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cPrompt>,                                /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>,,<bLink>,<xVal>),                    ;
        <(uVar)>,,<(xVal)>,,<(bLink)>,<xVal>}], /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<xVal>},                                 /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      {||DC_ReadVar(@<uVar>,,<xVal>,.f.)},      /* bGETLIST_READVAR      */ ;
      [{DC_GetAnchorCB(@<cDelim>),<(cDelim)>}], /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCMULTILINE [<uVar>]                           ;
                [PARENT <oParent>]                                          ;
                [VALID <bValid>]                                            ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [FONT <cFont>]                                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [HELPCODE <cHelpCode>]                                      ;
                [DATALINK <bLink>]                                          ;
                [OBJECT <oObject>]                                          ;
                [CARGO <xCargo>]                                            ;
                [<lNoWW:NOWORDWRAP>] [_NOWORDWRAP <_noww>]                  ;
                [<lNoB:NOBORDER>] [_NOBORDER <_nob>]                        ;
                [<lNoV:NOVERTSCROLL,NOVSCROLL>] [_NOVSCROLL <_nov>]         ;
                [<lNoH:NOHORIZSCROLL,NOHSCROLL>] [_NOHSCROLL <_noh>]        ;
                [<lIgT:IGNORETAB>] [_IGNORETAB <_ignoretab>]                ;
                [<lRO:READONLY>] [_READONLY <_ro>]                          ;
                [MAXLINES <nMaxLines> [MESSAGE <cMessage1>]]                ;
                [LINELENGTH <nLineLength> [MESSAGE <cMessage2>]]            ;
                [MAXCHARS <nMaxChars> [MESSAGE <cMessage3>]]                ;
                [EXITKEY <nExitKey>]                                        ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [<lCompat:COMPATIBILE,COMPATABILE,COMPATABLE,COMPATIBLE >]  ;
                   [_COMPAT <_compat>]                                      ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_MLE,                              /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,,,<bLink>),                                 ;
                      <(uVar)>,,,,<(bLink)>}],  /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.lNoWW.> [.OR. <_noww>],                                            ;
       <.lNoB.> [.OR. <_nob>],                                              ;
       <.lNoV.> [.OR. <_nov>],                                              ;
       <.lNoH.> [.OR. <_noh>],                                              ;
       <.lIgT.> [.OR. <_ignoretab>],                                        ;
       <.lCompat.> [.OR. <_compat>],                                        ;
       <.lRO.> [.OR. <_ro>],                                                ;
       <nExitKey>},                             /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                       <(oObject)>,'O'}],       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      {<nMaxLines>,<cMessage1>},                /* xGETLIST_OPTIONS2     */ ;
      {<nLineLength>,<cMessage2>},              /* xGETLIST_OPTIONS3     */ ;
      {<nMaxChars>,<cMessage3>},                /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCLISTBOX [<uVar>]                             ;
                [LIST <aList>]                                              ;
                [PARENT <oParent>]                                          ;
                [SIZE <nWidth>,<nHeight>]                                   ;
                [FONT <cFont>]                                              ;
                [PRESENTATION <aPres>]                                      ;
                [MARKMODE <nMarkMode>]                                      ;
                [SELECT <aSelect>]                                          ;
                [<lH:HORIZSCROLL>] [_HORIZSCROLL <_horizscroll>]            ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [DATALINK <bLink>]                                          ;
                [ITEMMARKED <bItemMarked>]                                  ;
                [ITEMSELECTED <bItemSelected>]                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [OBJECT <oObject>]                                          ;
                [CARGO <xCargo>]                                            ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [VALID <bValid>]                                            ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [<lMultiColumn:MULTICOLUMN>] [_MULTICOLUMN <_multicolumn>]  ;
                [HELPCODE <cHelpCode>]                                      ;
                [MESSAGE <cMessage>]                                        ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_LISTBOX,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,,,<bLink>),                                 ;
                      <(uVar)>,,,,<(bLink)>}],  /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.lH.> [.OR. <_horizscroll>],                                        ;
        <nMarkMode>,<aSelect>,                                              ;
        <.lMultiColumn.> [.OR. <_multicolumn>],                             ;
        <bItemMarked>,<bItemSelected>},         /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      <cMessage>,                               /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<aList>,'A'),                                       ;
                      <(aList)>,'A'}],          /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
     } )

* ------------------------------- *

#command @ <nRow> [, <nCol>] DCPUSHBUTTON [<text:CAPTION,PROMPT> <cText>]   ;
                [<fancy:FANCY>] [_FANCY <_fancy>]                           ;
                [<static:STATIC>] [_STATIC <_static>]                       ;
                  [FOCUSCOLOR <nTextColor>[,<nFrameColor>]]                 ;
                  [BITMAP <nBMUp> [,<nBMDn> [,<nBMNu> [,<nBMFl>]]]]         ;
                  [FLASH <nFiter> [,<nFDelay>]]                             ;
                  [REGION <aRegion>]                                        ;
                [<graphics:GRAPHICS>] [_GRAPHICS <_graphics>]               ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [TEXTOFFSET <nHoriz>, <nVert>]                              ;
                [TEXTHEIGHT <nTextHeight>]                                  ;
                [<action:ACTION,ACTIVATE> <bAction>]                        ;
                [WHEN <bWhen>]                                              ;
                [PARENT <oParent>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>]]                                  ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [HELPCODE <cHelpCode>]                                      ;
                [FONT <cFont>]                                              ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [OBJECT <oObject>]                                          ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [TITLE <cTitle> ]                                           ;
                [RELATIVE <oRel> ]                                          ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [SOUND <abSound>]                                           ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_PUSHBUTTON,                       /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nHoriz>,<nVert>,<nTextHeight>,<.fancy.> [.OR. <_fancy>],           ;
        <.graphics.> [.OR. <_graphics>], <.static.> [.OR. <_static>] },     ;
                                                /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* nGETLIST_GROUP        */ ;
      <nCursor>,                                /* bGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      <abSound>,                                /* xGETLIST_OPTIONS2     */ ;
      [{<nBMUp>,<nBMDn>,<nBMNu>,<nBMFl>}],      /* xGETLIST_OPTIONS3     */ ;
      [{<nTextColor>,<nFrameColor>}],           /* xGETLIST_OPTIONS4     */ ;
      <aRegion>,                                /* xGETLIST_OPTIONS5     */ ;
      [{<nFiter>,<nFDelay>}],                   /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#command  @ <nSRow>,<nSCol>,<nERow>,<nECol> DCBOX [<cBox>]                  ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CAPTION <cText>]                                           ;
                [GROUP <oGroup>]                                            ;
                [PARENT <oParent>]                                          ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
 =>                                                                         ;
   AADD( DCGUI_GETLIST,                                                     ;
     { GETLIST_STATIC,                          /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_GROUPBOX,                  /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      <nERow>,                                  /* nGETLIST_ENDROW       */ ;
      <nECol>,                                  /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <cBox>,                                   /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      DC_ReadOptions(GETLIST_STATIC,{}),        /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oGroup>,'O'),                                      ;
                        <(oGroup)>,'O'}],       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [DC_GetAnchorCB(@<oParent>,'O'),                                      ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCCOMBOBOX [<uVar>]                            ;
                [LIST <aList>]                                              ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PARENT <oParent>]                                          ;
                [<r:REFRESH>] [_REFRESH <_refresh>]                         ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [VALID <bValid>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
                [POINTER <nVar>]                                            ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [DATALINK <bLink>]                                          ;
                [WHEN <bWhen>]                                              ;
                [FONT <cFont>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [PRESENTATION <aPres>]                                      ;
                [TYPE <nType>]                                              ;
                [OBJECT <oObject>]                                          ;
                [CARGO <xCargo>]                                            ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [TITLE <cTitle>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_COMBOBOX,                         /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>,,<bLink>),                           ;
              <(uVar)>,,,,<(bLink)>}],          /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.r.> [.OR. <_refresh>]},                /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                       <(oParent)>,'O'}],       /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<aList>,'A'),                                       ;
                      <(aList)>,'A'}],          /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      [{DC_GetAnchorCB(@<nVar>,'N'),<(nVar)>}], /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#xcommand DCTOOLBAR [<options,...>] => @ DCTOOLBAR [<options>]

#command @ [<nRow>] [, <nCol>] DCTOOLBAR [OBJECT] <oToolBar> [TYPE <nType>] ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [BUTTONSIZE <nBWidth> [,<nBHeight>]]                        ;
                [PARENT <oParent>]                                          ;
                [RELATIVE <oRel>]                                           ;
                [<fancy:FANCY>] [_FANCY <_fancy>]                           ;
                [PRESENTATION <aPres>]                                      ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [ALIGN <nAlign>]                                            ;
                [CARGO <xCargo>]                                            ;
                [<v:VERTICAL>] [_VERTICAL <_vertical>]                      ;
                [<h:HORIZONTAL>] [_HORIZONTAL <_horizontal>]                ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [ID <cId>]                                                  ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_TOOLBAR,                          /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      [<nWidth>],                               /* nGETLIST_WIDTH        */ ;
      [<nHeight>],                              /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nAlign>,<nBWidth>,<nBHeight>,<.fancy.> [.OR. <_fancy>],            ;
        <.v.> [.OR. <_vertical>],                                           ;
        <.h.> [.OR. <_horizontal>]},            /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oToolBar>,'O'),                                     ;
                       <(oToolBar)>,'O'},       /* bGETLIST_GROUP        */ ;
      <nCursor>,                                /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                         <oRel>,'O'}],          /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand DCADDBUTTON  [CAPTION <cText>]                                    ;
                [<fancy:FANCY>] [_FANCY <_fancy>]                           ;
                [TYPE <nType>]                                              ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [<static:STATIC>] [_STATIC <_static>]                       ;
                  [FOCUSCOLOR <nTextColor>[,<nFrameColor>]]                 ;
                  [BITMAP <nBMUp> [,<nBMDn> [,<nBMNu> [,<nBMFl>]]]]         ;
                  [FLASH <nFiter> [,<nFDelay>]]                             ;
                  [REGION <aRegion>]                                        ;
                [<graphics:GRAPHICS>] [_GRAPHICS <_graphics>]               ;
                [TEXTHEIGHT <nTextHeight>]                                  ;
                [TEXTOFFSET <nHoriz>, <nVert>]                              ;
                [ACTION <bAction>]                                          ;
                [PARENT <oParent>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [HELPCODE <cHelpCode>]                                      ;
                [COLOR <ncFgC> [,<ncBgC>]]                                  ;
                [FONT <cFont> ]                                             ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [OBJECT <oObject>]                                          ;
                [DRAWINGAREA <oDrawingArea>]                                ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [<pr:EDITPROTECT,PROTECT> <bProtect>]                       ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [CARGO <xCargo>]                                            ;
                [SOUND <abSound>]                                           ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_ADDBUTTON,                        /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      [<nWidth>],                               /* nGETLIST_WIDTH        */ ;
      [<nHeight>],                              /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {nil,nil,nil,<.fancy.> [.OR. <_fancy>],                               ;
        <.graphics.> [.OR. <_graphics>], <.static.> [.OR. <_static>] },     ;
                                                /* xGETLIST_OPTIONS       */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      <nCursor>,                                /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<oDrawingArea>,'O'),                                ;
                        <(oDrawingArea)>,'O'}], /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      <abSound>,                                /* xGETLIST_OPTIONS2     */ ;
      [{<nBMUp>,<nBMDn>,<nBMNu>,<nBMFl>}],      /* xGETLIST_OPTIONS3     */ ;
      [{<nTextColor>,<nFrameColor>}],           /* xGETLIST_OPTIONS4     */ ;
      <aRegion>,                                /* xGETLIST_OPTIONS5     */ ;
      [{<nFiter>,<nFDelay>}],                   /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#xcommand DCMESSAGEBOX <oMsgBox> [<options,...>] =>                         ;
          @ DCMESSAGEBOX OBJECT <oMsgBox> [<options>]

#command @ [<nRow>] [,<nCol>] DCMESSAGEBOX                                  ;
                [OBJECT <oMsgBox>]                                          ;
                [TEXTOBJECT <oMsgBoxText>]                                  ;
                [TYPE <nType>]                                              ;
                [SIZE <nWidth> [,<nHeight>] ]                               ;
                [PARENT <oParent>]                                          ;
                [RELATIVE <oRel>]                                           ;
                [FONT <cFont>]                                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CARGO <xCargo>]                                            ;
                [PRESENTATION <aPres>]                                      ;
                [ALIGN <nAlign>]                                            ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [HIDE <bHide>]                                              ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [<lMotion:MOTION>] [_MOTION <_motion>]                      ;
                [<lClear:CLEAR>] [_CLEAR <_clear>]                          ;
                [ID <cId>]                                                  ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [<option:OPTIONS,SAYOPTIONS> <nOpt>]                        ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_MESSAGEBOX,                       /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nAlign>,<.lMotion.> [.OR. <_motion>],<nOpt>,                        ;
       <.lClear.> [.OR. <_clear>] },                                        ;
                                                /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oMsgBox>,'O'),<(oMsgBox)>,'O'}],                   ;
                                                /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),<(oParent)>,'O'}],                   ;
                                                /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),<(oRel)>,'O'}],                         ;
                                                /* bGETLIST_RELATIVE     */ ;
      [{DC_GetAnchorCb(@<oMsgBoxText>,'O'),<(oMsgBoxText)>,'O'}],           ;
                                                /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )


* ------------------------------- *

#command  @ <nRow> [,<nCol>] DC3STATE [<uVar>]                              ;
                [<prompt: PROMPT,CAPTION> <aVar>]                           ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PARENT <oParent>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [HELPCODE <cHelpCode>]                                      ;
                [DATALINK <bLink>]                                          ;
                [FONT <cFont>]                                              ;
                [WHEN <bWhen>]                                              ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [OBJECT <oObject>]                                          ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_3STATE,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,'N',,,<bLink>),                              ;
               <(uVar)>,'N',,,<(bLink)>}],      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(uVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<aVar>),<(aVar)>}],     /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#command  @ <nSRow>,<nSCol> [,<nERow>,<nECol>] DCGROUP <oGroup>             ;
                [BOX <cBox>]                                                ;
                [PARENT <oParent>]                                          ;
                [SIZE <nWidth>, <nHeight>]                                  ;
                [CAPTION <cText>]                                           ;
                [FONT <cFont>]                                              ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [HELPCODE <cHelpCode>]                                      ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [CARGO <xCargo>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_STATIC,                           /* nGETLIST_TYPE         */ ;
      XBPSTATIC_TYPE_GROUPBOX,                  /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      [<nERow>],                                /* nGETLIST_ENDROW       */ ;
      [<nECol>],                                /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<cBox>},                                 /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oGroup>,'O'),                                       ;
                       <(oGroup)>,'O'},         /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
   } )

* ------------------------------- *

#command  @ <nRow> [,<nCol>] DCSTATIC [ [TYPE] <nType> ]                    ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [OBJECT <oObject>]                                          ;
                [PARENT <oParent>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [OPTIONS <nOptions>]                                        ;
                [FONT <cFont>]                                              ;
                [CARGO <xCargo>]                                            ;
                [CAPTION <xCaption>]                                        ;
                [PRESENTATION <aPres>]                                      ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [HELPCODE <cHelpCode>]                                      ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [VSCROLL <oVStatic>                                         ;
                         RANGE <nVStart>, <nVEnd> [OBJECT <oVScroll>] ]     ;
                [HSCROLL <oHStatic>                                         ;
                         RANGE <nHStart>, <nHEnd> [OBJECT <oHScroll>] ]     ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_STATIC,                           /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <xCaption>,                               /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nOptions>},                             /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      { [{DC_GetAnchorCb(@<oVStatic>,'O'),<(oVStatic)>,'O'}],               ;
         <nVStart>, <nVEnd>,                                                ;
         [{DC_GetAnchorCb(@<oVScroll>,'O'),<(oVScroll)>,'O'}] },            ;
                                                /* xGETLIST_OPTIONS2     */ ;
      { [{DC_GetAnchorCb(@<oHStatic>,'O'),<(oHStatic)>,'O'}],               ;
         <nHStart>, <nHEnd>,                                                ;
         [{DC_GetAnchorCb(@<oHScroll>,'O'),<(oHScroll)>,'O'}] },            ;
                                                /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
   } )

* ------------------------------- *

#command  @ <nSRow> [,<nSCol>] DCTABPAGE [<oObject1>]                       ;
                [OBJECT <oObject2>]                                         ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [TYPE <nType>]                                              ;
                [TABHEIGHT <nTabH>]                                         ;
                [TABWIDTH <nTabW>]                                          ;
                [PREOFFSET <nPre>]                                          ;
                [POSTOFFSET <nPost>]                                        ;
                [PARENT <oParent>]                                          ;
                [GROUP <nGroup>]                                            ;
                [FONT <cFont>]                                              ;
                [CAPTION <cText>]                                           ;
                [CARGO <xCargo>]                                            ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [HELPCODE <cHelpCode>]                                      ;
                [COLOR <ncColor> [,<ncDisabled>] ]                          ;
                [DATALINK <bDataLink>]                                      ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [VALID <bValid>]                                            ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [RELATIVE <oRel>]                                           ;
                [TITLE <cTitle>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [PRESENTATION <aPres>]                                      ;
                [GROUP <cGroup>]                                            ;
                [STATICAREA <oStatic>]                                      ;
                [ANGLE <nAngle>]                                            ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_TABPAGE,                          /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <cText>,                                  /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      {<bDataLink>,<(bDataLink)>},              /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nPre>, <nPost>, <nGroup>, <nTabH>, <nTabW>, <nAngle> },            ;
                                                /* xGETLIST_OPTIONS      */ ;
      {<ncColor>,<ncDisabled>},                 /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {[DC_GetAnchorCB(@<oObject1>,'O'),<(oObject1)>,'O']                   ;
       [DC_GetAnchorCB(@<oObject2>,'O'),<(oObject2)>,'O']},                 ;
                                                /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<oStatic>,'O'),                                     ;
                        <(oStatic)>,'O'}],      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  DCMENUBAR [OBJECT] <oMenuBar> [PARENT <oParent>]                 ;
           [EVAL <bEval>]                                                   ;
           [PREEVAL <bPreEval>]                                             ;
           [TITLE <cTitle>]                                                 ;
           [CARGO <xCargo>]                                                 ;
           [ID <cId>]                                                       ;
           [GROUP <cGroup>]                                                 ;
  =>                                                                        ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_MENUBAR,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oMenuBar>,'O'),                                     ;
                       <(oMenuBar)>,'O'},       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  DCSUBMENU <oSubMenu>                                             ;
                [<prompt: PROMPT,CAPTION> <cPrompt>]                        ;
                [TOOLTIP <cToolTip>]                                        ;
                [INDEX <nIndex>]                                            ;
                [PARENT <oParent>]                                          ;
                [WHEN <bWhen>]                                              ;
                [ACTION <bAction>]                                          ;
                [HELPCODE <cHelpCode>]                                      ;
                [<lCheck:CHECKED>] [_CHECKED <_checked>]                    ;
                [<lSep:SEPARATOR>] [_SEPARATOR <_separator>]                ;
                [<lSelect:SELECT>] [_SELECT <_select>]                      ;
                [STYLE <nStyle>]                                            ;
                [ATTRIBUTE <nAttr>]                                         ;
                [LOCK <cLock>]                                              ;
                [PROTECT <bProtect>]                                        ;
                [RETURN <nReturn>]                                          ;
                [CARGO <xCargo>]                                            ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [ID <cId>]                                                  ;
                [PRESENTATION <aPres>]                                      ;
                [TITLE <cTitle>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GROUP <cGroup>]                                            ;
                [BITMAP <nBmUnChecked> [, <nBmChecked>] ]                   ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_SUBMENU,                          /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cPrompt>,                                /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<nIndex>,'N',),                                     ;
                         <(nIndex)>,'N'}],      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nReturn>,<cId>,<cLock>,                                             ;
       <.lCheck.> [.OR. <_checked>],<.lSep.> [.OR. <_separator>],           ;
       <nStyle>,<nAttr>,<.lSelect.> [.OR. <_select>]},                      ;
                                                /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oSubMenu>,'O'),                                     ;
                       <(oSubMenu)>,'O'},       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      [{<nBmUnChecked>,<nBmChecked>}],          /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  DCMENUITEM [[CAPTION][PROMPT] <cPrompt>]                         ;
                [INDEX <nIndex>]                                            ;
                [TOOLTIP <cToolTip>]                                        ;
                [PARENT <oParent>]                                          ;
                [WHEN <bWhen>]                                              ;
                [CHECKWHEN <bCheckWhen>]                                    ;
                [ACTION <bAction>]                                          ;
                [STYLE <nStyle>]                                            ;
                [ATTRIBUTE <nAttr>]                                         ;
                [HELPCODE <cHelpCode>]                                      ;
                [LOCK <cLock>]                                              ;
                [PROTECT <bProtect>]                                        ;
                [<lCheck:CHECKED>] [_CHECKED <_checked>]                    ;
                [<lSep:SEPARATOR>] [_SEPARATOR <_separator>]                ;
                [<lSelect:SELECT>] [_SELECT <_select>]                      ;
                [RETURN <nReturn>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [CARGO <xCargo>]                                            ;
                [ID <cId>]                                                  ;
                [TITLE <cTitle>]                                            ;
                [PRESENTATION <aPres>]                                      ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [ACCELKEY <nAccel>]                                         ;
                [GROUP <cGroup>]                                            ;
                [BITMAP <nBmUnChecked> [, <nBmChecked>] ]                   ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_MENUITEM,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      <cPrompt>,                                /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<nIndex>,'N',),                                     ;
                         <(nIndex)>,'N'}],      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nReturn>,<cId>,<cLock>,                                             ;
       <.lCheck.> [.OR. <_checked>],<.lSep.> [.OR. <_separator>],           ;
       <nStyle>,<nAttr>,<.lSelect.> [.OR. <_select>],<bCheckWhen>},         ;
                                                /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* oGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      [{<nBmUnChecked>,<nBmChecked>}],          /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  @ <nRow> [, <nCol>] DCBROWSE  [OBJECT] <oBrowse>                 ;
                [DATA <xData> [ELEMENT <nElement>]]                         ;
                [ALIAS <cAlias>]                                            ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PARENT <oParent>]                                          ;
                [INTO <uVar>]                                               ;
                [POINTER <nVar>]                                            ;
                [DATALINK <bLink>]                                          ;
                [PRESENTATION <aPres>]                                      ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [COLOR <bncFgC> [,<ncBgC>]]                                 ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [FONT <cFont>]                                              ;
                [CARGO <xCargo>]                                            ;
                [CURSORMODE <nCursorMode>]                                  ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [EDIT <nEditEvent> [ACTION <bEditAction>]                   ;
                   [MODE <nEditMode>] [FONT <cEditFont>]                    ;
                   [EXIT <bEditExit>]                                       ;
                   [<lNoAutoLock:NOAUTOLOCK>] [_NOAUTOLOCK <_noautolock>]]  ;
                [INSERT <nInsertEvent> [ACTION <bInsertAction>]             ;
                   [INSMODE <nInsertMode>]                                  ;
                   [EXIT <bInsertExit>] [DEFAULT <abDefault1>]              ;
                   [APPEND <nAppendEvent>] [APPMODE <nAppendMode>] ]        ;
                [DELETE <nDeleteEvent> [ACTION <bDeleteAction>]             ;
                   [EXIT <bDeleteExit>] ]                                   ;
                [DEFAULT <abDefault2>]                                      ;
                [HANDLER <EditHandler> [REFERENCE <xRef>]]                  ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [TITLE <cTitle>]                                            ;
                [FREEZELEFT <aFreezeL>]                                     ;
                [FREEZERIGHT <aFreezeR>]                                    ;
                [MARK <nbMark>]                                             ;
                [MKCOLOR <nbMarkEval>, <ncMFgC> [,<ncMBgC>] ]               ;
                [ITEMMARKED <bItemMarked>]                                  ;
                [ITEMSELECTED <bItemSelected>]                              ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [<lScope:SCOPE>] [_SCOPE <_lScope>]                         ;
                [<lNoV:NOVSCROLL,NOVERTSCROLL>] [_NOVSCROLL <_lNoV>]        ;
                [<lNoH:NOHSCROLL,NOHORIZSCROLL>] [_NOHSCROLL <_lNoH>]       ;
                [<lNoST:NOSOFTTRACK>] [_NOSOFTTRACK <_lNoST>]               ;
                [GROUP <cGroup>]                                            ;
                [THUMBLOCK <nThumbRecs>]                                    ;
                [HEADLINES <nHeadLines> [DELIMITER <cHeadDelim>]]           ;
                [FOOTLINES <nFootLines> [DELIMITER <cFootDelim>]]           ;
                [HEADPRES <aHeadPres>]                                      ;
                [FOOTPRES <aFootPres>]                                      ;
                [<lFit:FIT>] [_FIT <_lFit>]                                 ;
                [<lOptimize:OPTIMIZE>] [_OPTIMIZE <_lOptimize>]             ;
                [<lNoSizeCols:NOSIZECOLS>] [_NOSIZECOLS <_lNoSizeCols>]     ;
                [SORTSCOLOR <nSortedColorFG> [,<nSortedColorBG>] ]          ;
                [SORTUCOLOR <nUnSortedColorFG> [,<nUnSortedColorBG>] ]      ;
                [SORTUPBITMAP <nBitmapSortUp>]                              ;
                [SORTDOWNBITMAP <nBitmapSortDown>]                          ;
                [<lDescend:DESCENDING>] [_DESCENDING <_lDescend>]           ;
                [AUTOREFRESH <nRefreshInterval>]                            ;
                [<lRbSelect:RBSELECT>] [_RBSELECT <_lRbSelect>]             ;
                [HELPCODE <cHelpCode>]                                      ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_BROWSE,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>),                                    ;
                                <(uVar)>}],     /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      [{<bLink>,<(bLink)>}],                    /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nbMark>, <(nbMark)> ,                                              ;
        <nbMarkEval>, <(nbMarkEval)> ,                                      ;
        <ncMFgC>, <ncMBgC>,                                                 ;
        <aFreezeL>, <aFreezeR>,                                             ;
        <.lScope.> [.OR. <_lScope>], <nThumbRecs>,                          ;
        <nHeadLines>, <cHeadDelim>,                                         ;
        <nFootLines>, <cFootDelim>,                                         ;
        <aHeadPres>, <aFootPres>,                                           ;
        <.lNoV.> [.OR. <_lNoV>], <.lNoH.> [.OR. <_lNoH>],                   ;
        <.lNoST.> [.OR. <_lNoST>], <.lFit.> [.OR. <_lFit>],                 ;
        <.lOptimize.> [.OR. <_lOptimize>], <bItemMarked>,                   ;
        <bItemSelected>, <.lNoSizeCols.> [.OR. <_lNoSizeCols>],             ;
        <nSortedColorFG>,<nSortedColorBG>,                                  ;
        <nUnSortedColorFG>,<nUnSortedColorBG>,                              ;
        <nBitmapSortUp>,<nBitmapSortDown>,                                  ;
        <.lDescend.> [.OR. <_lDescend>],                                    ;
        <nRefreshInterval>,                                                 ;
        <.lRbSelect.> [.OR. <_lRbSelect>]},     /* xGETLIST_OPTIONS      */ ;
      [{<bncFgC>,<ncBgC>}],                     /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <cAlias>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oBrowse>,'O'),                                      ;
                       <(oBrowse)>,'O'},        /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<xData>),<(xData)>}],                               ;
                                                /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      {<nEditEvent>,<bEditAction>,<nEditMode>,<cEditFont>,<bEditExit>,      ;
       <.lNoAutoLock.> [.OR. <_noautolock>], <abDefault2>},                 ;
                                                /* xGETLIST_OPTIONS2     */ ;
      [{<nInsertEvent>,<bInsertAction>, <abDefault1>,<bInsertExit>,         ;
        <nAppendEvent>,<nInsertMode>,<nAppendMode>}],                       ;
                                                /* xGETLIST_OPTIONS3     */ ;
      [{<nDeleteEvent>,<bDeleteAction>,<bDeleteExit>}],                     ;
                                                /* xGETLIST_OPTIONS4     */ ;
      <nElement>,                               /* xGETLIST_OPTIONS5     */ ;
      [{DC_GetAnchorCB(@<nVar>,'N'),<(nVar)>}], /* xGETLIST_OPTIONS6     */ ;
      [<nCursorMode>],                          /* xGETLIST_OPTIONS7     */ ;
      [{|a,b,c,d,e,f,g,h|<EditHandler>(a,b,c,d,e,f,@g,h)}],                 ;
                                                /* xGETLIST_OPTIONS8     */ ;
      <xRef>,                                   /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )


* ------------------------------- *

#xcommand DCBROWSECOL                                                       ;
                [DATA <xData>]                                              ;
                [FIELD <fld>]                                               ;
                [PICTURE <cPict>]                                           ;
                [ELEMENT <nPointer>]                                        ;
                [WIDTH <nWidth>]                                            ;
                [<h:HEADER,HEADING> <cHeader>] [HEADPRES <aHeadPres>]       ;
                [<f:FOOTER,FOOTING> <cFooter>] [FOOTPRES <aFootPres>]       ;
                [TYPE <anType>]                                             ;
                [REPRESENTATION <aRep>]                                     ;
                [ALIGN <nAlign>]                                            ;
                [COLOR <bncFgC> [,<ncBgC>] ]                                ;
                [HCOLOR <bncHFgC> [,<ncHBgC>] ]                             ;
                [FCOLOR <bncFFgC> [,<ncFBgC>] ]                             ;
                [PARENT <oParent>]                                          ;
                [TOOLTIP <cToolTip>]                                        ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [HELPCODE <cHelpCode>]                                      ;
                [OBJECT <oObject>]                                          ;
                [HIDE <bHide>]                                              ;
                [VALID <bValid>]                                            ;
                [FONT <cFont>]                                              ;
                [CARGO <xCargo>]                                            ;
                [PRESENTATION <aPres>]                                      ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [WHEN <bWhen>]                                              ;
                [SORT <bSort>                                               ;
                     [<lb:LEFTBUTTON>] [_LEFTBUTTON <lLeftButton>]          ;
                     [<def:DEFAULT>] [_DEFAULT <lDefault>]]                 ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [EDITOR <bcEdit> [EXITKEY <nExitKey>] ]                     ;
                [GROUP <cGroup>]                                            ;
                [<prot: PROTECT, EDITPROTECT> <bProtect>]                   ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [DATATOOLTIP <bTipWhen> [TIPBLOCK <bTipBlock>]]             ;
                [<lNoCreate:NOCREATE>]                                      ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_BROWSECOL,                        /* nGETLIST_TYPE         */ ;
      <anType>,                                 /* nGETLIST_SUBTYPE      */ ;
      <cHeader>,                                /* cGETLIST_CAPTION      */ ;
      [ {|a| IIF(a==NIL .OR. <fld>==a, <fld>, <fld>:=a) } ],                ;
                                                /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      <cPict>,                                  /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<bSort>,<(bSort)>,<cFooter>,                                         ;
        <bcEdit>,<nExitKey>,                                                ;
        <.lb.>[.OR.<lLeftButton>],                                          ;
        <.lNoCreate.>,                                                      ;
        <.def.>[.OR.<lDefault>]},               /* xGETLIST_OPTIONS      */ ;
      [{<bncFgC>,<ncBgC>}],                     /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      <nPointer>,                               /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{<xData>,<(xData)>}],                    /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      [{<bncHFgC>,<ncHBgC>}],                   /* xGETLIST_OPTIONS2     */ ;
      <aHeadPres>,                              /* xGETLIST_OPTIONS3     */ ;
      <aFootPres>,                              /* xGETLIST_OPTIONS4     */ ;
      <(fld)>,                                  /* xGETLIST_OPTIONS5     */ ;
      <aRep>,                                   /* xGETLIST_OPTIONS6     */ ;
      <nAlign>,                                 /* xGETLIST_OPTIONS7     */ ;
      [{<bncFFgC>,<ncFBgC>}],                   /* xGETLIST_OPTIONS8     */ ;
      [{<bTipWhen>,<bTipBlock>}],               /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  @ <nRow> [, <nCol>] DCQUICKBROWSE                                ;
                [OBJECT <oBrowse>]                                          ;
                [ALIAS <cAlias>]                                            ;
                [FIELDS <aFields>]                                          ;
                [DATA <xData>]                                              ;
                [COLUMNS <aColumns>]                                        ;
                [COLTYPE <aColType>]                                        ;
                [COLREPRESENTATION <aColRep>]                               ;
                [COLWIDTH <aColWidth>]                                      ;
                [COLALIGN <aColAlign>]                                      ;
                [HEADERS <aHeaders>]                                        ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [STYLE <nStyle>]                                            ;
                [PARENT <oParent>]                                          ;
                [INTO <uVar>]                                               ;
                [POINTER <nVar>]                                            ;
                [DATALINK <bLink>]                                          ;
                [PRESENTATION <aPres>]                                      ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [COLOR <bncFgC> [,<ncBgC>]]                                 ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [FONT <cFont>]                                              ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [CARGO <xCargo>]                                            ;
                [CURSORMODE <nCursorMode>]                                  ;
                [EDIT <nEditEvent> [ACTION <bEditAction>]                   ;
                   [MODE <nEditMode>] [FONT <cEditFont>]                    ;
                   [EXIT <bEditExit>] [<lNoAutoLock:NOAUTOLOCK>] ]          ;
                [INSERT <nInsertEvent> [ACTION <bInsertAction>]             ;
                   [DEFAULT <abDefault>] [EXIT <bInsertExit>]               ;
                   [APPEND <nAppendEvent>] ]                                ;
                [DELETE <nDeleteEvent> [ACTION <bDeleteAction>]             ;
                   [EXIT <bDeleteExit>] ]                                   ;
                [HANDLER <EditHandler> [REFERENCE <xRef>]]                  ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [RELATIVE <oRel>]                                           ;
                [TITLE <cTitle>]                                            ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [<lNoV:NOVSCROLL>] [_NOVSCROLL <_nov>]                      ;
                [<lNoH:NOHSCROLL>] [_NOHSCROLL <_noh>]                      ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [ITEMMARKED <bItemMarked>]                                  ;
                [ITEMSELECTED <bItemSelected>]                              ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_QUICKBROWSE,                      /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>),                                    ;
                                <(uVar)>}],     /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      [{<bLink>,<(bLink)>}],                    /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      { <nCursorMode>, <nStyle>,                                            ;
        <.lNoV.> [.OR. <_nov>], <.lNoH.> [.OR. <_noh>],                     ;
        <bItemMarked>, <bItemSelected> } ,                                  ;
                                                /* xGETLIST_OPTIONS      */ ;
      [{<bncFgC>,<ncBgC>}],                     /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      <cAlias>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oBrowse>,'O'),                                     ;
                       <(oBrowse)>,'O'}],       /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<xData>),<(xData)>}],   /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      [{<nEditEvent>,<bEditAction>,<nEditMode>,                             ;
        <cEditFont>,<bEditExit>,                                            ;
        <.lNoAutoLock.>}],                      /* xGETLIST_OPTIONS2     */ ;
      [{<nInsertEvent>,<bInsertAction>,                                     ;
        <abDefault>,<bInsertExit>,                                          ;
        <nAppendEvent>}],                       /* xGETLIST_OPTIONS3     */ ;
      [{<nDeleteEvent>,<bDeleteAction>,                                     ;
        <bDeleteExit>}],                        /* xGETLIST_OPTIONS4     */ ;
      [{<aHeaders>,<aColumns>,<aFields>,<aColType>,                         ;
        <aColRep>,<aColWidth>,<aColAlign>}],    /* xGETLIST_OPTIONS5     */ ;
      [{DC_GetAnchorCB(@<nVar>,'N'),<(nVar)>}], /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      [{|a,b,c,d,e,f,g,h|<EditHandler>(a,b,c,d,e,f,@g,h)}],                 ;
                                                /* xGETLIST_OPTIONS8     */ ;
      <xRef>,                                   /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ------------------------------- *

#xcommand  DCBITMAP <ncbResource>                                           ;
                [PARENT <oParent>]                                          ;
                [TARGETRECT <nSRow>,<nSCol>,<nERow>,<nECol>]                ;
                [SOURCERECT <a>,<b>,<c>,<d>]                                ;
                [BITS <nB>]                                                 ;
                [HIDE <bHide>]                                              ;
                [PLANES <nP>]                                               ;
                [OBJECT <oObject>]                                          ;
                [CARGO <xCargo>]                                            ;
                [<s: AUTOSCALE>] [_AUTOSCALE <_autoscale> ]                 ;
                [<cen: CENTER>] [_CENTER <_center>]                         ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [GROUP <cGroup>]                                            ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_BITMAP,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      <ncbResource>,                            /* bGETLIST_VAR          */ ;
      <nSRow>,                                  /* nGETLIST_STARTROW     */ ;
      <nSCol>,                                  /* nGETLIST_STARTCOL     */ ;
      <nERow>,                                  /* nGETLIST_ENDROW       */ ;
      <nECol>,                                  /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nB>,<nP>,<.s.> [.OR. <_autoscale>],<a>,<b>,<c>,<d>,                 ;
       <.cen.> [.OR. <_center>]},               /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
   } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCSPINBUTTON [<nVar>]                          ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PARENT <oParent>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [VALID <bValid>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
                [FONT <cFont>]                                              ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [PRESENTATION <aPres>]                                      ;
                [MASTER <oMaster>]                                          ;
                [OBJECT <oObject>]                                          ;
                [CALLBACK <bCallBack>]                                      ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [DATALINK <bLink>]                                          ;
                [<l: LIMITS,RANGE> <nBott>,<nTop>]                          ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [<f: FASTSPIN>] [_FASTSPIN <_fastspin>]                     ;
                [<z: PADZERO>] [_PADZERO <_padzero>]                        ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SPINBUTTON,                       /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<nVar>,'N',,<bLink>),                               ;
                <(nVar)>,'N',,<(bLink)>}],      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      {<bCallBack>,<(bCallBack)>},              /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.f.> [.OR. <_fastspin>],<.z.> [.OR. <_padzero>],                    ;
       <nBott>,<nTop>},                         /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(nVar)>,                                 /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<oMaster>,'O'),                                     ;
                        <(oMaster)>,'O'}],      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCSCROLLBAR                                    ;
                [DATA <uVar>]                                               ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [PARENT <oParent>]                                          ;
                [PRESENTATION <aPres>]                                      ;
                [TYPE <nType>]                                              ;
                [SCROLL <bScroll>]                                          ;
                [OBJECT <oBar>]                                             ;
                [RANGE <nBott>,<nTop>]                                      ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [HIDE <bHide>]                                              ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [<a :AUTOTRACK>] [_AUTOTRACK <_autotrack>]                  ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SCROLLBAR,                        /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>),                                    ;
                       <(uVar)>}],              /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      {<bScroll>,<(bScroll)>},                  /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<.a.> [.OR. <_autotrack>],<nBott>,<nTop>},                           ;
                                                /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oBar>,'O'),                                        ;
                     <(oBar)>,'O'}],            /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCCUSTOM <bCustom>                             ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [VAR <uVar>]                                                ;
                [PARENT <oParent>]                                          ;
                [CAPTION <cCaption>]                                        ;
                [PRESENTATION <aPres>]                                      ;
                [TYPE <nType>]                                              ;
                [OBJECT <oCustom>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [OPTIONS <aOptions>]                                        ;
                [DATALINK <bLink>]                                          ;
                [FONT <cFont>]                                              ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [VALID <bValid>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
                [TOOLTIP <cToolTip>]                                        ;
                [ACTION <bAction>]                                          ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ ID <cId>]                                                 ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_CUSTOM,                           /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <cCaption>,                               /* cGETLIST_CAPTION      */ ;
      [{DC_GetAnchorCB(@<uVar>,,<uVar>,,<bLink>),                           ;
                <(uVar)>,,,,<(bLink)>}],        /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      <aOptions>,                               /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      <(bCustom)>,                              /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oCustom>,'O'),                                     ;
                        <(oCustom)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      {<bCustom>,<(bCustom)>},                  /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCPROGRESS <oProgress>                         ;
                [SIZE <nWidth> [,<nHeight>]]                                ;
                [TYPE <nType>]                                              ;
                [PARENT <oParent>]                                          ;
                [PRESENTATION <aPres>]                                      ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [MAXCOUNT <nMaxCount>]                                      ;
                [TOOLTIP <cToolTip>]                                        ;
                [CARGO <xCargo>]                                            ;
                [HIDE <bHide>]                                              ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [EVERY <nCount>]                                            ;
                [<lPercent:PERCENT>] [_PERCENT <_percent>]                  ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
                [<lVert:VERTICAL>] [_VERTICAL <_vertical>]                  ;
                [<lBroken:BROKEN>] [_BROKEN <_broken>]                      ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_PROGRESS,                         /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* nGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nMaxCount>,<.lPercent.> [.OR. <_percent>],<nCount>,                 ;
       <.lVert.> [.OR. <_vertical>],<.lBroken.> [.OR. <_broken>]},          ;
                                                /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oProgress>,'O'),                                   ;
                        <(oProgress)>,'O'}],    /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCAPPCRT <oCrt>                                ;
                [SIZE <nHeight> [,<nWidth>]]                                ;
                [PARENT <oParent>]                                          ;
                [CAPTION <cCaption>]                                        ;
                [TYPE <nType>]                                              ;
                [BORDER <nB>]                                               ;
                [FONT <cFont>]                                              ;
                [FONTSIZE <nFW>,<nFH>]                                      ;
                [ACTION <bAction>]                                          ;
                [CURSOR <nCursor>]                                          ;
                [COLOR <ncFgC> [,<ncBgC>] ]                                 ;
                [CARGO <xCargo>]                                            ;
                [THREAD <oThread>]                                          ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [HIDE <bHide>]                                              ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [TITLE <cTitle>]                                            ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
  =>                                                                        ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_APPCRT,                           /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      <cCaption>,                               /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      <cFont>,                                  /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nFW>,<nFH>,<nB>},                       /* xGETLIST_OPTIONS      */ ;
      [{<ncFgC>,<ncBgC>}],                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      {DC_GetAnchorCB(@<oCrt>,'O'),<(oCrt)>},   /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      [{DC_GetAnchorCB(@<oThread>,'O'),                                     ;
                        <(oThread)>,'O'}],      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  DCHOTKEY <anAccel>                                                ;
                [PARENT <oParent>]                                          ;
                [WHEN <bWhen>]                                              ;
                [ACTION <bAction>]                                          ;
                [ID <cID>]                                                  ;
                [TITLE <cTitle>]                                            ;
                [GROUP <cGroup>]                                            ;
 =>                                                                         ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_HOTKEY,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      <bAction>,                                /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      nil,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cID>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      <anAccel>,                                /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      nil,                                      /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  @ <nRow> [,<nCol>] DCOBJECT <oObject>                             ;
                [PARENT <oParent>]                                          ;
                [MESSAGE <cMsg> [INTO <oMsg>]]                              ;
                [WHEN <bWhen>]                                              ;
                [HIDE <bHide>]                                              ;
                [EDITPROTECT <bProtect>]                                    ;
                [VALID <bValid>]                                            ;
                [HELPCODE <cHelpCode>]                                      ;
                [TITLE <cTitle>]                                            ;
                [TOOLTIP <cToolTip>]                                        ;
                [CURSOR <nCursor>]                                          ;
                [CARGO <xCargo>]                                            ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [<p: PIXEL>] [_PIXEL <_pixel>]                              ;
                [RELATIVE <oRel>]                                           ;
                [ID <cId>]                                                  ;
                [ACCELKEY <nAccel>]                                         ;
                [GOTFOCUS <bGotFocus>]                                      ;
                [LOSTFOCUS <bLostFocus>]                                    ;
                [<lTabStop:TABSTOP>] [_TABSTOP <_tab>]                      ;
                [<lNoTabStop:NOTABSTOP>] [_NOTABSTOP <_notab>]              ;
                [TABGROUP <nTabGroup>]                                      ;
                [<lVisible:VISIBLE>] [_VISIBLE <_vis>]                      ;
                [<lInvisible:INVISIBLE>] [INVISIBLE <_invis>]               ;
                [GROUP <cGroup>]                                            ;
   =>                                                                       ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_OBJECT,                           /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      <nRow>,                                   /* nGETLIST_STARTROW     */ ;
      <nCol>,                                   /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      <bWhen>,                                  /* bGETLIST_WHEN         */ ;
      <bValid>,                                 /* bGETLIST_VALID        */ ;
      <cToolTip>,                               /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      <oObject>,                                /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      {<cMsg>,[{DC_GetAnchorCB(@<oMsg>,'O'),<(oMsg)>,'O'}]},                ;
                                                /* cGETLIST_MESSAGE      */ ;
      <cHelpCode>,                              /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      <oObject>,                                /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      <bProtect>,                               /* bGETLIST_PROTECT      */ ;
      <.p.> [.OR. <_pixel>],                    /* lGETLIST_PIXEL        */ ;
      <nCursor>,                                /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      [{DC_GetAnchorCb(@<oRel>,'O'),                                        ;
                        <(oRel)>,'O'}],         /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      <nAccel>,                                 /* nGETLIST_ACCELKEY     */ ;
      <bGotFocus>,                              /* bGETLIST_GOTFOCUS     */ ;
      <bLostFocus>,                             /* bGETLIST_LOSTFOCUS    */ ;
      DC_LogicTest([<.lTabStop.>],[<_tab>],[<.lNoTabStop.>],[<_notab>]),    ;
                                                /* lGETLIST_TABSTOP      */ ;
      <nTabGroup>,                              /* nGETLIST_TABGROUP     */ ;
      DC_LogicTest([<.lVisible.>],[<_vis>],[<.lInvisible.>],[<_invis>]),    ;
                                                /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  DCSETPARENT [TO] [<oParent>]                                      ;
 =>                                                                         ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SETPARENT,                        /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      nil,                                      /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      nil,                                      /* bGETLIST_PREEVAL      */ ;
    } )

* ----------------------------- *

#command  DCSETGROUP [TO] [<cGroup>]                                        ;
 =>                                                                         ;
   AADD( DCGUI_GETLIST,                                                     ;
    { GETLIST_SETGROUP,                         /* nGETLIST_TYPE         */ ;
      nil,                                      /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      nil,                                      /* bGETLIST_PREEVAL      */ ;
    } )



* ------------------------------- *

#command DCSTATUSBAR <oObject>                                              ;
                [TYPE <nType>]                                              ;
                [ALIGN <nAlign>]                                            ;
                [HEIGHT <nHeight>]                                          ;
                [WIDTH <nWidth>]                                            ;
                [SPACING <nSpacing>]                                        ;
                [PARENT <oParent>]                                          ;
                [CARGO <xCargo>]                                            ;
                [PRESENTATION <aPres>]                                      ;
                [EVAL <bEval>]                                              ;
                [PREEVAL <bPreEval>]                                        ;
                [TITLE <cTitle>]                                            ;
                [HIDE <bHide>]                                              ;
                [ID <cId>]                                                  ;
                [GROUP <cGroup>]                                            ;
 =>                                                                         ;
  AADD( DCGUI_GETLIST,                                                      ;
    { GETLIST_STATUSBAR,                        /* nGETLIST_TYPE         */ ;
      <nType>,                                  /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      <nWidth>,                                 /* nGETLIST_WIDTH        */ ;
      <nHeight>,                                /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      <xCargo>,                                 /* xGETLIST_CARGO        */ ;
      <aPres>,                                  /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      {<nAlign>,<nSpacing>},                    /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      [{DC_GetAnchorCB(@<oObject>,'O'),                                     ;
                        <(oObject)>,'O'}],      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      [{DC_GetAnchorCB(@<oParent>,'O'),                                     ;
                        <(oParent)>,'O'}],      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* bGETLIST_PROTECT      */ ;
      .t.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      <bEval>,                                  /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      <cTitle>,                                 /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      <cId>,                                    /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      <bHide>,                                  /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      .f.,                                      /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      .f.,                                      /* lGETLIST_VISIBLE      */ ;
      <cGroup>,                                 /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(),ProcLine()},                  /* aGETLIST_PROC         */ ;
      <bPreEval>,                               /* bGETLIST_PREEVAL      */ ;
   } )

* ------------------------------- *

#command DCGETOPTIONS                                                         ;
                [ NAME <cName>]                                               ;
                [ TITLE <cTitle>]                                             ;
                [ WINDOWHEIGHT <nWndHeight>]                                  ;
                [ WINDOWWIDTH <nWndWidth>]                                    ;
                [ ROWSPACE <nRowSpace>]                                       ;
                [ FONT <cFont> ]                                              ;
                [ SAYFONT <cSayFont>]                                         ;
                [ SAYWIDTH <nSayWidth>]                                       ;
                [ SAYHEIGHT <nSayHeight>]                                     ;
                [ GETHEIGHT <nGetHeight>]                                     ;
                [ GETFONT <cGetFont>]                                         ;
                [ WINDOWROW <nWindowRow>]                                     ;
                [ WINDOWCOL <nWindowCol>]                                     ;
                [ ROWOFFSET <nRowOffset>]                                     ;
                [ COLOFFSET <nColOffset>]                                     ;
                [ <lDesign:DESIGN> [HOTKEY <nDesignHotKey>] ]                 ;
                [ <p:PIXEL>] [_PIXEL <_p>]                                    ;
                [ MENU <acMenu> [MSGBOX <oMsgBox>]                            ;
                       [KEYLIST <cKeyList>] [KEYTYPE <nKeyType>]              ;
                       [WRAPPER <bWrapper>] ]                                 ;
                [ BUTTONS <aButtons>]                                         ;
                [ ICON <nIcon>]                                               ;
                [ <lCheckGet:CHECKGET>] [_CHECKGET <_checkget>]               ;
                [ <lNoCheckGet:NOCHECKGET>] [_NOCHECKGET <_nocheckget>]       ;
                [ <h:HELPFILE,HELPBLOCK> <bcHelp>]                            ;
                [ <lVisible:VISIBLE>] [_VISIBLE <_visible>]                   ;
                [ <lNoTrans:NOTRANSLATE>] [_NOTRANSLATE <_notranslate>]       ;
                [ <lSayRight:SAYRIGHTJUST> ] [_SAYRIGHTJUST <_sayright>]      ;
                [ BITMAP <nBitMap> ]                                          ;
                [ PRESENTATION <aPres> ]                                      ;
                [ COLOR <nBGColor> ]                                          ;
                [ SAYOPTIONS <nSayOpt> ]                                      ;
                [ EVAL <bEval> ]                                              ;
                [ PREEVAL <bPreEval> ]                                        ;
                [ POSTEVAL <bPostEval> ]                                      ;
                [ MODALSTATE <nModalState> ]                                  ;
                [ <lNoMin:NOMINBUTTON> ] [_NOMINBUTTON <_nomin>]              ;
                [ <lNoMax:NOMAXBUTTON> ] [_NOMAXBUTTON <_nomax>]              ;
                [ <lTabStop:TABSTOP> ] [_TABSTOP <_tabstop>]                  ;
                [ <lAbortQuery:ABORTQUERY> [_ABORTQUERY <_abortquery>]        ;
                                           [MSG <bAbortQuery>] ]              ;
                [ <lCloseQuery:CLOSEQUERY> [_CLOSEQUERY <_closequery>]        ;
                                           [MSG <bCloseQuery>] ]              ;
                [ <lExitQuery:EXITQUERY>   [_EXITQUERY <_exitquery>]          ;
                                           [MSG <bExitQuery>] ]               ;
                [ ROWPIXELS <nRowPixels> ]                                    ;
                [ COLPIXELS <nColPixels> ]                                    ;
                [ <lNoEscape:NOESCAPEKEY> ] [_NOESCAPEKEY <_noescape>]        ;
                [ <s:SOURCECODE,SOURCEFILE> <cSource> ]                       ;
                [ TOOLTIPCOLOR <nTFg>, <nTBg> ]                               ;
                [ BORDER <nBorder> ]                                          ;
                [ <lExValid:EXITVALIDATE> ] [_EXITVALIDATE <_exitvalid>]      ;
                [ <lNoTask:NOTASKLIST,NOTASKBAR> ] [_NOTASKLIST <_notask>]    ;
                [ MINSIZE <nMinCol>, <nMinRow> ]                              ;
                [ MAXSIZE <nMaxCol>, <nMaxRow> ]                              ;
                [ <lNoReSize:NORESIZE> ] [_NORESIZE <_noresize>]              ;
                [ <lNoTitle:NOTITLEBAR> ] [_NOTITLEBAR <_notitle>]            ;
                [ <lNoMove:NOMOVEWITHOWNER> ] [_NOMOVEWITHOWNER <_nomove>]    ;
                [ ORIGIN <nOrigin> ]                                          ;
                [ HILITEGETS <nHiliteColor> ]                                 ;
                [ <lNoSuper:NOSUPERVISE> ] [_NOSUPERVISE <_nosuper>]          ;
                [ <lHide:HIDE> ] [_HIDE <_hide>]                              ;
                [ <lNoBusy:NOBUSYPOINTER> ] [_NOBUSYPOINTER <_nobusy>]        ;
                [ BUSYMESSAGE <bcBusyMsg> ]                                   ;
                [ <lCascade:CASCADE> ] [_CASCADE <_cascade>]                  ;
                [ <lAutoResize:AUTORESIZE> ] [_AUTORESIZE <_autoresize>]      ;
                [ COLORGETS <aColorGets> ]                                    ;
                [ <lNoConfirm:NOCONFIRM> ] [_NOCONFIRM <_noconfirm>]          ;
                [ <lConfirm:CONFIRM> ] [_CONFIRM <_confirm>]                  ;
                [ FITPAD <nFitPad> ]                                          ;
                [ BUTTONALIGN <nButtonAlign> ]                                ;
                [ DISABLEDCOLOR <anDisabledBGClr> ]                           ;
                [ <lEnterTab:ENTERTAB> ] [_ENTERTAB <_entertab>]              ;
                [ EDITPROTECT <bEditProtect> ]                                ;
                [ NOEDITNAVKEYS <bNoEditNavKeys> ]                            ;
                [ MESSAGEINTO <obMessageInto> ]                               ;
                [ BUTTONSOUND <abButtonSound> ]                               ;
                [ HELPCODE <cHelpCode> ]                                      ;
                [ <lMsgClear:MESSAGECLEAR>] [_MESSAGECLEAR <_msgclear>]       ;
                [ <lAWM:AUTOWINDOWMENU,AUTOWINMENU> ] [_AUTOWINDOWMENU <_awm>]     ;
                [ KEYBOARD <cKeyboard> ]                                      ;
                [ <lNWM:NOWINDOWMENU,NOWINMENU> ] [_NOWINDOWMENU <_nwm>]         ;
      =>                                                                      ;
   GetOptions :=                                                              ;
     { <cName>,                               /* cGETOPT_NAME          */     ;
       <cTitle>,                              /* cGETOPT_TITLE         */     ;
       <nWndHeight>,                          /* nGETOPT_WNDHEIGHT     */     ;
       <nWndWidth>,                           /* nGETOPT_WNDWIDTH      */     ;
       <nRowSpace>,                           /* nGETOPT_ROWSPACE      */     ;
       <nSayWidth>,                           /* nGETOPT_SAYWIDTH      */     ;
       <cSayFont>,                            /* cGETOPT_SAYFONT       */     ;
       <cGetFont>,                            /* cGETOPT_GETFONT       */     ;
       <nGetHeight>,                          /* nGETOPT_GETHEIGHT     */     ;
       <aButtons>,                            /* aGETOPT_BUTTONS       */     ;
       <nWindowRow>,                          /* nGETOPT_WNDROW        */     ;
       <nWindowCol>,                          /* nGETOPT_WNDCOL        */     ;
       <nRowOffset>,                          /* nGETOPT_ROWOFFSET     */     ;
       <nColOffset>,                          /* nGETOPT_COLOFFSET     */     ;
       IIF(<.lDesign.>,.t.,nil),              /* lGETOPT_DESIGN        */     ;
       [{<acMenu>,<oMsgBox>,<cKeyList>,<nKeyType>,<bWrapper>}],               ;
                                              /* cGETOPT_MENU          */     ;
       [<.p.>][<_p>],                         /* lGETOPT_PIXEL         */     ;
       nil,                                   /* xGETOPT_SPARE         */     ;
       <nIcon>,                               /* nGETOPT_ICON          */     ;
       [<.lCheckGet.>.AND.!<.lNoCheckGet.>],  /* lGETOPT_CHECKGET      */     ;
       <bcHelp>,                              /* cGETOPT_HELPFILE      */     ;
       [<.lVisible.>][<_visible>],            /* lGETOPT_VISIBLE       */     ;
       !<.lNoTrans.> [.AND. !<_notranslate>], /* lGETOPT_TRANSLATE     */     ;
       [<.lSayRight.>][<_sayright>],          /* lGETOPT_SAYRIGHT      */     ;
       <nBitMap>,                             /* nGETOPT_BITMAP        */     ;
       <aPres>,                               /* aGETOPT_PRESENT       */     ;
       <nBGColor>,                            /* aGETOPT_BGCOLOR       */     ;
       <nSayOpt>,                             /* nGETOPT_SAYOPT        */     ;
       <bEval>,                               /* bGETOPT_EVAL          */     ;
       <nModalState>,                         /* nGETOPT_MODALSTATE    */     ;
       <nSayHeight>,                          /* nGETOPT_SAYHEIGHT     */     ;
       !<.lNoMin.> [.AND. !<_nomin>],         /* lGETOPT_MINBUTTON     */     ;
       !<.lNoMax.> [.AND. !<_nomax>],         /* lGETOPT_MAXBUTTON     */     ;
       [<.lTabStop.>] [<_tabstop>],           /* lGETOPT_TABSTOP       */     ;
       {[<.lAbortQuery.>][<_abortquery>],<bAbortQuery>},                      ;
                                              /* lGETOPT_ABORTQUERY    */     ;
       <nRowPixels>,                          /* nGETOPT_ROWPIXELS     */     ;
       <nColPixels>,                          /* nGETOPT_COLPIXELS     */     ;
       !<.lNoEscape.> [.AND. !<_noescape>],   /* lGETOPT_ESCAPEKEY     */     ;
       <cSource>,                             /* cGETOPT_SOURCECODE    */     ;
       [{<nTFg>,<nTBg>}],                     /* aGETOPT_TOOLCOLOR     */     ;
       <nBorder>,                             /* nGETOPT_BORDER        */     ;
       [<.lExValid.>][<_exitvalid>],          /* lGETOPT_EXVALID       */     ;
       {[<.lCloseQuery.>][<_closequery>],<bCloseQuery>},                      ;
                                              /* lGETOPT_CLOSEQUERY    */     ;
       [<.lNoTask.>][<_notask>],              /* lGETOPT_NOTASKLIST    */     ;
       [{<nMinCol>,<nMinRow>}],               /* aGETOPT_MINSIZE       */     ;
       [{<nMaxCol>,<nMaxRow>}],               /* aGETOPT_MAXSIZE       */     ;
       [<.lNoReSize.>][<_noresize>],          /* lGETOPT_NORESIZE      */     ;
       [<.lNoTitle.>][<_notitle>],            /* lGETOPT_NOTITLEBAR    */     ;
       [<.lNoMove.>][<_nomove>],              /* lGETOPT_NOMOVE        */     ;
       <nOrigin>,                             /* nGETOPT_ORIGIN        */     ;
       <nHiliteColor>,                        /* nGETOPT_HILITECOLOR   */     ;
       !<.lNoSuper.> [.OR. <_nosuper>],       /* lGETOPT_SUPERVISE     */     ;
       [<.lHide.>][<_hide>],                  /* lGETOPT_HIDEDIALOG    */     ;
       [<.lNoBusy.>][<_nobusy>],              /* lGETOPT_NOBUSY        */     ;
       <bcBusyMsg>,                           /* cGETOPT_BUSYMSG       */     ;
       <nDesignHotKey>,                       /* nGETOPT_DESIGNKEY     */     ;
       [<.lCascade.>][<_cascade>],            /* lGETOPT_CASCADE       */     ;
       [<.lAutoResize.>][<_autoresize>],      /* lGETOPT_AUTORESIZE    */     ;
       <aColorGets>,                          /* aGETOPT_COLORGETS     */     ;
       [!<.lNoConfirm.>][<.lConfirm.>],       /* lGETOPT_CONFIRM       */     ;
       <nFitPad>,                             /* nGETOPT_FITPAD        */     ;
       <nButtonAlign>,                        /* nGETOPT_BUTTONALIGN   */     ;
       {[<.lExitQuery.>][<_exitquery>],<bExitQuery>},                         ;
                                              /* lGETOPT_EXITQUERY     */     ;
       <anDisabledBGClr>,                     /* nGETOPT_DISABLEDCOLOR */     ;
       [<.lEnterTab.>][<_entertab>],          /* lGETOPT_ENTERTAB      */     ;
       <bPreEval>,                            /* bGETOPT_PREEVAL       */     ;
       <cFont>,                               /* cGETOPT_FONT          */     ;
       <bEditProtect>,                        /* bGETOPT_EDITPROTECT   */     ;
       <obMessageInto>,                       /* oGETOPT_MESSAGEINTO   */     ;
       <bNoEditNavKeys>,                      /* bGETOPT_NOEDITNAVKEYS */     ;
       <abButtonSound>,                       /* aGETOPT_BUTTONSOUND   */     ;
       [<.lMsgClear.>][<_msgclear>],          /* lGETOPT_MESSAGECLEAR  */     ;
       <cHelpCode>,                           /* cGETOPT_HELPCODE      */     ;
       [<.lAWM.>][<_awm>],                    /* lGETOPT_AUTOWINMENU   */     ;
       <cKeyboard>,                           /* cGETOPT_KEYBOARD      */     ;
       [<.lNWM.>][<_nwm>],                    /* lGETOPT_NOWINMENU     */     ;
    }


#xtrans  DCGET OPTIONS               ;
         [WINDOW HEIGHT <WH>]        ;
         [WINDOW WIDTH <WW>]         ;
         [WINDOW ROW <WR>]           ;
         [WINDOW COL <WC>]           ;
         [<clauses,...>]             ;
                               =>    ;
         DCGETOPTIONS                ;
         [WINDOWHEIGHT <WH>]         ;
         [WINDOWWIDTH <WW>]          ;
         [WINDOWROW <WR>]            ;
         [WINDOWCOL <WC>]            ;
         [<clauses>]

#xcommand DCREAD GUI                                                        ;
          [ TO <lVar> ]                                                     ;
          [ TITLE <cTitle> ]                                                ;
          [ OPTIONS <aOptions> ]                                            ;
          [ <lButtons:ADDBUTTONS> ] [_ADDBUTTONS <_addbuttons>]             ;
          [ BUTTONS <nButtons> ]                                            ;
          [ HANDLER <Handler> [REFERENCE <xRef>] ]                          ;
          [ PARENT <oParent> ]                                              ;
          [ OWNER <oOwner> ]                                                ;
          [ APPWINDOW <oAppWindow> ]                                        ;
          [ <lExit:EXIT> ] [_EXIT <_lExit>]                                 ;
          [ <lFit:FIT> ] [_FIT <_lFit>]                                     ;
          [ <lModal:MODAL> ] [_MODAL <_lModal>]                             ;
          [ EVAL <bEval> ]                                                  ;
          [ <lSave:SAVE> ] [_SAVE <_save>]                                  ;
          [ <lEnterExit:ENTEREXIT> ] [_ENTEREXIT <_lEnterExit>]             ;
          [ <lArrayTran:ARRAYTRANSLATE> ] [_ARRAYTRANSLATE <_lArrayTran> ]  ;
          [ SETFOCUS <xSetFocus> ]                                          ;
          [ GROUP <acGroup> ]                                               ;
          [ TIMEOUT <nSeconds> ]                                            ;
          [ WAIT <nWait> ]                                                  ;
          [ <lClearEvents:CLEAREVENTS> ] [_CLEAREVENTS <_clearevents>]      ;
          [ <lNoDestroy:NODESTROY> ] [_NODESTROY <_nodestroy>]              ;
          [ <lSetAppWindow:SETAPPWINDOW> ] [_SETAPPWINDOW <_setappwindow>]  ;
          [ WRITESOURCE <cWriteSource> ]                                    ;
          [ <lExpress:EXPRESS> ] [_EXPRESS <_express>]                      ;
          [ POSTEVENT <nEvent> ]                                            ;
  =>                                                                        ;
    [<lVar> := ]                                                            ;
       DC_ReadGui(  DCGUI_GETLIST,                                          ;
                    <cTitle>,                                               ;
                    <aOptions>,                                             ;
                    IIF(<.lButtons.> [.OR. <_addbuttons>],                  ;
                         DCGUI_BUTTON_OK+DCGUI_BUTTON_CANCEL, <nButtons>),  ;
                    [{|a,b,c,d,e,f,g,h|<Handler>(a,b,c,d,e,f,@g,h)}],       ;
                    <xRef>,                                                 ;
                    <oParent>,                                              ;
                    <.lFit.> [.OR. <_lFit>],                                ;
                    nil,                                                    ;
                    <.lExit.> [.OR. <_lExit>],                              ;
                    <oAppWindow>,                                           ;
                    <.lModal.> [.OR. <_lModal>],                            ;
                    <bEval>,                                                ;
                    <.lEnterExit.> [.OR. <_lEnterExit>],                    ;
                    <.lArrayTran.> [.OR. <_lArrayTran>],                    ;
                    <oOwner>,                                               ;
                    [<xSetFocus>],                                          ;
                    <acGroup>,                                              ;
                    <nSeconds>,                                             ;
                    <nWait>,                                                ;
                    <.lClearEvents.> [.OR. <_clearevents>],                 ;
                    !<.lNoDestroy.> [.AND. !<_nodestroy>],                  ;
                    <.lSetAppWindow.> [.OR. <_setappwindow>],               ;
                    <cWriteSource>,                                         ;
                    <.lExpress.> [.OR. <_express>],                         ;
                    <nEvent> )                                              ;
    ; IF !<.lSave.> [.AND. !<_save>] ; DCGUI_GETLIST := {} ; ENDIF


#xcommand DCREAD [TEXT]                                                     ;
          [ TO <lVar> ]                                                     ;
          [ TITLE <cTitle> ]                                                ;
          [ OPTIONS <aOptions> ]                                            ;
          [ HANDLER <Handler> ]                                             ;
          [ PARENT <oDlg> ]                                                 ;
          [ APPWINDOW <oAppWindow> ]                                        ;
          [ AREA <aReadArea> ]                                              ;
          [ REFERENCE <xRef> ]                                              ;
  =>                                                                        ;
    [<lVar> := ]                                                            ;
       DC_ReadGets( DCGUI_GETLIST,                                          ;
                    <cTitle>,                                               ;
                    <aReadArea>,                                            ;
                    <aOptions>,                                             ;
                    [{|a,b,c,d,e,f,g,h|<Handler>(a,b,c,d,e,f,g,h)}],        ;
                    <xRef>,                                                 ;
                    <oDlg>,                                                 ;
                    <oAppWindow>  )


#command DCQOUT WINDOW [<oCrt>] [EVAL <bEval>] [ <app:APPWINDOW> ]           ;
         => DC_QoutWindow( <oCrt>, <bEval>, <.app.> )

#command DCQOUT [<list,...>]  =>  DC_DebugQout( {<list>} )

#xcommand DCQQOUT [<list,...>]  =>  DC_DebugQQout( {<list>} )

#xcommand DCDEBUG <var1> [,<varN>] =>  ;
          DC_DebugQout( {<(var1)> + ':',<var1>} ) [; DC_DebugQout( {<(varN)> + ':',<varN>} ) ]

#xcommand DCQDEBUG => DC_DebugQOut()

#xcommand DCQDEBUG <var1> [,<varN>] =>  ;
          DC_DebugQout( {<(var1)> + ':',<var1>} ) [; DC_DebugQout( {<(varN)> + ':',<varN>} ) ]

#xcommand DCQQDEBUG <var1> [,<varN>] =>  ;
          DC_DebugQout( {<(var1)> + ':',<var1>} ) [; DC_DebugQout( {<(varN)> + ':',<varN>} ) ]

#xcommand DCQDEBUGOFF <var1> [,<varN>] =>  ;
          DC_DebugQout( {<var1>} ) [; DC_DebugQout( {<varN>} ) ]

#command DCMSGBOX <list,...>       ;
           [TITLE <cTitle>]        ;
           [TIMEOUT <nSeconds>]    ;
           [<yesno:YESNO>]         ;
           [TO <output>]           ;
           [FONT <cFont>]          ;
           [BUTTONS <aButtons>]    ;
           [CHOICE <nChoice>]      ;
           [HOTKEY <cHotKey>]      ;
           [EVAL <bEval>]          ;
   =>                              ;
  [<output> := ] ;
    DC_MsgBox(,,{<list>},<cTitle>,,<nSeconds>,<.yesno.>,<nChoice>, ;
              <aButtons>,,,<cHotKey>,<cFont>,<bEval>)

#command DCWAITON <msg>            ;
         <m:MODAL>                 ;
         [TO <output>]             ;
         [TITLE <title>]           ;
         [PARENT <parent>]         ;
         [OWNER <owner>]           ;
   =>                              ;
  [<output> := ] ;
    DC_WaitOn(<msg>,,,,,,<title>,,<parent>,<owner>,<m>)

#command DCGUI ON => DC_Gui(.t.)

#command DCGUI OFF => DC_Gui(.f.)

#command GUI ON => DC_Gui(.t.)

#command GUI OFF => DC_Gui(.f.)

#command @ [<nSRow>, <nSCol>, <nERow>, <nECol>] DCACHOICE <array>     ;
           [TITLE <cTitle>]        ;
           [ELEMENT <nElement>]    ;
           [WINSTART <nWinStart>]  ;
           [OBJECT <oObject>]      ;
           [<lCenter:CENTER>]      ;
           [TO <output>]           ;
           [<lNoDestroy:NODESTROY>];
   =>                              ;
  [<output> := ] ;
    DC_AChoice(<nSRow>,<nSCol>,<nERow>,<nECol>,<array>,,,<nElement>, ;
               <nWinStart>,,{.t.,,<cTitle>,.t.,!<.lNoDestroy.>},,,,<oObject>,<.lCenter.>)

#command @ [<nTop>, <nLeft>] DCAPICK <array>                           ;
           [SIZE <nWidth>, <nHeight>]                                  ;
           [HEADER <acHeader>]                                         ;
           [COLWIDTH <anColWidth>]                                     ;
           [TITLE <cTitle>]                                            ;
           [TAG <anTag> [COLOR <aTagColor>] ]                          ;
           [HANDLER <bHandler>]                                        ;
           [START <nStart>]                                            ;
           [FONT <cFontName>]                                          ;
           [PARENT <oParent>]                                          ;
           [OWNER <oOwner>]                                            ;
           [<lCenter:CENTER>]                                          ;
           [<lMenu:MENU>]                                              ;
           [TO <output>]                                               ;
           [<lNoVScroll:NOVSCROLL>]                                    ;
           [<lNoHScroll:NOHSCROLL>]                                    ;
           [PRESENTATION <aPres>]                                      ;
   =>                                                                  ;
  [<output> := ]                                                       ;
    DC_APick ( <nTop>, <nLeft>, <nWidth>, <nHeight>, <array>,          ;
               <acHeader>, <anColWidth>, <cTitle>, <anTag>,            ;
               <aTagColor>, <bHandler>, <nStart>, <cFontName>,         ;
               <oParent>, <oOwner>, <.lCenter.>, <.lMenu.>,            ;
               <.lNoVScroll.>, <.lNoHScroll.>, <aPres> )


#xcommand DCFINDADDCOL                                                  ;
         [DATA <bData>]                                                 ;
         [ELEMENT <nElement>]                                           ;
         [HEADER <cHeader>]                                             ;
         [WIDTH <nWidth>]                                               ;
         [<t: TAG,ORDER,INDEX,SORT> <bncOrder>]                         ;
         [PROMPT <cPrompt>]                                             ;
         [PREFIX <bcPrefix>]                                            ;
         [SEEK <bSeek>]                                                 ;
         [TO <aArray>]                                                  ;
   =>                                                                   ;
         AAdd( <aArray>, { [<bData>] [<nElement>], <cHeader>, <nWidth>, ;
               <bncOrder>, <cPrompt>, <bcPrefix>, <bSeek> } )

#command @ [<nRow>,<nCol>] DCFINDBROWSE                                        ;
         FIELDS <aFields>                                                      ;
         [PARENT <oParent>]                                                    ;
         [SIZE <nWidth>, <nHeight>]                                            ;
         [TITLE <cTitle>]                                                      ;
         [<lAutoSeek:AUTOSEEK>]                                                ;
         [<lHeaders:HEADERS>]                                                  ;
         [<p: PIXEL>] [_PIXEL <_pixel>]                                        ;
         [DATA <acbData>]                                                      ;
         [POINTER <nPointer>]                                                  ;
         [EVAL <bEval>]                                                        ;
         [PRESENTATION <aPres>]                                                ;
         [<lNoHeaders:NOHEADERS>]                                              ;
         [<lNoHScroll:NOHSCROLL>]                                              ;
         [<lNoVScroll:NOVSCROLL>]                                              ;
         [<lExit:EXIT>]                                                        ;
         [SEEKDELAY <nDelay>]                                                  ;
         [TO <lStatus>]                                                        ;
         [FONT <cFont>]                                                        ;
         [<lb:LEFTBUTTONSORT>]                                                 ;
         [POPUP <bPopUp>]                                                      ;
         [SORT <aSort>]                                                        ;
         [GETLIST <aGetList>]                                                  ;
         [ITEMSELECTED <bItemSelected>]                                        ;
   =>                                                                          ;
         [<lStatus> := ] DC_FindBrowse( <aFields>, <oParent>, <nRow>, <nCol>,  ;
                        <nWidth>, <nHeight>, <cTitle>, <.lAutoSeek.>,          ;
                        !<.lNoHeaders.>, <.p.> [.OR. <_pixel>], <acbData>,     ;
                        <nPointer>, <bEval>, <aPres>, !<.lNoHScroll.>,         ;
                        !<.lNoVScroll.>, <.lExit.>, <nDelay>, <cFont>, <.lb.>, ;
                        <bPopUp>, <aSort>, [@<aGetList>], <bItemSelected> )


#command GETSETFUNCTION <cFunction> DEFAULT <xDefault> => ;
         FUNCTION <cFunction>( xValue ) ;
         ; STATIC sxValue := <xDefault> ;
         ; LOCAL xOldValue := sxValue ;
         ; IF Valtype(<xDefault>) == Valtype(xValue) ;
         ;   sxValue := xValue ;
         ; ENDIF ;
         ; RETURN xOldValue

#define _DCDIALOG_CH

#endif



